/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/base/common/assert",["require","exports"],function(e,t){function n(e,t){if(!e||null===e)throw new Error(t?"Assertion failed ("+t+")":"Assertion Failed")}t.ok=n}),define("vs/base/common/collections",["require","exports"],function(e,t){function n(){return Object.create(null)}function r(){return Object.create(null)}function o(e,t,n){void 0===n&&(n=null);var r=String(t);return a(e,r)?e[r]:n}function i(e,t,n){var r=String(t);return a(e,r)?e[r]:("function"==typeof n&&(n=n()),e[r]=n,n)}function s(e,t,n){e[n(t)]=t}function a(e,t){return g.call(e,t)}function u(e){return{every:function(t){for(var n in e)if(g.call(e,n)&&!t(n))return!1;return!0}}}function c(e){var t=[];for(var n in e)g.call(e,n)&&t.push(e[n]);return t}function l(e,t){for(var n in e)if(g.call(e,n)){var r=t({key:n,value:e[n]},function(){delete e[n]});if(r===!1)return}}function d(e,t){return g.call(e,t)?(delete e[t],!0):!1}function h(e,t){var r=n();return e.forEach(function(e){return i(r,t(e),[]).push(e)}),r}function p(e){var n=e.length;return 0===n?t.EmptyIterable:1===n?e[0]:{every:function(t){for(var r=0;n>r;r++)if(!e[r].every(t))return!1;return!0}}}function f(e){return{every:function(t){return t(e)}}}function m(e){if(Array.isArray(e))return e;var t=[];return e.every(function(e){return t.push(e),!0}),t}t.createStringDictionary=n,t.createNumberDictionary=r,t.lookup=o,t.lookupOrInsert=i,t.insert=s;var g=Object.prototype.hasOwnProperty;t.contains=a,t.keys=u,t.values=c,t.forEach=l,t.remove=d,t.groupBy=h,t.EmptyIterable={every:function(e){return!0}},t.combine=p,t.singleton=f,t.toArray=m;var v=function(){function e(e){this.size=e,this.cache=Object.create(null),this.order=[]}return e.prototype.get=function(e){var t=this.cache[e];return t&&t.element},e.prototype.put=function(e,t,n){var r=this.cache[e],o={element:t,onRemove:n};this.cache[e]=o,r||this.order.push(e),this.swipe()},e.prototype.swipe=function(){for(;this.order.length>this.size;){var e=this.order.shift(),t=this.cache[e];t.onRemove(),delete this.cache[e]}},e}();t.LimitedSizeCache=v}),define("vs/base/common/diff/diffChange",["require","exports"],function(e,t){t.DifferenceType={Add:0,Remove:1,Change:2};var n=function(){function e(e,t,n,r){this.originalStart=e,this.originalLength=t,this.modifiedStart=n,this.modifiedLength=r}return e.prototype.getChangeType=function(){return 0===this.originalLength?t.DifferenceType.Add:0===this.modifiedLength?t.DifferenceType.Remove:t.DifferenceType.Change},e.prototype.getOriginalEnd=function(){return this.originalStart+this.originalLength},e.prototype.getModifiedEnd=function(){return this.modifiedStart+this.modifiedLength},e}();t.DiffChange=n}),define("vs/base/common/diff/diff",["require","exports","vs/base/common/diff/diffChange"],function(e,t,n){var r=function(){function e(){}return e.Assert=function(e,t){if(!e)throw new Error(t)},e}();t.Debug=r;var o=function(){function e(){}return e.Copy=function(e,t,n,r,o){for(var i=0;o>i;i++)n[r+i]=e[t+i]},e}();t.MyArray=o;var i=1447,s=function(){function e(){this.m_changes=[],this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE,this.m_originalCount=0,this.m_modifiedCount=0}return e.prototype.MarkNextChange=function(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new n.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE},e.prototype.AddOriginalElement=function(e,t){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,t),this.m_originalCount++},e.prototype.AddModifiedElement=function(e,t){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,t),this.m_modifiedCount++},e.prototype.getChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes},e.prototype.getReverseChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes},e}(),a=function(){function e(e,t,n){void 0===n&&(n=null),this.OriginalSequence=e,this.ModifiedSequence=t,this.ContinueProcessingPredicate=n,this.m_originalIds=[],this.m_modifiedIds=[],this.m_forwardHistory=[],this.m_reverseHistory=[],this.ComputeUniqueIdentifiers()}return e.prototype.ComputeUniqueIdentifiers=function(){var e=this.OriginalSequence.getLength(),t=this.ModifiedSequence.getLength();this.m_originalIds=new Array(e),this.m_modifiedIds=new Array(t);var n,r={},o=1;for(n=0;e>n;n++){var i=this.OriginalSequence.getElementHash(n);r.hasOwnProperty(i)?this.m_originalIds[n]=r[i]:(this.m_originalIds[n]=o++,r[i]=this.m_originalIds[n])}for(n=0;t>n;n++){var s=this.ModifiedSequence.getElementHash(n);r.hasOwnProperty(s)?this.m_modifiedIds[n]=r[s]:(this.m_modifiedIds[n]=o++,r[s]=this.m_modifiedIds[n])}},e.prototype.ElementsAreEqual=function(e,t){return this.m_originalIds[e]===this.m_modifiedIds[t]},e.prototype.ComputeDiff=function(){return this._ComputeDiff(0,this.OriginalSequence.getLength()-1,0,this.ModifiedSequence.getLength()-1)},e.prototype._ComputeDiff=function(e,t,n,r){var o=[!1];return this.ComputeDiffRecursive(e,t,n,r,o)},e.prototype.ComputeDiffRecursive=function(e,t,o,i,s){for(s[0]=!1;t>=e&&i>=o&&this.ElementsAreEqual(e,o);)e++,o++;for(;t>=e&&i>=o&&this.ElementsAreEqual(t,i);)t--,i--;if(e>t||o>i){var a;return i>=o?(r.Assert(e===t+1,"originalStart should only be one more than originalEnd"),a=[new n.DiffChange(e,0,o,i-o+1)]):t>=e?(r.Assert(o===i+1,"modifiedStart should only be one more than modifiedEnd"),a=[new n.DiffChange(e,t-e+1,o,0)]):(r.Assert(e===t+1,"originalStart should only be one more than originalEnd"),r.Assert(o===i+1,"modifiedStart should only be one more than modifiedEnd"),a=[]),a}var u=[0],c=[0],l=this.ComputeRecursionPoint(e,t,o,i,u,c,s),d=u[0],h=c[0];if(null!==l)return l;if(!s[0]){var p=this.ComputeDiffRecursive(e,d,o,h,s),f=[];return f=s[0]?[new n.DiffChange(d+1,t-(d+1)+1,h+1,i-(h+1)+1)]:this.ComputeDiffRecursive(d+1,t,h+1,i,s),this.ConcatenateChanges(p,f)}return[new n.DiffChange(e,t-e+1,o,i-o+1)]},e.prototype.WALKTRACE=function(e,t,r,o,i,a,u,c,l,d,h,p,f,m,g,v,_,y){var k,b=null,E=null,T=new s,S=t,C=r,M=f[0]-v[0]-o,w=Number.MIN_VALUE,I=this.m_forwardHistory.length-1;do k=M+e,k===S||C>k&&l[k-1]<l[k+1]?(h=l[k+1],m=h-M-o,w>h&&T.MarkNextChange(),w=h,T.AddModifiedElement(h+1,m),M=k+1-e):(h=l[k-1]+1,m=h-M-o,w>h&&T.MarkNextChange(),w=h-1,T.AddOriginalElement(h,m+1),M=k-1-e),I>=0&&(l=this.m_forwardHistory[I],e=l[0],S=1,C=l.length-1);while(--I>=-1);if(b=T.getReverseChanges(),y[0]){var x=f[0]+1,L=v[0]+1;if(null!==b&&b.length>0){var N=b[b.length-1];x=Math.max(x,N.getOriginalEnd()),L=Math.max(L,N.getModifiedEnd())}E=[new n.DiffChange(x,p-x+1,L,g-L+1)]}else{T=new s,S=a,C=u,M=f[0]-v[0]-c,w=Number.MAX_VALUE,I=_?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do k=M+i,k===S||C>k&&d[k-1]>=d[k+1]?(h=d[k+1]-1,m=h-M-c,h>w&&T.MarkNextChange(),w=h+1,T.AddOriginalElement(h+1,m+1),M=k+1-i):(h=d[k-1],m=h-M-c,h>w&&T.MarkNextChange(),w=h,T.AddModifiedElement(h+1,m+1),M=k-1-i),I>=0&&(d=this.m_reverseHistory[I],i=d[0],S=1,C=d.length-1);while(--I>=-1);E=T.getChanges()}return this.ConcatenateChanges(b,E)},e.prototype.ComputeRecursionPoint=function(e,t,r,s,a,u,c){var l,d,h,p=0,f=0,m=0,g=0;e--,r--,a[0]=0,u[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];var v=t-e+(s-r),_=v+1,y=new Array(_),k=new Array(_),b=s-r,E=t-e,T=e-r,S=t-s,C=E-b,M=C%2===0;y[b]=e,k[E]=t,c[0]=!1;var w,I;for(h=1;v/2+1>=h;h++){var x=0,L=0;for(p=this.ClipDiagonalBound(b-h,h,b,_),f=this.ClipDiagonalBound(b+h,h,b,_),w=p;f>=w;w+=2){for(l=w===p||f>w&&y[w-1]<y[w+1]?y[w+1]:y[w-1]+1,d=l-(w-b)-T,I=l;t>l&&s>d&&this.ElementsAreEqual(l+1,d+1);)l++,d++;if(y[w]=l,l+d>x+L&&(x=l,L=d),!M&&Math.abs(w-E)<=h-1&&l>=k[w])return a[0]=l,u[0]=d,I<=k[w]&&i>0&&i+1>=h?this.WALKTRACE(b,p,f,T,E,m,g,S,y,k,l,t,a,d,s,u,M,c):null}var N=(x-e+(L-r)-h)/2;if(null!==this.ContinueProcessingPredicate&&!this.ContinueProcessingPredicate(x,this.OriginalSequence,N))return c[0]=!0,a[0]=x,u[0]=L,N>0&&i>0&&i+1>=h?this.WALKTRACE(b,p,f,T,E,m,g,S,y,k,l,t,a,d,s,u,M,c):(e++,r++,[new n.DiffChange(e,t-e+1,r,s-r+1)]);for(m=this.ClipDiagonalBound(E-h,h,E,_),g=this.ClipDiagonalBound(E+h,h,E,_),w=m;g>=w;w+=2){for(l=w===m||g>w&&k[w-1]>=k[w+1]?k[w+1]-1:k[w-1],d=l-(w-E)-S,I=l;l>e&&d>r&&this.ElementsAreEqual(l,d);)l--,d--;if(k[w]=l,M&&Math.abs(w-b)<=h&&l<=y[w])return a[0]=l,u[0]=d,I>=y[w]&&i>0&&i+1>=h?this.WALKTRACE(b,p,f,T,E,m,g,S,y,k,l,t,a,d,s,u,M,c):null}if(i>=h){var R=new Array(f-p+2);R[0]=b-p+1,o.Copy(y,p,R,1,f-p+1),this.m_forwardHistory.push(R),R=new Array(g-m+2),R[0]=E-m+1,o.Copy(k,m,R,1,g-m+1),this.m_reverseHistory.push(R)}}return this.WALKTRACE(b,p,f,T,E,m,g,S,y,k,l,t,a,d,s,u,M,c)},e.prototype.ConcatenateChanges=function(e,t){var n=[],r=null;return 0===e.length||0===t.length?t.length>0?t:e:this.ChangesOverlap(e[e.length-1],t[0],n)?(r=new Array(e.length+t.length-1),o.Copy(e,0,r,0,e.length-1),r[e.length-1]=n[0],o.Copy(t,1,r,e.length,t.length-1),r):(r=new Array(e.length+t.length),o.Copy(e,0,r,0,e.length),o.Copy(t,0,r,e.length,t.length),r)},e.prototype.ChangesOverlap=function(e,t,o){if(r.Assert(e.originalStart<=t.originalStart,"Left change is not less than or equal to right change"),r.Assert(e.modifiedStart<=t.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=t.originalStart||e.modifiedStart+e.modifiedLength>=t.modifiedStart){var i=e.originalStart,s=e.originalLength,a=e.modifiedStart,u=e.modifiedLength;return e.originalStart+e.originalLength>=t.originalStart&&(s=t.originalStart+t.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=t.modifiedStart&&(u=t.modifiedStart+t.modifiedLength-e.modifiedStart),o[0]=new n.DiffChange(i,s,a,u),!0}return o[0]=null,!1},e.prototype.ClipDiagonalBound=function(e,t,n,r){if(e>=0&&r>e)return e;var o=n,i=r-n-1,s=t%2===0;if(0>e){var a=o%2===0;return s===a?0:1}var u=i%2===0;return s===u?r-1:r-2},e}();t.LcsDiff=a});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/base/common/events",["require","exports"],function(e,t){var n=function(){function e(e){this.time=(new Date).getTime(),this.originalEvent=e,this.source=null}return e}();t.Event=n;var r=function(e){function t(t,n,r,o){e.call(this,o),this.key=t,this.oldValue=n,this.newValue=r}return __extends(t,e),t}(n);t.PropertyChangeEvent=r;var o=function(e){function t(t,n){e.call(this,n),this.element=t}return __extends(t,e),t}(n);t.ViewerEvent=o,t.EventType={PROPERTY_CHANGED:"propertyChanged",SELECTION:"selection",FOCUS:"focus",BLUR:"blur",HIGHLIGHT:"highlight",EXPAND:"expand",COLLAPSE:"collapse",TOGGLE:"toggle",CONTENTS_CHANGED:"contentsChanged",BEFORE_RUN:"beforeRun",RUN:"run",EDIT:"edit",SAVE:"save",CANCEL:"cancel",CHANGE:"change",DISPOSE:"dispose"}}),define("vs/base/common/hash",["require","exports"],function(e,t){function n(e){for(var t=1540483477,n=24,r=0,o=e.length,i=o,s=0^i,a=r;i>=2;){var u=e.charCodeAt(a),c=e.charCodeAt(a+1),l=u|c<<16;l*=t,l^=l>>n,l*=t,s*=t,s^=l,a+=2,i-=2}return 1===i&&(s^=e.charCodeAt(a),s*=t),s^=s>>13,s*=t,s^=s>>15}function r(e,t){return(t<<5)+t+e&2147483647}t.computeMurmur2StringHashCode=n,t.combine=r}),define("vs/base/common/http",["require","exports"],function(e,t){function n(e){return e>=300&&303>=e||307===e}function r(e,t,n,r){var o,i;return{header:function(n){if("undefined"==typeof i)for(i=Object.create(null),c.lastIndex=t;;){var r=c.exec(e);if(!r)break;if(i[r[1].toLowerCase()]=r[2],r[3])break}return i[n.toLowerCase()]},value:function(){return"undefined"==typeof o&&(o=e.substr(n+2,r)),o}}}function o(e,t,n){void 0===n&&(n=0);var o=e.responseText;for(u.lastIndex=n;;){var i=u.exec(o);if(!i)return n;var s=parseInt(i[1],10);if(o.length<u.lastIndex+s)return n;t.push(r(o,n,u.lastIndex-2,s)),n=u.lastIndex+s}}t.GET="GET",t.POST="POST",t.PUT="PUT",t.DELETE="DELETE";var i;!function(e){e.CONTENT_TYPE="Content-Type",e.CONTENT_LENGTH="Content-Length",e.LAST_MODIFIED="Last-Modified",e.LOCATION="Location",e.ETAG="ETag",e.X_CONTENT_CHARSET="X-Content-Charset",e.X_CONTENT_TYPES="X-Content-Types",e.X_CONTENT_HASH="X-Content-Hash",e.X_FILEPATH="X-Filepath",e.X_RESOURCE="X-Resource"}(i=t.Header||(t.Header={}));var s;!function(e){e.RAW="application/octet-stream",e.JSON="application/json",e.TEXT="text/plain",e.HTML="text/html"}(s=t.Mime||(t.Mime={}));var a;!function(e){e.UTF8="utf-8",e.UTF8_BOM="UTF8_BOM"}(a=t.Charset||(t.Charset={})),t.isRedirect=n;var u=/X-Chunk-Length:(\d+)\r\n\r\n/gi,c=/(.+?):(.+?)\r\n(\r\n)?/gm;t.parseChunkedData=o}),define("vs/base/common/lifecycle",["require","exports"],function(e,t){function n(e){for(var t=0,n=e.length;n>t;t++)e[t]&&e[t].dispose();return[]}function r(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return{dispose:function(){return n(e)}}}function o(e){return{dispose:function(){return n(e)}}}function i(e){return{dispose:function(){return e()}}}function s(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return o(e.map(i))}function a(e){if(e){if("function"==typeof e)return e(),null;if(Array.isArray(e)){for(;e.length>0;)e.pop()();return e}return null}return null}t.empty=Object.freeze({dispose:function(){}}),t.disposeAll=n,t.combinedDispose=r,t.combinedDispose2=o,t.fnToDisposable=i,t.toDisposable=s,t.cAll=a}),define("vs/base/common/paths",["require","exports","vs/base/common/platform"],function(e,t,n){function r(e,n){e=o(e),n=o(n);for(var r=e.split(t.sep),i=n.split(t.sep);r.length>0&&i.length>0&&r[0]===i[0];)r.shift(),i.shift();for(var s=0,a=r.length;a>s;s++)i.unshift("..");return i.join(t.sep)}function o(e,r){if(!e)return e;if(!g.test(e)){var o=r&&n.isWindows?"/":"\\";if(-1===e.indexOf(o))return e}for(var i=e.split(/[\\\/]/),s=0,a=i.length;a>s;s++)"."===i[s]&&i[s+1]?(i.splice(s,1),s-=1):".."===i[s]&&i[s-1]&&(i.splice(s-1,2),s-=2);return i.join(r?t.nativeSep:t.sep)}function i(e){function t(){return"."===n||"/"===n||"\\"===n?(n=void 0,r=!0):n=s(n),{value:n,done:r}}var n=e,r=!1;return{next:t}}function s(e){var t=~e.lastIndexOf("/")||~e.lastIndexOf("\\");return 0===t?".":0===~t?e[0]:e.substring(0,~t)}function a(e){var t=~e.lastIndexOf("/")||~e.lastIndexOf("\\");return 0===t?e:~t===e.length-1?a(e.substring(0,e.length-1)):e.substr(~t+1)}function u(e){e=a(e);var t=~e.lastIndexOf(".");return t?e.substring(~t):""}function c(e){if(!e)return 0;if(e=e.replace(/\/|\\/g,"/"),"/"===e[0])return"/"!==e[1]?1:2;if(":"===e[1])return"/"===e[2]?3:2;if(0===e.indexOf("file:///"))return 8;var t=e.indexOf("://");return-1!==t?t+3:0}function l(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];var n,r=c(e[0]);n=e[0].substr(0,r),e[0]=e[0].substr(r);for(var o=[],i=/[\\\/]$/.test(e[e.length-1]),s=0;s<e.length;s++)o.push.apply(o,e[s].split(/\/|\\/));for(var s=0;s<o.length;s++){var a=o[s];"."===a||0===a.length?(o.splice(s,1),s-=1):".."===a&&o[s-1]&&".."!==o[s-1]&&(o.splice(s-1,2),s-=2)}i&&o.push("");var u=o.join("/");return n&&(u=n.replace(/\/|\\/g,"/")+u),u}function d(e){return n.isWindows&&e?(e=this.normalize(e,!0),e[0]===t.nativeSep&&e[1]===t.nativeSep):!1}function h(e){return e&&"/"===e[0]}function p(e,n){return h(n?e:o(e))?e:t.sep+e}function f(e){return e&&e.length>1&&"."===e[0]}function m(e,t){if(e===t)return!0;e=o(e),t=o(t);var r=t.length,i=t.charCodeAt(r-1);if(i===v&&(t=t.substring(0,r-1),r-=1),e===t)return!0;if(n.isLinux||(e=e.toLowerCase(),t=t.toLowerCase()),e===t)return!0;if(0!==e.indexOf(t))return!1;var s=e.charCodeAt(r);return s===v}t.sep="/",t.nativeSep=n.isWindows?"\\":"/",t.relative=r;var g=/[\\\/]\.\.?[\\\/]?|[\\\/]?\.\.?[\\\/]/;t.normalize=o,t.dirnames=i,t.dirname=s,t.basename=a,t.extname=u,t.join=l,t.isUNC=d,t.isAbsolute=h,t.makeAbsolute=p,t.isRelative=f;var v="/".charCodeAt(0);t.isEqualOrParent=m}),define("vs/base/common/stopwatch",["require","exports","vs/base/common/platform"],function(e,t,n){var r=n.globals.performance&&"function"==typeof n.globals.performance.now,o=function(){function e(e){this._startTime=e,this._stopTime=-1}return e.create=function(){return new e(r?n.globals.performance.now():(new Date).getTime())},e.prototype.stop=function(){this._stopTime=r?n.globals.performance.now():(new Date).getTime()},e.prototype.elapsed=function(){if(-1!==this._stopTime)return this._stopTime-this._startTime;var e=r?n.globals.performance.now():(new Date).getTime();return e-this._startTime},e}();t.StopWatch=o}),define("vs/base/common/graph",["require","exports","vs/base/common/types","vs/base/common/collections"],function(e,t,n,r){function o(e){return{data:e,incoming:{},outgoing:{}}}t.newNode=o;var i=function(){function e(e){this._hashFn=e,this._nodes=Object.create(null)}return e.prototype.roots=function(){var e=[];return r.forEach(this._nodes,function(t){n.isEmptyObject(t.value.outgoing)&&e.push(t.value)}),e},e.prototype.traverse=function(e,t,n){var r=this.lookup(e);r&&this._traverse(r,t,{},n)},e.prototype._traverse=function(e,t,n,o){var i=this,s=this._hashFn(e.data);if(!r.contains(n,s)){n[s]=!0,o(e.data);var a=t?e.outgoing:e.incoming;r.forEach(a,function(e){return i._traverse(e.value,t,n,o)})}},e.prototype.insertEdge=function(e,t){var n=this.lookupOrInsertNode(e),r=this.lookupOrInsertNode(t);n.outgoing[this._hashFn(t)]=r,r.incoming[this._hashFn(e)]=n},e.prototype.removeNode=function(e){var t=this._hashFn(e);delete this._nodes[t],r.forEach(this._nodes,function(e){delete e.value.outgoing[t],delete e.value.incoming[t]})},e.prototype.lookupOrInsertNode=function(e){var t=this._hashFn(e),n=r.lookup(this._nodes,t);return n||(n=o(e),this._nodes[t]=n),n},e.prototype.lookup=function(e){return r.lookup(this._nodes,this._hashFn(e))},Object.defineProperty(e.prototype,"length",{get:function(){return Object.keys(this._nodes).length},enumerable:!0,configurable:!0}),e}();t.Graph=i}),define("vs/base/common/uri",["require","exports","vs/base/common/marshalling","vs/base/common/platform"],function(e,t,n,r){function o(e){return encodeURIComponent(e).replace(/[!'()*]/g,function(e){return"%"+e.charCodeAt(0).toString(16).toUpperCase()})}var i=function(){function e(){this._scheme=e._empty,this._authority=e._empty,this._path=e._empty,this._query=e._empty,this._fragment=e._empty}return Object.defineProperty(e.prototype,"scheme",{get:function(){return this._scheme},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"authority",{get:function(){return this._authority},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"path",{get:function(){return this._path},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"query",{get:function(){return this._query},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fragment",{get:function(){return this._fragment},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fsPath",{get:function(){if(!this._fsPath){var t;t=this._authority&&"file"===this.scheme?"//"+this._authority+this._path:e._driveLetterPath.test(this._path)?this._path[1].toLowerCase()+this._path.substr(2):this._path,r.isWindows&&(t=t.replace(/\//g,"\\")),this._fsPath=t}return this._fsPath},enumerable:!0,configurable:!0}),e.prototype["with"]=function(t,n,r,o,i){var s=new e;return s._scheme=t||this.scheme,s._authority=n||this.authority,s._path=r||this.path,s._query=o||this.query,s._fragment=i||this.fragment,e._validate(s),s},e.prototype.withScheme=function(e){return this["with"](e,void 0,void 0,void 0,void 0)},e.prototype.withAuthority=function(e){return this["with"](void 0,e,void 0,void 0,void 0)},e.prototype.withPath=function(e){return this["with"](void 0,void 0,e,void 0,void 0)},e.prototype.withQuery=function(e){return this["with"](void 0,void 0,void 0,e,void 0)},e.prototype.withFragment=function(e){return this["with"](void 0,void 0,void 0,void 0,e)},e.parse=function(t){var n=e._parse(t);return n=n["with"](void 0,decodeURIComponent(n.authority),decodeURIComponent(n.path),decodeURIComponent(n.query),decodeURIComponent(n.fragment))},e.file=function(t){t=t.replace(/\\/g,"/"),t=t.replace(/%/g,"%25"),t=t.replace(/#/g,"%23"),t=t.replace(/\?/g,"%3F"),t=e._driveLetter.test(t)?"/"+t:t;var n=e._parse(t);if(n.scheme||n.fragment||n.query)throw new Error;return n=n["with"]("file",void 0,decodeURIComponent(n.path),void 0,void 0)},e._parse=function(t){var n=new e,r=e._regexp.exec(t);return r&&(n._scheme=r[2]||n._scheme,n._authority=r[4]||n._authority,n._path=r[5]||n._path,n._query=r[7]||n._query,n._fragment=r[9]||n._fragment),e._validate(n),n},e.create=function(t,n,r,o,i){return(new e)["with"](t,n,r,o,i)},e._validate=function(e){if(e.authority&&e.path&&"/"!==e.path[0])throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character');if(!e.authority&&0===e.path.indexOf("//"))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')},e.prototype.toString=function(){if(!this._formatted){var t=[];if(this._scheme&&(t.push(this._scheme),t.push(":")),(this._authority||"file"===this._scheme)&&t.push("//"),this._authority){var n,r=this._authority;r=r.toLowerCase(),n=r.indexOf(":"),-1===n?t.push(o(r)):(t.push(o(r.substr(0,n))),t.push(r.substr(n)))}if(this._path){var i,s=this._path;e._driveLetterPath.test(s)?s="/"+s[1].toLowerCase()+s.substr(2):e._driveLetter.test(s)&&(s=s[0].toLowerCase()+s.substr(1)),i=s.split("/");for(var a=0,u=i.length;u>a;a++)i[a]=o(i[a]);t.push(i.join("/"))}if(this._query){var c=/https?/i.test(this.scheme)?encodeURI:o;t.push("?"),t.push(c(this._query))}this._fragment&&(t.push("#"),t.push(o(this._fragment))),this._formatted=t.join("")}return this._formatted},e.prototype.toJSON=function(){return this.toString()},e.prototype._toSerialized=function(){return{$isURI:!0,_scheme:this._scheme,_authority:this._authority,_path:this._path,_query:this._query,_fragment:this._fragment,_fsPath:this._fsPath,_formatted:this._formatted}},e._fromSerialized=function(t){var n=new e;return n._scheme=t._scheme,n._authority=t._authority,n._path=t._path,n._query=t._query,n._fragment=t._fragment,n._fsPath=t._fsPath,n._formatted=t._formatted,n},e.isURI=function(t){return t instanceof e?!0:t?"string"!=typeof t.scheme?!1:"string"!=typeof t.authority?!1:"string"!=typeof t.fsPath?!1:"string"!=typeof t.query?!1:"string"!=typeof t.fragment?!1:"function"!=typeof t["with"]?!1:"function"!=typeof t.withScheme?!1:"function"!=typeof t.withAuthority?!1:"function"!=typeof t.withPath?!1:"function"!=typeof t.withQuery?!1:"function"!=typeof t.withFragment?!1:"function"!=typeof t.toString?!1:"function"!=typeof t.toJSON?!1:!0:!1},e._empty="",e._regexp=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,e._driveLetterPath=/^\/[a-zA-z]:/,e._driveLetter=/^[a-zA-z]:/,e}();Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i,n.registerMarshallingContribution({canSerialize:function(e){return i.isURI(e)},serialize:function(e,t){return e._toSerialized()},canDeserialize:function(e){return e.$isURI},deserialize:function(e,t){return i._fromSerialized(e)}})}),define("vs/editor/common/config/defaultConfig",["require","exports"],function(e,t){var n=function(){function e(){this.editor={lineNumbers:!0,selectOnLineNumbers:!0,lineNumbersMinChars:5,glyphMargin:!1,lineDecorationsWidth:10,revealHorizontalRightPadding:30,roundedSelection:!0,theme:"vs",readOnly:!1,scrollbar:{verticalScrollbarSize:14,horizontal:"auto",useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1},overviewRulerLanes:2,hideCursorInOverviewRuler:!1,scrollBeyondLastLine:!0,automaticLayout:!1,wrappingColumn:300,wrappingIndent:"same",wordWrapBreakBeforeCharacters:"{([+",wordWrapBreakAfterCharacters:" 	})]?|&,;",wordWrapBreakObtrusiveCharacters:".",tabFocusMode:!1,longLineBoundary:300,forcedTokenizationBoundary:1e3,hover:!0,contextmenu:!0,mouseWheelScrollSensitivity:1,quickSuggestions:!0,quickSuggestionsDelay:10,iconsInSuggestions:!0,autoClosingBrackets:!0,formatOnType:!1,suggestOnTriggerCharacters:!0,selectionHighlight:!0,outlineMarkers:!1,referenceInfos:!0,renderWhitespace:!1,tabSize:"auto",insertSpaces:"auto",fontFamily:"",fontSize:0,lineHeight:0}}return e}();t.DefaultConfig=new n}),define("vs/editor/common/core/arrays",["require","exports"],function(e,t){var n;!function(e){function t(e,t){for(var n,r=0,o=e.length-1;o>r;)n=r+Math.ceil((o-r)/2),e[n].startIndex>t?o=n-1:r=n;return r}e.findIndexInSegmentsArray=t}(n=t.Arrays||(t.Arrays={}))}),define("vs/editor/common/core/idGenerator",["require","exports"],function(e,t){var n=function(){function e(e){this._prefix=e,this._lastId=0}return e.prototype.generate=function(){return this._prefix+ ++this._lastId},e}();t.IdGenerator=n}),define("vs/editor/common/core/position",["require","exports"],function(e,t){var n=function(){function e(e,t){this.lineNumber=e,this.column=t}return e.prototype.equals=function(e){return!!e&&this.lineNumber===e.lineNumber&&this.column===e.column},e.prototype.isBefore=function(e){return this.lineNumber<e.lineNumber?!0:e.lineNumber<this.lineNumber?!1:this.column<e.column},e.prototype.isBeforeOrEqual=function(e){return this.lineNumber<e.lineNumber?!0:e.lineNumber<this.lineNumber?!1:this.column<=e.column},e.prototype.clone=function(){return new e(this.lineNumber,this.column)},e.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},e.lift=function(t){return new e(t.lineNumber,t.column)},e.isIPosition=function(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column},e.asEmptyRange=function(e){return{startLineNumber:e.lineNumber,startColumn:e.column,endLineNumber:e.lineNumber,endColumn:e.column}},e.startPosition=function(e){return{lineNumber:e.startLineNumber,column:e.startColumn}},e.endPosition=function(e){return{lineNumber:e.endLineNumber,column:e.endColumn}},e}();t.Position=n}),define("vs/editor/common/core/range",["require","exports","vs/editor/common/core/position"],function(e,t,n){var r=function(){function e(e,t,n,r){e>n||e===n&&t>r?(this.startLineNumber=n,this.startColumn=r,this.endLineNumber=e,this.endColumn=t):(this.startLineNumber=e,this.startColumn=t,this.endLineNumber=n,this.endColumn=r)}return e.prototype.isEmpty=function(){return e.isEmpty(this)},e.prototype.containsPosition=function(t){return e.containsPosition(this,t)},e.prototype.containsRange=function(t){return e.containsRange(this,t)},e.prototype.plusRange=function(t){return e.plusRange(this,t)},e.prototype.intersectRanges=function(t){return e.intersectRanges(this,t)},e.prototype.equalsRange=function(t){return e.equalsRange(this,t)},e.prototype.getEndPosition=function(){return new n.Position(this.endLineNumber,this.endColumn)},e.prototype.getStartPosition=function(){return new n.Position(this.startLineNumber,this.startColumn)},e.prototype.cloneRange=function(){return new e(this.startLineNumber,this.startColumn,this.endLineNumber,this.endColumn)},e.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},e.prototype.setEndPosition=function(t,n){return new e(this.startLineNumber,this.startColumn,t,n)},e.prototype.setStartPosition=function(t,n){return new e(t,n,this.endLineNumber,this.endColumn)},e.prototype.collapseToStart=function(){return new e(this.startLineNumber,this.startColumn,this.startLineNumber,this.startColumn)},e.lift=function(t){return t?new e(t.startLineNumber,t.startColumn,t.endLineNumber,t.endColumn):null},e.isIRange=function(e){return e&&"number"==typeof e.startLineNumber&&"number"==typeof e.startColumn&&"number"==typeof e.endLineNumber&&"number"==typeof e.endColumn},e.isEmpty=function(e){return e.startLineNumber===e.endLineNumber&&e.startColumn===e.endColumn},e.containsPosition=function(e,t){return t.lineNumber<e.startLineNumber||t.lineNumber>e.endLineNumber?!1:t.lineNumber===e.startLineNumber&&t.column<e.startColumn?!1:t.lineNumber===e.endLineNumber&&t.column>e.endColumn?!1:!0},e.containsRange=function(e,t){return t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber?!1:t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber?!1:t.startLineNumber===e.startLineNumber&&t.startColumn<e.startColumn?!1:t.endLineNumber===e.endLineNumber&&t.endColumn>e.endColumn?!1:!0},e.areIntersectingOrTouching=function(e,t){return e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<t.startColumn?!1:t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<e.startColumn?!1:!0},e.intersectRanges=function(t,n){var r=t.startLineNumber,o=t.startColumn,i=t.endLineNumber,s=t.endColumn,a=n.startLineNumber,u=n.startColumn,c=n.endLineNumber,l=n.endColumn;return a>r?(r=a,o=u):r===a&&(o=Math.max(o,u)),i>c?(i=c,s=l):i===c&&(s=Math.min(s,l)),r>i?null:r===i&&o>s?null:new e(r,o,i,s)},e.plusRange=function(t,n){var r,o,i,s;return n.startLineNumber<t.startLineNumber?(r=n.startLineNumber,o=n.startColumn):n.startLineNumber===t.startLineNumber?(r=n.startLineNumber,o=Math.min(n.startColumn,t.startColumn)):(r=t.startLineNumber,o=t.startColumn),n.endLineNumber>t.endLineNumber?(i=n.endLineNumber,s=n.endColumn):n.endLineNumber===t.endLineNumber?(i=n.endLineNumber,s=Math.max(n.endColumn,t.endColumn)):(i=t.endLineNumber,s=t.endColumn),new e(r,o,i,s)},e.equalsRange=function(e,t){return!!e&&!!t&&e.startLineNumber===t.startLineNumber&&e.startColumn===t.startColumn&&e.endLineNumber===t.endLineNumber&&e.endColumn===t.endColumn},e.compareRangesUsingStarts=function(e,t){return e.startLineNumber===t.startLineNumber?e.startColumn===t.startColumn?e.endLineNumber===t.endLineNumber?e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber:e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber},e.compareRangesUsingEnds=function(e,t){return e.endLineNumber===t.endLineNumber?e.endColumn===t.endColumn?e.startLineNumber===t.startLineNumber?e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber:e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber},e.spansMultipleLines=function(e){return e.endLineNumber>e.startLineNumber},e.hashCode=function(e){return 17*e.startLineNumber+23*e.startColumn+29*e.endLineNumber+37*e.endColumn},e.collapseToStart=function(e){return{startLineNumber:e.startLineNumber,startColumn:e.startColumn,endLineNumber:e.startLineNumber,endColumn:e.startColumn}},e}();t.Range=r}),define("vs/editor/common/modes",["require","exports"],function(e,t){function n(e){return null===e||"object"!=typeof e?!1:"string"!=typeof e.label||"string"!=typeof e.codeSnippet||"string"!=typeof e.type?!1:e.highlights&&!Array.isArray(e.highlights)?!1:e.typeLabel&&"string"!=typeof e.typeLabel?!1:e.documentationLabel&&"string"!=typeof e.documentationLabel?!1:!0}!function(e){e[e.None=0]="None",e[e.Open=1]="Open",e[e.Close=-1]="Close"}(t.Bracket||(t.Bracket={}));t.Bracket;t.isISuggestion=n,function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"}(t.IndentAction||(t.IndentAction={}));t.IndentAction}),define("vs/editor/common/modes/abstractState",["require","exports"],function(e,t){var n=function(){function e(e,t){void 0===t&&(t=null),this.mode=e,this.stateData=t}return e.prototype.getMode=function(){return this.mode},e.prototype.clone=function(){var e=this.makeClone();return e.initializeFrom(this),e},e.prototype.makeClone=function(){throw new Error("Abstract Method")},e.prototype.initializeFrom=function(e){this.stateData=null!==e.stateData?e.stateData.clone():null},e.prototype.getStateData=function(){return this.stateData},e.prototype.setStateData=function(e){this.stateData=e},e.prototype.equals=function(t){return null===t||this.mode!==t.getMode()?!1:t instanceof e?e.safeEquals(this.stateData,t.stateData):!1},e.prototype.tokenize=function(e){throw new Error("Abstract Method")},e.safeEquals=function(e,t){return null===e&&null===t?!0:null===e||null===t?!1:e.equals(t)},e.safeClone=function(e){
return e?e.clone():null},e}();t.AbstractState=n}),define("vs/editor/common/modes/lineStream",["require","exports"],function(e,t){var n=function(){function e(e){this._source=e,this.sourceLength=e.length,this._pos=0,this.whitespace="	  ",this.whitespaceArr=this.stringToArray(this.whitespace),this.separators="",this.separatorsArr=this.stringToArray(this.separators),this.tokenStart=-1,this.tokenEnd=-1}return e.prototype.stringToArray=function(t){return e.STRING_TO_ARRAY_CACHE.hasOwnProperty(t)||(e.STRING_TO_ARRAY_CACHE[t]=this.actualStringToArray(t)),e.STRING_TO_ARRAY_CACHE[t]},e.prototype.actualStringToArray=function(e){for(var t=0,n=0;n<e.length;n++)t=e.charCodeAt(n);var r=[];for(n=0;t>n;n++)r[n]=!1;for(n=0;n<e.length;n++)r[e.charCodeAt(n)]=!0;return r},e.prototype.pos=function(){return this._pos},e.prototype.eos=function(){return this._pos>=this.sourceLength},e.prototype.peek=function(){if(this._pos>=this.sourceLength)throw new Error("Stream is at the end");return this._source[this._pos]},e.prototype.next=function(){if(this._pos>=this.sourceLength)throw new Error("Stream is at the end");return this.tokenStart=-1,this.tokenEnd=-1,this._source[this._pos++]},e.prototype.next2=function(){if(this._pos>=this.sourceLength)throw new Error("Stream is at the end");this.tokenStart=-1,this.tokenEnd=-1,this._pos++},e.prototype.advance=function(e){if(0===e)return"";var t=this._pos;return this._pos+=e,this.tokenStart=-1,this.tokenEnd=-1,this._source.substring(t,this._pos)},e.prototype._advance2=function(e){return 0===e?e:(this._pos+=e,this.tokenStart=-1,this.tokenEnd=-1,e)},e.prototype.advanceToEOS=function(){var e=this._pos;return this._pos=this.sourceLength,this.resetPeekedToken(),this._source.substring(e,this._pos)},e.prototype.goBack=function(e){this._pos-=e,this.resetPeekedToken()},e.prototype.createPeeker=function(e){var t=this;if(e instanceof RegExp)return function(){var n=e.exec(t._source.substr(t._pos));if(null===n)return 0;if(0!==n.index)throw new Error('Regular expression must begin with the character "^"');return n[0].length};if((e instanceof String||"string"==typeof e)&&e)return function(){for(var n=e.length,r=t._pos+n<=t.sourceLength,o=0;r&&n>o;o++)r=t._source.charCodeAt(t._pos+o)===e.charCodeAt(o);return r?n:0};throw new Error("Condition must be either a regular expression, function or a non-empty string")},e.prototype._advanceIfStringCaseInsensitive=function(e){var t,n=this._pos,r=this._source,o=e.length;if(1>o||n+o>this.sourceLength)return 0;for(t=0;o>t;t++)if(r.charAt(n+t).toLowerCase()!==e.charAt(t).toLowerCase())return 0;return o},e.prototype.advanceIfStringCaseInsensitive=function(e){return this.advance(this._advanceIfStringCaseInsensitive(e))},e.prototype.advanceIfStringCaseInsensitive2=function(e){return this._advance2(this._advanceIfStringCaseInsensitive(e))},e.prototype._advanceIfString=function(e){var t,n=this._pos,r=this._source,o=e.length;if(1>o||n+o>this.sourceLength)return 0;for(t=0;o>t;t++)if(r.charCodeAt(n+t)!==e.charCodeAt(t))return 0;return o},e.prototype.advanceIfString=function(e){return this.advance(this._advanceIfString(e))},e.prototype.advanceIfString2=function(e){return this._advance2(this._advanceIfString(e))},e.prototype._advanceIfCharCode=function(e){return this._pos<this.sourceLength&&this._source.charCodeAt(this._pos)===e?1:0},e.prototype.advanceIfCharCode=function(e){return this.advance(this._advanceIfCharCode(e))},e.prototype.advanceIfCharCode2=function(e){return this._advance2(this._advanceIfCharCode(e))},e.prototype._advanceIfRegExp=function(e){return this._pos>=this.sourceLength?0:e.test(this._source.substr(this._pos))?RegExp.lastMatch.length:0},e.prototype.advanceIfRegExp=function(e){return this.advance(this._advanceIfRegExp(e))},e.prototype.advanceIfRegExp2=function(e){return this._advance2(this._advanceIfRegExp(e))},e.prototype.advanceLoop=function(e,t,n){if(this.eos())return"";var r=this.createPeeker(e),o=this._pos,i=0,s=null;for(s=t?function(e){return e>0}:function(e){return 0===e};!this.eos()&&s(i=r());)i>0?this.advance(i):this.next();return n&&!this.eos()&&this.advance(i),this._source.substring(o,this._pos)},e.prototype.advanceWhile=function(e){return this.advanceLoop(e,!0,!1)},e.prototype.advanceUntil=function(e,t){return this.advanceLoop(e,!1,t)},e.prototype._advanceUntilString=function(e,t){if(this.eos()||0===e.length)return 0;var n=this._pos,r=this._source.indexOf(e,n);return-1===r?this.sourceLength-n:t?r+e.length-n:r-n},e.prototype.advanceUntilString=function(e,t){return this.advance(this._advanceUntilString(e,t))},e.prototype.advanceUntilString2=function(e,t){return this._advance2(this._advanceUntilString(e,t))},e.prototype.resetPeekedToken=function(){this.tokenStart=-1,this.tokenEnd=-1},e.prototype.setTokenRules=function(e,t){(this.separators!==e||this.whitespace!==t)&&(this.separators=e,this.separatorsArr=this.stringToArray(this.separators),this.whitespace=t,this.whitespaceArr=this.stringToArray(this.whitespace),this.resetPeekedToken())},e.prototype.peekToken=function(){if(-1!==this.tokenStart)return this._source.substring(this.tokenStart,this.tokenEnd);var e=this._source,t=this.sourceLength,n=this.whitespaceArr,r=this.separatorsArr,o=this._pos;if(o>=t)throw new Error("Stream is at the end");for(;n[e.charCodeAt(o)]&&t>o;)o++;var i=o;if(r[e.charCodeAt(i)]&&t>i)i++;else for(;!r[e.charCodeAt(i)]&&!n[e.charCodeAt(i)]&&t>i;)i++;return this.tokenStart=o,this.tokenEnd=i,e.substring(o,i)},e.prototype.nextToken=function(){if(this._pos>=this.sourceLength)throw new Error("Stream is at the end");var e;return e=-1===this.tokenStart?this.peekToken():this._source.substring(this.tokenStart,this.tokenEnd),this._pos=this.tokenEnd,this.tokenStart=-1,this.tokenEnd=-1,e},e.prototype.peekWhitespace=function(){for(var e=this._source,t=this.sourceLength,n=this.whitespaceArr,r=this._pos;n[e.charCodeAt(r)]&&t>r;)r++;return e.substring(this._pos,r)},e.prototype._skipWhitespace=function(){for(var e=this._source,t=this.sourceLength,n=this.whitespaceArr,r=this._pos,o=this._pos;n[e.charCodeAt(o)]&&t>o;)o++;return o-r},e.prototype.skipWhitespace=function(){return this.advance(this._skipWhitespace())},e.prototype.skipWhitespace2=function(){return this._advance2(this._skipWhitespace())},e.STRING_TO_ARRAY_CACHE={},e}();t.LineStream=n}),define("vs/editor/common/modes/linkComputer",["require","exports"],function(e,t){function n(e){return e&&"function"==typeof e.getLineCount&&"function"==typeof e.getLineContent?c.computeLinks(e):[]}var r=[],o=1,i=9,s=10;r[1]={h:2,H:2},r[2]={t:3,T:3},r[3]={t:4,T:4},r[4]={p:5,P:5},r[5]={s:6,S:6,":":7},r[6]={":":7},r[7]={"/":8},r[8]={"/":9};var a;!function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"}(a||(a={}));var u=function(){var e=" 	<>)]}'\"",t=".,;",n=null,r=function(e){for(var t=0,n=0,r=e.length;r>n;n++)t=Math.max(t,e.charCodeAt(n));return t},o=function(e,t){for(var r=0,o=e.length;o>r;r++)n[e.charCodeAt(r)]=t};return function(){if(null===n){var i=Math.max(r(e),r(t));n=[];for(var s=0;i>s;s++)n[s]=a.None;o(e,a.ForceTermination),o(t,a.CannotEndIn)}return n}}(),c=function(){function e(){}return e._createLink=function(e,t,n,r){return{range:{startLineNumber:t,startColumn:n+1,endLineNumber:t,endColumn:r+1},url:e.substring(n,r)}},e.computeLinks=function(t){var n,c,l,d,h,p,f,m,g,v,_,y,k=[],b=u(),E=b.length;for(n=1,c=t.getLineCount();c>=n;n++){for(l=t.getLineContent(n),d=0,p=l.length,f=0,m=o;p>d;){if(g=l.charAt(d),v=l.charCodeAt(d),y=!1,m===s){if(_=E>v?b[v]:a.None,_===a.ForceTermination){h=d-1;do{if(v=l.charCodeAt(h),_=E>v?b[v]:a.None,_!==a.CannotEndIn)break;h--}while(h>f);k.push(e._createLink(l,n,f,h+1)),y=!0}}else m===i?(_=E>v?b[v]:a.None,_===a.ForceTermination?y=!0:m=s):r[m].hasOwnProperty(g)?m=r[m][g]:y=!0;y&&(m=o,f=d+1),d++}m===s&&k.push(e._createLink(l,n,f,p))}return k},e}();t.computeLinks=n}),define("vs/editor/common/modes/monarch/monarchCommon",["require","exports"],function(e,t){function n(e){return e?!1:!0}function r(e,t){return e.ignoreCase&&t?t.toLowerCase():t}function o(e){return e.replace(/[&<>'"_]/g,"-")}function i(e,t){console.log(e.name+": "+t)}function s(e,t){throw new Error(e.name+": "+t)}function a(e,t,o,i,s){var a=/\$((\$)|(#)|(\d\d?)|[sS](\d\d?)|@(\w+))/g,u=null;return t.replace(a,function(t,a,c,l,d,h,p,f,m){return n(c)?n(l)?!n(d)&&d<i.length?r(e,i[d]):!n(p)&&e&&"string"==typeof e[p]?e[p]:(null===u&&(u=s.split("."),u.unshift(s)),!n(h)&&h<u.length?r(e,u[h]):""):r(e,o):"$"})}function u(e,t){for(;t&&t.length>0;){var n=e.tokenizer[t];if(n)return n;var r=t.lastIndexOf(".");t=0>r?null:t.substr(0,r)}return null}function c(e,t){for(;t&&t.length>0;){var n=e.stateNames[t];if(n)return!0;var r=t.lastIndexOf(".");t=0>r?null:t.substr(0,r)}return!1}t.empty=n,t.fixCase=r,t.sanitize=o,t.log=i,t.throwError=s,t.substituteMatches=a,t.findRules=u,t.stateExists=c}),define("vs/editor/common/modes/monarch/monarchCompile",["require","exports","vs/editor/common/modes/monarch/monarchCommon","vs/editor/common/modes","vs/base/common/objects"],function(e,t,n,r,o){function i(e,t){if(!t)return!1;if(!Array.isArray(t))return!1;var n;for(n in t)if(t.hasOwnProperty(n)&&!e(t[n]))return!1;return!0}function s(e,t,n){return"boolean"==typeof e?e:(n&&(e||void 0===t)&&n(),void 0===t?null:t)}function a(e,t,n){return"string"==typeof e?e:(n&&(e||void 0===t)&&n(),void 0===t?null:t)}function u(e,t){if("string"!=typeof t)return null;for(var r=0;t.indexOf("@")>=0&&5>r;)r++,t=t.replace(/@(\w+)/g,function(r,o){var i="";return"string"==typeof e[o]?i=e[o]:e[o]&&e[o]instanceof RegExp?i=e[o].source:void 0===e[o]?n.throwError(e,"language definition does not contain attribute '"+o+"', used at: "+t):n.throwError(e,"attribute reference '"+o+"' must be a string, used at: "+t),n.empty(i)?"":"(?:"+i+")"});return new RegExp(t,e.ignoreCase?"i":"")}function c(e,t,n,r){if(0>r)return e;if(r<t.length)return t[r];if(r>=100){r-=100;var o=n.split(".");if(o.unshift(n),r<o.length)return o[r]}return null}function l(e,t,r,s){var a=-1,l=r,d=r.match(/^\$(([sS]?)(\d\d?)|#)(.*)$/);d&&(d[3]&&(a=parseInt(d[3]),d[2]&&(a+=100)),l=d[4]);var h="~",p=l;l&&0!==l.length?/^\w*$/.test(p)?h="==":(d=l.match(/^(@|!@|~|!~|==|!=)(.*)$/),d&&(h=d[1],p=d[2])):(h="!=",p="");var f;if("~"!==h&&"!~"!==h||!/^(\w|\|)*$/.test(p))if("@"===h||"!@"===h){var m=e[p];m||n.throwError(e,"the @ match target '"+p+"' is not defined, in rule: "+t),i(function(e){return"string"==typeof e},m)||n.throwError(e,"the @ match target '"+p+"' must be an array of strings, in rule: "+t);var g=o.createKeywordMatcher(m,e.ignoreCase);f=function(e){return"@"===h?g(e):!g(e)}}else if("~"===h||"!~"===h)if(p.indexOf("$")<0){var v=u(e,"^"+p+"$");f=function(e){return"~"===h?v.test(e):!v.test(e)}}else f=function(t,r,o,i){var s=u(e,"^"+n.substituteMatches(e,p,r,o,i)+"$");return s.test(t)};else if(p.indexOf("$")<0){var _=n.fixCase(e,p);f=function(e){return"=="===h?e===_:e!==_}}else{var _=n.fixCase(e,p);f=function(t,r,o,i,s){var a=n.substituteMatches(e,_,r,o,i);return"=="===h?t===a:t!==a}}else{var g=o.createKeywordMatcher(p.split("|"),e.ignoreCase);f=function(e){return"~"===h?g(e):!g(e)}}return-1===a?{name:r,value:s,test:function(e,t,n,r){return f(e,e,t,n,r)}}:{name:r,value:s,test:function(e,t,n,r){var o=c(e,t,n,a);return f(o?o:"",e,t,n,r)}}}function d(e,t,o){if(o){if("string"==typeof o)return o;if(o.token||""===o.token){if("string"!=typeof o.token)return n.throwError(e,"a 'token' attribute must be of type string, in rule: "+t),{token:""};var i={token:o.token};if(o.token.indexOf("$")>=0&&(i.tokenSubst=!0),"string"==typeof o.bracket&&("@open"===o.bracket?i.bracket=r.Bracket.Open:"@close"===o.bracket?i.bracket=r.Bracket.Close:n.throwError(e,"a 'bracket' attribute must be either '@open' or '@close', in rule: "+t)),o.next)if("string"!=typeof o.next)n.throwError(e,"the next state must be a string value in rule: "+t);else{var s=o.next;/^(@pop|@push|@popall)$/.test(s)||("@"===s[0]&&(s=s.substr(1)),s.indexOf("$")<0&&(n.stateExists(e,n.substituteMatches(e,s,"",[],""))||n.throwError(e,"the next state '"+o.next+"' is not defined in rule: "+t))),i.next=s}return"number"==typeof o.goBack&&(i.goBack=o.goBack),"string"==typeof o.switchTo&&(i.switchTo=o.switchTo),"string"==typeof o.log&&(i.log=o.log),"string"==typeof o.nextEmbedded&&(i.nextEmbedded=o.nextEmbedded,e.usesEmbedded=!0),i}if(Array.isArray(o)){var a,u=[];for(a in o)o.hasOwnProperty(a)&&(u[a]=d(e,t,o[a]));return{group:u}}if(o.cases){var c,h=[];for(c in o.cases)if(o.cases.hasOwnProperty(c)){var p=d(e,t,o.cases[c]);"@default"===c||"@"===c||""===c?h.push({test:null,value:p,name:c}):"@eos"===c?h.push({test:function(e,t,n,r){return r},value:p,name:c}):h.push(l(e,t,c,p))}var f=e.defaultToken;return{test:function(e,t,n,r){var o;for(o in h)if(h.hasOwnProperty(o)){var i=!h[o].test||h[o].test(e,t,n,r);if(i)return h[o].value}return f}}}return n.throwError(e,"an action must be a string, an object with a 'token' or 'cases' attribute, or an array of actions; in rule: "+t),""}return{token:""}}function h(e){function t(o,i,u){var c;for(c in u)if(u.hasOwnProperty(c)){var d=u[c],h=d.include;if(h)"string"!=typeof h&&n.throwError(r,"an 'include' attribute must be a string at: "+o),"@"===h[0]&&(h=h.substr(1)),e.tokenizer[h]||n.throwError(r,"include target '"+h+"' is not defined at: "+o),t(o+"."+h,i,e.tokenizer[h]);else{var f=new p(o);if(Array.isArray(d)&&d.length>=1&&d.length<=3)if(f.setRegex(l,d[0]),d.length>=3)if("string"==typeof d[1])f.setAction(l,{token:d[1],next:d[2]});else if("object"==typeof d[1]){var m=d[1];m.next=d[2],f.setAction(l,m)}else n.throwError(r,"a next state as the last element of a rule can only be given if the action is either an object or a string, at: "+o);else f.setAction(l,d[1]);else d.regex||n.throwError(r,"a rule must either be an array, or an object with a 'regex' or 'include' field at: "+o),d.name&&(f.name=a(d.name)),d.matchOnlyAtStart&&(f.matchOnlyAtLineStart=s(d.matchOnlyAtLineStart)),f.setRegex(l,d.regex),f.setAction(l,d.action);i.push(f)}}}if(!e||"object"!=typeof e)throw new Error("Monarch: expecting a language definition object");if("string"!=typeof e.name)throw new Error("Monarch: a language definition must include a string 'name' attribute");var r={};if(r.name=e.name,r.displayName=a(e.displayName,r.name),r.noThrow=!1,r.maxStack=100,r.start=a(e.start),r.ignoreCase=s(e.ignoreCase,!1),r.lineComment=a(e.lineComment,"//"),r.blockCommentStart=a(e.blockCommentStart,"/*"),r.blockCommentEnd=a(e.blockCommentEnd,"*/"),r.tokenPostfix=a(e.tokenPostfix,"."+r.name),r.defaultToken=a(e.defaultToken,"source",function(){n.throwError(r,"the 'defaultToken' must be a string")}),r.usesEmbedded=!1,r.wordDefinition=e.wordDefinition||void 0,!r.lineComment&&e.lineComments&&("string"==typeof e.lineComments?r.lineComment=e.lineComments:"string"==typeof e.lineComments[0]&&(r.lineComment=e.lineComments[0])),r.suggestSupport={textualCompletions:!0,disableAutoTrigger:!1,triggerCharacters:[],snippets:[]},"undefined"!=typeof e.suggestSupport){var o=e.suggestSupport;if(Array.isArray(o.snippets))for(var i=o.snippets,u=0,c=i.length;c>u;u++)"string"==typeof i[u]?r.suggestSupport.snippets.push({type:"snippet",label:i[u],codeSnippet:i[u]}):r.suggestSupport.snippets.push(i[u]);Array.isArray(o.triggerCharacters)&&(r.suggestSupport.triggerCharacters=o.triggerCharacters),"undefined"!=typeof o.textualCompletions&&(r.suggestSupport.textualCompletions=o.textualCompletions),"undefined"!=typeof o.disableAutoTrigger&&(r.suggestSupport.disableAutoTrigger=o.disableAutoTrigger)}var l=e;l.name=r.name,l.displayName=r.displayName,l.ignoreCase=r.ignoreCase,l.noThrow=r.noThrow,l.usesEmbedded=r.usesEmbedded,l.stateNames=e.tokenizer,l.defaultToken=r.defaultToken,e.tokenizer&&"object"==typeof e.tokenizer||n.throwError(r,"a language definition must define the 'tokenizer' attribute as an object"),r.tokenizer=[];var d;for(d in e.tokenizer)if(e.tokenizer.hasOwnProperty(d)){r.start||(r.start=d);var h=e.tokenizer[d];r.tokenizer[d]=new Array,t("tokenizer."+d,r.tokenizer[d],h)}r.usesEmbedded=l.usesEmbedded,e.brackets?Array.isArray(e.brackets)||n.throwError(r,"the 'brackets' attribute must be defined as an array"):e.brackets=[{open:"{",close:"}",token:"delimiter.curly"},{open:"[",close:"]",token:"delimiter.square"},{open:"(",close:")",token:"delimiter.parenthesis"},{open:"<",close:">",token:"delimiter.angle"}];var f=[];for(var m in e.brackets)if(e.brackets.hasOwnProperty(m)){var g=e.brackets[m];g&&Array.isArray(g)&&3===g.length&&(g={token:g[2],open:g[0],close:g[1]}),g.open===g.close&&n.throwError(r,"open and close brackets in a 'brackets' attribute must be different: "+g.open+"\n hint: use the 'bracket' attribute if matching on equal brackets is required."),"string"==typeof g.open&&"string"==typeof g.token?f.push({token:a(g.token)+r.tokenPostfix,open:n.fixCase(r,a(g.open)),close:n.fixCase(r,a(g.close))}):n.throwError(r,"every element in the 'brackets' array must be a '{open,close,token}' object or array")}r.brackets=f;var v;if(e.autoClosingPairs?(Array.isArray(e.autoClosingPairs)||n.throwError(r,"the 'autoClosingPairs' attribute must be an array of string pairs (as arrays)"),v=e.autoClosingPairs.slice(0)):v=[['"','"'],["'","'"],["@brackets"]],r.autoClosingPairs=[],v)for(var _ in v)if(v.hasOwnProperty(_)){var y,k=v[_];if("@brackets"===k||"@brackets"===k[0]){var b;for(b in f)f.hasOwnProperty(b)&&f[b].open&&1===f[b].open.length&&f[b].close&&1===f[b].close.length&&(y={open:f[b].open,close:f[b].close,notIn:["string","comment"]},r.autoClosingPairs.push(y))}else Array.isArray(k)&&2===k.length&&"string"==typeof k[0]&&1===k[0].length&&"string"==typeof k[1]&&1===k[1].length?(y={open:n.fixCase(r,k[0]),close:n.fixCase(r,k[1]),notIn:["string","comment"]},r.autoClosingPairs.push(y)):"string"==typeof k.open&&1===k.open.length&&"string"==typeof k.close&&1===k.close.length?(y={open:n.fixCase(r,k.open[0]),close:n.fixCase(r,k.close[0]),notIn:["string","comment"]},r.autoClosingPairs.push(y)):n.throwError(r,"every element in an 'autoClosingPairs' array must be a pair of 1 character strings, or a '@brackets' directive")}var E=[];if(e.enhancedBrackets){Array.isArray(e.enhancedBrackets)||n.throwError(r,"the 'enhancedBrackets' attribute must be defined as an array");for(var m in e.enhancedBrackets)if(e.enhancedBrackets.hasOwnProperty(m)){var g=e.enhancedBrackets[m];g.hasOwnProperty("openTrigger")&&"string"!=typeof g.openTrigger&&n.throwError(r,"openTrigger in the 'enhancedBrackets' array must be a string"),!g.hasOwnProperty("open")||g.open instanceof RegExp||n.throwError(r,"open in the 'enhancedBrackets' array must be a regex"),g.hasOwnProperty("closeComplete")&&"string"!=typeof g.closeComplete&&n.throwError(r,"closeComplete in the 'enhancedBrackets' array must be a string"),g.hasOwnProperty("matchCase")&&"boolean"!=typeof g.matchCase&&n.throwError(r,"matchCase in the 'enhancedBrackets' array must be a boolean"),g.hasOwnProperty("closeTrigger")&&"string"!=typeof g.closeTrigger&&n.throwError(r,"closeTrigger in the 'enhancedBrackets' array must be a string"),!g.hasOwnProperty("close")||g.close instanceof RegExp||n.throwError(r,"close in the 'enhancedBrackets' array must be a regex"),g.hasOwnProperty("tokenType")&&("string"!=typeof g.tokenType?n.throwError(r,"tokenType in the 'enhancedBrackets' array must be a string"):g.tokenType+=r.tokenPostfix),E.push(g)}}r.enhancedBrackets=E;for(var T=[],u=0;u<f.length;++u)T.push({tokenType:f[u].token,open:f[u].open,close:f[u].close,isElectric:!0});return r.standardBrackets=T,r.outdentTriggers=a(e.outdentTriggers,""),r.noThrow=!0,r}var p=function(){function e(e){this.regex=new RegExp(""),this.action={token:""},this.matchOnlyAtLineStart=!1,this.name="",this.name=e}return e.prototype.setRegex=function(e,t){var r;"string"==typeof t?r=t:t instanceof RegExp?r=t.source:n.throwError(e,"rules must start with a match string or regular expression: "+this.name),this.matchOnlyAtLineStart=r.length>0&&"^"===r[0],this.name=this.name+": "+r,this.regex=u(e,"^(?:"+(this.matchOnlyAtLineStart?r.substr(1):r)+")")},e.prototype.setAction=function(e,t){this.action=d(e,this.name,t)},e}();t.compile=h}),define("vs/editor/common/modes/nullMode",["require","exports","vs/editor/common/modes"],function(e,t,n){function r(e,t,r,o,i){void 0===o&&(o=0);var s=[{startIndex:o,type:"",bracket:n.Bracket.None}],a=[{startIndex:o,mode:e}];return{tokens:s,actualStopOffset:o+t.length,endState:r,modeTransitions:a}}var o=function(){function e(e,t){this.mode=e,this.stateData=t}return e.prototype.clone=function(){var t=this.stateData?this.stateData.clone():null;return new e(this.mode,t)},e.prototype.equals=function(e){if(this.mode!==e.getMode())return!1;var t=e.getStateData();return this.stateData||t?this.stateData&&t?this.stateData.equals(t):!1:!0},e.prototype.getMode=function(){return this.mode},e.prototype.tokenize=function(e){return e.advanceToEOS(),{type:""}},e.prototype.getStateData=function(){return this.stateData},e.prototype.setStateData=function(e){this.stateData=e},e}();t.NullState=o;var i=function(){function e(){this.tokenTypeClassificationSupport=this}return e.createWordRegExp=function(e){void 0===e&&(e="");for(var t="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?",n="(-?\\d*\\.\\d\\w*)|([^",r=0;r<t.length;r++)e.indexOf(t[r])>=0||(n+="\\"+t[r]);return n+="\\s]+)",new RegExp(n,"g")},e.prototype.getId=function(){return e.ID},e.prototype.getWordDefinition=function(){return e.DEFAULT_WORD_REGEXP},e.DEFAULT_WORD_REGEXP=e.createWordRegExp(),e.ID="vs.editor.modes.nullMode",e}();t.NullMode=i,t.nullTokenize=r}),define("vs/editor/common/viewModel/prefixSumComputer",["require","exports"],function(e,t){var n=function(){function e(e){this.values=e,this.prefixSum=[];for(var t=0,n=this.values.length;n>t;t++)this.prefixSum[t]=0;this.prefixSumValidIndex=-1}return e.prototype.getCount=function(){return this.values.length},e.prototype.insertValue=function(e,t){this.values.splice(e,0,t),this.prefixSum.splice(e,0,0),e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1)},e.prototype.insertValues=function(t,n){0!==n.length&&(this.values=this.values.slice(0,t).concat(n).concat(this.values.slice(t)),this.prefixSum=this.prefixSum.slice(0,t).concat(e._zeroArray(n.length)).concat(this.prefixSum.slice(t)),t-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=t-1))},e._zeroArray=function(e){for(var t=new Array(e),n=0;e>n;n++)t[n]=0;return t},e.prototype.changeValue=function(e,t){this.values[e]!==t&&(this.values[e]=t,e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1))},e.prototype.removeValues=function(e,t){this.values.splice(e,t),this.prefixSum.splice(e,t),e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1)},e.prototype.getTotalValue=function(){return 0===this.values.length?0:this.getAccumulatedValue(this.values.length-1)},e.prototype.getAccumulatedValue=function(e){if(0>e)return 0;if(e<=this.prefixSumValidIndex)return this.prefixSum[e];var t=this.prefixSumValidIndex+1;0===t&&(this.prefixSum[0]=this.values[0],t++),e>=this.values.length&&(e=this.values.length-1);for(var n=t;e>=n;n++)this.prefixSum[n]=this.prefixSum[n-1]+this.values[n];return this.prefixSumValidIndex=Math.max(this.prefixSumValidIndex,e),this.prefixSum[e]},e.prototype.getIndexOf=function(e,t){for(var n,r,o,i=0,s=this.values.length-1;s>=i;)if(n=i+(s-i)/2|0,o=this.getAccumulatedValue(n),r=o-this.values[n],r>e)s=n-1;else{if(!(e>=o))break;i=n+1}t.index=n,t.remainder=e-r},e}();t.PrefixSumComputer=n}),define("vs/nls!vs/base/common/json",["vs/nls","vs/nls!vs/editor/common/worker/editorWorkerServer"],function(e,t){return e.create("vs/base/common/json",t)}),define("vs/base/common/json",["require","exports","vs/nls!vs/base/common/json"],function(e,t,n){function r(e,t){function n(t,n){for(var r=0,o=0;t>r||!n;){var i=e.charCodeAt(f);if(i>=h._0&&i<=h._9)o=16*o+i-h._0;else if(i>=h.A&&i<=h.F)o=16*o+i-h.A+10;else{if(!(i>=h.a&&i<=h.f))break;o=16*o+i-h.a+10}f++,r++}return t>r&&(o=-1),o}function r(){var t=f;if(e.charCodeAt(f)===h._0)f++;else for(f++;f<e.length&&s(e.charCodeAt(f));)f++;if(f<e.length&&e.charCodeAt(f)===h.dot){if(f++,!(f<e.length&&s(e.charCodeAt(f))))return y=l.UnexpectedEndOfNumber,e.substring(t,n);for(f++;f<e.length&&s(e.charCodeAt(f));)f++}var n=f;if(f<e.length&&(e.charCodeAt(f)===h.E||e.charCodeAt(f)===h.e))if(f++,(f<e.length&&e.charCodeAt(f)===h.plus||e.charCodeAt(f)===h.minus)&&f++,f<e.length&&s(e.charCodeAt(f))){for(f++;f<e.length&&s(e.charCodeAt(f));)f++;n=f}else y=l.UnexpectedEndOfNumber;return e.substring(t,n)}function a(){for(var t="",r=f;;){if(f>=m){t+=e.substring(r,f),y=l.UnexpectedEndOfString;break}var o=e.charCodeAt(f);if(o===h.doubleQuote){t+=e.substring(r,f),f++;break}if(o!==h.backslash){if(i(o)){t+=e.substring(r,f),y=l.UnexpectedEndOfString;break}f++}else{if(t+=e.substring(r,f),f++,f>=m){y=l.UnexpectedEndOfString;break}switch(o=e.charCodeAt(f++)){case h.doubleQuote:t+='"';break;case h.backslash:t+="\\";break;case h.slash:t+="/";break;case h.b:t+="\b";break;case h.f:t+="\f";break;case h.n:t+="\n";break;case h.r:t+="\r";break;case h.t:t+="	";break;case h.u:var o=n(4,!0);o>=0?t+=String.fromCharCode(o):y=l.InvalidUnicode;break;default:y=l.InvalidEscapeCharacter}r=f}}return t}function u(){if(g="",y=l.None,v=f,f>=m)return v=m,_=d.EOF;var t=e.charCodeAt(f);if(o(t)){do f++,g+=String.fromCharCode(t),t=e.charCodeAt(f);while(o(t));return _=d.Trivia}if(i(t))return f++,g+=String.fromCharCode(t),t===h.carriageReturn&&e.charCodeAt(f)===h.lineFeed&&(f++,g+="\n"),_=d.LineBreakTrivia;switch(t){case h.openBrace:return f++,_=d.OpenBraceToken;case h.closeBrace:return f++,_=d.CloseBraceToken;case h.openBracket:return f++,_=d.OpenBracketToken;case h.closeBracket:return f++,_=d.CloseBracketToken;case h.colon:return f++,_=d.ColonToken;case h.comma:return f++,_=d.CommaToken;case h.doubleQuote:return f++,g=a(),_=d.StringLiteral;case h.slash:var n=f-1;if(e.charCodeAt(f+1)===h.slash){for(f+=2;m>f&&!i(e.charCodeAt(f));)f++;return g=e.substring(n,f),_=d.LineCommentTrivia}if(e.charCodeAt(f+1)===h.asterisk){f+=2;for(var u=m-1,p=!1;u>f;){var k=e.charCodeAt(f);if(k===h.asterisk&&e.charCodeAt(f+1)===h.slash){f+=2,p=!0;break}f++}return p||(f++,y=l.UnexpectedEndOfComment),g=e.substring(n,f),_=d.BlockCommentTrivia}return g+=String.fromCharCode(t),f++,_=d.Unknown;case h.minus:if(g+=String.fromCharCode(t),f++,f===m||!s(e.charCodeAt(f)))return _=d.Unknown;case h._0:case h._1:case h._2:case h._3:case h._4:case h._5:case h._6:case h._7:case h._8:case h._9:return g+=r(),_=d.NumericLiteral;default:for(;m>f&&c(t);)f++,t=e.charCodeAt(f);if(v!==f){switch(g=e.substring(v,f)){case"true":return _=d.TrueKeyword;case"false":return _=d.FalseKeyword;case"null":return _=d.NullKeyword}return _=d.Unknown}return g+=String.fromCharCode(t),f++,_=d.Unknown}}function c(e){if(o(e)||i(e))return!1;switch(e){case h.closeBrace:case h.closeBracket:case h.openBrace:case h.openBracket:case h.doubleQuote:case h.colon:case h.comma:return!1}return!0}function p(){var e;do e=u();while(e>=d.LineCommentTrivia&&e<=d.Trivia);return e}void 0===t&&(t=!1);var f=0,m=e.length,g="",v=0,_=d.Unknown,y=l.None;return{getPosition:function(){return f},scan:t?p:u,getToken:function(){return _},getTokenValue:function(){return g},getTokenOffset:function(){return v},getTokenLength:function(){return f-v},getTokenError:function(){return y}}}function o(e){return e===h.space||e===h.tab||e===h.verticalTab||e===h.formFeed||e===h.nonBreakingSpace||e===h.ogham||e>=h.enQuad&&e<=h.zeroWidthSpace||e===h.narrowNoBreakSpace||e===h.mathematicalSpace||e===h.ideographicSpace||e===h.byteOrderMark}function i(e){return e===h.lineFeed||e===h.carriageReturn||e===h.lineSeparator||e===h.paragraphSeparator}function s(e){return e>=h._0&&e<=h._9}function a(e){return e>=h.a&&e<=h.z||e>=h.A&&e<=h.Z}function u(e,t){var n,o,i=r(e),s=[],a=0;do switch(o=i.getPosition(),n=i.scan()){case d.LineCommentTrivia:case d.BlockCommentTrivia:case d.EOF:a!==o&&s.push(e.substring(a,o)),void 0!==t&&s.push(i.getTokenValue().replace(/[^\r\n]/g,t)),a=i.getPosition()}while(n!==d.EOF);return s.join("")}function c(e,t){function o(){for(var e=f.scan();e===d.Unknown;)i(n.localize(0,null)),e=f.scan();return e}function i(e,n,r){if(void 0===n&&(n=[]),void 0===r&&(r=[]),t.push(e),n.length+r.length>0)for(var i=f.getToken();i!==d.EOF;){if(-1!==n.indexOf(i)){o();break}if(-1!==r.indexOf(i))break;i=o()}}function s(){if(f.getToken()!==d.StringLiteral)return p;var e=f.getTokenValue();return o(),e}function a(){var e;switch(f.getToken()){case d.NumericLiteral:try{e=JSON.parse(f.getTokenValue()),"number"!=typeof e&&(i(n.localize(1,null)),e=0)}catch(t){e=0}break;case d.NullKeyword:e=null;break;case d.TrueKeyword:e=!0;break;case d.FalseKeyword:e=!1;break;default:return p}return o(),e}function u(e){var t=s();if(t===p)return i(n.localize(2,null),[],[d.CloseBraceToken,d.CommaToken]),!1;if(f.getToken()===d.ColonToken){o();var r=h();r!==p?e[t]=r:i(n.localize(3,null),[],[d.CloseBraceToken,d.CommaToken])}else i(n.localize(4,null),[],[d.CloseBraceToken,d.CommaToken]);return!0}function c(){if(f.getToken()!==d.OpenBraceToken)return p;var e={};o();for(var t=!1;f.getToken()!==d.CloseBraceToken&&f.getToken()!==d.EOF;){f.getToken()===d.CommaToken?(t||i(n.localize(5,null),[],[]),o()):t&&i(n.localize(6,null),[],[]);var r=u(e);r||i(n.localize(7,null),[],[d.CloseBraceToken,d.CommaToken]),t=!0}return f.getToken()!==d.CloseBraceToken?i(n.localize(8,null),[d.CloseBraceToken],[]):o(),e}function l(){if(f.getToken()!==d.OpenBracketToken)return p;var e=[];o();for(var t=!1;f.getToken()!==d.CloseBracketToken&&f.getToken()!==d.EOF;){f.getToken()===d.CommaToken?(t||i(n.localize(9,null),[],[]),o()):t&&i(n.localize(10,null),[],[]);var r=h();r===p?i(n.localize(11,null),[],[d.CloseBracketToken,d.CommaToken]):e.push(r),t=!0}return f.getToken()!==d.CloseBracketToken?i(n.localize(12,null),[d.CloseBracketToken],[]):o(),e}function h(){var e=l();return e!==p?e:(e=c(),e!==p?e:(e=s(),e!==p?e:a()))}void 0===t&&(t=[]);var p=Object(),f=r(e,!0);o();var m=h();return m===p?void i(n.localize(13,null),[],[]):(f.getToken()!==d.EOF&&i(n.localize(14,null),[],[]),m)}!function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter"}(t.ScanError||(t.ScanError={}));var l=t.ScanError;!function(e){e[e.Unknown=0]="Unknown",e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.EOF=16]="EOF"}(t.SyntaxKind||(t.SyntaxKind={}));var d=t.SyntaxKind;t.createScanner=r,t.isLetter=a;var h;!function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",
e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"}(h||(h={})),t.stripComments=u,t.parse=c}),define("vs/nls!vs/base/common/severity",["vs/nls","vs/nls!vs/editor/common/worker/editorWorkerServer"],function(e,t){return e.create("vs/base/common/severity",t)}),define("vs/base/common/callbackList",["require","exports","vs/base/common/errors"],function(e,t,n){var r=function(){function e(){}return e.prototype.add=function(e,t,n){var r=this;void 0===t&&(t=null),this._callbacks||(this._callbacks=[],this._contexts=[]),this._callbacks.push(e),this._contexts.push(t),Array.isArray(n)&&n.push({dispose:function(){return r.remove(e,t)}})},e.prototype.remove=function(e,t){if(void 0===t&&(t=null),this._callbacks){for(var n=!1,r=0,o=this._callbacks.length;o>r;r++)if(this._callbacks[r]===e){if(this._contexts[r]===t)return this._callbacks.splice(r,1),void this._contexts.splice(r,1);n=!0}if(n)throw new Error("When adding a listener with a context, you should remove it with the same context")}},e.prototype.invoke=function(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];if(this._callbacks){for(var r=[],o=this._callbacks.slice(0),i=this._contexts.slice(0),s=0,a=o.length;a>s;s++)try{r.push(o[s].apply(i[s],e))}catch(u){n.onUnexpectedError(u)}return r}},e.prototype.isEmpty=function(){return!this._callbacks||0===this._callbacks.length},e.prototype.dispose=function(){this._callbacks=void 0,this._contexts=void 0},e}();Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=r}),define("vs/base/common/event",["require","exports","vs/base/common/callbackList"],function(e,t,n){function r(e,t){return function(n,r,o){var i=e.addListener2(t,function(){n.apply(r,arguments)});return Array.isArray(o)&&o.push(i),i}}var o;!function(e){var t={dispose:function(){}};e.None=function(){return t}}(o||(o={})),Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=o;var i=function(){function e(e){this._options=e}return Object.defineProperty(e.prototype,"event",{get:function(){var t=this;return this._event||(this._event=function(r,o,i){t._callbacks||(t._callbacks=new n["default"]),t._options&&t._options.onFirstListenerAdd&&t._callbacks.isEmpty()&&t._options.onFirstListenerAdd(t),t._callbacks.add(r,o);var s;return s={dispose:function(){s.dispose=e._noop,t._disposed||(t._callbacks.remove(r,o),t._options&&t._options.onLastListenerRemove&&t._callbacks.isEmpty()&&t._options.onLastListenerRemove(t))}},Array.isArray(i)&&i.push(s),s}),this._event},enumerable:!0,configurable:!0}),e.prototype.fire=function(e){this._callbacks&&this._callbacks.invoke.call(this._callbacks,e)},e.prototype.dispose=function(){this._callbacks&&(this._callbacks.dispose(),this._callbacks=void 0,this._disposed=!0)},e._noop=function(){},e}();t.Emitter=i,t.fromEventEmitter=r}),define("vs/base/common/cancellation",["require","exports","vs/base/common/event"],function(e,t,n){var r;!function(e){e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n["default"].None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n["default"].None})}(r=t.CancellationToken||(t.CancellationToken={}));var o=Object.freeze(function(e,t){var n=setTimeout(e.bind(t),0);return{dispose:function(){clearTimeout(n)}}}),i=function(){function e(){this._isCancelled=!1}return e.prototype.cancel=function(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this._emitter=void 0))},Object.defineProperty(e.prototype,"isCancellationRequested",{get:function(){return this._isCancelled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onCancellationRequested",{get:function(){return this._isCancelled?o:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)},enumerable:!0,configurable:!0}),e}(),s=function(){function e(){}return Object.defineProperty(e.prototype,"token",{get:function(){return this._token||(this._token=new i),this._token},enumerable:!0,configurable:!0}),e.prototype.cancel=function(){this._token?this._token.cancel():this._token=r.Cancelled},e.prototype.dispose=function(){this.cancel()},e}();t.CancellationTokenSource=s});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/base/common/eventEmitter",["require","exports","vs/base/common/errors"],function(e,t,n){var r=function(){function e(e,t,n){void 0===n&&(n=null),this._type=e,this._data=t,this._emitterType=n}return e.prototype.getType=function(){return this._type},e.prototype.getData=function(){return this._data},e.prototype.getEmitterType=function(){return this._emitterType},e}();t.EmitterEvent=r;var o=function(){function e(e){if(void 0===e&&(e=null),this._listeners={},this._bulkListeners=[],this._collectedEvents=[],this._deferredCnt=0,e){this._allowedEventTypes={};for(var t=0;t<e.length;t++)this._allowedEventTypes[e[t]]=!0}else this._allowedEventTypes=null}return e.prototype.dispose=function(){this._listeners={},this._bulkListeners=[],this._collectedEvents=[],this._deferredCnt=0,this._allowedEventTypes=null},e.prototype.addListener=function(e,t){if("*"===e)throw new Error("Use addBulkListener(listener) to register your listener!");if(this._allowedEventTypes&&!this._allowedEventTypes.hasOwnProperty(e))throw new Error("This object will never emit this event type!");this._listeners.hasOwnProperty(e)?this._listeners[e].push(t):this._listeners[e]=[t];var n=this;return function(){n&&(n._removeListener(e,t),n=null,t=null)}},e.prototype.addListener2=function(e,t){var n=this.addListener(e,t);return{dispose:n}},e.prototype.on=function(e,t){return this.addListener(e,t)},e.prototype.addOneTimeListener=function(e,t){var n=this.addListener(e,function(e){n(),t(e)});return n},e.prototype.addOneTimeDisposableListener=function(e,t){var n=this.addOneTimeListener(e,t);return{dispose:n}},e.prototype.addBulkListener=function(e){var t=this;return this._bulkListeners.push(e),function(){t._removeBulkListener(e)}},e.prototype.addBulkListener2=function(e){var t=this.addBulkListener(e);return{dispose:t}},e.prototype.addEmitter=function(e,t){var n=this;return void 0===t&&(t=null),e.addBulkListener(function(e){var o=e;if(t){o=[];for(var i=0,s=e.length;s>i;i++)o.push(new r(e[i].getType(),e[i].getData(),t))}0===n._deferredCnt?n._emitEvents(o):n._collectedEvents.push.apply(n._collectedEvents,o)})},e.prototype.addEmitter2=function(e,t){var n=this.addEmitter(e,t);return{dispose:n}},e.prototype.addEmitterTypeListener=function(e,t,n){if(t){if("*"===e)throw new Error("Bulk listeners cannot specify an emitter type");return this.addListener(e+"/"+t,n)}return this.addListener(e,n)},e.prototype._removeListener=function(e,t){if(this._listeners.hasOwnProperty(e))for(var n=this._listeners[e],r=0,o=n.length;o>r;r++)if(n[r]===t){n.splice(r,1);break}},e.prototype._removeBulkListener=function(e){for(var t=0,n=this._bulkListeners.length;n>t;t++)if(this._bulkListeners[t]===e){this._bulkListeners.splice(t,1);break}},e.prototype._emitToSpecificTypeListeners=function(e,t){if(this._listeners.hasOwnProperty(e))for(var r=this._listeners[e].slice(0),o=0,i=r.length;i>o;o++)try{r[o](t)}catch(s){n.onUnexpectedError(s)}},e.prototype._emitToBulkListeners=function(e){for(var t=this._bulkListeners.slice(0),r=0,o=t.length;o>r;r++)try{t[r](e)}catch(i){n.onUnexpectedError(i)}},e.prototype._emitEvents=function(e){this._bulkListeners.length>0&&this._emitToBulkListeners(e);for(var t=0,n=e.length;n>t;t++){var r=e[t];this._emitToSpecificTypeListeners(r.getType(),r.getData()),r.getEmitterType()&&this._emitToSpecificTypeListeners(r.getType()+"/"+r.getEmitterType(),r.getData())}},e.prototype.emit=function(e,t){if(void 0===t&&(t={}),this._allowedEventTypes&&!this._allowedEventTypes.hasOwnProperty(e))throw new Error("Cannot emit this event type because it wasn't white-listed!");if(this._listeners.hasOwnProperty(e)||0!==this._bulkListeners.length){var n=new r(e,t);0===this._deferredCnt?this._emitEvents([n]):this._collectedEvents.push(n)}},e.prototype.deferredEmit=function(e){this._deferredCnt=this._deferredCnt+1;var t=null;try{t=e()}catch(r){n.onUnexpectedError(r)}return this._deferredCnt=this._deferredCnt-1,0===this._deferredCnt&&this._emitCollected(),t},e.prototype._emitCollected=function(){var e=this._collectedEvents;this._collectedEvents=[],e.length>0&&this._emitEvents(e)},e}();t.EventEmitter=o;var i=function(){function e(e,t){this.target=e,this.arg=t}return e}(),s=function(e){function t(t){void 0===t&&(t=null),e.call(this,t),this._emitQueue=[]}return __extends(t,e),t.prototype._emitToSpecificTypeListeners=function(e,t){if(this._listeners.hasOwnProperty(e))for(var n=this._listeners[e],r=0,o=n.length;o>r;r++)this._emitQueue.push(new i(n[r],t))},t.prototype._emitToBulkListeners=function(e){for(var t=this._bulkListeners,n=0,r=t.length;r>n;n++)this._emitQueue.push(new i(t[n],e))},t.prototype._emitEvents=function(t){for(e.prototype._emitEvents.call(this,t);this._emitQueue.length>0;){var r=this._emitQueue.shift();try{r.target(r.arg)}catch(o){n.onUnexpectedError(o)}}},t}(o);t.OrderGuaranteeEventEmitter=s}),define("vs/base/common/eventSource",["require","exports","vs/base/common/callbackList"],function(e,t,n){var r=function(){function e(){}return e.prototype.fire=function(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return this._value?this._value.invoke.apply(this._value,e):void 0},Object.defineProperty(e.prototype,"value",{get:function(){var e=this;return this._value||(this._value=new n["default"]),{add:function(t,n,r){e._value.add(t,n,r)},remove:this._value.remove.bind(this._value)}},enumerable:!0,configurable:!0}),e}();t.EventSource=r}),define("vs/base/common/filters",["require","exports","vs/base/common/strings"],function(e,t,n){function r(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return function(t,n){for(var r=0,o=e.length;o>r;r++){var i=e[r](t,n);if(i)return i}return null}}function o(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return function(t,n){for(var r=[],o=0,i=e.length;i>o;o++){var s=e[o](t,n);if(!s)return null;r=r.concat(s)}return r}}function i(e,t,n){if(0===n.length||n.length<t.length)return null;e&&(t=t.toLowerCase(),n=n.toLowerCase());for(var r=0;r<t.length;r++)if(t[r]!==n[r])return null;return t.length>0?[{start:0,end:t.length}]:[]}function s(e,t){var n=t.toLowerCase().indexOf(e.toLowerCase());return-1===n?null:[{start:n,end:n+e.length}]}function a(e,t){return u(e.toLowerCase(),t.toLowerCase(),0,0)}function u(e,t,n,r){if(n===e.length)return[];if(r===t.length)return null;if(e[n]===t[r]){var o=null;if(o=u(e,t,n+1,r+1))return f({start:r,end:r+1},o)}return u(e,t,n,r+1)}function c(e){return e>=97&&122>=e}function l(e){return e>=65&&90>=e}function d(e){return e>=48&&57>=e}function h(e){return[32,9,10,13].indexOf(e)>-1}function p(e){return c(e)||l(e)||d(e)}function f(e,t){return 0===t.length?t=[e]:e.end===t[0].start?t[0].start=e.start:t.unshift(e),t}function m(e,t){for(var n=t;n<e.length;n++){var r=e.charCodeAt(n);if(l(r)||d(r)||n>0&&!p(e.charCodeAt(n-1)))return n}return e.length}function g(e,t,n,r){if(n===e.length)return[];if(r===t.length)return null;if(e[n]!==t[r].toLowerCase())return null;var o=null,i=r+1;for(o=g(e,t,n+1,r+1);!o&&(i=m(t,i))<t.length;)o=g(e,t,n+1,i),i++;return null===o?null:f({start:r,end:r+1},o)}function v(e){if(e.length>40)return!1;for(var t=0,n=0,r=0,o=0,i=0;i<e.length;i++)o=e.charCodeAt(i),l(o)&&t++,c(o)&&n++,p(o)&&r++;var s=t/e.length,a=n/e.length,u=r/e.length;return a>.2&&.8>s&&u>.6}function _(e){for(var t=0,n=0,r=0,o=0,i=0;i<e.length;i++)r=e.charCodeAt(i),l(r)&&t++,c(r)&&n++,h(r)&&o++;return 0!==t&&0!==n||0!==o?5>=t:e.length<=30}function y(e,t){if(0===t.length)return null;if(!_(e))return null;if(!v(t))return null;for(var n=null,r=0;r<t.length&&null===(n=g(e.toLowerCase(),t,0,r));)r=m(t,r+1);return n}function k(e,t){var r=E[e];r||(r=new RegExp(n.convertSimple2RegExpPattern(e),"i"),E[e]=r);var o=r.exec(t);return o?[{start:o.index,end:o.index+o[0].length}]:b(e,t)}t.or=r,t.and=o,t.matchesStrictPrefix=function(e,t){return i(!1,e,t)},t.matchesPrefix=function(e,t){return i(!0,e,t)},t.matchesContiguousSubString=s,t.matchesSubString=a,t.matchesCamelCase=y;var b=r(t.matchesPrefix,y,s),E={};t.matchesFuzzy=k}),define("vs/base/common/glob",["require","exports","vs/base/common/strings","vs/base/common/paths"],function(e,t,n,r){function o(e){switch(e){case 0:return"";case 1:return h+"*?";default:return"(?:"+d+"|"+h+"+"+d+"|"+d+h+"+)*?"}}function i(e,t){if(!e)return[];for(var n,r=[],o=!1,i=!1,s="",a=0;a<e.length;a++){switch(n=e[a]){case t:if(!o&&!i){r.push(s),s="";continue}break;case"{":o=!0;break;case"}":o=!1;break;case"[":i=!0;break;case"]":i=!1}s+=n}return s&&r.push(s),r}function s(e){if(!e)return"";var t="",r=i(e,"/");if(r.every(function(e){return"**"===e}))t=".*";else{var a=!1;r.forEach(function(e,u){if("**"===e)return void(a||(t+=o(2),a=!0));for(var c,l=!1,p="",f=!1,m="",g=0;g<e.length;g++)if(c=e[g],"}"!==c&&l)p+=c;else if("]"!==c&&f){var v;switch(c){case"-":v=c;break;case"^":v=c;break;default:v=n.escapeRegExpCharacters(c)}m+=v}else switch(c){case"{":l=!0;continue;case"[":f=!0;continue;case"}":var _=i(p,","),y="(?:"+_.reduce(function(e,t,n,r){return e+"|"+s(t)},s(_[0]))+")";t+=y,l=!1,p="";break;case"]":t+="["+m+"]",f=!1,m="";break;case"?":t+=h;continue;case"*":t+=o(1);continue;default:t+=n.escapeRegExpCharacters(c)}u<r.length-1&&"**"!==r[u+1]&&(t+=d),a=!1})}return t}function a(e){if(!e)return null;if(e=e.trim(),l[e]){var t=l[e];return t.lastIndex=0,t}var n=s(e);n="^"+n+"$";var r;try{r=new RegExp(n)}catch(o){r=/.^/}return l[e]=r,r}function u(e,t,n){if(!e||!t)return!1;if("string"==typeof e)try{return a(e).test(t)}catch(r){return!1}return c(e,t,n)}function c(e,t,o){for(var i=Object.getOwnPropertyNames(e),s=0;s<i.length;s++){var a=i[s];if(u(a,t)){var c=e[a];if("boolean"==typeof c){if(c===!1)continue;return a}if(c&&"string"==typeof c.when){if(!o||!o.length)continue;var l=c,d=n.rtrim(r.basename(t),r.extname(t)),h=n.replaceAll(l.when,"$(basename)",d);if(o.some(function(e){return e===h}))return a;continue}return a}}return null}var l=Object.create(null),d="[/\\\\]",h="[^/\\\\]";t.splitGlobAware=i,t.match=u}),define("vs/base/common/mime",["require","exports","vs/base/common/paths","vs/base/common/types","vs/base/common/strings"],function(e,t,n,r,o){function i(e){void 0===e&&(e=!0);var t=function(t){return e?/^\./.test(t):!0},n=function(e){return e.replace(/^\./,"")},r=[];r=r.concat(Object.keys(h)),r=r.filter(t).map(n),r.sort();for(var o=[],i=null,s=null,a=[],u=function(){a.length>0&&o.push("'"+a.join("', '")+"'")},c=0,l=r.length;l>c;c++){var d=r[c];if(0!==d.length&&d!==s){var p=d.charAt(0);i!==p&&(u(),i=p,a=[]),a.push(d),s=d}}return u(),o.join(",\n")}function s(e,t){e&&t&&(h[e]&&h[e]!==t&&console.warn("Overwriting filename <<"+e+">> to now point to mime <<"+t+">>"),h[e]=t)}function a(e,t){e&&t&&p.push({regexp:e,mime:t})}function u(e){if(!e)return!1;var n;return n=r.isArray(e)?e:e.split(",").map(function(e){return e.trim()}),n.indexOf(t.MIME_BINARY)>=0}function c(e,r){if(!e)return[t.MIME_UNKNOWN];if(r&&(o.startsWithUTF8BOM(r)&&(r=r.substr(1)),r.length>0))for(var i=0;i<p.length;++i){var s=r.match(p[i].regexp);if(s&&s.length>0&&s[0].length===r.length)return[p[i].mime,t.MIME_TEXT]}e=e.toLowerCase();var a,u,c=n.basename(e);n.extname(e);for(var l in h){var d=l.toLowerCase();if(!a&&c===d){a=l;break}"."===l[0]&&o.endsWith(c,d)&&(!u||d.length>u.length)&&(u=l)}return a?[h[a],t.MIME_TEXT]:u?[h[u],t.MIME_TEXT]:[t.MIME_UNKNOWN]}function l(e){return e?"string"==typeof e?e===t.MIME_BINARY||e===t.MIME_TEXT||e===t.MIME_UNKNOWN:1===e.length&&l(e[0]):!0}function d(e,t){for(var n in h){var r=h[n];if(r===e)return t+n}return null}t.MIME_TEXT="text/plain",t.MIME_BINARY="application/octet-stream",t.MIME_UNKNOWN="application/unknown";var h=Object.create(null),p=[];t.generateKnownFilenames=i,t.registerTextMimeByFilename=s,t.registerTextMimeByFirstLine=a,t.isBinaryMime=u,t.guessMimeTypes=c,t.isUnspecific=l,t.suggestFilename=d});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/base/common/network",["require","exports","vs/base/common/assert","vs/base/common/strings","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/paths","vs/base/common/uri"],function(e,t,n,r,o,i,s,a){i.registerMarshallingContribution({canSerialize:function(e){return e instanceof p},serialize:function(e,t){return e._toSerialized()},canDeserialize:function(e){return e.$isURL},deserialize:function(e,t){return new p(e.$value)}});var u=":".charCodeAt(0),c="/".charCodeAt(0),l="?".charCodeAt(0),d="#".charCodeAt(0),h=function(){function e(e){this.spec=e||r.empty,this.specLength=this.spec.length,this.parse()}return e.prototype.forwardSubstring=function(e,t){return t>e?this.spec.substring(e,t):r.empty},e.prototype.getScheme=function(){return this.forwardSubstring(this.schemeStart,this.domainStart-1)},e.prototype.getProtocol=function(){return this.forwardSubstring(this.schemeStart,this.domainStart)},e.prototype.getDomain=function(){return this.forwardSubstring(this.domainStart+2,this.portStart)},e.prototype.getPort=function(){return this.forwardSubstring(this.portStart+1,this.pathStart)},e.prototype.getHost=function(){return this.forwardSubstring(this.domainStart+2,this.pathStart)},e.prototype.getPath=function(){return this.forwardSubstring(this.pathStart,this.queryStringStart)},e.prototype.getQueryString=function(){return this.forwardSubstring(this.queryStringStart+1,this.fragmentIdStart)},e.prototype.getFragmentId=function(){return this.forwardSubstring(this.fragmentIdStart+1,this.specLength)},e.prototype.getAllBeforePath=function(){return this.forwardSubstring(0,this.pathStart)},e.prototype.getAllBeforeFragmentId=function(){return this.forwardSubstring(0,this.fragmentIdStart)},e.prototype.combine=function(e){var t=e.indexOf("?"),n=e.indexOf("#"),o=e.length;-1!==t&&o>t&&(o=t),-1!==n&&o>n&&(o=n);var i=e.substring(0,o),a=e.substring(o);i=i.replace("\\","/");var u;for(u=r.startsWith(i,"/")?s.join(i):s.join(s.dirname(this.getPath()),i);"/"===u.charAt(0);)u=u.substr(1);for(;0===u.indexOf("../");)u=u.substr(3);return this.getAllBeforePath()+"/"+u+a},e.prototype.parse=function(){var e,t,n=0,r=1,o=2,i=3,s=4,a=n,h=this.spec,p=this.specLength,f=-1,m=-1;for(this.schemeStart=0,this.domainStart=this.specLength,this.portStart=this.specLength,this.pathStart=this.specLength,this.queryStringStart=this.specLength,this.fragmentIdStart=this.specLength,e=0;p>e;e++){switch(t=h.charCodeAt(e),a){case n:f===c&&t===c&&(a=r,this.domainStart=e-1);break;case r:t===u?(a=o,this.portStart=e):t===c?(a=i,this.portStart=e,this.pathStart=e):t===d&&(this.portStart=e,this.pathStart=e,this.queryStringStart=e,this.fragmentIdStart=e,e=p);break;case o:t===c?(a=i,this.pathStart=e):t===d&&(this.pathStart=e,this.queryStringStart=e,this.fragmentIdStart=e,e=p);break;case i:t===l?(a=s,this.queryStringStart=e):t===d&&(this.queryStringStart=e,this.fragmentIdStart=e,e=p);break;case s:t===d&&(this.fragmentIdStart=e,e=p)}m=f,f=t}a===n&&(this.schemeStart=this.specLength)},e}();t.ParsedUrl=h;var p=function(e){function t(t){e.call(this),n.ok(!!t,"spec must not be null"),"string"==typeof t?this._uri=a["default"].parse(t):this._uri=t,this._spec=this._uri.toString(),this._parsed=null}return __extends(t,e),t.fromEncoded=function(e){return new t(decodeURIComponent(e))},t.fromValue=function(e){return new t(e)},t.fromUri=function(e){return new t(e)},t.prototype.equals=function(e){return this.toString()!==String(e)?!1:e instanceof t||a["default"].isURI(e)},t.prototype.hashCode=function(){return o.computeMurmur2StringHashCode(this._spec)},t.prototype.isInMemory=function(){return this.scheme===f.inMemory},t.prototype.getScheme=function(){return this._ensureParsedUrl(),this._parsed.getScheme()},t.prototype.getPath=function(){return this._ensureParsedUrl(),this._parsed.getPath()},t.prototype.toUnique=function(){return this._ensureParsedUrl(),this._parsed.getAllBeforeFragmentId()},t.prototype.startsWith=function(e){return r.startsWith(this._spec,e._spec)},t.prototype.combine=function(e){return this._ensureParsedUrl(),new t(this._parsed.combine(e))},t.prototype._ensureParsedUrl=function(){null===this._parsed&&(this._parsed=new h(this._spec))},Object.defineProperty(t.prototype,"scheme",{get:function(){return this._uri.scheme},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"authority",{get:function(){return this._uri.authority},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"path",{get:function(){return this._uri.path},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"fsPath",{get:function(){return this._uri.fsPath},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"query",{get:function(){return this._uri.query},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"fragment",{get:function(){return this._uri.fragment},enumerable:!0,configurable:!0}),t.prototype.withScheme=function(e){return a["default"].create(e,this.authority,this.fsPath,this.query,this.fragment)},t.prototype.withAuthority=function(e){return a["default"].create(this.scheme,e,this.fsPath,this.query,this.fragment)},t.prototype.withPath=function(e){return a["default"].create(this.scheme,this.authority,e,this.query,this.fragment)},t.prototype.withQuery=function(e){return a["default"].create(this.scheme,this.authority,this.fsPath,e,this.fragment)},t.prototype.withFragment=function(e){return a["default"].create(this.scheme,this.authority,this.fsPath,this.query,e)},t.prototype["with"]=function(e,t,n,r,o){return a["default"].create(e,t,n,r,o)},t.prototype.toString=function(){return this._spec},t.prototype.toJSON=function(){return this.toString()},t.prototype._toSerialized=function(){return{$isURL:!0,$value:this.toString().replace(/URL_MARSHAL_REMOVE.*$/,"")}},t}(a["default"]);t.URL=p;var f;!function(e){e.inMemory="inmemory",e.http="http",e.https="https",e.file="file"}(f=t.schemas||(t.schemas={}))}),define("vs/base/common/severity",["require","exports","vs/nls!vs/base/common/severity","vs/base/common/strings"],function(e,t,n,r){var o;!function(e){e[e.Ignore=0]="Ignore",e[e.Info=1]="Info",e[e.Warning=2]="Warning",e[e.Error=3]="Error"}(o||(o={}));var o;!function(e){function t(t){return t?r.equalsIgnoreCase(s,t)?e.Error:r.equalsIgnoreCase(a,t)||r.equalsIgnoreCase(u,t)?e.Warning:r.equalsIgnoreCase(c,t)?e.Info:e.Ignore:e.Ignore}function o(e){return l[e]||r.empty}function i(e,t){return t-e}var s="error",a="warning",u="warn",c="info",l=Object.create(null);l[e.Error]=n.localize(0,null),l[e.Warning]=n.localize(1,null),l[e.Info]=n.localize(2,null),e.fromValue=t,e.toString=o,e.compare=i}(o||(o={})),Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=o}),define("vs/base/common/timer",["require","exports","vs/base/common/platform","vs/base/common/errors","vs/base/common/stopwatch"],function(e,t,n,r,o){function i(e,t,n,r){return h.start(e,t,n,r)}function s(){return h}t.ENABLE_TIMER=!1;var a=n.globals.msWriteProfilerMark;!function(e){e[e.EDITOR=0]="EDITOR",e[e.LANGUAGES=1]="LANGUAGES",e[e.WORKER=2]="WORKER",e[e.WORKBENCH=3]="WORKBENCH",e[e.STARTUP=4]="STARTUP"}(t.Topic||(t.Topic={}));var u=t.Topic,c=function(){function e(){}return e.prototype.stop=function(){},e.prototype.timeTaken=function(){return-1},e}(),l=function(){function e(e,t,n,r,i){if(this.timeKeeper=e,this.name=t,this.description=i,this.topic=n,this.stopTime=null,r)return void(this.startTime=r);if(this.startTime=new Date,this.sw=o.StopWatch.create(),a){var s=["Monaco",this.topic,this.name,"start"];a(s.join("|"))}}return e.prototype.stop=function(e){if(null===this.stopTime){if(e)return this.stopTime=e,this.sw=null,void this.timeKeeper._onEventStopped(this);if(this.stopTime=new Date,this.sw&&this.sw.stop(),this.timeKeeper._onEventStopped(this),a){var t=["Monaco",this.topic,this.name,"stop"];a(t.join("|"))}}},e.prototype.timeTaken=function(){return this.sw?this.sw.elapsed():this.stopTime?this.stopTime.getTime()-this.startTime.getTime():-1},e}(),d=function(){function e(){this.cleaningIntervalId=-1,this.collectedEvents=[],this.listeners=[]}return e.prototype.isEnabled=function(){return t.ENABLE_TIMER},e.prototype.start=function(e,n,r,o){if(!this.isEnabled())return t.nullEvent;var i;"string"==typeof e?i=e:e===u.EDITOR?i="Editor":e===u.LANGUAGES?i="Languages":e===u.WORKER?i="Worker":e===u.WORKBENCH?i="Workbench":e===u.STARTUP&&(i="Startup"),this.initAutoCleaning();var s=new l(this,n,i,r,o);return this.addEvent(s),s},e.prototype.dispose=function(){-1!==this.cleaningIntervalId&&(n.clearInterval(this.cleaningIntervalId),this.cleaningIntervalId=-1)},e.prototype.addListener=function(e){this.listeners.push(e)},e.prototype.removeListener=function(e){for(var t=0;t<this.listeners.length;t++)if(this.listeners[t]===e)return void this.listeners.splice(t,1)},e.prototype.addEvent=function(t){t.id=e.EVENT_ID,e.EVENT_ID++,this.collectedEvents.push(t),this.collectedEvents.length>e._EVENT_CACHE_LIMIT&&this.collectedEvents.shift()},e.prototype.initAutoCleaning=function(){var t=this;-1===this.cleaningIntervalId&&(this.cleaningIntervalId=n.setInterval(function(){var n=Date.now();t.collectedEvents.forEach(function(t){!t.stopTime&&n-t.startTime.getTime()>=e._MAX_TIMER_LENGTH&&t.stop()})},e._CLEAN_UP_INTERVAL))},e.prototype.getCollectedEvents=function(){return this.collectedEvents.slice(0)},e.prototype.clearCollectedEvents=function(){this.collectedEvents=[]},e.prototype._onEventStopped=function(e){for(var t=[e],n=this.listeners.slice(0),o=0;o<n.length;o++)try{n[o](t)}catch(i){r.onUnexpectedError(i)}},e.prototype.setInitialCollectedEvents=function(t,n){var r=this;this.isEnabled()&&(n&&(e.PARSE_TIME=n),t.forEach(function(e){var t=new l(r,e.name,e.topic,e.startTime,e.description);t.stop(e.stopTime),r.addEvent(t)}))},e._MAX_TIMER_LENGTH=6e4,e._CLEAN_UP_INTERVAL=12e4,e._EVENT_CACHE_LIMIT=1e3,e.EVENT_ID=1,e.PARSE_TIME=new Date,e}();t.TimeKeeper=d;var h=new d;t.nullEvent=new c,t.start=i,t.getTimeKeeper=s});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/base/common/async",["require","exports","vs/base/common/errors","vs/base/common/winjs.base","vs/base/common/platform","vs/base/common/cancellation"],function(e,t,n,r,o,i){function s(e,t){if(e){var n=function(){for(var n=[],o=0;o<arguments.length;o++)n[o-0]=arguments[o];var s=new i.CancellationTokenSource;return new r.TPromise(function(r,o){n.push(s.token);var i=e.apply(t,n);i&&"function"==typeof i.then?i.then(r,o):r(i)},function(){s.cancel()})};return n}}function a(e,t){return new r.TPromise(function(r,o,i){e.done(function(e){try{t(e)}catch(o){n.onUnexpectedError(o)}r(e)},function(e){try{t(e)}catch(r){n.onUnexpectedError(r)}o(e)},function(e){i(e)})},function(){e.cancel()})}function u(e){function t(){return e.length?e.pop()():null}function n(e){e&&o.push(e);var i=t();return i?i.then(n):r.TPromise.as(o)}var o=[];return e=e.reverse(),r.Promise.as(null).then(n)}function c(e){var t,n=this,r=!1;return function(){return r?t:(r=!0,t=e.apply(n,arguments))}}function l(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return new r.Promise(function(n,r){return e.apply(void 0,t.concat([function(e,t){return e?r(e):n(t)}]))})}function d(e,t){for(var n=[],o=2;o<arguments.length;o++)n[o-2]=arguments[o];return new r.Promise(function(r,o){return t.call.apply(t,[e].concat(n,[function(e,t){return e?o(e):r(t)}]))})}t.wrapAsWinJSPromise=s;var h=function(){function e(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}return e.prototype.queue=function(e){var t=this;if(this.activePromise){if(this.queuedPromiseFactory=e,!this.queuedPromise){var n=function(){t.queuedPromise=null;var e=t.queue(t.queuedPromiseFactory);return t.queuedPromiseFactory=null,e};this.queuedPromise=new r.Promise(function(e,r,o){t.activePromise.then(n,n,o).done(e)},function(){t.activePromise.cancel()})}return new r.Promise(function(e,n,r){t.queuedPromise.then(e,n,r)},function(){})}return this.activePromise=e(),new r.Promise(function(e,n,r){t.activePromise.done(function(n){t.activePromise=null,e(n)},function(e){t.activePromise=null,n(e)},r)},function(){t.activePromise.cancel()})},e}();t.Throttler=h;var p=function(){function e(e){this.defaultDelay=e,this.timeout=null,this.completionPromise=null,this.onSuccess=null,this.task=null}return e.prototype.trigger=function(e,t){var n=this;return void 0===t&&(t=this.defaultDelay),this.task=e,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new r.Promise(function(e){n.onSuccess=e},function(){}).then(function(){n.completionPromise=null,n.onSuccess=null;var e=n.task();return n.task=null,e})),this.timeout=setTimeout(function(){n.timeout=null,n.onSuccess(null)},t),this.completionPromise},e.prototype.isTriggered=function(){return null!==this.timeout},e.prototype.cancel=function(){this.cancelTimeout(),this.completionPromise&&(this.completionPromise.cancel(),this.completionPromise=null)},e.prototype.cancelTimeout=function(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)},e}();t.Delayer=p;var f=function(e){function t(t){e.call(this,t),this.throttler=new h}return __extends(t,e),t.prototype.trigger=function(t,n){var r=this;return e.prototype.trigger.call(this,function(){return r.throttler.queue(t)},n)},t}(p);t.ThrottledDelayer=f;var m=function(e){function t(t,n){void 0===n&&(n=0),e.call(this,t),this.minimumPeriod=n,this.periodThrottler=new h}return __extends(t,e),t.prototype.trigger=function(t,n){var o=this;return e.prototype.trigger.call(this,function(){return o.periodThrottler.queue(function(){return r.Promise.join([r.Promise.timeout(o.minimumPeriod),t()]).then(function(e){return e[1]})})},n)},t}(f);t.PeriodThrottledDelayer=m;var g=function(){function e(){var e=this;this._value=new r.TPromise(function(t,n){e._completeCallback=t,e._errorCallback=n})}return Object.defineProperty(e.prototype,"value",{get:function(){return this._value},enumerable:!0,configurable:!0}),e.prototype.complete=function(e){this._completeCallback(e)},e.prototype.error=function(e){
this._errorCallback(e)},e}();t.PromiseSource=g;var v=function(e){function t(t){var r,o,i;e.call(this,function(e,t,n){r=e,o=t,i=n},function(){o(n.canceled())}),t.then(r,o,i)}return __extends(t,e),t}(r.TPromise);t.ShallowCancelThenPromise=v,t.always=a,t.sequence=u,t.once=c;var _=function(){function e(e){this.maxDegreeOfParalellism=e,this.outstandingPromises=[],this.runningPromises=0}return e.prototype.queue=function(e){var t=this;return new r.TPromise(function(n,r,o){t.outstandingPromises.push({factory:e,c:n,e:r,p:o}),t.consume()})},e.prototype.consume=function(){for(var e=this;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){var t=this.outstandingPromises.shift();this.runningPromises++;var n=t.factory();n.done(t.c,t.e,t.p),n.done(function(){return e.consumed()},function(){return e.consumed()})}},e.prototype.consumed=function(){this.runningPromises--,this.consume()},e}();t.Limiter=_;var y=function(){function e(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}return e.prototype.dispose=function(){this.cancel(),this.runner=null},e.prototype.cancel=function(){-1!==this.timeoutToken&&(o.clearTimeout(this.timeoutToken),this.timeoutToken=-1)},e.prototype.setRunner=function(e){this.runner=e},e.prototype.setTimeout=function(e){this.timeout=e},e.prototype.schedule=function(){this.cancel(),this.timeoutToken=o.setTimeout(this.timeoutHandler,this.timeout)},e.prototype.onTimeout=function(){this.timeoutToken=-1,this.runner&&this.runner()},e}();t.RunOnceScheduler=y,t.nfcall=l,t.ninvoke=d});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/diff/diffComputer",["require","exports","vs/base/common/diff/diff","vs/base/common/strings"],function(e,t,n,r){function o(e,t,r){var o=new n.LcsDiff(e,t,r);return o.ComputeDiff()}function i(e){if(e.length<=1)return e;var t,n,r,o,i,s,u=[e[0]],c=u[0];for(t=1,n=e.length;n>t;t++)s=e[t],r=s.originalStart-(c.originalStart+c.originalLength),o=s.modifiedStart-(c.modifiedStart+c.modifiedLength),i=Math.min(r,o),a>i?(c.originalLength=s.originalStart+s.originalLength-c.originalStart,c.modifiedLength=s.modifiedStart+s.modifiedLength-c.modifiedStart):(u.push(s),c=s);return u}var s=5e3,a=3,u=function(){function e(e,t,n){this.buffer=e,this.startMarkers=t,this.endMarkers=n}return e.prototype.equals=function(t){if(!(t instanceof e))return!1;var n=t;if(this.getLength()!==n.getLength())return!1;for(var r=0,o=this.getLength();o>r;r++){var i=this.getElementHash(r),s=n.getElementHash(r);if(i!==s)return!1}return!0},e.prototype.getLength=function(){return this.startMarkers.length},e.prototype.getElementHash=function(e){return this.buffer.substring(this.startMarkers[e].offset,this.endMarkers[e].offset)},e.prototype.getStartLineNumber=function(e){return e===this.startMarkers.length?this.startMarkers[e-1].lineNumber+1:this.startMarkers[e].lineNumber},e.prototype.getStartColumn=function(e){return this.startMarkers[e].column},e.prototype.getEndLineNumber=function(e){return this.endMarkers[e].lineNumber},e.prototype.getEndColumn=function(e){return this.endMarkers[e].column},e}(),c=function(e){function t(t,n){var r,o,i,s,a,u="",c=[],l=[];for(i=0,r=0,o=t.length;o>r;r++)u+=t[r],s=1,a=t[r].length+1,n&&(s=this._getFirstNonBlankColumn(t[r],1),a=this._getLastNonBlankColumn(t[r],1)),c.push({offset:i+s-1,lineNumber:r+1,column:s}),l.push({offset:i+a-1,lineNumber:r+1,column:a}),i+=t[r].length;e.call(this,u,c,l)}return __extends(t,e),t.prototype._getFirstNonBlankColumn=function(e,t){var n=r.firstNonWhitespaceIndex(e);return-1===n?t:n+1},t.prototype._getLastNonBlankColumn=function(e,t){var n=r.lastNonWhitespaceIndex(e);return-1===n?t:n+2},t.prototype.getCharSequence=function(e,t){var n,r,o,i,s=[],a=[];for(n=e;t>=n;n++)for(o=this.startMarkers[n],i=this.endMarkers[n],r=o.offset;r<i.offset;r++)s.push({offset:r,lineNumber:o.lineNumber,column:o.column+(r-o.offset)}),a.push({offset:r+1,lineNumber:o.lineNumber,column:o.column+(r-o.offset)+1});return new u(this.buffer,s,a)},t}(u),l=function(){function e(e,t,n){0===e.originalLength?(this.originalStartLineNumber=0,this.originalStartColumn=0,this.originalEndLineNumber=0,this.originalEndColumn=0):(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart),this.originalStartColumn=t.getStartColumn(e.originalStart),this.originalEndLineNumber=t.getEndLineNumber(e.originalStart+e.originalLength-1),this.originalEndColumn=t.getEndColumn(e.originalStart+e.originalLength-1)),0===e.modifiedLength?(this.modifiedStartLineNumber=0,this.modifiedStartColumn=0,this.modifiedEndLineNumber=0,this.modifiedEndColumn=0):(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart),this.modifiedStartColumn=n.getStartColumn(e.modifiedStart),this.modifiedEndLineNumber=n.getEndLineNumber(e.modifiedStart+e.modifiedLength-1),this.modifiedEndColumn=n.getEndColumn(e.modifiedStart+e.modifiedLength-1))}return e}(),d=function(){function e(e,t,n,r,s){if(0===e.originalLength?(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart)-1,this.originalEndLineNumber=0):(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart),this.originalEndLineNumber=t.getEndLineNumber(e.originalStart+e.originalLength-1)),0===e.modifiedLength?(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart)-1,this.modifiedEndLineNumber=0):(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart),this.modifiedEndLineNumber=n.getEndLineNumber(e.modifiedStart+e.modifiedLength-1)),0!==e.originalLength&&0!==e.modifiedLength&&r()){var a=t.getCharSequence(e.originalStart,e.originalStart+e.originalLength-1),u=n.getCharSequence(e.modifiedStart,e.modifiedStart+e.modifiedLength-1),c=o(a,u,r);s&&(c=i(c)),this.charChanges=[];for(var d=0,h=c.length;h>d;d++)this.charChanges.push(new l(c[d],a,u))}}return e}(),h=function(){function e(e,t,n){this.shouldPostProcessCharChanges=n.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=n.shouldIgnoreTrimWhitespace,this.maximumRunTimeMs=s,this.original=new c(e,this.shouldIgnoreTrimWhitespace),this.modified=new c(t,this.shouldIgnoreTrimWhitespace),n.shouldConsiderTrimWhitespaceInEmptyCase&&this.shouldIgnoreTrimWhitespace&&this.original.equals(this.modified)&&(this.shouldIgnoreTrimWhitespace=!1,this.original=new c(e,this.shouldIgnoreTrimWhitespace),this.modified=new c(t,this.shouldIgnoreTrimWhitespace))}return e.prototype.computeDiff=function(){this.computationStartTime=(new Date).getTime();for(var e=o(this.original,this.modified,this._continueProcessingPredicate.bind(this)),t=[],n=0,r=e.length;r>n;n++)t.push(new d(e[n],this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldPostProcessCharChanges));return t},e.prototype._continueProcessingPredicate=function(){if(0===this.maximumRunTimeMs)return!0;var e=(new Date).getTime();return e-this.computationStartTime<this.maximumRunTimeMs},e}();t.DiffComputer=h}),define("vs/editor/common/model/editStack",["require","exports","vs/base/common/errors"],function(e,t,n){var r=function(){function e(e){this.model=e,this.currentOpenStackElement=null,this.past=[],this.future=[]}return e.prototype.pushStackElement=function(){null!==this.currentOpenStackElement&&(this.past.push(this.currentOpenStackElement),this.currentOpenStackElement=null)},e.prototype.clear=function(){this.currentOpenStackElement=null,this.past=[],this.future=[]},e.prototype.pushEditOperation=function(e,t,r){this.future=[],this.currentOpenStackElement||(this.currentOpenStackElement={beforeVersionId:this.model.getAlternativeVersionId(),beforeCursorState:e,editOperations:[],afterCursorState:null,afterVersionId:-1});var o={operations:this.model.applyEdits(t)};this.currentOpenStackElement.editOperations.push(o);try{this.currentOpenStackElement.afterCursorState=r?r(o.operations):null}catch(i){n.onUnexpectedError(i),this.currentOpenStackElement.afterCursorState=null}return this.currentOpenStackElement.afterVersionId=this.model.getVersionId(),this.currentOpenStackElement.afterCursorState},e.prototype.undo=function(){if(this.pushStackElement(),this.past.length>0){var e=this.past.pop();try{for(var t=e.editOperations.length-1;t>=0;t--)e.editOperations[t]={operations:this.model.applyEdits(e.editOperations[t].operations)}}catch(n){return this.clear(),null}return this.future.push(e),{selections:e.beforeCursorState,recordedVersionId:e.beforeVersionId}}return null},e.prototype.redo=function(){if(this.future.length>0){if(this.currentOpenStackElement)throw new Error("How is this possible?");var e=this.future.pop();try{for(var t=0;t<e.editOperations.length;t++)e.editOperations[t]={operations:this.model.applyEdits(e.editOperations[t].operations)}}catch(n){return this.clear(),null}return this.past.push(e),{selections:e.afterCursorState,recordedVersionId:e.afterVersionId}}return null},e}();t.EditStack=r}),define("vs/editor/common/model/tokensBinaryEncoding",["require","exports","vs/base/common/strings","vs/base/common/errors"],function(e,t,n,r){function o(e,n){if(0===n.length)return g;if(1===n.length&&0===n[0].startIndex&&!n[0].type&&!n[0].bracket)return _;var o,i,s,a,u,c,l=e._inflate,d=e._deflate,h=-1,p=new Array(n.length);for(o=0,i=n.length;i>o;o++)c=n[o],c.startIndex<=h&&(c.startIndex=h+1,r.onUnexpectedError({message:"Invalid tokens detected",tokens:n})),d.hasOwnProperty(c.type)?s=d[c.type]:(s=l.length,d[c.type]=s,l.push(c.type)),a=c.bracket,0>a&&(a=2),u=a*t.BRACKET_OFFSET+s*t.TYPE_OFFSET+c.startIndex*t.START_INDEX_OFFSET,p[o]=u,h=c.startIndex;return p}function i(e,n){if(0===n)return f;var r=n/t.START_INDEX_OFFSET&t.START_INDEX_MASK,o=n/t.TYPE_OFFSET&t.TYPE_MASK,i=n/t.BRACKET_OFFSET&t.BRACKET_MASK;return 2===i&&(i=-1),new p(r,e._inflate[o],i)}function s(e){return e/t.START_INDEX_OFFSET&t.START_INDEX_MASK}function a(e,r){var o=r/t.TYPE_OFFSET&t.TYPE_MASK;return 0===o?n.empty:e._inflate[o]}function u(e){var n=e/t.BRACKET_OFFSET&t.BRACKET_MASK;return 2===n&&(n=-1),n}function c(e,n){if(0===n.length)return m;if(1===n.length&&0===n[0])return v;var r,o,i,s,a,u,c=new Array(n.length),l=e._inflate;for(r=0,o=n.length;o>r;r++)i=n[r],s=i/t.START_INDEX_OFFSET&t.START_INDEX_MASK,u=i/t.TYPE_OFFSET&t.TYPE_MASK,a=i/t.BRACKET_OFFSET&t.BRACKET_MASK,2===a&&(a=-1),c[r]=new p(s,l[u],a);return c}function l(e,t){return h(e,t)}function d(e,n,r,o,i){if(0===n.length)return m;if(1===n.length&&0===n[0])return v;var s,a,u,c,l,d,f,g=h(n,r),_=[],y=e._inflate;for(u=n[g],d=u/t.TYPE_OFFSET&t.TYPE_MASK,f=u/t.BRACKET_OFFSET&t.BRACKET_MASK,l=0,_.push(new p(l,y[d],f)),s=g+1,a=n.length;a>s&&(u=n[s],c=u/t.START_INDEX_OFFSET&t.START_INDEX_MASK,!(c>=o));s++)d=u/t.TYPE_OFFSET&t.TYPE_MASK,f=u/t.BRACKET_OFFSET&t.BRACKET_MASK,l=c-r+i,_.push(new p(l,y[d],f));return _}function h(e,t){for(var n,r,o=0,i=e.length-1;i>o;)n=o+Math.ceil((i-o)/2),r=4294967295&e[n],r>t?i=n-1:o=n;return o}var p=function(){function e(e,t,n){this.startIndex=e,this.type=t,this.bracket=n}return e.prototype.toString=function(){return"{ "+this.startIndex+", '"+this.type+"', "+this.bracket+"}"},e}();t.START_INDEX_MASK=4294967295,t.TYPE_MASK=65535,t.BRACKET_MASK=255,t.START_INDEX_OFFSET=1,t.TYPE_OFFSET=Math.pow(2,32),t.BRACKET_OFFSET=Math.pow(2,48);var f={startIndex:0,type:"",bracket:0},m=[],g=[],v=[f],_=[0];t.deflateArr=o,t.inflate=i,t.getStartIndex=s,t.getType=a,t.getBracket=u,t.inflateArr=c,t.findIndexOfOffset=l,t.sliceAndInflate=d,t.findIndexInSegmentsArray=h}),define("vs/editor/common/editorCommon",["require","exports","vs/editor/common/model/tokensBinaryEncoding"],function(e,t,n){function r(e){return"indent"===e?o.Indent:"same"===e?o.Same:o.None}!function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"}(t.SelectionDirection||(t.SelectionDirection={}));t.SelectionDirection;!function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent"}(t.WrappingIndent||(t.WrappingIndent={}));var o=t.WrappingIndent;t.wrappingIndentFromString=r,function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"}(t.OverviewRulerLane||(t.OverviewRulerLane={}));t.OverviewRulerLane;!function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(t.EndOfLinePreference||(t.EndOfLinePreference={}));t.EndOfLinePreference;!function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"}(t.EndOfLineSequence||(t.EndOfLineSequence={}));t.EndOfLineSequence;t.LineTokensBinaryEncoding=n,function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"}(t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));t.TrackedRangeStickiness;!function(e){e[e.Simple=0]="Simple",e[e.Center=1]="Center",e[e.CenterIfOutsideViewport=2]="CenterIfOutsideViewport"}(t.VerticalRevealType||(t.VerticalRevealType={}));t.VerticalRevealType;!function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET"}(t.MouseTargetType||(t.MouseTargetType={}));t.MouseTargetType;t.KEYBINDING_CONTEXT_EDITOR_TEXT_FOCUS="editorTextFocus",t.KEYBINDING_CONTEXT_EDITOR_FOCUS="editorFocus",t.KEYBINDING_CONTEXT_EDITOR_TAB_MOVES_FOCUS="editorTabMovesFocus",t.KEYBINDING_CONTEXT_EDITOR_HAS_MULTIPLE_SELECTIONS="editorHasMultipleSelections",t.KEYBINDING_CONTEXT_EDITOR_HAS_NON_EMPTY_SELECTION="editorHasSelection",t.KEYBINDING_CONTEXT_EDITOR_LANGUAGE_ID="editorLangId",t.ViewEventNames={ModelFlushedEvent:"modelFlushedEvent",LinesDeletedEvent:"linesDeletedEvent",LinesInsertedEvent:"linesInsertedEvent",LineChangedEvent:"lineChangedEvent",TokensChangedEvent:"tokensChangedEvent",DecorationsChangedEvent:"decorationsChangedEvent",CursorPositionChangedEvent:"cursorPositionChangedEvent",CursorSelectionChangedEvent:"cursorSelectionChangedEvent",RevealRangeEvent:"revealRangeEvent",LineMappingChangedEvent:"lineMappingChangedEvent"},function(e){e[e.Value=0]="Value",e[e.Selection=1]="Selection",e[e.Position=2]="Position",e[e.Scroll=3]="Scroll"}(t.CodeEditorStateFlag||(t.CodeEditorStateFlag={}));t.CodeEditorStateFlag;t.EditorType={ICodeEditor:"vs.editor.ICodeEditor",IDiffEditor:"vs.editor.IDiffEditor"},t.ClassName={EditorWarningDecoration:"greensquiggly",EditorErrorDecoration:"redsquiggly"},t.EventType={Disposed:"disposed",ConfigurationChanged:"configurationChanged",ModelDispose:"modelDispose",ModelChanged:"modelChanged",ModelTokensChanged:"modelTokensChanged",ModelModeChanged:"modelsModeChanged",ModelModeSupportChanged:"modelsModeSupportChanged",ModelContentChanged:"contentChanged",ModelContentChanged2:"contentChanged2",ModelContentChangedFlush:"flush",ModelContentChangedLinesDeleted:"linesDeleted",ModelContentChangedLinesInserted:"linesInserted",ModelContentChangedLineChanged:"lineChanged",EditorTextBlur:"blur",EditorTextFocus:"focus",EditorFocus:"widgetFocus",EditorBlur:"widgetBlur",ModelPropertiesChanged:"propertiesChanged",ModelDecorationsChanged:"decorationsChanged",CursorPositionChanged:"positionChanged",CursorSelectionChanged:"selectionChanged",CursorRevealRange:"revealRange",ViewFocusGained:"focusGained",ViewFocusLost:"focusLost",ViewFocusChanged:"focusChanged",ViewScrollWidthChanged:"scrollWidthChanged",ViewScrollHeightChanged:"scrollHeightChanged",ViewScrollChanged:"scrollChanged",ViewZonesChanged:"zonesChanged",ViewLayoutChanged:"viewLayoutChanged",ContextMenu:"contextMenu",MouseDown:"mousedown",MouseUp:"mouseup",MouseMove:"mousemove",MouseLeave:"mouseleave",KeyDown:"keydown",KeyUp:"keyup",EditorLayout:"editorLayout",DiffUpdated:"diffUpdated"},t.Handler={ExecuteCommand:"executeCommand",ExecuteCommands:"executeCommands",CursorLeft:"cursorLeft",CursorLeftSelect:"cursorLeftSelect",CursorWordLeft:"cursorWordLeft",CursorWordLeftSelect:"cursorWordLeftSelect",CursorRight:"cursorRight",CursorRightSelect:"cursorRightSelect",CursorWordRight:"cursorWordRight",CursorWordRightSelect:"cursorWordRightSelect",CursorUp:"cursorUp",CursorUpSelect:"cursorUpSelect",CursorDown:"cursorDown",CursorDownSelect:"cursorDownSelect",CursorPageUp:"cursorPageUp",CursorPageUpSelect:"cursorPageUpSelect",CursorPageDown:"cursorPageDown",CursorPageDownSelect:"cursorPageDownSelect",CursorHome:"cursorHome",CursorHomeSelect:"cursorHomeSelect",CursorEnd:"cursorEnd",CursorEndSelect:"cursorEndSelect",CursorTop:"cursorTop",CursorTopSelect:"cursorTopSelect",CursorBottom:"cursorBottom",CursorBottomSelect:"cursorBottomSelect",AddCursorDown:"addCursorDown",AddCursorUp:"addCursorUp",CursorUndo:"cursorUndo",MoveTo:"moveTo",MoveToSelect:"moveToSelect",CreateCursor:"createCursor",LastCursorMoveToSelect:"lastCursorMoveToSelect",JumpToBracket:"jumpToBracket",Type:"type",ReplacePreviousChar:"replacePreviousChar",Paste:"paste",Tab:"tab",Indent:"indent",Outdent:"outdent",DeleteLeft:"deleteLeft",DeleteRight:"deleteRight",DeleteWordLeft:"deleteWordLeft",DeleteWordRight:"deleteWordRight",DeleteAllLeft:"deleteAllLeft",DeleteAllRight:"deleteAllRight",Enter:"enter",RemoveSecondaryCursors:"removeSecondaryCursors",CancelSelection:"cancelSelection",Cut:"cut",Undo:"undo",Redo:"redo",WordSelect:"wordSelect",WordSelectDrag:"wordSelectDrag",LastCursorWordSelect:"lastCursorWordSelect",LineSelect:"lineSelect",LineSelectDrag:"lineSelectDrag",LastCursorLineSelect:"lastCursorLineSelect",LastCursorLineSelectDrag:"lastCursorLineSelectDrag",LineInsertBefore:"lineInsertBefore",LineInsertAfter:"lineInsertAfter",LineBreakInsert:"lineBreakInsert",SelectAll:"selectAll"}}),define("vs/editor/common/model/modelLine",["require","exports","vs/base/common/strings","vs/editor/common/editorCommon"],function(e,t,n,r){function o(e){return"number"==typeof e[0]}function i(e,t,n){if(0===n)return null;if(!t||0===t.length)return null;if(1===t.length)if(o(t)){if(0===t[0])return null}else if(0===t[0].startIndex&&""===t[0].type&&!t[0].bracket)return null;return new f(e,t)}function s(e,t){return t&&0!==t.length?1===t.length&&0===t[0].startIndex?t[0].mode===e?null:new _(t[0].mode):new y(t):null}var a={adjust:function(){},finish:function(){}},u={adjust:function(){},finish:function(){}},c=function(){function e(e,t){this.lineNumber=e,this.text=t,this.isInvalid=!1}return e.prototype.setState=function(e){this._state=e},e.prototype.getState=function(){return this._state||null},e.prototype._setModeTransitions=function(e,t){var n=s(e,t);if(null===n){if("undefined"==typeof this._modeTransitions)return;return void(this._modeTransitions=null)}this._modeTransitions=n},e.prototype.getModeTransitions=function(){return this._modeTransitions?this._modeTransitions:v.INSTANCE},e.prototype.setTokens=function(e,t,n,r){this._setLineTokens(e,t),this._setModeTransitions(n,r)},e.prototype._setLineTokens=function(e,t){var n=i(e,t,this.text.length);if(null===n){if("undefined"==typeof this._lineTokens)return;return void(this._lineTokens=null)}this._lineTokens=n},e.prototype.getTokens=function(){return this._lineTokens?this._lineTokens:0===this.text.length?m.INSTANCE:g.INSTANCE},e.prototype._createTokensAdjuster=function(){if(!this._lineTokens)return a;var e=this._lineTokens,t=r.LineTokensBinaryEncoding,n=e.getBinaryEncodedTokens(),o=n.length,i=0,s=0,u=function(e,r,a){for(var u=a-1;e>s&&o>i;){if(s>0&&0!==r){var c=n[i]/t.TYPE_OFFSET&t.TYPE_MASK,l=n[i]/t.BRACKET_OFFSET&t.BRACKET_MASK,d=Math.max(u,s+r),h=l*t.BRACKET_OFFSET+c*t.TYPE_OFFSET+d*t.START_INDEX_OFFSET;if(0>r)for(;i>0;){var p=n[i-1]/t.START_INDEX_OFFSET&t.START_INDEX_MASK;if(!(p>=d))break;n.splice(i-1,1),o--,i--}n[i]=h}i++,o>i&&(s=n[i]/t.START_INDEX_OFFSET&t.START_INDEX_MASK)}},c=function(e,t){u(Number.MAX_VALUE,e,1)};return{adjust:u,finish:c}},e.prototype._setText=function(e){if(this.text=e,this._lineTokens){for(var t=r.LineTokensBinaryEncoding,n=this._lineTokens.getBinaryEncodedTokensMap(),o=this._lineTokens.getBinaryEncodedTokens(),i=this.text.length;o.length>0;){var s=o[o.length-1]/t.START_INDEX_OFFSET&t.START_INDEX_MASK;if(i>s)break;o.pop()}this._setLineTokens(n,o)}},e.prototype._createMarkersAdjuster=function(e){var t=this;if(!this._markers)return u;if(0===this._markers.length)return u;var n=this._markers,r=n.length,o=0,i=n[o],s=function(s,a,u,c,l){for(;r>o&&(i.column<s||!l&&i.column===s&&(c||i.stickToPreviousCharacter));){if(0!==a){var d=Math.max(u,i.column+a);i.column!==d&&(e[i.id]=!0,i.oldLineNumber=i.oldLineNumber||t.lineNumber,i.oldColumn=i.oldColumn||i.column,i.column=Math.max(u,i.column+a))}o++,r>o&&(i=n[o])}},a=function(e,t){s(Number.MAX_VALUE,e,1,!1,!1)};return{adjust:s,finish:a}},e.prototype.applyEdits=function(e,t){for(var n=0,r=this.text,o=this._createTokensAdjuster(),i=this._createMarkersAdjuster(e),s=0,a=t.length;a>s;s++){var u=t[s].startColumn,c=t[s].endColumn,l=n+t[s].startColumn,d=n+t[s].endColumn,h=t[s].text;o.adjust(u-1,n,1),i.adjust(u-1+1,n,1,l!==d,t[s].forceMoveMarkers);var p=Math.min(d-l,h.length);p>0&&(o.adjust(u-1+p,n,l),i.adjust(u-1+1+p,n,l,!0,t[s].forceMoveMarkers)),r=r.substring(0,l-1)+h+r.substring(d-1),n+=h.length-(d-l),o.adjust(c,n,l),i.adjust(c+1,n,l,!1,t[s].forceMoveMarkers)}return o.finish(n,r.length),i.finish(n,r.length),this._setText(r),n},e.prototype.split=function(t,n,r){var o=this.text.substring(0,n-1),i=this.text.substring(n-1),s=null;if(this._markers){for(var a=0,u=this._markers.length;u>a;a++){var c=this._markers[a];if(c.column>n||c.column===n&&(r||!c.stickToPreviousCharacter)){var l=this._markers.slice(0,a);s=this._markers.slice(a),this._markers=l;break}}if(s)for(var a=0,u=s.length;u>a;a++){var c=s[a];t[c.id]=!0,c.oldLineNumber=c.oldLineNumber||this.lineNumber,c.oldColumn=c.oldColumn||c.column,c.column-=n-1}}this._setText(o);var d=new e(this.lineNumber+1,i);return s&&d.addMarkers(s),d},e.prototype.append=function(e,t){var n=this.text.length;this._setText(this.text+t.text);var o=t._lineTokens;if(o){var i=o.getBinaryEncodedTokens();if(n>0)for(var s=r.LineTokensBinaryEncoding,a=0,u=i.length;u>a;a++){var c=i[a],l=c/s.START_INDEX_OFFSET&s.START_INDEX_MASK,d=c/s.TYPE_OFFSET&s.TYPE_MASK,h=c/s.BRACKET_OFFSET&s.BRACKET_MASK,p=l+n,f=h*s.BRACKET_OFFSET+d*s.TYPE_OFFSET+p*s.START_INDEX_OFFSET;i[a]=f}var m=this._lineTokens;m?this._setLineTokens(m.getBinaryEncodedTokensMap(),m.getBinaryEncodedTokens().concat(i)):this._setLineTokens(o.getBinaryEncodedTokensMap(),i)}if(t._markers){for(var g=t._markers,a=0,u=g.length;u>a;a++){var v=g[a];e[v.id]=!0,v.oldLineNumber=v.oldLineNumber||t.lineNumber,v.oldColumn=v.oldColumn||v.column,v.column+=n}this.addMarkers(g)}},e.prototype.addMarker=function(t){t.line=this,this._markers?this._markers.push(t):this._markers=[t],this._markers.sort(e._compareMarkers)},e.prototype.addMarkers=function(t){if(0!==t.length){var n,r;for(n=0,r=t.length;r>n;n++)t[n].line=this;this._markers?this._markers=this._markers.concat(t):this._markers=t.slice(0),this._markers.sort(e._compareMarkers)}},e._compareMarkers=function(e,t){return e.column===t.column?(e.stickToPreviousCharacter?0:1)-(t.stickToPreviousCharacter?0:1):e.column-t.column},e.prototype.removeMarker=function(e){var t=this._indexOfMarkerId(e.id);t>=0&&this._markers.splice(t,1),e.line=null},e.prototype.removeMarkers=function(e){if(this._markers)for(var t=0,n=this._markers.length;n>t;t++){var r=this._markers[t];e[r.id]&&(r.line=null,this._markers.splice(t,1),n--,t--)}},e.prototype.getMarkers=function(){return this._markers?this._markers.slice(0):[]},e.prototype.updateLineNumber=function(e,t){if(this._markers){var n,r,o,i=this._markers;for(n=0,r=i.length;r>n;n++)o=i[n],e[o.id]=!0,o.oldLineNumber=o.oldLineNumber||this.lineNumber}this.lineNumber=t},e.prototype.deleteLine=function(e,t,n){if(this._markers){var r,o,i,s=this._markers;for(r=0,o=s.length;o>r;r++)i=s[r],e[i.id]=!0,i.oldColumn=i.oldColumn||i.column,i.oldLineNumber=i.oldLineNumber||n,i.column=t;return s}return[]},e.prototype._indexOfMarkerId=function(e){if(this._markers){var t,n,r=this._markers;for(t=0,n=r.length;n>t;t++)if(r[t].id===e)return t}return-1},e}();t.ModelLine=c;var l=r.LineTokensBinaryEncoding.getStartIndex,d=r.LineTokensBinaryEncoding.getType,h=r.LineTokensBinaryEncoding.getBracket,p=r.LineTokensBinaryEncoding.findIndexOfOffset,f=function(){function e(e,t){this.map=e,o(t)?this._tokens=t:this._tokens=r.LineTokensBinaryEncoding.deflateArr(e,t)}return e.prototype.toString=function(){return r.LineTokensBinaryEncoding.inflateArr(this.map,this._tokens).toString()},e.prototype.getBinaryEncodedTokensMap=function(){return this.map},e.prototype.getBinaryEncodedTokens=function(){return this._tokens},e.prototype.getTokenCount=function(){return this._tokens.length},e.prototype.getTokenStartIndex=function(e){return l(this._tokens[e])},e.prototype.getTokenType=function(e){return d(this.map,this._tokens[e])},e.prototype.getTokenBracket=function(e){return h(this._tokens[e])},e.prototype.getTokenEndIndex=function(e,t){return e+1<this._tokens.length?l(this._tokens[e+1]):t},e.prototype.equals=function(e){return this===e},e.prototype.findIndexOfOffset=function(e){return p(this._tokens,e)},e}();t.LineTokens=f;var m=function(){function e(){}return e.prototype.getBinaryEncodedTokens=function(){return e.TOKENS},e.prototype.getBinaryEncodedTokensMap=function(){return null},e.prototype.getTokenCount=function(){return 0},e.prototype.getTokenStartIndex=function(e){return 0},e.prototype.getTokenType=function(e){return n.empty},e.prototype.getTokenBracket=function(e){return 0},e.prototype.getTokenEndIndex=function(e,t){return 0},e.prototype.equals=function(e){return e===this},e.prototype.findIndexOfOffset=function(e){return 0},e.INSTANCE=new e,e.TOKENS=[],e}(),g=function(){function e(){}return e.prototype.getBinaryEncodedTokensMap=function(){return null},e.prototype.getBinaryEncodedTokens=function(){return e.TOKENS},e.prototype.getTokenCount=function(){return 1},e.prototype.getTokenStartIndex=function(e){return 0},e.prototype.getTokenType=function(e){return n.empty},e.prototype.getTokenBracket=function(e){return 0},e.prototype.getTokenEndIndex=function(e,t){return t},e.prototype.equals=function(e){return this===e},e.prototype.findIndexOfOffset=function(e){return 0},e.INSTANCE=new e,e.TOKENS=[0],e}();t.DefaultLineTokens=g;var v=function(){function e(){}return e.prototype.toArray=function(e){return[{startIndex:0,mode:e}]},e.INSTANCE=new e,e}(),_=function(){function e(e){this._mode=e}return e.prototype.toArray=function(e){return[{startIndex:0,mode:this._mode}]},e}(),y=function(){function e(e){this._modeTransitions=e}return e.prototype.toArray=function(e){return this._modeTransitions.slice(0)},e}()});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/model/textModel",["require","exports","vs/base/common/eventEmitter","vs/base/common/strings","vs/editor/common/core/position","vs/editor/common/core/range","vs/editor/common/model/modelLine","vs/editor/common/editorCommon","vs/base/common/platform"],function(e,t,n,r,o,i,s,a,u){var c=" ".charCodeAt(0),l="	".charCodeAt(0),d=999,h=u.isLinux||u.isMacintosh?"\n":"\r\n",p=function(e){function t(t,n){t.push(a.EventType.ModelContentChanged),e.call(this,t),this._constructLines(n),this._setVersionId(1),this._isDisposed=!1,this._isDisposing=!1}return __extends(t,e),t.prototype.getVersionId=function(){if(this._isDisposed)throw new Error("TextModel.getVersionId: Model is disposed");return this._versionId},t.prototype.getAlternativeVersionId=function(){if(this._isDisposed)throw new Error("TextModel.getAlternativeVersionId: Model is disposed");return this._alternativeVersionId},t.prototype._increaseVersionId=function(){this._setVersionId(this._versionId+1)},t.prototype._setVersionId=function(e){this._versionId=e,this._alternativeVersionId=this._versionId},t.prototype._overwriteAlternativeVersionId=function(e){this._alternativeVersionId=e},t.prototype.isDisposed=function(){return this._isDisposed},t.prototype.dispose=function(){if(this._isDisposed)throw new Error("TextModel.dispose: Model is disposed");this._isDisposed=!0,this._lines=null,this._EOL=null,this._BOM=null,e.prototype.dispose.call(this)},t.prototype._createContentChangedFlushEvent=function(){return{changeType:a.EventType.ModelContentChangedFlush,detail:null,versionId:-1,isUndoing:!1,isRedoing:!1}},t.prototype._emitContentChanged2=function(e,t,n,r,o,s,u,c){var l={range:new i.Range(e,t,n,r),rangeLength:o,text:s,versionId:this.getVersionId(),isUndoing:u,isRedoing:c};this._isDisposing||this.emit(a.EventType.ModelContentChanged2,l)},t.prototype._resetValue=function(e,n){this._constructLines(t.toRawText(n)),this._increaseVersionId(),e.detail=this.toRawText(),e.versionId=this._versionId},t.prototype.toRawText=function(){return{BOM:this._BOM,EOL:this._EOL,lines:this.getLinesContent(),length:this.getValueLength()}},t.prototype.setValue=function(e){if(this._isDisposed)throw new Error("TextModel.setValue: Model is disposed");if(null!==e){var t=this.getFullModelRange(),n=this.getValueLengthInRange(t),r=this.getLineCount(),o=this.getLineMaxColumn(r),i=this._createContentChangedFlushEvent();this._resetValue(i,e),this._emitModelContentChangedFlushEvent(i),this._emitContentChanged2(1,1,r,o,n,this.getValue(),!1,!1)}},t.prototype.getValue=function(e,t){if(void 0===t&&(t=!1),this._isDisposed)throw new Error("TextModel.getValue: Model is disposed");var n=this.getFullModelRange(),r=this.getValueInRange(n,e);return t?this._BOM+r:r},t.prototype.getValueLength=function(e,t){if(void 0===t&&(t=!1),this._isDisposed)throw new Error("TextModel.getValueLength: Model is disposed");var n=this.getFullModelRange(),r=this.getValueLengthInRange(n,e);return t?this._BOM.length+r:r},t.prototype.getEmptiedValueInRange=function(e,t,n){if(void 0===t&&(t=""),void 0===n&&(n=a.EndOfLinePreference.TextDefined),this._isDisposed)throw new Error("TextModel.getEmptiedValueInRange: Model is disposed");var r=this.validateRange(e);if(r.isEmpty())return"";if(r.startLineNumber===r.endLineNumber)return this._repeatCharacter(t,r.endColumn-r.startColumn);var o=this._getEndOfLine(n),i=r.startLineNumber-1,s=r.endLineNumber-1,u=[];u.push(this._repeatCharacter(t,this._lines[i].text.length-r.startColumn+1));for(var c=i+1;s>c;c++)u.push(this._repeatCharacter(t,this._lines[c].text.length));return u.push(this._repeatCharacter(t,r.endColumn-1)),u.join(o)},t.prototype._repeatCharacter=function(e,t){for(var n="",r=0;t>r;r++)n+=e;return n},t.prototype.getValueInRange=function(e,t){if(void 0===t&&(t=a.EndOfLinePreference.TextDefined),this._isDisposed)throw new Error("TextModel.getValueInRange: Model is disposed");var n=this.validateRange(e);if(n.isEmpty())return"";if(n.startLineNumber===n.endLineNumber)return this._lines[n.startLineNumber-1].text.substring(n.startColumn-1,n.endColumn-1);var r=this._getEndOfLine(t),o=n.startLineNumber-1,i=n.endLineNumber-1,s=[];s.push(this._lines[o].text.substring(n.startColumn-1));for(var u=o+1;i>u;u++)s.push(this._lines[u].text);return s.push(this._lines[i].text.substring(0,n.endColumn-1)),s.join(r)},t.prototype.getValueLengthInRange=function(e,t){if(void 0===t&&(t=a.EndOfLinePreference.TextDefined),this._isDisposed)throw new Error("TextModel.getValueInRange: Model is disposed");var n=this.validateRange(e);if(n.isEmpty())return 0;if(n.startLineNumber===n.endLineNumber)return n.endColumn-n.startColumn;var r=this._getEndOfLine(t).length,o=n.startLineNumber-1,i=n.endLineNumber-1,s=0;s+=this._lines[o].text.length-n.startColumn+1;for(var u=o+1;i>u;u++)s+=r+this._lines[u].text.length;return s+=r+(n.endColumn-1)},t.prototype.isDominatedByLongLines=function(e){if(this._isDisposed)throw new Error("TextModel.isDominatedByLongLines: Model is disposed");
var t,n,r,o=0,i=0,s=this._lines;for(t=0,n=this._lines.length;n>t;t++)r=s[t].text.length,r>=e?i+=r:o+=r;return i>o},t.prototype._extractIndentationFactors=function(){var e,t,n,r,o,i,s,a,u,d,h,p=this._lines,f=0,m="",g=0,v=[],_=0,y=[];for(e=0,t=p.length;t>e;e++){for(s=p[e].text,a=!1,u=0,h=0,d=0,n=0,r=s.length;r>n;n++)if(o=s.charCodeAt(n),o===l)d++;else{if(o!==c){a=!0,u=n;break}h++}if(1===h&&(h=0),a&&(d>0||h>0)&&(f++,d>0&&_++,h>0&&(y[h]=(y[h]||0)+1)),a){h=0;var k=!0;for(n=0;g>n&&u>n;n++)i=m.charCodeAt(n),o=s.charCodeAt(n),k&&i!==o&&(k=!1),k||(i===c&&h++,o===c&&h++);for(;g>n;n++)i=m.charCodeAt(n),i===c&&h++;for(;u>n;n++)o=s.charCodeAt(n),o===c&&h++;1===h&&(h=0),h>0&&(v[h]=(v[h]||0)+1),g=u,m=s}}return{linesWithIndentationCount:f,linesIndentedWithTabs:_,relativeSpaceCounts:v,absoluteSpaceCounts:y}},t.prototype.guessIndentation=function(e){if(this._isDisposed)throw new Error("TextModel.guessIndentation: Model is disposed");var t,n,r=this._extractIndentationFactors(),o=r.linesWithIndentationCount,i=r.linesIndentedWithTabs,s=r.absoluteSpaceCounts,a=r.relativeSpaceCounts,u=0;for(t=1,n=s.length;n>t;t++)u+=s[t]||0;if(i>=u)return{insertSpaces:!1,tabSize:e};if(6>o&&i>0)return{insertSpaces:!1,tabSize:e};var c,l,d,h,p=[];for(c=2,n=s.length;n>c;c++)if(s[c]){for(l=0,d=0,h=c;n>h;h+=c)s[h]?l+=s[h]:d+=c/h;p[c]=l/(1+d)}var f=e,m=0,g=[2,4,6,8];for(t=0;t<g.length;t++)c=g[t],l=(p[c]||0)+(a[c]||0),l>m&&(f=c,m=l);return{insertSpaces:!0,tabSize:f}},t.prototype.getLineCount=function(){if(this._isDisposed)throw new Error("TextModel.getLineCount: Model is disposed");return this._lines.length},t.prototype.getLineContent=function(e){if(this._isDisposed)throw new Error("TextModel.getLineContent: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");return this._lines[e-1].text},t.prototype.getLinesContent=function(){if(this._isDisposed)throw new Error("TextModel.getLineContent: Model is disposed");for(var e=[],t=0,n=this._lines.length;n>t;t++)e[t]=this._lines[t].text;return e},t.prototype.getEOL=function(){if(this._isDisposed)throw new Error("TextModel.getEOL: Model is disposed");return this._EOL},t.prototype.setEOL=function(e){var t=e===a.EndOfLineSequence.CRLF?"\r\n":"\n";if(this._EOL!==t){var n=this.getFullModelRange(),r=this.getValueLengthInRange(n),o=this.getLineCount(),i=this.getLineMaxColumn(o);this._EOL=t,this._increaseVersionId();var s=this._createContentChangedFlushEvent();s.detail=this.toRawText(),s.versionId=this._versionId,this._emitModelContentChangedFlushEvent(s),this._emitContentChanged2(1,1,o,i,r,this.getValue(),!1,!1)}},t.prototype.getLineMinColumn=function(e){return 1},t.prototype.getLineMaxColumn=function(e){if(this._isDisposed)throw new Error("TextModel.getLineMaxColumn: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");return this._lines[e-1].text.length+1},t.prototype.getLineFirstNonWhitespaceColumn=function(e){if(this._isDisposed)throw new Error("TextModel.getLineFirstNonWhitespaceColumn: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");var t=r.firstNonWhitespaceIndex(this._lines[e-1].text);return-1===t?0:t+1},t.prototype.getLineLastNonWhitespaceColumn=function(e){if(this._isDisposed)throw new Error("TextModel.getLineLastNonWhitespaceColumn: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");var t=r.lastNonWhitespaceIndex(this._lines[e-1].text);return-1===t?0:t+2},t.prototype.validateLineNumber=function(e){if(this._isDisposed)throw new Error("TextModel.validateLineNumber: Model is disposed");return 1>e&&(e=1),e>this._lines.length&&(e=this._lines.length),e},t.prototype.validatePosition=function(e){if(this._isDisposed)throw new Error("TextModel.validatePosition: Model is disposed");var t=e.lineNumber?e.lineNumber:1,n=e.column?e.column:1;1>t&&(t=1),t>this._lines.length&&(t=this._lines.length),1>n&&(n=1);var r=this.getLineMaxColumn(t);return n>r&&(n=r),new o.Position(t,n)},t.prototype.validateRange=function(e){if(this._isDisposed)throw new Error("TextModel.validateRange: Model is disposed");var t=this.validatePosition(new o.Position(e.startLineNumber,e.startColumn)),n=this.validatePosition(new o.Position(e.endLineNumber,e.endColumn));return new i.Range(t.lineNumber,t.column,n.lineNumber,n.column)},t.prototype.modifyPosition=function(e,t){if(this._isDisposed)throw new Error("TextModel.modifyPosition: Model is disposed");for(var n=this.validatePosition(e);t>0;){var r=this.getLineMaxColumn(n.lineNumber);if(n.column<r){var o=Math.min(t,r-n.column);t-=o,n.column+=o}if(0===t)break;if(t-=this._EOL.length,0>t)throw new Error("TextModel.modifyPosition: Breaking line terminators");if(++n.lineNumber,n.lineNumber>this._lines.length)throw new Error("TextModel.modifyPosition: Offset goes beyond the end of the model");n.column=1}for(;0>t;){if(n.column>1){var i=Math.min(-t,n.column-1);t+=i,n.column-=i}if(0===t)break;if(t+=this._EOL.length,t>0)throw new Error("TextModel.modifyPosition: Breaking line terminators");if(--n.lineNumber,n.lineNumber<1)throw new Error("TextModel.modifyPosition: Offset goes beyond the beginning of the model");n.column=this.getLineMaxColumn(n.lineNumber)}return n},t.prototype.getFullModelRange=function(){if(this._isDisposed)throw new Error("TextModel.getFullModelRange: Model is disposed");var e=this.getLineCount();return new i.Range(1,1,e,this.getLineMaxColumn(e))},t.prototype._emitModelContentChangedFlushEvent=function(e){this._isDisposing||this.emit(a.EventType.ModelContentChanged,e)},t.toRawText=function(e){for(var t=0,n=-1;-1!==(n=e.indexOf("\r",n+1));)t++;var o=e.split(/\r\n|\r|\n/),i="";r.startsWithUTF8BOM(o[0])&&(i=r.UTF8_BOM_CHARACTER,o[0]=o[0].substr(1));var s=o.length-1,a="";return a=0===s?h:t>s/2?"\r\n":"\n",{BOM:i,EOL:a,lines:o,length:e.length}},t.prototype._constructLines=function(e){var t,n,r=e.lines,o=[];for(t=0,n=r.length;n>t;t++)o.push(new s.ModelLine(t+1,r[t]));this._BOM=e.BOM,this._EOL=e.EOL,this._lines=o},t.prototype._getEndOfLine=function(e){switch(e){case a.EndOfLinePreference.LF:return"\n";case a.EndOfLinePreference.CRLF:return"\r\n";case a.EndOfLinePreference.TextDefined:return this.getEOL()}throw new Error("Unknown EOL preference")},t.prototype._toRegExp=function(e,t,n,o){if(""===e)return null;var i=null;try{i=r.createRegExp(e,t,n,o)}catch(s){return null}try{if(r.regExpLeadsToEndlessLoop(i))return null}catch(s){return null}return i},t.prototype.findMatches=function(e,t,n,r,o,s){if(void 0===s&&(s=d),this._isDisposed)throw new Error("Model.findMatches: Model is disposed");var a=this._toRegExp(e,n,r,o);if(!a)return[];var u;return u=i.Range.isIRange(t)?t:this.getFullModelRange(),this._doFindMatches(u,a,s)},t.prototype.findNextMatch=function(e,t,n,r,o){if(this._isDisposed)throw new Error("Model.findNextMatch: Model is disposed");var i=this._toRegExp(e,n,r,o);if(!i)return null;var s,a,u=this.validatePosition(t),c=this.getLineCount(),l=u.lineNumber;if(s=this._lines[l-1].text.substring(u.column-1),a=this._findMatchInLine(i,s,l,u.column-1))return a;for(var d=1;c>d;d++){var h=(l+d-1)%c;if(s=this._lines[h].text,a=this._findMatchInLine(i,s,h+1,0))return a}return null},t.prototype._doFindMatches=function(e,t,n){var r,o=[],i=0;if(e.startLineNumber===e.endLineNumber)return r=this._lines[e.startLineNumber-1].text.substring(e.startColumn-1,e.endColumn-1),i=this._findMatchesInLine(t,r,e.startLineNumber,e.startColumn-1,i,o,n),o;r=this._lines[e.startLineNumber-1].text.substring(e.startColumn-1),i=this._findMatchesInLine(t,r,e.startLineNumber,e.startColumn-1,i,o,n);for(var s=e.startLineNumber+1;s<e.endLineNumber&&n>i;s++)i=this._findMatchesInLine(t,this._lines[s-1].text,s,0,i,o,n);return n>i&&(r=this._lines[e.endLineNumber-1].text.substring(0,e.endColumn-1),i=this._findMatchesInLine(t,r,e.endLineNumber,0,i,o,n)),o},t.prototype._findMatchInLine=function(e,t,n,r){var o=e.exec(t);return o?new i.Range(n,o.index+1+r,n,o.index+1+o[0].length+r):null},t.prototype._findMatchesInLine=function(e,t,n,r,o,s,a){var u;do if(u=e.exec(t),u&&(s.push(new i.Range(n,u.index+1+r,n,u.index+1+u[0].length+r)),o++,o>=a))return o;while(u);return o},t}(n.OrderGuaranteeEventEmitter);t.TextModel=p}),define("vs/editor/common/model/textModelWithTokensHelpers",["require","exports","vs/editor/common/modes/nullMode","vs/editor/common/core/range","vs/editor/common/editorCommon","vs/editor/common/core/arrays","vs/base/common/errors"],function(e,t,n,r,o,i,s){var a=o.LineTokensBinaryEncoding.getType,u=o.LineTokensBinaryEncoding.getBracket,c=o.LineTokensBinaryEncoding.getStartIndex,l=function(){function e(){}return e._safeGetWordDefinition=function(e){var t=null;if(e.tokenTypeClassificationSupport)try{t=e.tokenTypeClassificationSupport.getWordDefinition()}catch(n){s.onUnexpectedError(n)}return t},e.ensureValidWordDefinition=function(e){var t=n.NullMode.DEFAULT_WORD_REGEXP;if(e&&e instanceof RegExp)if(e.global)t=e;else{var r="g";e.ignoreCase&&(r+="i"),e.multiline&&(r+="m"),t=new RegExp(e.source,r)}return t.lastIndex=0,t},e.massageWordDefinitionOf=function(t){return e.ensureValidWordDefinition(e._safeGetWordDefinition(t))},e.getWords=function(t,n){if(!t._lineIsTokenized(n))return e._getWordsInText(t.getLineContent(n),e.massageWordDefinitionOf(t.getMode()));var r=[],o=t.getLineContent(n);if(o.length>0){var i,s,a,u,c,l,d,h,p,f,m,g,v=t._getLineModeTransitions(n);for(i=0,c=0,s=v.length;s>i;i++)if(d=e.massageWordDefinitionOf(v[i].mode),c=v[i].startIndex,l=s>i+1?v[i+1].startIndex:o.length,h=o.substring(c,l),p=h.match(d))for(m=0,a=0,u=p.length;u>a;a++)g=p[a],g.length>0&&(f=h.indexOf(g,m),m=f+g.length,r.push({start:c+f,end:c+m}))}return r},e._getWordsInText=function(e,t){var n,r,o,i,s,a,u=e.match(t)||[],c=[];for(n=0;n<u.length;n++)a=u[n].trim(),a.length>0&&(r=e.indexOf(a,o),o=r+a.length,i=r,s=o,c.push({start:i,end:s}));return c},e._getWordAtColumn=function(t,n,r,o){var i=o[r].startIndex,s=r+1<o.length?o[r+1].startIndex:t.length,a=o[r].mode;return e._getWordAtText(n,e.massageWordDefinitionOf(a),t.substring(i,s),i)},e.getWordAtPosition=function(t,n){if(!t._lineIsTokenized(n.lineNumber))return e._getWordAtText(n.column,e.massageWordDefinitionOf(t.getMode()),t.getLineContent(n.lineNumber),0);var r=null,o=t.getLineContent(n.lineNumber),s=t._getLineModeTransitions(n.lineNumber),a=n.column-1,u=i.Arrays.findIndexInSegmentsArray(s,a);return r=e._getWordAtColumn(o,n.column,u,s),!r&&u>0&&s[u].startIndex===a&&(r=e._getWordAtColumn(o,n.column,u-1,s)),r},e._getWordAtText=function(e,t,n,r){var o,i,s,a,u,c,l=n.match(t);if(l)for(o=0;o<l.length;o++)if(c=l[o].trim(),c.length>0&&(i=n.indexOf(c,s),s=i+c.length,a=r+i+1,u=r+s+1,e>=a&&u>=e))return{word:c,startColumn:a,endColumn:u};return null},e}();t.WordHelper=l;var d=function(){function e(){}return e._sign=function(e){return 0>e?-1:e>0?1:0},e._findMatchingBracketUp=function(t,n,o,i,s){var l,d,h,p=s;for(l=o;l>=1;l--){var f=t.getLineTokens(l,!1),m=f.getBinaryEncodedTokens(),g=f.getBinaryEncodedTokensMap(),v=t.getLineContent(l);for(h=(l===o?i:m.length)-1;h>=0;h--)if(a(g,m[h])===n&&(p+=e._sign(u(m[h])),0===p))return d=h===m.length-1?v.length:c(m[h+1]),new r.Range(l,c(m[h])+1,l,d+1)}return null},e._findMatchingBracketDown=function(t,n,o,i,s){var l,d,h,p,f,m=1;for(l=o,d=t.getLineCount();d>=l;l++){if(s&&!t._lineIsTokenized(l))return{range:null,isAccurate:!1};var g=t.getLineTokens(l,!1),v=g.getBinaryEncodedTokens(),_=g.getBinaryEncodedTokensMap(),y=t.getLineContent(l);for(p=l===o?i+1:0,f=v.length;f>p;p++)if(a(_,v[p])===n&&(m+=e._sign(u(v[p])),0===m))return h=p===v.length-1?y.length:c(v[p+1]),{range:new r.Range(l,c(v[p])+1,l,h+1),isAccurate:!0}}return{range:null,isAccurate:!0}},e.findMatchingBracketUp=function(t,n,r){var o,i,s,a=r.column-1,u=-1,l=t.getLineTokens(r.lineNumber,!1),d=l.getBinaryEncodedTokens(),h=t.getLineContent(r.lineNumber);for(o=0,i=d.length;-1===u&&i>o;o++)s=o===i-1?h.length:c(d[o+1]),c(d[o])<=a&&s>=a&&(u=o);return e._findMatchingBracketUp(t,n,r.lineNumber,u+1,0)},e.matchBracket=function(t,n,o){if(o&&!t._lineIsTokenized(n.lineNumber))return{brackets:null,isAccurate:!1};var i,s,l=t.getLineContent(n.lineNumber),d={brackets:null,isAccurate:!0};if(l.length>0){var h,p,f,m,g,v=n.column-1,_=t.getLineTokens(n.lineNumber,!1),y=_.getBinaryEncodedTokens(),k=_.getBinaryEncodedTokensMap();for(i=0,s=y.length;null===d.brackets&&s>i;i++)if(h=y[i],f=c(h),g=a(k,h),m=u(h),p=i===s-1?l.length:c(y[i+1]),v>=f&&p>=v){if(0>m){var b=e._findMatchingBracketUp(t,g,n.lineNumber,i,-1);b&&(d.brackets=[new r.Range(n.lineNumber,f+1,n.lineNumber,p+1),b])}if(null===d.brackets&&m>0){var E=e._findMatchingBracketDown(t,g,n.lineNumber,i,o);d.isAccurate=E.isAccurate,E.range&&(d.brackets=[new r.Range(n.lineNumber,f+1,n.lineNumber,p+1),E.range])}}}return d},e}();t.BracketsHelper=d}),define("vs/editor/common/model/tokenIterator",["require","exports","vs/editor/common/editorCommon"],function(e,t,n){var r=n.LineTokensBinaryEncoding.getStartIndex,o=n.LineTokensBinaryEncoding.inflate,i=function(){function e(e,t){this._model=e,this._currentLineNumber=t.lineNumber,this._currentTokenIndex=0,this._readLineTokens(this._currentLineNumber),this._next=null,this._prev=null;for(var n=t.column-1,o=Number.MAX_VALUE,i=this._currentTokens.length-1;i>=0;i--){if(r(this._currentTokens[i])<=n&&o>=n){this._currentTokenIndex=i,this._next=this._current(),this._prev=this._current();break}o=r(this._currentTokens[i])}}return e.prototype._readLineTokens=function(e){this._currentLineTokens=this._model.getLineTokens(e,!1),this._currentTokens=this._currentLineTokens.getBinaryEncodedTokens(),this._map=this._currentLineTokens.getBinaryEncodedTokensMap()},e.prototype._advanceNext=function(){if(this._prev=this._next,this._next=null,this._currentTokenIndex+1<this._currentTokens.length)this._currentTokenIndex++,this._next=this._current();else{for(;this._currentLineNumber+1<=this._model.getLineCount();)if(this._currentLineNumber++,this._readLineTokens(this._currentLineNumber),this._currentTokens.length>0){this._currentTokenIndex=0,this._next=this._current();break}null===this._next&&(this._readLineTokens(this._currentLineNumber),this._currentTokenIndex=this._currentTokens.length,this._advancePrev(),this._next=null)}},e.prototype._advancePrev=function(){if(this._next=this._prev,this._prev=null,this._currentTokenIndex>0)this._currentTokenIndex--,this._prev=this._current();else for(;this._currentLineNumber>1;)if(this._currentLineNumber--,this._readLineTokens(this._currentLineNumber),this._currentTokens.length>0){this._currentTokenIndex=this._currentTokens.length-1,this._prev=this._current();break}},e.prototype._current=function(){return{token:o(this._map,this._currentTokens[this._currentTokenIndex]),lineNumber:this._currentLineNumber,startColumn:r(this._currentTokens[this._currentTokenIndex])+1,endColumn:this._currentTokenIndex+1<this._currentTokens.length?r(this._currentTokens[this._currentTokenIndex+1])+1:this._model.getLineContent(this._currentLineNumber).length+1}},e.prototype.hasNext=function(){return null!==this._next},e.prototype.next=function(){var e=this._next;return this._advanceNext(),e},e.prototype.hasPrev=function(){return null!==this._prev},e.prototype.prev=function(){var e=this._prev;return this._advancePrev(),e},e.prototype._invalidate=function(){var e=function(){throw new Error("iteration isn't valid anymore")};this.hasNext=e,this.next=e,this.hasPrev=e,this.prev=e},e}();t.TokenIterator=i}),define("vs/editor/common/modes/autoIndentation",["require","exports","vs/base/common/strings","vs/editor/common/modes"],function(e,t,n,r){var o;!function(e){e[e.Unknown=0]="Unknown",e[e.Lowercase=1]="Lowercase",e[e.Uppercase=2]="Uppercase",e[e.Camelcase=3]="Camelcase"}(o||(o={}));var i=function(){function e(e,t,n,r){void 0===t&&(t=[]),void 0===n&&(n=null),void 0===r&&(r=!1),this.brackets=e,this.regexBrackets=t?t:[],this.docComment=n?n:null,this.caseInsensitive=r?r:!1}return e.prototype.getElectricCharacters=function(){for(var e,t=[],n=this.brackets.length,r=0;n>r;r++)if(e=this.brackets[r],e.isElectric){var o=e.close.charAt(e.close.length-1);t.push(this.caseInsensitive?o.toLowerCase():o)}var i;n=this.regexBrackets.length;for(var r=0;n>r;r++)i=this.regexBrackets[r],i.openTrigger&&t.push(this.caseInsensitive?i.openTrigger.toLowerCase():i.openTrigger),i.closeTrigger&&t.push(this.caseInsensitive?i.closeTrigger.toLowerCase():i.closeTrigger);if(this.docComment&&t.push(this.docComment.open.charAt(this.docComment.open.length-1)),this.caseInsensitive)for(var s=t.length,r=0;s>r;++r)t.push(t[r].toUpperCase());return t=t.filter(function(e,t,n){return n.indexOf(e)==t})},e.prototype.onEnter=function(e,t){return 0===e.getTokenCount()?null:this._onEnterRegexBrackets(e,t)},e.prototype.onElectricCharacter=function(e,t){return 0===e.getTokenCount()?null:this._onElectricCharacterDocComment(e,t)||this._onElectricCharacterRegexBrackets(e,t)||this._onElectricCharacterStandardBrackets(e,t)},e.prototype.stringIsBracket=function(e){var t=e;this.caseInsensitive&&(t=e.toLowerCase());for(var n,r=0;r<this.brackets.length;r++)if(n=this.brackets[r],t===n.open||t===n.close)return!0;return!1},e.prototype.containsTokenTypes=function(e,t){for(var n=t.split("."),r=0;r<n.length;++r)if(e.indexOf(n[r])<0)return!1;return!0},e.prototype._onEnterRegexBrackets=function(e,t){for(var n=0;n<this.regexBrackets.length;++n){var o=this.regexBrackets[n],i=e.getLineContent();this.caseInsensitive&&(i=i.toLowerCase());var s=i.substr(0,t),a=s.match(o.open);if(a){if(o.closeComplete){s=i.substring(t);var u=a[0].replace(o.open,o.closeComplete);if(0===s.indexOf(u))return{indentAction:r.IndentAction.IndentOutdent}}return{indentAction:r.IndentAction.Indent}}}return null},e.prototype._onElectricCharacterStandardBrackets=function(e,t){var r=e.findIndexOfOffset(t),o=e.getTokenText(r),i=e.getTokenType(r);if(!this.stringIsBracket(o))return null;if(r>=0&&e.getTokenEndIndex(r)-1>t)return null;var s=n.firstNonWhitespaceIndex(e.getLineContent());return-1!==s&&s<=t-o.length?null:{matchBracketType:i}},e.prototype._onElectricCharacterRegexBrackets=function(e,t){for(var n=e.getLineContent(),r=0;r<this.regexBrackets.length;++r){var o=this.regexBrackets[r];if(o.openTrigger&&o.closeComplete&&(n.charAt(t)===o.openTrigger||this.caseInsensitive&&n.charAt(t).toLowerCase()===o.openTrigger.toLowerCase())){var i=n.substr(0,t+1),s=i.match(o.open);if(s){var a=s[0].replace(o.open,o.closeComplete);return o.matchCase&&(a=this._changeLettercase(a,this._detectLetercase(s[0]))),{appendText:a}}}if(o.closeTrigger&&(n.charAt(t)===o.closeTrigger||this.caseInsensitive&&n.charAt(t).toLowerCase()===o.closeTrigger.toLowerCase())){var s=i.match(o.close);if(s){var u=s[0];return this.caseInsensitive&&(u=u.toLowerCase()),{matchBracketType:u.replace(o.close,o.tokenType)}}}}return null},e.prototype._onElectricCharacterDocComment=function(e,t){if(!this.docComment||!this.docComment.close)return null;var n=e.getLineContent(),r=n[t];if(r!==this.docComment.open.charAt(this.docComment.open.length-1))return null;if(n.indexOf(this.docComment.close,t)>=0)return null;var o=e.findIndexOfOffset(t);return this.containsTokenTypes(e.getTokenType(o),this.docComment.scope)?n.substring(e.getTokenStartIndex(o),t+1)!==this.docComment.open?null:{appendText:this.docComment.close}:null},e.prototype._detectLetercase=function(e){return e.toLowerCase()===e?o.Lowercase:e.toUpperCase()===e?o.Uppercase:e.length>1&&e.charAt(0).toUpperCase()===e.charAt(0)&&e.charAt(1).toLowerCase()===e.charAt(1)?o.Camelcase:o.Unknown},e.prototype._changeLettercase=function(e,t){switch(t){case o.Lowercase:return e.toLowerCase();case o.Uppercase:return e.toUpperCase();case o.Camelcase:for(var n=e.toLowerCase().split(" "),r=0;r<n.length;++r)n[r]=n[r].charAt(0).toUpperCase()+n[r].substr(1);return n.join(" ");default:return e}},e}();t.Brackets=i}),define("vs/editor/common/modes/modesFilters",["require","exports","vs/base/common/filters"],function(e,t,n){function r(e){return function(t,n){var r=e(t,n.filterText||n.label);return n.highlights=r||[],!!r}}function o(e,t){return function(n,r){return e(n,r)||t(n,r)}}function i(e,t){return function(n,r){return e(n,r)&&t(n,r)}}t.StrictPrefix=r(n.matchesStrictPrefix),t.Prefix=r(n.matchesPrefix),t.CamelCase=r(n.matchesCamelCase),t.ContiguousSubString=r(n.matchesContiguousSubString),t.or=o,t.and=i,t.DefaultFilter=o(o(t.Prefix,t.CamelCase),t.ContiguousSubString)});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/modes/supports",["require","exports","vs/base/common/winjs.base","vs/base/common/strings","vs/editor/common/modes/lineStream","vs/editor/common/modes/nullMode","vs/editor/common/modes/autoIndentation","vs/editor/common/modes/modesFilters","vs/editor/common/modes","vs/editor/common/core/arrays"],function(e,t,n,r,o,i,s,a,u,c){function l(e,t,n){var r=e.modeTransitions;if(1===r.length)return n(r[0].mode,e,t);var o=c.Arrays.findIndexInSegmentsArray(r,t),i=r[o].mode,s=r[o].startIndex,a=e.findIndexOfOffset(s),u=-1,l=-1;o+1<r.length?(l=e.findIndexOfOffset(r[o+1].startIndex),u=e.getTokenStartIndex(l)):(l=e.getTokenCount(),u=e.getLineContent().length);var d=e.getTokenStartIndex(a),h=new f(e,i,a,l,d,u);return n(i,h,t-d)}function d(e,t,n,o){if(void 0===o&&(o=!1),!Array.isArray(n)||0===n.length)return!1;if(e.getLineContent().length<=t)return!1;for(var i=e.findIndexOfOffset(t),s=e.getTokenType(i),a=0,u=n.length;u>a;a++)if(o){if(s.indexOf(n[a])>=0)return!0}else if(r.endsWith(s,n[a]))return!0;return!1}function h(e){return"function"==typeof e}var p=function(){function e(e,t,n){this.startIndex=e,this.type=t,this.bracket=n}return e.prototype.toString=function(){return"("+this.startIndex+", "+this.type+", "+this.bracket+")"},e}();t.Token=p,t.handleEvent=l,t.isLineToken=d;var f=function(){function e(e,t,n,r,o,i){this.modeTransitions=[{startIndex:0,mode:t}],this._actual=e,this._firstTokenInModeIndex=n,this._nextTokenAfterMode=r,this._firstTokenCharacterOffset=o,this._nextCharacterAfterModeIndex=i}return e.prototype.getLineContent=function(){var e=this._actual.getLineContent();return e.substring(this._firstTokenCharacterOffset,this._nextCharacterAfterModeIndex)},e.prototype.getTokenCount=function(){return this._nextTokenAfterMode-this._firstTokenInModeIndex},e.prototype.findIndexOfOffset=function(e){return this._actual.findIndexOfOffset(e+this._firstTokenCharacterOffset)-this._firstTokenInModeIndex},e.prototype.getTokenStartIndex=function(e){return this._actual.getTokenStartIndex(e+this._firstTokenInModeIndex)-this._firstTokenCharacterOffset},e.prototype.getTokenEndIndex=function(e){return this._actual.getTokenEndIndex(e+this._firstTokenInModeIndex)-this._firstTokenCharacterOffset},e.prototype.getTokenType=function(e){return this._actual.getTokenType(e+this._firstTokenInModeIndex)},e.prototype.getTokenBracket=function(e){return this._actual.getTokenBracket(e+this._firstTokenInModeIndex)},e.prototype.getTokenText=function(e){return this._actual.getTokenText(e+this._firstTokenInModeIndex)},e}();t.FilteredLineContext=f;var m=function(){function e(e){this._mode=e}return Object.defineProperty(e.prototype,"mode",{get:function(){return this._mode},enumerable:!0,configurable:!0}),e}();t.AbstractSupport=m;var g=function(e){function t(t,n,r,o){if(e.call(this,t),this.customization=n,this.supportsNestedModes=r,this._embeddedModesListeners={},this.supportsNestedModes&&!this.mode.registerSupport)throw new Error("Cannot be a mode with nested modes unless I can emit a tokenizationSupport changed event!");this.shouldGenerateEmbeddedModels=o,this.defaults={enterNestedMode:!h(n.enterNestedMode),getNestedMode:!h(n.getNestedMode),getNestedModeInitialState:!h(n.getNestedModeInitialState),getLeavingNestedModeData:!h(n.getLeavingNestedModeData),onReturningFromNestedMode:!h(n.onReturningFromNestedMode)}}return __extends(t,e),t.prototype.dispose=function(){for(var e in this._embeddedModesListeners)this._embeddedModesListeners[e].dispose(),delete this._embeddedModesListeners[e]},t.prototype.getInitialState=function(){return this.customization.getInitialState()},t.prototype.tokenize=function(e,t,n,r){return void 0===n&&(n=0),void 0===r&&(r=n+e.length),t.getMode()!==this.mode?this._nestedTokenize(e,t,n,r,[],[]):this._myTokenize(e,t,n,r,[],[])},t.prototype._nestedTokenize=function(e,t,n,r,o,s){for(var a=t.getStateData(),u=this.getLeavingNestedModeData(e,a),c=t;c.getStateData()&&c.getStateData().getMode()!==this.mode;)c=c.getStateData();var l=c.getMode();if(!u){var d;return d=l.tokenizationSupport?l.tokenizationSupport.tokenize(e,t,n,r):i.nullTokenize(l,e,t,n),d.tokens=o.concat(d.tokens),d.modeTransitions=s.concat(d.modeTransitions),d}var h=u.nestedModeBuffer;if(h.length>0){var p;p=l.tokenizationSupport?l.tokenizationSupport.tokenize(h,t,n,r):i.nullTokenize(l,h,t,n),t=p.endState,o=o.concat(p.tokens),s=s.concat(p.modeTransitions)}var f=u.bufferAfterNestedMode,m=u.stateAfterNestedMode;return m.setStateData(a.getStateData()),this.onReturningFromNestedMode(m,t),this._myTokenize(f,m,n+h.length,r,o,s)},t.prototype._myTokenize=function(e,n,r,i,s,a){var c,l,d=this,h=new o.LineStream(e),f=null,m=null;n=n.clone(),(a.length<=0||a[a.length-1].mode!==this.mode)&&a.push({startIndex:r,mode:this.mode});for(var g=Math.min(i-r,e.length),v=u.Bracket.None;h.pos()<g;){l=h.pos();do{if(c=n.tokenize(h),null===c||void 0===c||(void 0===c.type||null===c.type)&&(void 0===c.nextState||null===c.nextState))throw new Error("Tokenizer must return a valid state");if(c.nextState&&(c.nextState.setStateData(n.getStateData()),n=c.nextState),h.pos()<=l)throw new Error("Stream did not advance while tokenizing. Mode id is "+this.mode.getId()+' (stuck at token type: "'+c.type+'", prepend tokens: "'+s.map(function(e){return e.type}).join(",")+'").')}while(!c.type&&""!==c.type);if((f!==c.type||c.bracket||null===f)&&s.push(new p(l+r,c.type,c.bracket||v)),f=c.type,this.supportsNestedModes&&this.enterNestedMode(n)){var _=this._getEmbeddedLevel(n);if(_<t.MAX_EMBEDDED_LEVELS){var y=this.getNestedModeInitialState(n),k=y.state.getMode();if("function"==typeof k.addSupportChangedListener&&!this._embeddedModesListeners.hasOwnProperty(k.getId())){var b=!1;this._embeddedModesListeners[k.getId()]=k.addSupportChangedListener(function(e){b||e.tokenizationSupport&&(b=!0,d.mode.registerSupport("tokenizationSupport",function(e){return e.tokenizationSupport}),b=!1)})}if(!h.eos()){var E=e.substr(h.pos()),T=this._nestedTokenize(E,y.state,r+h.pos(),i,s,a);return T.retokenize=T.retokenize||y.missingModePromise,T}n=y.state,m=y.missingModePromise}}}return{tokens:s,actualStopOffset:h.pos()+r,modeTransitions:a,endState:n,retokenize:m}},t.prototype._getEmbeddedLevel=function(e){for(var t=-1;e;)t++,e=e.getStateData();return t},t.prototype.enterNestedMode=function(e){return this.defaults.enterNestedMode?!1:this.customization.enterNestedMode(e)},t.prototype.getNestedMode=function(e){return this.defaults.getNestedMode?null:this.customization.getNestedMode(e)},t._validatedNestedMode=function(e){var t=new i.NullMode,n=null;return e&&e.mode&&(t=e.mode),e&&e.missingModePromise&&(n=e.missingModePromise),{mode:t,missingModePromise:n}},t.prototype.getNestedModeInitialState=function(e){if(this.defaults.getNestedModeInitialState){var n,r=t._validatedNestedMode(this.getNestedMode(e)),o=r.missingModePromise;return n=r.mode.tokenizationSupport?r.mode.tokenizationSupport.getInitialState():new i.NullState(r.mode,null),n.setStateData(e),{state:n,missingModePromise:o}}return this.customization.getNestedModeInitialState(e)},t.prototype.getLeavingNestedModeData=function(e,t){return this.defaults.getLeavingNestedModeData?null:this.customization.getLeavingNestedModeData(e,t)},t.prototype.onReturningFromNestedMode=function(e,t){return this.defaults.onReturningFromNestedMode?null:this.customization.onReturningFromNestedMode(e,t)},t.MAX_EMBEDDED_LEVELS=5,t}(m);t.TokenizationSupport=g;var v=function(e){function t(t,n){e.call(this,t),this.contribution=n,this.brackets=new s.Brackets(n.brackets,n.regexBrackets,n.docComment,n.caseInsensitive)}return __extends(t,e),t.prototype.getElectricCharacters=function(){return Array.isArray(this.contribution.embeddedElectricCharacters)?this.contribution.embeddedElectricCharacters.concat(this.brackets.getElectricCharacters()):this.brackets.getElectricCharacters()},t.prototype.onElectricCharacter=function(e,t){var n=this;return l(e,t,function(e,t,r){return n.mode===e?n.brackets.onElectricCharacter(t,r):e.electricCharacterSupport?e.electricCharacterSupport.onElectricCharacter(t,r):null})},t.prototype.onEnter=function(e,t){var n=this;return l(e,t,function(e,t,r){return n.mode===e?n.brackets.onEnter(t,r):e.electricCharacterSupport?e.electricCharacterSupport.onEnter(t,r):null})},t}(m);t.BracketElectricCharacterSupport=v;var _=function(e){function t(t,n){e.call(this,t),this.contribution=n}return __extends(t,e),t.prototype.canFindDeclaration=function(e,t){var n=this;return l(e,t,function(e,t,r){return n.mode===e?!Array.isArray(n.contribution.tokens)||n.contribution.tokens.length<1||d(t,r,n.contribution.tokens):e.declarationSupport?e.declarationSupport.canFindDeclaration(t,r):!1})},t.prototype.findDeclaration=function(e,t){return this.contribution.findDeclaration(e,t)},t}(m);t.DeclarationSupport=_;var y=function(e){function t(t,n){e.call(this,t),this.contribution=n}return __extends(t,e),t.prototype.canFindTypeDeclaration=function(e,t){var n=this;return l(e,t,function(e,t,r){return n.mode===e?!Array.isArray(n.contribution.tokens)||n.contribution.tokens.length<1||d(t,r,n.contribution.tokens):e.typeDeclarationSupport?e.typeDeclarationSupport.canFindTypeDeclaration(t,r):!1})},t.prototype.findTypeDeclaration=function(e,t){return this.contribution.findTypeDeclaration(e,t)},t}(m);t.TypeDeclarationSupport=y;var k=function(e){function t(t,n){e.call(this,t),this.contribution=n}return __extends(t,e),t.prototype.canFindReferences=function(e,t){var n=this;return l(e,t,function(e,t,r){return n.mode===e?!Array.isArray(n.contribution.tokens)||n.contribution.tokens.length<1||d(t,r,n.contribution.tokens):e.referenceSupport?e.referenceSupport.canFindReferences(t,r):!1})},t.prototype.findReferences=function(e,t,n){return this.contribution.findReferences(e,t,n)},t}(m);t.ReferenceSupport=k;var b=function(e){function t(t,n){e.call(this,t),this.contribution=n}return __extends(t,e),t.prototype.getParameterHintsTriggerCharacters=function(){return this.contribution.triggerCharacters},t.prototype.shouldTriggerParameterHints=function(e,t){var n=this;return l(e,t,function(e,t,r){return n.mode===e?Array.isArray(n.contribution.excludeTokens)?1===n.contribution.excludeTokens.length&&"*"===n.contribution.excludeTokens[0]?!1:!d(t,r-1,n.contribution.excludeTokens):!0:e.parameterHintsSupport?e.parameterHintsSupport.shouldTriggerParameterHints(t,r):!1})},t.prototype.getParameterHints=function(e,t){return this.contribution.getParameterHints(e,t)},t}(m);t.ParameterHintsSupport=b;var E=function(e){function t(t,n){if(e.call(this,t),this.contribution=n,this.suggest=function(e,t){return n.suggest(e,t)},"function"==typeof n.getSuggestionDetails&&(this.getSuggestionDetails=function(e,t,r){return n.getSuggestionDetails(e,t,r)}),this.sortByType=[],this.separatorForType=[],Array.isArray(n.sortBy)&&n.sortBy.length>0)for(var r=0;r<n.sortBy.length;++r)this.sortByType.push(n.sortBy[r].type),this.separatorForType.push(n.sortBy[r].partSeparator)}return __extends(t,e),t.prototype.shouldAutotriggerSuggest=function(e,t,n){var r=this;return l(e,t,function(e,t,o){return r.mode===e?r.contribution.disableAutoTrigger?!1:Array.isArray(r.contribution.excludeTokens)?1===r.contribution.excludeTokens.length&&"*"===r.contribution.excludeTokens[0]?!1:!d(t,o-1,r.contribution.excludeTokens,!0):!0:e.suggestSupport?e.suggestSupport.shouldAutotriggerSuggest(t,o,n):!1})},t.prototype.getFilter=function(){return a.DefaultFilter},t.prototype.getSorter=function(){var e=this;return function(t,n){if(e.sortByType.length>0){
var o=e.sortByType.indexOf(t.type),i=e.sortByType.indexOf(n.type);if(0>o&&(o=e.sortByType.length),0>i&&(i=e.sortByType.length),i>o)return-1;if(o>i)return 1;if(o<e.sortByType.length){var s=e.separatorForType[o],a="string"==typeof s&&s.length>0?t.label.split(s):[t.label],u="string"==typeof s&&s.length>0?n.label.split(s):[n.label];if(a.length<u.length)return-1;if(a.length>u.length)return 1;for(var c=0;c<a.length;c++){var l=r.localeCompare(a[c],u[c]);if(0!==l)return l}return 0}}var d=0;return t.sortText&&n.sortText&&(d=t.sortText.localeCompare(n.sortText)),d||(d=r.localeCompare(t.label.toLowerCase(),n.label.toLowerCase())),r.localeCompare(t.documentationLabel||"",n.documentationLabel||"")}},t.prototype.getTriggerCharacters=function(){return this.contribution.triggerCharacters},t.prototype.shouldShowEmptySuggestionList=function(){return!0},t}(m);t.SuggestSupport=E;var T=function(e){function t(t,n){e.call(this,t,n),this.suggest=function(e,t){return n.suggest(e,t).then(function(r){return n.composeSuggest(e,t,r)})}}return __extends(t,e),t}(E);t.ComposableSuggestSupport=T;var S=function(e){function t(t,n){e.call(this,t),this._autoClosingPairs=n.autoClosingPairs,this._surroundingPairs=Array.isArray(n.surroundingPairs)?n.surroundingPairs:n.autoClosingPairs}return __extends(t,e),t.prototype.getAutoClosingPairs=function(){return this._autoClosingPairs},t.prototype.shouldAutoClosePair=function(e,t,n){var r=this;return l(t,n,function(t,n,o){if(r.mode===t){if(0===n.getTokenCount())return!0;for(var i=n.findIndexOfOffset(o-1),s=n.getTokenType(i),a=0;a<r._autoClosingPairs.length;++a)if(r._autoClosingPairs[a].open===e){if(r._autoClosingPairs[a].notIn)for(var u=0;u<r._autoClosingPairs[a].notIn.length;++u)if(s.indexOf(r._autoClosingPairs[a].notIn[u])>-1)return!1;break}return!0}return t.characterPairSupport?t.characterPairSupport.shouldAutoClosePair(e,n,o):null})},t.prototype.getSurroundingPairs=function(){return this._surroundingPairs},t}(m);t.CharacterPairSupport=S;var C=function(){function e(){}return e.prototype.valueSetsReplace=function(e,t,n){for(var r=null,o=0,i=e.length;null===r&&i>o;o++)r=this.valueSetReplace(e[o],t,n);return r},e.prototype.valueSetReplace=function(e,t,n){var r=e.indexOf(t);return r>=0?(r+=n?1:-1,0>r?r=e.length-1:r%=e.length,e[r]):null},e}();t.ReplaceSupport=new C;var M=function(){function e(e){void 0===e&&(e=null),this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]],this.defaults={textReplace:!e||!h(e.textReplace),navigateValueSetFallback:!e||!h(e.navigateValueSetFallback)},this.customization=e}return e.prototype.navigateValueSet=function(e,t,r){var o=this.doNavigateValueSet(e,t,r,!0);return o&&o.value&&o.range?n.TPromise.as(o):this.defaults.navigateValueSetFallback?n.TPromise.as(null):this.customization.navigateValueSetFallback(e,t,r)},e.prototype.doNavigateValueSet=function(e,t,n,r){var o,i=this.getModel(e),s={range:null,value:null};if(r)t.startColumn===t.endColumn&&(t.endColumn+=1),o=i.getValueInRange(t),s.range=t;else{var a={lineNumber:t.startLineNumber,column:t.startColumn},u=i.getWordAtPosition(a);if(!u||-1===u.startColumn)return null;o=u.word,s.range={startLineNumber:t.startLineNumber,endLineNumber:t.endLineNumber,startColumn:u.startColumn,endColumn:u.endColumn}}var c=this.numberReplace(o,n);if(null!==c)s.value=c;else{var l=this.textReplace(o,n);if(null!==l)s.value=l;else if(r)return this.doNavigateValueSet(e,t,n,!1)}return s},e.prototype.numberReplace=function(e,t){var n=Math.pow(10,e.length-(e.lastIndexOf(".")+1)),r=Number(e),o=parseFloat(e);return isNaN(r)||isNaN(o)||r!==o?null:0!==r||t?(r=Math.floor(r*n),r+=t?n:-n,String(r/n)):null},e.prototype.textReplace=function(e,n){return this.defaults.textReplace?t.ReplaceSupport.valueSetsReplace(this._defaultValueSet,e,n):this.customization.textReplace(e,n)||t.ReplaceSupport.valueSetsReplace(this._defaultValueSet,e,n)},e.prototype.getModel=function(e){throw new Error("Not implemented")},e}();t.AbstractInplaceReplaceSupport=M;var w=function(e){function t(t,n){void 0===n&&(n=null),e.call(this,n),this.resourceService=t}return __extends(t,e),t.prototype.getModel=function(e){return this.resourceService.get(e)},t}(M);t.WorkerInplaceReplaceSupport=w;var I=function(e){function t(t,n){void 0===n&&(n=null),e.call(this,n),this.modelService=t}return __extends(t,e),t.prototype.getModel=function(e){return this.modelService.getModel(e)},t}(M);t.MainInplaceReplaceSupport=I;var x=function(){function e(e){this._contribution=e}return e.prototype.getCommentsConfiguration=function(){return this._contribution.commentsConfiguration},e}();t.CommentsSupport=x;var L=function(){function e(e){this._contribution=e}return e.prototype.getWordDefinition=function(){return"undefined"==typeof this._contribution.wordDefinition?i.NullMode.DEFAULT_WORD_REGEXP:this._contribution.wordDefinition},e}();t.TokenTypeClassificationSupport=L}),define("vs/editor/common/modes/supports/onEnter",["require","exports","vs/editor/common/modes/supports","vs/editor/common/modes","vs/base/common/errors","vs/base/common/strings"],function(e,t,n,r,o,i){var s=function(){function e(t,n){n=n||{},n.brackets=n.brackets||[{open:"(",close:")"},{open:"{",close:"}"},{open:"[",close:"]"}],this._modeId=t,this._brackets=n.brackets.map(function(t){return{open:t.open,openRegExp:e._createOpenBracketRegExp(t.open),close:t.close,closeRegExp:e._createCloseBracketRegExp(t.close)}}),this._regExpRules=n.regExpRules||[],this._indentationRules=n.indentationRules}return e.prototype.onEnter=function(e,t){var r=this,o=e.getLineContext(t.lineNumber);return n.handleEvent(o,t.column-1,function(n,o,i){return r._modeId===n.getId()?r._onEnter(e,t):n.onEnterSupport?n.onEnterSupport.onEnter(e,t):null})},e.prototype._onEnter=function(e,t){var n=e.getLineContent(t.lineNumber),r=n.substr(0,t.column-1),o=n.substr(t.column-1),i=1===t.lineNumber?"":e.getLineContent(t.lineNumber-1);return this._actualOnEnter(i,r,o)},e.prototype._actualOnEnter=function(t,n,r){for(var o=0,i=this._regExpRules.length;i>o;o++){var s=this._regExpRules[o];if(s.beforeText.test(n)){if(!s.afterText)return s.action;if(s.afterText.test(r))return s.action}}if(n.length>0&&r.length>0)for(var o=0,i=this._brackets.length;i>o;o++){var a=this._brackets[o];if(a.openRegExp.test(n)&&a.closeRegExp.test(r))return e._INDENT_OUTDENT}if(this._indentationRules){if(this._indentationRules.increaseIndentPattern&&this._indentationRules.increaseIndentPattern.test(n))return e._INDENT;if(this._indentationRules.indentNextLinePattern&&this._indentationRules.indentNextLinePattern.test(n))return e._INDENT;if(/^\s/.test(n)){if(this._indentationRules.decreaseIndentPattern&&this._indentationRules.decreaseIndentPattern.test(r))return e._OUTDENT;if(this._indentationRules.indentNextLinePattern&&this._indentationRules.indentNextLinePattern.test(t))return e._OUTDENT}}if(n.length>0)for(var o=0,i=this._brackets.length;i>o;o++){var a=this._brackets[o];if(a.openRegExp.test(n))return e._INDENT}return null},e._createOpenBracketRegExp=function(t){var n=i.escapeRegExpCharacters(t);return/\B/.test(n.charAt(0))||(n="\\b"+n),n+="\\s*$",e._safeRegExp(n)},e._createCloseBracketRegExp=function(t){var n=i.escapeRegExpCharacters(t);return/\B/.test(n.charAt(n.length-1))||(n+="\\b"),n="^\\s*"+n,e._safeRegExp(n)},e._safeRegExp=function(e){try{return new RegExp(e)}catch(t){return o.onUnexpectedError(t),null}},e._INDENT={indentAction:r.IndentAction.Indent},e._INDENT_OUTDENT={indentAction:r.IndentAction.IndentOutdent},e._OUTDENT={indentAction:r.IndentAction.Outdent},e}();t.OnEnterSupport=s}),define("vs/editor/common/modes/textToHtmlTokenizer",["require","exports","vs/base/common/strings","vs/editor/common/modes/nullMode"],function(e,t,n,r){function o(e,t){return a(e,s(t))}function i(e,t,n){return u(e,s(t),n)}function s(e){return e&&e.tokenizationSupport?e.tokenizationSupport:{shouldGenerateEmbeddedModels:!1,getInitialState:function(){return new r.NullState(null,null)},tokenize:function(e,t,n,o){return void 0===n&&(n=0),r.nullTokenize(null,e,t,n,o)}}}function a(e,t){var n={tagName:"div",style:"white-space: pre",children:[]},r=function(e,t){n.children.push({tagName:"span",className:e,text:t})},o=function(){n.children.push({tagName:"br"})};return c(e,t,r,o),n}function u(e,t,r){void 0===r&&(r=""),r&&r.length>0&&(r=" "+r);var o="",i=function(e,t){o+='<span class="'+e+r+'">'+n.escape(t)+"</span>"},s=function(){o+="<br/>"};return o='<div style="white-space: pre;">',c(e,t,i,s),o+="</div>"}function c(e,t,n,r){for(var o=e.split(/\r\n|\r|\n/),i=t.getInitialState(),s=0;s<o.length;s++)i=l(o[s],t,n,i),s<o.length-1&&r()}function l(e,t,n,r){for(var o,i=t.tokenize(e,r),s=i.endState,a=i.tokens,u=0,c=0;c<a.length;c++){var l=a[c];c<a.length-1?(o=e.substring(u,a[c+1].startIndex),u=a[c+1].startIndex):o=e.substr(u);var d="token",h=l.type.replace(/[^a-z0-9\-]/gi," ");h.length>0&&(d+=" "+h),n(d,o)}return s}t.tokenizeToHtmlContent=o,t.tokenizeToString=i}),define("vs/nls!vs/editor/common/model/textModelWithTokens",["vs/nls","vs/nls!vs/editor/common/worker/editorWorkerServer"],function(e,t){return e.create("vs/editor/common/model/textModelWithTokens",t)});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/model/textModelWithTokens",["require","exports","vs/nls!vs/editor/common/model/textModelWithTokens","vs/base/common/timer","vs/editor/common/modes/nullMode","vs/editor/common/model/textModelWithTokensHelpers","vs/editor/common/model/tokenIterator","vs/editor/common/model/textModel","vs/editor/common/config/defaultConfig","vs/editor/common/editorCommon","vs/base/common/async","vs/editor/common/core/arrays","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/winjs.base"],function(e,t,n,r,o,i,s,a,u,c,l,d,h,p,f,m){var g=function(){function e(){this._inflate=[""],this._deflate={"":0}}return e}();t.TokensInflatorMap=g;var v=function(){function e(e,t){var n=this;this._modePromise=e,this._externalModePromise=new m.TPromise(function(e,t,r){n._externalModePromise_c=e,n._externalModePromise_e=t},function(){}),this._model=t,this._isDisposed=!1,m.TPromise.timeout(0).then(function(){return n._modePromise}).then(function(e){if(n._isDisposed)return void n._externalModePromise_c(!1);var t=n._model;n.dispose(),t.setMode(e),t._warmUpTokens(),n._externalModePromise_c(!0)}).done(null,function(e){n._externalModePromise_e(e),h.onUnexpectedError(e)})}return e.prototype.getModePromise=function(){return this._externalModePromise},e.prototype.dispose=function(){this._modePromise=null,this._model=null,this._isDisposed=!0},e}(),_=function(){function e(e,t){var n=this;this._retokenizePromise=e,this._model=t,this._isDisposed=!1,this.isFulfilled=!1,m.TPromise.timeout(0).then(function(){return n._retokenizePromise}).then(function(){n._isDisposed||(n.isFulfilled=!0,n._model.onRetokenizerFulfilled())}).done(null,h.onUnexpectedError)}return e.prototype.getRange=function(){return null},e.prototype.dispose=function(){this._retokenizePromise=null,this._model=null,this._isDisposed=!0},e}();t.FullModelRetokenizer=_;var y=function(){function e(e,t){this.modeTransitions=t.getModeTransitions().toArray(e),this._text=t.text,this._lineTokens=t.getTokens()}return e.prototype.getLineContent=function(){return this._text},e.prototype.getTokenCount=function(){return this._lineTokens.getTokenCount()},e.prototype.getTokenStartIndex=function(e){return this._lineTokens.getTokenStartIndex(e)},e.prototype.getTokenEndIndex=function(e){return this._lineTokens.getTokenEndIndex(e,this._text.length)},e.prototype.getTokenType=function(e){return this._lineTokens.getTokenType(e)},e.prototype.getTokenBracket=function(e){return this._lineTokens.getTokenBracket(e)},e.prototype.getTokenText=function(e){var t=this._lineTokens.getTokenStartIndex(e),n=this._lineTokens.getTokenEndIndex(e,this._text.length);return this._text.substring(t,n)},e.prototype.findIndexOfOffset=function(e){return this._lineTokens.findIndexOfOffset(e)},e}(),k=function(e){function t(n,r,i,s){var a=this;if(n.push(c.EventType.ModelTokensChanged),n.push(c.EventType.ModelModeChanged),n.push(c.EventType.ModelModeSupportChanged),e.call(this,n,r),this._shouldAutoTokenize=i,this._shouldSimplifyMode=r.length>t.MODEL_SYNC_LIMIT,this._shouldDenyMode=r.length>t.MODEL_TOKENIZATION_LIMIT,this._stopLineTokenizationAfter=u.DefaultConfig.editor.stopLineTokenizationAfter,s)if(m.TPromise.is(s)){var d=s._value;if(d&&"function"==typeof d.getId)this._mode=this._massageMode(d),this._resetModeListener(this._mode);else{var h=s;this._modeToModelBinder=new v(h,this),this._mode=new o.NullMode}}else this._mode=this._massageMode(s),this._resetModeListener(this._mode);else this._mode=new o.NullMode;this._revalidateTokensTimeout=-1,this._scheduleRetokenizeNow=new l.RunOnceScheduler(function(){return a._retokenizeNow()},200),this._retokenizers=[],this._resetTokenizationState()}return __extends(t,e),t.prototype.dispose=function(){this._modeToModelBinder&&(this._modeToModelBinder.dispose(),this._modeToModelBinder=null),this._resetModeListener(null),this._clearTimers(),this._mode=null,this._lastState=null,this._tokensInflatorMap=null,this._retokenizers=p.disposeAll(this._retokenizers),this._scheduleRetokenizeNow.dispose(),e.prototype.dispose.call(this)},t.prototype._massageMode=function(e){return this._shouldDenyMode?new o.NullMode:this._shouldSimplifyMode?new b(e):e},t.prototype.whenModeIsReady=function(){var e=this;return this._modeToModelBinder?this._modeToModelBinder.getModePromise().then(function(){return e._mode}):m.TPromise.as(this._mode)},t.prototype.onRetokenizerFulfilled=function(){this._scheduleRetokenizeNow.schedule()},t.prototype._retokenizeNow=function(){var e=this._retokenizers.filter(function(e){return e.isFulfilled});this._retokenizers=this._retokenizers.filter(function(e){return!e.isFulfilled});for(var t=!1,n=0;n<e.length;n++)e[n].getRange()||(t=!0);if(t){for(var n=0,r=this._lines.length;r>n;n++)this._lines[n].isInvalid=!0;this._invalidLineStartIndex=0}else{for(var o=Number.MAX_VALUE,n=0;n<e.length;n++){var i=e[n].getRange();o=Math.min(o,i.startLineNumber);for(var s=i.startLineNumber;s<=i.endLineNumber;s++)this._lines[s-1].isInvalid=!0}o-1<this._invalidLineStartIndex&&(this._invalidLineStartIndex<this._lines.length&&(this._lines[this._invalidLineStartIndex].isInvalid=!0),this._invalidLineStartIndex=o-1)}this._beginBackgroundTokenization();for(var n=0;n<e.length;n++)e[n].dispose()},t.prototype._createRetokenizer=function(e,t){return new _(e,this)},t.prototype._resetValue=function(t,n){e.prototype._resetValue.call(this,t,n),this._resetTokenizationState()},t.prototype._resetMode=function(e,t){this._mode=t,this._resetModeListener(t),this._resetTokenizationState(),this.emitModelTokensChangedEvent(1,this.getLineCount())},t.prototype._resetModeListener=function(e){var t=this;this._modeListener&&(this._modeListener.dispose(),this._modeListener=null),e&&"function"==typeof e.addSupportChangedListener&&(this._modeListener=e.addSupportChangedListener(function(e){return t._onModeSupportChanged(e)}))},t.prototype._onModeSupportChanged=function(e){this._emitModelModeSupportChangedEvent(e),e.tokenizationSupport&&(this._resetTokenizationState(),this.emitModelTokensChangedEvent(1,this.getLineCount()))},t.prototype._resetTokenizationState=function(){this._retokenizers=p.disposeAll(this._retokenizers),this._scheduleRetokenizeNow.cancel(),this._clearTimers();for(var e=0;e<this._lines.length;e++)this._lines[e].setState(null);this._initializeTokenizationState(),this._tokenizationElapsedTime=0,this._tokenizationTotalCharacters=1},t.prototype._clearTimers=function(){-1!==this._revalidateTokensTimeout&&(clearTimeout(this._revalidateTokensTimeout),this._revalidateTokensTimeout=-1)},t.prototype._initializeTokenizationState=function(){var e=null;if(this._mode.tokenizationSupport)try{e=this._mode.tokenizationSupport.getInitialState()}catch(n){n.friendlyMessage=t.MODE_TOKENIZATION_FAILED_MSG,h.onUnexpectedError(n),this._mode=new o.NullMode}e||(e=new o.NullState(this._mode,null)),this._lines[0].setState(e),this._lastState=null,this._tokensInflatorMap=new g,this._invalidLineStartIndex=0,this._beginBackgroundTokenization()},t.prototype.setStopLineTokenizationAfter=function(e){if(this._isDisposed)throw new Error("TextModelWithTokens.setStopLineTokenizationAfter: Model is disposed");this._stopLineTokenizationAfter=e},t.prototype.getLineTokens=function(e,t){if(void 0===t&&(t=!1),this._isDisposed)throw new Error("TextModelWithTokens.getLineTokens: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");return t||this._updateTokensUntilLine(e,!0),this._lines[e-1].getTokens()},t.prototype.getLineContext=function(e){if(this._isDisposed)throw new Error("TextModelWithTokens.getLineContext: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");return this._updateTokensUntilLine(e,!0),new y(this._mode,this._lines[e-1])},t.prototype._getInternalTokens=function(e){return this._updateTokensUntilLine(e,!0),this._lines[e-1].getTokens()},t.prototype.setValue=function(t,n){if(void 0===n&&(n=null),this._isDisposed)throw new Error("TextModelWithTokens.setValue: Model is disposed");if(null!==t&&e.prototype.setValue.call(this,t),n)if(this._modeToModelBinder&&(this._modeToModelBinder.dispose(),this._modeToModelBinder=null),m.TPromise.is(n))this._modeToModelBinder=new v(n,this);else{var r=this._massageMode(n);if(this._mode!==r){var o={oldMode:this._mode,newMode:r};this._resetMode(o,r),this._emitModelModeChangedEvent(o)}}},t.prototype.getMode=function(){if(this._isDisposed)throw new Error("TextModelWithTokens.getMode: Model is disposed");return this._mode},t.prototype.setMode=function(e){if(this._isDisposed)throw new Error("TextModelWithTokens.setMode: Model is disposed");e&&this.setValue(null,e)},t.prototype.getModeAtPosition=function(e,t){if(this._isDisposed)throw new Error("TextModelWithTokens.getModeAtPosition: Model is disposed");var n=this.validatePosition({lineNumber:e,column:t}),r=n.lineNumber,o=n.column;if(1===o)return this.getStateBeforeLine(r).getMode();if(o===this.getLineMaxColumn(r))return this.getStateAfterLine(r).getMode();var i=this._getLineModeTransitions(r),s=d.Arrays.findIndexInSegmentsArray(i,o-1);return i[s].mode},t.prototype._invalidateLine=function(e){this._lines[e].isInvalid=!0,e<this._invalidLineStartIndex&&(this._invalidLineStartIndex<this._lines.length&&(this._lines[this._invalidLineStartIndex].isInvalid=!0),this._invalidLineStartIndex=e,this._beginBackgroundTokenization())},t.prototype._updateLineTokens=function(e,t,n,r){this._lines[e].setTokens(t,r.tokens,n,r.modeTransitions)},t.prototype._beginBackgroundTokenization=function(){var e=this;this._shouldAutoTokenize&&-1===this._revalidateTokensTimeout&&(this._revalidateTokensTimeout=setTimeout(function(){e._revalidateTokensTimeout=-1,e._revalidateTokensNow()},0))},t.prototype._warmUpTokens=function(){if(this._isDisposed)throw new Error("TextModelWithTokens._warmUpTokens: Model is disposed");for(var e=Math.min(100,this.getLineCount()),t=e,n=1;e>=n;n++){var r=this._lines[n-1].text;if(r.length>=200){t=n-1;break}}this._revalidateTokensNow(t)},t.prototype._revalidateTokensNow=function(e){void 0===e&&(e=this._invalidLineStartIndex+1e6);var t=r.start(r.Topic.EDITOR,"backgroundTokenization");e=Math.min(this._lines.length,e);for(var n,o=20,i=this._invalidLineStartIndex+1,s=0,a=0,u=0,c=this._stopLineTokenizationAfter,l=f.StopWatch.create(),d=i;e>=d;d++){if(n=l.elapsed(),n>o){e=d-1;break}if(a=this._lines[d-1].text.length,-1!==c&&a>c&&(a=c),s>0&&(u=n/s*a,n+u>o)){e=d-1;break}this._updateTokensUntilLine(d,!1),s+=a}n=l.elapsed();var h=r.start(r.Topic.EDITOR,"**speed: "+this._tokenizationTotalCharacters/this._tokenizationElapsedTime);h.stop(),e>=i&&this.emitModelTokensChangedEvent(i,e),this._invalidLineStartIndex<this._lines.length&&this._beginBackgroundTokenization(),t.stop()},t.prototype.getStateBeforeLine=function(e){return this._updateTokensUntilLine(e-1,!0),this._lines[e-1].getState()},t.prototype.getStateAfterLine=function(e){return this._updateTokensUntilLine(e,!0),e<this._lines.length?this._lines[e].getState():this._lastState},t.prototype._getLineModeTransitions=function(e){if(this._isDisposed)throw new Error("TextModelWithTokens._getLineModeTransitions: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");return this._updateTokensUntilLine(e,!0),this._lines[e-1].getModeTransitions().toArray(this._mode)},t.prototype._updateTokensUntilLine=function(e,n){var r=this._lines.length,i=e-1,s=this._stopLineTokenizationAfter;-1===s&&(s=1e9);for(var a=f.StopWatch.create(),u=0,c=this._invalidLineStartIndex+1,l=e,d=this._invalidLineStartIndex;i>=d;d++){var p=d+1,m=null,g=this._lines[d].text;if(this._mode.tokenizationSupport){try{m=this._mode.tokenizationSupport.tokenize(this._lines[d].text,this._lines[d].getState(),0,s),u=m?m.actualStopOffset:this._lines[d].text.length}catch(v){v.friendlyMessage=t.MODE_TOKENIZATION_FAILED_MSG,h.onUnexpectedError(v)}m&&m.retokenize&&this._retokenizers.push(this._createRetokenizer(m.retokenize,d+1)),m&&m.tokens&&m.tokens.length>0&&(m.actualStopOffset=Math.max(m.actualStopOffset,m.tokens[m.tokens.length-1].startIndex+1)),m&&m.actualStopOffset<g.length&&(m.tokens.push({startIndex:m.actualStopOffset,type:"",bracket:0}),m.endState=this._lines[d].getState())}if(m||(m=o.nullTokenize(this._mode,g,this._lines[d].getState())),m.modeTransitions||(m.modeTransitions=[]),0===m.modeTransitions.length&&m.modeTransitions.push({startIndex:0,mode:this._mode}),this._updateLineTokens(d,this._tokensInflatorMap,this._mode,m),this._lines[d].isInvalid&&(this._lines[d].isInvalid=!1),r>p)if(null!==this._lines[p].getState()&&m.endState.equals(this._lines[p].getState())){for(var _=d+1;r>_&&!this._lines[_].isInvalid;){if(r>_+1){if(null===this._lines[_+1].getState())break}else if(null===this._lastState)break;_++}this._invalidLineStartIndex=Math.max(this._invalidLineStartIndex,_),d=_-1}else this._lines[p].setState(m.endState);else this._lastState=m.endState}this._invalidLineStartIndex=Math.max(this._invalidLineStartIndex,i+1),this._tokenizationElapsedTime+=a.elapsed(),this._tokenizationTotalCharacters+=u,n&&l>=c&&this.emitModelTokensChangedEvent(c,l)},t.prototype.emitModelTokensChangedEvent=function(e,t){var n={fromLineNumber:e,toLineNumber:t};this._isDisposing||this.emit(c.EventType.ModelTokensChanged,n)},t.prototype._emitModelModeChangedEvent=function(e){this._isDisposing||this.emit(c.EventType.ModelModeChanged,e)},t.prototype._emitModelModeSupportChangedEvent=function(e){this._isDisposing||this.emit(c.EventType.ModelModeSupportChanged,e)},t.prototype._lineIsTokenized=function(e){return this._invalidLineStartIndex>e-1},t.prototype._getWordDefinition=function(){return i.WordHelper.massageWordDefinitionOf(this._mode)},t.prototype.getWordAtPosition=function(e){if(this._isDisposed)throw new Error("TextModelWithTokens.getWordAtPosition: Model is disposed");return i.WordHelper.getWordAtPosition(this,this.validatePosition(e))},t.prototype.getWordUntilPosition=function(e){if(this._isDisposed)throw new Error("TextModelWithTokens.getWordUntilPosition: Model is disposed");var t=this.getWordAtPosition(e);return t?{word:t.word.substr(0,e.column-t.startColumn),startColumn:t.startColumn,endColumn:e.column}:{word:"",startColumn:e.column,endColumn:e.column}},t.prototype.getWords=function(e){if(this._isDisposed)throw new Error("TextModelWithTokens.getWords: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");return i.WordHelper.getWords(this,this.validateLineNumber(e))},t.prototype.tokenIterator=function(e,t){if(this._isDisposed)throw new Error("TextModelWithTokens.tokenIterator: Model is disposed");var n=new s.TokenIterator(this,this.validatePosition(e)),r=t(n);return n._invalidate(),r},t.prototype.findMatchingBracketUp=function(e,t){if(this._isDisposed)throw new Error("TextModelWithTokens.findMatchingBracketUp: Model is disposed");return i.BracketsHelper.findMatchingBracketUp(this,e,this.validatePosition(t))},t.prototype.matchBracket=function(e,t){if(void 0===t&&(t=!1),this._isDisposed)throw new Error("TextModelWithTokens.matchBracket: Model is disposed");return i.BracketsHelper.matchBracket(this,this.validatePosition(e),t)},t.MODE_TOKENIZATION_FAILED_MSG=n.localize(0,null),t.MODEL_SYNC_LIMIT=5242880,t.MODEL_TOKENIZATION_LIMIT=52428800,t}(a.TextModel);t.TextModelWithTokens=k;var b=function(){function e(e){this._id="vs.editor.modes.simplifiedMode:"+e.getId(),this.tokenizationSupport=e.tokenizationSupport,this.electricCharacterSupport=e.electricCharacterSupport,this.commentsSupport=e.commentsSupport,this.characterPairSupport=e.characterPairSupport,this.tokenTypeClassificationSupport=e.tokenTypeClassificationSupport}return e.prototype.getId=function(){return this._id},e}()});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/model/mirrorModel",["require","exports","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/textModel","vs/editor/common/model/textModelWithTokens","vs/editor/common/model/modelLine","vs/editor/common/editorCommon","vs/base/common/network","vs/base/common/lifecycle"],function(e,t,n,r,o,i,s,a,u){function c(e,t,n,o,i,s){return new p(e,t,r.TextModel.toRawText(n),o,i,s)}var l=function(e){function t(t,n,r,o,i,a){e.call(this,t.concat([s.EventType.ModelDispose]),r,!1,o),a||(a={}),this._setVersionId(n),this._associatedResource=i,this._extraProperties=a}return __extends(t,e),t.prototype.getModeId=function(){if(this._isDisposed)throw new Error("AbstractMirrorModel.getModeId: Model is disposed");return this.getMode().getId()},t.prototype.getEmbeddedAtPosition=function(e){return null},t.prototype.getAllEmbedded=function(){return[]},t.prototype._constructLines=function(t){e.prototype._constructLines.call(this,t),this._EOL="\n"},t.prototype.destroy=function(){this.dispose()},t.prototype.dispose=function(){this.emit(s.EventType.ModelDispose),e.prototype.dispose.call(this)},t.prototype.getAssociatedResource=function(){if(this._isDisposed)throw new Error("AbstractMirrorModel.getAssociatedResource: Model is disposed");return this._associatedResource},t.prototype.getProperty=function(e){if(this._isDisposed)throw new Error("AbstractMirrorModel.getProperty: Model is disposed");return this._extraProperties.hasOwnProperty(e)?this._extraProperties[e]:null},t.prototype._ensurePrefixSum=function(){if(!this._lineStarts){for(var e=[],t=this.getEOL().length,r=0,o=this._lines.length;o>r;r++)e.push(this._lines[r].text.length+t);this._lineStarts=new n.PrefixSumComputer(e)}},t.prototype.getRangeFromOffsetAndLength=function(e,t){if(this._isDisposed)throw new Error("AbstractMirrorModel.getRangeFromOffsetAndLength: Model is disposed");var n=this.getPositionFromOffset(e),r=this.getPositionFromOffset(e+t);return{startLineNumber:n.lineNumber,startColumn:n.column,endLineNumber:r.lineNumber,endColumn:r.column}},t.prototype.getOffsetAndLengthFromRange=function(e){if(this._isDisposed)throw new Error("AbstractMirrorModel.getOffsetAndLengthFromRange: Model is disposed");var t=this.getOffsetFromPosition({lineNumber:e.startLineNumber,column:e.startColumn}),n=this.getOffsetFromPosition({lineNumber:e.endLineNumber,column:e.endColumn});return{offset:t,length:n-t}},t.prototype.getPositionFromOffset=function(e){if(this._isDisposed)throw new Error("AbstractMirrorModel.getPositionFromOffset: Model is disposed");this._ensurePrefixSum();var t={index:0,remainder:0};return this._lineStarts.getIndexOf(e,t),{lineNumber:t.index+1,column:this.getEOL().length+t.remainder}},t.prototype.getOffsetFromPosition=function(e){if(this._isDisposed)throw new Error("AbstractMirrorModel.getOffsetFromPosition: Model is disposed");return this.getLineStart(e.lineNumber)+e.column-1},t.prototype.getLineStart=function(e){if(this._isDisposed)throw new Error("AbstractMirrorModel.getLineStart: Model is disposed");this._ensurePrefixSum();var t=Math.min(e,this._lines.length)-1;return this._lineStarts.getAccumulatedValue(t-1)},t.prototype.getAllWordsWithRange=function(){if(this._isDisposed)throw new Error("AbstractMirrorModel.getAllWordsWithRange: Model is disposed");if(this._lines.length>1e4)return[];var e,t=[],n=function(n){var o=r.text.substring(n.start,n.end),i={startLineNumber:e+1,startColumn:n.start+1,endLineNumber:e+1,endColumn:n.end+1};t.push({text:o,range:i})};for(e=0;e<this._lines.length;e++){var r=this._lines[e];this.wordenize(r.text).forEach(n)}return t},t.prototype.getAllWords=function(){var e=this;if(this._isDisposed)throw new Error("AbstractMirrorModel.getAllWords: Model is disposed");var t=[];return this._lines.forEach(function(n){e.wordenize(n.text).forEach(function(e){t.push(n.text.substring(e.start,e.end))})}),t},t.prototype.getAllUniqueWords=function(e){if(this._isDisposed)throw new Error("AbstractMirrorModel.getAllUniqueWords: Model is disposed");var t=!1,n={};return this.getAllWords().filter(function(r){return e&&!t&&e===r?(t=!0,!1):n[r]?!1:(n[r]=!0,!0)})},t.prototype.wordenize=function(e){for(var t,n=[],r=this._getWordDefinition();t=r.exec(e);)n.push({start:t.index,end:t.index+t[0].length});return n},t.prototype.getWord=function(e,t,n){for(var r=this.wordenize(e),o=0;o<r.length&&t>=r[o].start;o++){var i=r[o];if(t<=i.end)return n(e,i.start,i.end)}return n(e,-1,-1)},t}(o.TextModelWithTokens);t.AbstractMirrorModel=l;var d=function(e){function t(n,r,o,i){e.call(this,["changed"],n.getVersionId(),t._getMirrorValueWithinRanges(n,r),o,i),this._actualModel=n}return __extends(t,e),t._getMirrorValueWithinRanges=function(e,t){var n,o="",i=1,s=1;for(n=0;n<t.length;n++){var a=t[n];o+=e.getEmptiedValueInRange({startLineNumber:i,startColumn:s,endLineNumber:a.startLineNumber,endColumn:a.startColumn}," "),o+=e.getValueInRange(a),i=a.endLineNumber,s=a.endColumn}var u=e.getLineCount(),c=e.getLineMaxColumn(u);return o+=e.getEmptiedValueInRange({startLineNumber:i,startColumn:s,endLineNumber:u,endColumn:c}," "),r.TextModel.toRawText(o)},t.prototype.setIncludedRanges=function(e){var n=this.getVersionId();this._lineStarts=null,this._constructLines(t._getMirrorValueWithinRanges(this._actualModel,e)),this._resetTokenizationState(),this._setVersionId(n+1),this.emit("changed",{})},t}(l);t.MirrorModelEmbedded=d;var h=function(){function e(e){this.mode=e,this.ranges=[]}return e}();t.createMirrorModelFromString=c;var p=function(e){function t(t,n,r,o,i,s){e.call(this,["changed"],n,r,o,i,s),this._resourceService=t,this._embeddedModels={},this._updateEmbeddedModels()}return __extends(t,e),t.prototype.getEmbeddedAtPosition=function(e){if(this._isDisposed)throw new Error("MirrorModel.getEmbeddedAtPosition: Model is disposed");var t=this.getModeAtPosition(e.lineNumber,e.column);return this._embeddedModels.hasOwnProperty(t.getId())?this._embeddedModels[t.getId()]:null},t.prototype.getAllEmbedded=function(){var e=this;if(this._isDisposed)throw new Error("MirrorModel.getAllEmbedded: Model is disposed");return Object.keys(this._embeddedModels).map(function(t){return e._embeddedModels[t]})},t.prototype.dispose=function(){var t=this;e.prototype.dispose.call(this);var n=Object.keys(this._embeddedModels).map(function(e){return t._embeddedModels[e]});n.forEach(function(e){return t._resourceService.remove(e.getAssociatedResource())}),u.disposeAll(n),this._embeddedModels={}},t.prototype.setMode=function(t){e.prototype.setMode.call(this,t),this._updateEmbeddedModels()},t._getModesRanges=function(e){for(var t={},n=function(e,n){return t.hasOwnProperty(e)||(t[e]=new h(n)),t[e]},r=e.getLineCount(),o=e.getMode().getId(),i=e.getMode(),s=1,a=1,u=1;r>=u;u++)for(var c=e._getLineModeTransitions(u),l=0;l<c.length;l++){
var d=c[l];if(d.mode.getId()!==o){var p=n(o,i);p.ranges.push({startLineNumber:s,startColumn:a,endLineNumber:u,endColumn:d.startIndex+1}),o=d.mode.getId(),i=d.mode,s=u,a=d.startIndex+1}}var f=r,m=e.getLineMaxColumn(f);if(s!==f||a!==m){var p=n(o,i);p.ranges.push({startLineNumber:s,startColumn:a,endLineNumber:f,endColumn:m})}return t},t.prototype._updateEmbeddedModels=function(){if(!this._resourceService||!this.getMode().tokenizationSupport||!this.getMode().tokenizationSupport.shouldGenerateEmbeddedModels)return!1;for(var e=t._getModesRanges(this),n=Object.keys(this._embeddedModels),r=0;r<n.length;r++){var o=n[r];e.hasOwnProperty(o)||this._embeddedModels[o].setIncludedRanges([{startLineNumber:1,startColumn:1,endLineNumber:1,endColumn:1}])}for(var i=Object.keys(e),r=0;r<i.length;r++){var s=i[r];if(this._embeddedModels.hasOwnProperty(s))this._embeddedModels[s].setIncludedRanges(e[s].ranges);else{var u=new a.URL(this.getAssociatedResource().toString()+"URL_MARSHAL_REMOVE"+s);this._embeddedModels[s]=new d(this,e[s].ranges,e[s].mode,u),this._resourceService.insert(this._embeddedModels[s].getAssociatedResource(),this._embeddedModels[s])}}return!1},t.prototype.onEvents=function(e){if(this._isDisposed)throw new Error("MirrorModel.onEvents: Model is disposed");for(var t=!1,n=0,r=e.length;r>n;n++){var o=e[n];switch(o.type){case s.EventType.ModelContentChanged:var i=o;switch(this._lineStarts=null,this._setVersionId(i.versionId),i.changeType){case s.EventType.ModelContentChangedFlush:this._onLinesFlushed(i),t=!0;break;case s.EventType.ModelContentChangedLinesDeleted:this._onLinesDeleted(i),t=!0;break;case s.EventType.ModelContentChangedLinesInserted:this._onLinesInserted(i),t=!0;break;case s.EventType.ModelContentChangedLineChanged:this._onLineChanged(i),t=!0}break;case s.EventType.ModelPropertiesChanged:this._extraProperties=o.properties;break;default:console.warn("Unknown model event: "+o.type)}}var a=!1;return t&&(this.emit("changed",{}),a=this._updateEmbeddedModels()),a},t.prototype._onLinesFlushed=function(e){this._constructLines(e.detail),this._resetTokenizationState()},t.prototype._onLineChanged=function(e){this._lines[e.lineNumber-1].applyEdits({},[{startColumn:1,endColumn:Number.MAX_VALUE,text:e.detail,forceMoveMarkers:!1}]),this._invalidateLine(e.lineNumber-1)},t.prototype._onLinesDeleted=function(e){var t=e.fromLineNumber-1,n=e.toLineNumber-1,r=this._lines[t].getState();this._lines.splice(t,n-t+1),t<this._lines.length&&(this._lines[t].setState(r),this._invalidateLine(t))},t.prototype._onLinesInserted=function(e){var t,n,r=(this.getEOL().length,e.detail.split("\n"));for(t=e.fromLineNumber-1,n=0;t<e.toLineNumber;t++,n++)this._lines.splice(t,0,new i.ModelLine(0,r[n]));e.fromLineNumber>=2&&this._invalidateLine(e.fromLineNumber-2)},t}(l);t.MirrorModel=p});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/model/textModelWithMarkers",["require","exports","vs/editor/common/core/position","vs/editor/common/model/textModelWithTokens","vs/editor/common/core/idGenerator"],function(e,t,n,r,o){var i=function(){function e(e,t,n){this.id=e,this.column=t,this.stickToPreviousCharacter=n,this.oldLineNumber=0,this.oldColumn=0,this.line=null}return e.prototype.toString=function(){return"{'"+this.id+"';"+this.column+","+this.stickToPreviousCharacter+",["+this.oldLineNumber+","+this.oldColumn+"]}"},e}();t.LineMarker=i;var s=0,a=function(e){function t(t,n,r){e.call(this,t,n,!0,r),this._markerIdGenerator=new o.IdGenerator(++s+";"),this._markerIdToMarker={}}return __extends(t,e),t.prototype.dispose=function(){this._markerIdToMarker=null,e.prototype.dispose.call(this)},t.prototype._resetValue=function(t,n){e.prototype._resetValue.call(this,t,n),this._markerIdToMarker={}},t.prototype._addMarker=function(e,t,r){if(this._isDisposed)throw new Error("TextModelWithMarkers._addMarker: Model is disposed");var o=this.validatePosition(new n.Position(e,t)),s=new i(this._markerIdGenerator.generate(),o.column,r);return this._markerIdToMarker[s.id]=s,this._lines[o.lineNumber-1].addMarker(s),s.id},t.prototype._addMarkers=function(e){for(var t=Object.create(null),n=[],r=0,o=e.length;o>r;r++){var s=e[r],a=new i(this._markerIdGenerator.generate(),s.column,s.stickToPreviousCharacter);this._markerIdToMarker[a.id]=a,t[s.lineNumber]||(t[s.lineNumber]=[]),t[s.lineNumber].push(a),n.push(a.id)}for(var u=Object.keys(t),r=0,o=u.length;o>r;r++){var c=parseInt(u[r],10);this._lines[c-1].addMarkers(t[u[r]])}return n},t.prototype._changeMarker=function(e,t,r){if(this._isDisposed)throw new Error("TextModelWithMarkers._changeMarker: Model is disposed");if(this._markerIdToMarker.hasOwnProperty(e)){var o=this._markerIdToMarker[e],i=this.validatePosition(new n.Position(t,r));i.lineNumber!==o.line.lineNumber&&(o.line.removeMarker(o),this._lines[i.lineNumber-1].addMarker(o)),o.column=i.column}},t.prototype._changeMarkerStickiness=function(e,t){if(this._isDisposed)throw new Error("TextModelWithMarkers._changeMarkerStickiness: Model is disposed");if(this._markerIdToMarker.hasOwnProperty(e)){var n=this._markerIdToMarker[e];n.stickToPreviousCharacter!==t&&(n.stickToPreviousCharacter=t)}},t.prototype._getMarker=function(e){if(this._isDisposed)throw new Error("TextModelWithMarkers._getMarker: Model is disposed");if(this._markerIdToMarker.hasOwnProperty(e)){var t=this._markerIdToMarker[e];return new n.Position(t.line.lineNumber,t.column)}return null},t.prototype._getMarkersCount=function(){return Object.keys(this._markerIdToMarker).length},t.prototype._getLineMarkers=function(e){if(this._isDisposed)throw new Error("TextModelWithMarkers._getLineMarkers: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");return this._lines[e-1].getMarkers()},t.prototype._removeMarker=function(e){if(this._isDisposed)throw new Error("TextModelWithMarkers._removeMarker: Model is disposed");if(this._markerIdToMarker.hasOwnProperty(e)){var t=this._markerIdToMarker[e];t.line.removeMarker(t),delete this._markerIdToMarker[e]}},t.prototype._removeMarkers=function(e){for(var t=Object.create(null),n=0,r=e.length;r>n;n++){var o=e[n];if(this._markerIdToMarker.hasOwnProperty(o)){var i=this._markerIdToMarker[o],s=i.line.lineNumber;t[s]||(t[s]=Object.create(null)),t[s][o]=!0,delete this._markerIdToMarker[o]}}for(var a=Object.keys(t),n=0,r=a.length;r>n;n++){var s=parseInt(a[n],10);this._lines[s-1].removeMarkers(t[a[n]])}},t.prototype._getMarkersInMap=function(e){if(this._isDisposed)throw new Error("TextModelWithMarkers._getMarkersInMap: Model is disposed");var t,n=[];for(t in e)e.hasOwnProperty(t)&&this._markerIdToMarker.hasOwnProperty(t)&&n.push(this._markerIdToMarker[t]);return n},t}(r.TextModelWithTokens);t.TextModelWithMarkers=a});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/model/textModelWithTrackedRanges",["require","exports","vs/editor/common/core/range","vs/editor/common/model/textModelWithMarkers","vs/editor/common/model/textModelWithTokens","vs/editor/common/editorCommon","vs/editor/common/core/idGenerator"],function(e,t,n,r,o,i,s){var a=function(e){function t(t,n,r){e.call(this,t,r),this.trackedRangeId=r.addTrackedRange({startLineNumber:n,startColumn:1,endLineNumber:n,endColumn:r.getLineMaxColumn(n)},i.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges)}return __extends(t,e),t.prototype.getRange=function(){return this._model.getTrackedRange(this.trackedRangeId)},t.prototype.dispose=function(){var t=this._model;t.isValidTrackedRange(this.trackedRangeId)&&t.removeTrackedRange(this.trackedRangeId),e.prototype.dispose.call(this)},t}(o.FullModelRetokenizer),u=function(){function e(e,t,n){this.id=e,this.startMarkerId=t,this.endMarkerId=n}return e}(),c=0,l=function(e){function t(t,n,r){e.call(this,t,n,r),this._rangeIdGenerator=new s.IdGenerator(++c+";"),this._ranges={},this._markerIdToRangeId={},this._multiLineTrackedRanges={}}return __extends(t,e),t.prototype._createRetokenizer=function(e,t){return new a(e,t,this)},t.prototype.dispose=function(){this._ranges=null,this._markerIdToRangeId=null,this._multiLineTrackedRanges=null,e.prototype.dispose.call(this)},t.prototype._resetValue=function(t,n){e.prototype._resetValue.call(this,t,n),this._ranges={},this._markerIdToRangeId={},this._multiLineTrackedRanges={}},t.prototype._setRangeIsMultiLine=function(e,t){var n=this._multiLineTrackedRanges.hasOwnProperty(e);!n&&t?this._multiLineTrackedRanges[e]=!0:n&&!t&&delete this._multiLineTrackedRanges[e]},t.prototype._shouldStartMarkerSticksToPreviousCharacter=function(e){return e===i.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges||e===i.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore?!0:!1},t.prototype._shouldEndMarkerSticksToPreviousCharacter=function(e){return e===i.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges||e===i.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore?!0:!1},t.prototype._getTrackedRangesCount=function(){return Object.keys(this._ranges).length},t.prototype.addTrackedRange=function(e,t){if(this._isDisposed)throw new Error("TextModelWithTrackedRanges.addTrackedRange: Model is disposed");e=this.validateRange(e);var n=this._shouldStartMarkerSticksToPreviousCharacter(t),r=this._shouldEndMarkerSticksToPreviousCharacter(t),o=this._addMarker(e.startLineNumber,e.startColumn,n),i=this._addMarker(e.endLineNumber,e.endColumn,r),s=new u(this._rangeIdGenerator.generate(),o,i);return this._ranges[s.id]=s,this._markerIdToRangeId[o]=s.id,this._markerIdToRangeId[i]=s.id,this._setRangeIsMultiLine(s.id,e.startLineNumber!==e.endLineNumber),s.id},t.prototype._addTrackedRanges=function(e,t){for(var n=[],r=0,o=e.length;o>r;r++){var i=e[r],s=t[r];n.push({lineNumber:i.startLineNumber,column:i.startColumn,stickToPreviousCharacter:this._shouldStartMarkerSticksToPreviousCharacter(s)}),n.push({lineNumber:i.endLineNumber,column:i.endColumn,stickToPreviousCharacter:this._shouldEndMarkerSticksToPreviousCharacter(s)})}for(var a=this._addMarkers(n),c=[],r=0,o=e.length;o>r;r++){var i=e[r],l=a[2*r],d=a[2*r+1],h=new u(this._rangeIdGenerator.generate(),l,d);this._ranges[h.id]=h,this._markerIdToRangeId[l]=h.id,this._markerIdToRangeId[d]=h.id,this._setRangeIsMultiLine(h.id,i.startLineNumber!==i.endLineNumber),c.push(h.id)}return c},t.prototype.changeTrackedRange=function(e,t){if(this._isDisposed)throw new Error("TextModelWithTrackedRanges.changeTrackedRange: Model is disposed");if(this._ranges.hasOwnProperty(e)){t=this.validateRange(t);var n=this._ranges[e];this._changeMarker(n.startMarkerId,t.startLineNumber,t.startColumn),this._changeMarker(n.endMarkerId,t.endLineNumber,t.endColumn),this._setRangeIsMultiLine(n.id,t.startLineNumber!==t.endLineNumber)}},t.prototype.changeTrackedRangeStickiness=function(e,t){if(this._isDisposed)throw new Error("TextModelWithTrackedRanges.changeTrackedRangeStickiness: Model is disposed");if(this._ranges.hasOwnProperty(e)){var n=this._ranges[e];this._changeMarkerStickiness(n.startMarkerId,this._shouldStartMarkerSticksToPreviousCharacter(t)),this._changeMarkerStickiness(n.endMarkerId,this._shouldEndMarkerSticksToPreviousCharacter(t))}},t.prototype.isValidTrackedRange=function(e){return this._isDisposed||!this._ranges?!1:this._ranges.hasOwnProperty(e)},t.prototype.removeTrackedRange=function(e){if(this._isDisposed)throw new Error("TextModelWithTrackedRanges.removeTrackedRange: Model is disposed");if(this._ranges.hasOwnProperty(e)){var t=this._ranges[e];this._removeMarker(t.startMarkerId),this._removeMarker(t.endMarkerId),this._setRangeIsMultiLine(t.id,!1),delete this._ranges[t.id],delete this._markerIdToRangeId[t.startMarkerId],delete this._markerIdToRangeId[t.endMarkerId]}},t.prototype.removeTrackedRanges=function(e){for(var t=[],n=0,r=e.length;r>n;n++){var o=e[n];if(this._ranges.hasOwnProperty(o)){var i=this._ranges[o];t.push(i.startMarkerId),t.push(i.endMarkerId),this._setRangeIsMultiLine(i.id,!1),delete this._ranges[i.id],delete this._markerIdToRangeId[i.startMarkerId],delete this._markerIdToRangeId[i.endMarkerId]}}t.length>0&&this._removeMarkers(t)},t.prototype._newEditorRange=function(e,t){return t.isBefore(e)?new n.Range(e.lineNumber,e.column,e.lineNumber,e.column):new n.Range(e.lineNumber,e.column,t.lineNumber,t.column)},t.prototype.getTrackedRange=function(e){if(this._isDisposed)throw new Error("TextModelWithTrackedRanges.getTrackedRange: Model is disposed");var t=this._ranges[e],n=this._getMarker(t.startMarkerId),r=this._getMarker(t.endMarkerId);return this._newEditorRange(n,r)},t.prototype._getMultiLineTrackedRanges=function(e,t){var n,r,o,i,s=[];for(n in this._multiLineTrackedRanges)if(this._multiLineTrackedRanges.hasOwnProperty(n)){if(r=this._ranges[n],o=this._getMarker(r.startMarkerId),o.lineNumber>t)continue;if(i=this._getMarker(r.endMarkerId),i.lineNumber<e)continue;s.push({id:r.id,range:this._newEditorRange(o,i)})}return s},t.prototype.getLinesTrackedRanges=function(e,t){if(this._isDisposed)throw new Error("TextModelWithTrackedRanges.getLinesTrackedRanges: Model is disposed");var n,r,o,i,s,a,u,c,l=this._getMultiLineTrackedRanges(e,t),d={};for(i=0,s=l.length;s>i;i++)d[l[i].id]=!0;for(a=e;t>=a;a++)for(n=this._getLineMarkers(a),i=0,s=n.length;s>i;i++)r=n[i],this._markerIdToRangeId.hasOwnProperty(r.id)&&(o=this._markerIdToRangeId[r.id],d.hasOwnProperty(o)||(u=this._getMarker(this._ranges[o].startMarkerId),c=this._getMarker(this._ranges[o].endMarkerId),l.push({id:o,range:this._newEditorRange(u,c)}),d[o]=!0));return l},t.prototype._onChangedMarkers=function(e){var t,n,r,o,i,s,a={};for(i=0,s=e.length;s>i;i++)o=e[i],this._markerIdToRangeId.hasOwnProperty(o.id)&&(r=this._markerIdToRangeId[o.id],n=this._ranges[r],a.hasOwnProperty(n.id)?t=a[n.id]:(t={startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0},a[n.id]=t),o.id===n.startMarkerId?(t.startLineNumber=o.oldLineNumber,t.startColumn=o.oldColumn):(t.endLineNumber=o.oldLineNumber,t.endColumn=o.oldColumn),this._setRangeIsMultiLine(n.id,this._getMarker(n.startMarkerId).lineNumber!==this._getMarker(n.endMarkerId).lineNumber));return a},t}(r.TextModelWithMarkers);t.TextModelWithTrackedRanges=l});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/model/textModelWithDecorations",["require","exports","vs/base/common/strings","vs/editor/common/model/textModelWithTrackedRanges","vs/editor/common/editorCommon","vs/base/common/errors","vs/editor/common/core/idGenerator","vs/editor/common/core/range"],function(e,t,n,r,o,i,s,a){function u(e){return e.replace(/[^a-z0-9\-]/gi," ")}function c(e){return new m(e)}function l(e,t){return void 0===t&&(t=null),new v(e,t)}var d=function(){function e(){this.changedMarkers={},this.oldDecorationRange={},this.oldDecorationOptions={},this.newOrChangedDecorations={},this.removedDecorations={}}return e.prototype.addNewDecoration=function(e){this.newOrChangedDecorations[e]=!0},e.prototype.addRemovedDecoration=function(e,t,n,r){this.newOrChangedDecorations.hasOwnProperty(e)&&delete this.newOrChangedDecorations[e],this.oldDecorationRange.hasOwnProperty(e)||(this.oldDecorationRange[e]=n),this.oldDecorationOptions.hasOwnProperty(e)||(this.oldDecorationOptions[e]=r),this.removedDecorations[e]=!0},e.prototype.addMovedDecoration=function(e,t){this.oldDecorationRange.hasOwnProperty(e)||(this.oldDecorationRange[e]=t),this.newOrChangedDecorations[e]=!0},e.prototype.addUpdatedDecoration=function(e,t){this.oldDecorationOptions.hasOwnProperty(e)||(this.oldDecorationOptions[e]=t),this.newOrChangedDecorations[e]=!0},e}();t.DeferredEventsBuilder=d;var h=0,p=function(e){function t(t,n,r){t.push(o.EventType.ModelDecorationsChanged),e.call(this,t,n,r),this._decorationIdGenerator=new s.IdGenerator(++h+";"),this.decorations={},this.rangeIdToDecorationId={},this._currentDeferredEvents=null}return __extends(t,e),t.prototype.dispose=function(){this.decorations=null,this.rangeIdToDecorationId=null,e.prototype.dispose.call(this)},t.prototype._resetValue=function(t,n){e.prototype._resetValue.call(this,t,n),this.decorations={},this.rangeIdToDecorationId={}},t.prototype.changeDecorations=function(e,t){var n=this;if(void 0===t&&(t=0),this._isDisposed)throw new Error("TextModelWithDecorations.changeDecorations: Model is disposed");return this._withDeferredEvents(function(r){var o={addDecoration:function(e,o){return n._addDecorationImpl(r,t,n.validateRange(e),c(o))},changeDecoration:function(e,t){n._changeDecorationImpl(r,e,n.validateRange(t))},changeDecorationOptions:function(e,t){n._changeDecorationOptionsImpl(r,e,c(t))},removeDecoration:function(e){n._removeDecorationImpl(r,e)},deltaDecorations:function(e,o){return n._deltaDecorationsImpl(r,t,e,n._normalizeDeltaDecorations(o))}},s=null;try{s=e(o)}catch(a){i.onUnexpectedError(a)}return o.addDecoration=null,o.changeDecoration=null,o.removeDecoration=null,o.deltaDecorations=null,s})},t.prototype.deltaDecorations=function(e,t,n){if(void 0===n&&(n=0),this._isDisposed)throw new Error("TextModelWithDecorations.deltaDecorations: Model is disposed");return e||(e=[]),this.changeDecorations(function(n){return n.deltaDecorations(e,t)},n)},t.prototype.removeAllDecorationsWithOwnerId=function(e){if(this._isDisposed)throw new Error("TextModelWithDecorations.removeAllDecorationsWithOwnerId: Model is disposed");var t,n,r=[];for(t in this.decorations)this.decorations.hasOwnProperty(t)&&(n=this.decorations[t],n.ownerId===e&&r.push(n.id));this._removeDecorationsImpl(null,r)},t.prototype.getDecorationOptions=function(e){if(this._isDisposed)throw new Error("TextModelWithDecorations.getDecorationOptions: Model is disposed");return this.decorations.hasOwnProperty(e)?this.decorations[e].options:null},t.prototype.getDecorationRange=function(e){if(this._isDisposed)throw new Error("TextModelWithDecorations.getDecorationRange: Model is disposed");if(this.decorations.hasOwnProperty(e)){var t=this.decorations[e];return this.getTrackedRange(t.rangeId)}return null},t.prototype.getLineDecorations=function(e,t,n){if(void 0===t&&(t=0),void 0===n&&(n=!1),this._isDisposed)throw new Error("TextModelWithDecorations.getLineDecorations: Model is disposed");return 1>e||e>this.getLineCount()?[]:this.getLinesDecorations(e,e,t,n)},t.prototype._getDecorationsInRange=function(e,t,n,r,i,s){var a,u,c,l,d=[],h=this.getLinesTrackedRanges(e,n);for(u=0,l=h.length;l>u;u++)if(c=h[u],this.rangeIdToDecorationId.hasOwnProperty(c.id)){if(a=this.decorations[this.rangeIdToDecorationId[c.id]],i&&a.ownerId&&a.ownerId!==i)continue;if(s&&(a.options.className===o.ClassName.EditorErrorDecoration||a.options.className===o.ClassName.EditorWarningDecoration))continue;if(c.range.startLineNumber===e&&c.range.endColumn<t)continue;if(c.range.endLineNumber===n&&c.range.startColumn>r)continue;d.push({id:a.id,ownerId:a.ownerId,range:c.range,options:a.options})}return d},t.prototype.getLinesDecorations=function(e,t,n,r){if(void 0===n&&(n=0),void 0===r&&(r=!1),this._isDisposed)throw new Error("TextModelWithDecorations.getLinesDecorations: Model is disposed");var o=this.getLineCount();return e=Math.min(o,Math.max(1,e)),t=Math.min(o,Math.max(1,t)),this._getDecorationsInRange(e,1,t,Number.MAX_VALUE,n,r)},t.prototype.getDecorationsInRange=function(e,t,n){if(this._isDisposed)throw new Error("TextModelWithDecorations.getDecorationsInRange: Model is disposed");var r=this.validateRange(e);return this._getDecorationsInRange(r.startLineNumber,r.startColumn,r.endLineNumber,r.endColumn,t,n)},t.prototype.getAllDecorations=function(e,t){if(void 0===e&&(e=0),void 0===t&&(t=!1),this._isDisposed)throw new Error("TextModelWithDecorations.getAllDecorations: Model is disposed");var n,r,i=[];for(n in this.decorations)if(this.decorations.hasOwnProperty(n)){if(r=this.decorations[n],e&&r.ownerId&&r.ownerId!==e)continue;if(t&&(r.options.className===o.ClassName.EditorErrorDecoration||r.options.className===o.ClassName.EditorWarningDecoration))continue;i.push({id:r.id,ownerId:r.ownerId,range:this.getTrackedRange(r.rangeId),options:r.options})}return i},t.prototype._withDeferredEvents=function(e){var t=this;return this.deferredEmit(function(){var n=t._currentDeferredEvents?!1:!0;n&&(t._currentDeferredEvents=new d);try{var r=e(t._currentDeferredEvents);n&&t._handleCollectedEvents(t._currentDeferredEvents)}finally{n&&(t._currentDeferredEvents=null)}return r})},t.prototype._handleCollectedEvents=function(e){var t=this._getMarkersInMap(e.changedMarkers),n=this._onChangedMarkers(t);this._onChangedRanges(e,n),this._handleCollectedDecorationsEvents(e);for(var r=0,o=t.length;o>r;r++)t[r].oldLineNumber=0,t[r].oldColumn=0},t.prototype._onChangedRanges=function(e,t){var n,r;for(n in t)t.hasOwnProperty(n)&&this.rangeIdToDecorationId.hasOwnProperty(n)&&(r=this.rangeIdToDecorationId[n],e.addMovedDecoration(r,t[n]))},t.prototype._handleCollectedDecorationsEvents=function(e){var t,n,r,i=[],s=[],a=[];for(t in e.newOrChangedDecorations)e.newOrChangedDecorations.hasOwnProperty(t)&&(a.push(t),n=this._getDecorationData(t),n.isForValidation=n.options.className===o.ClassName.EditorErrorDecoration||n.options.className===o.ClassName.EditorWarningDecoration,i.push(n),e.oldDecorationRange.hasOwnProperty(t)&&(r=e.oldDecorationRange[t],r.startLineNumber=r.startLineNumber||n.range.startLineNumber,r.startColumn=r.startColumn||n.range.startColumn,r.endLineNumber=r.endLineNumber||n.range.endLineNumber,r.endColumn=r.endColumn||n.range.endColumn));for(t in e.removedDecorations)e.removedDecorations.hasOwnProperty(t)&&(a.push(t),s.push(t));if(a.length>0){var u={ids:a,addedOrChangedDecorations:i,removedDecorations:s,oldOptions:e.oldDecorationOptions,oldRanges:e.oldDecorationRange};this.emitModelDecorationsChangedEvent(u)}},t.prototype._getDecorationData=function(e){var t=this.decorations[e];return{id:t.id,ownerId:t.ownerId,range:this.getTrackedRange(t.rangeId),isForValidation:!1,options:t.options}},t.prototype.emitModelDecorationsChangedEvent=function(e){this._isDisposing||this.emit(o.EventType.ModelDecorationsChanged,e)},t.prototype._normalizeDeltaDecorations=function(e){for(var t=[],n=0,r=e.length;r>n;n++){var o=e[n];t.push(new g(n,this.validateRange(o.range),c(o.options)))}return t},t.prototype._addDecorationImpl=function(e,t,n,r){var o=this.addTrackedRange(n,r.stickiness),i=new f(this._decorationIdGenerator.generate(),t,o,r);return this.decorations[i.id]=i,this.rangeIdToDecorationId[o]=i.id,e.addNewDecoration(i.id),i.id},t.prototype._addDecorationsImpl=function(e,t,n){for(var r=this._addTrackedRanges(n.map(function(e){return e.range}),n.map(function(e){return e.options.stickiness})),o=[],i=0,s=n.length;s>i;i++){var a=r[i],u=new f(this._decorationIdGenerator.generate(),t,a,n[i].options);this.decorations[u.id]=u,this.rangeIdToDecorationId[a]=u.id,e.addNewDecoration(u.id),o.push(u.id)}return o},t.prototype._changeDecorationImpl=function(e,t,n){if(this.decorations.hasOwnProperty(t)){var r=this.decorations[t],o=this.getTrackedRange(r.rangeId);this.changeTrackedRange(r.rangeId,n),e.addMovedDecoration(t,o)}},t.prototype._changeDecorationOptionsImpl=function(e,t,n){if(this.decorations.hasOwnProperty(t)){var r=this.decorations[t],o=r.options;o.stickiness!==n.stickiness&&this.changeTrackedRangeStickiness(r.rangeId,n.stickiness),r.options=n,e.addUpdatedDecoration(t,o)}},t.prototype._removeDecorationImpl=function(e,t){if(this.decorations.hasOwnProperty(t)){var n=this.decorations[t],r=null;e&&(r=this.getTrackedRange(n.rangeId)),this.removeTrackedRange(n.rangeId),delete this.rangeIdToDecorationId[n.rangeId],delete this.decorations[t],e&&e.addRemovedDecoration(t,n.ownerId,r,n.options)}},t.prototype._removeDecorationsImpl=function(e,t){for(var n=[],r=0,o=t.length;o>r;r++){var i=t[r];if(this.decorations.hasOwnProperty(i)){var s=this.decorations[i];if(e){var a=this.getTrackedRange(s.rangeId);e.addRemovedDecoration(i,s.ownerId,a,s.options)}n.push(s.rangeId),delete this.rangeIdToDecorationId[s.rangeId],delete this.decorations[i]}}n.length>0&&this.removeTrackedRanges(n)},t.prototype._resolveOldDecorations=function(e){for(var t=[],n=0,r=e.length;r>n;n++){var o=e[n];if(this.decorations.hasOwnProperty(o)){var i=this.decorations[o];t.push({id:o,range:this.getTrackedRange(i.rangeId),options:i.options})}}return t},t.prototype._deltaDecorationsImpl=function(e,t,n,r){if(0===n.length)return this._addDecorationsImpl(e,t,r);if(0===r.length)return this._removeDecorationsImpl(e,n),[];var o=this._resolveOldDecorations(n);o.sort(function(e,t){return a.Range.compareRangesUsingStarts(e.range,t.range)}),r.sort(function(e,t){return a.Range.compareRangesUsingStarts(e.range,t.range)});for(var i=[],s=0,u=o.length,c=0,l=r.length,d=[],h=[];u>s&&l>c;){var p=o[s],f=r[c],m=a.Range.compareRangesUsingStarts(p.range,f.range);0>m?(h.push(p.id),s++):m>0?(d.push(f),c++):p.options.equals(f.options)?(i[f.index]=p.id,s++,c++):(h.push(p.id),s++)}for(;u>s;)h.push(o[s].id),s++;for(;l>c;)d.push(r[c]),c++;if(h.length>0&&this._removeDecorationsImpl(e,h),d.length>0)for(var g=this._addDecorationsImpl(e,t,d),v=0,_=d.length;_>v;v++)i[d[v].index]=g[v];return i},t}(r.TextModelWithTrackedRanges);t.TextModelWithDecorations=p;var f=function(){function e(e,t,n,r){this.id=e,this.ownerId=t,this.rangeId=n,this.options=r}return e}(),m=function(){function e(e){this.stickiness=e.stickiness||o.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges,this.className=u(e.className||n.empty),this.hoverMessage=e.hoverMessage||n.empty,this.htmlMessage=e.htmlMessage||[],this.isWholeLine=e.isWholeLine||!1,this.overviewRuler=l(e.overviewRuler,e.showInOverviewRuler),this.glyphMarginClassName=u(e.glyphMarginClassName||n.empty),this.linesDecorationsClassName=u(e.linesDecorationsClassName||n.empty),this.inlineClassName=u(e.inlineClassName||n.empty)}return e._htmlContentEquals=function(t,n){return t.formattedText===n.formattedText&&t.text===n.text&&t.className===n.className&&t.style===n.style&&t.customStyle===n.customStyle&&t.tagName===n.tagName&&t.isText===n.isText&&e._htmlContentArrEquals(t.children,n.children)},e._htmlContentArrEquals=function(t,n){if(!t)return!n;if(!n)return!1;var r=t.length,o=n.length;if(r!==o)return!1;for(var i=0;r>i;i++)if(!e._htmlContentEquals(t[i],n[i]))return!1;return!0},e._overviewRulerEquals=function(e,t){return e.color===t.color&&e.position===t.position&&e.darkColor===t.darkColor},e.prototype.equals=function(t){return this.stickiness===t.stickiness&&this.className===t.className&&this.hoverMessage===t.hoverMessage&&this.isWholeLine===t.isWholeLine&&this.showInOverviewRuler===t.showInOverviewRuler&&this.glyphMarginClassName===t.glyphMarginClassName&&this.linesDecorationsClassName===t.linesDecorationsClassName&&this.inlineClassName===t.inlineClassName&&e._htmlContentArrEquals(this.htmlMessage,t.htmlMessage)&&e._overviewRulerEquals(this.overviewRuler,t.overviewRuler)},e}(),g=function(){function e(e,t,n){this.index=e,this.range=t,this.options=n}return e}(),v=function(){function e(e,t){this.color=n.empty,this.darkColor=n.empty,this.position=o.OverviewRulerLane.Center,t&&(this.color=t),e&&e.color&&(this.color=e.color),e&&e.darkColor&&(this.darkColor=e.darkColor),e&&e.hasOwnProperty("position")&&(this.position=e.position)}return e}()});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/model/editableTextModel",["require","exports","vs/editor/common/core/range","vs/editor/common/model/editStack","vs/editor/common/model/modelLine","vs/editor/common/model/textModelWithDecorations","vs/editor/common/editorCommon"],function(e,t,n,r,o,i,s){var a=function(e){function t(t,n,o){t.push(s.EventType.ModelContentChanged),t.push(s.EventType.ModelContentChanged2),e.call(this,t,n,o),this._commandManager=new r.EditStack(this),this._isUndoing=!1,this._isRedoing=!1,this._hasEditableRange=!1,this._editableRangeId=null}return __extends(t,e),t.prototype.dispose=function(){this._commandManager=null,e.prototype.dispose.call(this)},t.prototype._resetValue=function(t,n){e.prototype._resetValue.call(this,t,n),this._commandManager=new r.EditStack(this),this._hasEditableRange=!1,this._editableRangeId=null},t.prototype.pushStackElement=function(){if(this._isDisposed)throw new Error("EditableTextModel.pushStackElement: Model is disposed");this._commandManager.pushStackElement()},t.prototype.pushEditOperations=function(e,t,n){if(this._isDisposed)throw new Error("EditableTextModel.pushEditOperations: Model is disposed");return this._commandManager.pushEditOperation(e,t,n)},t.prototype._reduceOperations=function(e){return e.length<1e3?e:[this._toSingleEditOperation(e)]},t.prototype._toSingleEditOperation=function(e){for(var t=!1,r=e[0].range,o=e[e.length-1].range,i=new n.Range(r.startLineNumber,r.startColumn,o.endLineNumber,o.endColumn),s=r.startLineNumber,a=r.startColumn,u=[],c=0,l=e.length;l>c;c++){var d=e[c],h=d.range;t=t||d.forceMoveMarkers;for(var p=s;p<h.startLineNumber;p++)p===s?u.push(this._lines[p-1].text.substring(a-1)):(u.push("\n"),u.push(this._lines[p-1].text));if(h.startLineNumber===s?u.push(this._lines[h.startLineNumber-1].text.substring(a-1,h.startColumn-1)):(u.push("\n"),u.push(this._lines[h.startLineNumber-1].text.substring(0,h.startColumn-1))),d.lines)for(var f=0,m=d.lines.length;m>f;f++)0!==f&&u.push("\n"),u.push(d.lines[f]);s=d.range.endLineNumber,a=d.range.endColumn}return{identifier:e[0].identifier,range:i,lines:u.join("").split("\n"),forceMoveMarkers:t}},t.prototype.applyEdits=function(e){for(var r=[],o=0;o<e.length;o++){var i=e[o];r[o]={identifier:i.identifier,range:this.validateRange(i.range),lines:i.text?i.text.split(/\r\n|\r|\n/):null,forceMoveMarkers:i.forceMoveMarkers}}r.sort(function(e,t){return n.Range.compareRangesUsingEnds(e.range,t.range)});for(var o=r.length-2;o>=0;o--)if(r[o+1].range.getStartPosition().isBeforeOrEqual(r[o].range.getEndPosition()))throw new Error("Overlapping ranges are not allowed!");r=this._reduceOperations(r);var s=this.getEditableRange(),a=s.getStartPosition(),u=s.getEndPosition();for(o=0;o<r.length;o++){var c=r[o].range;if(!a.isBeforeOrEqual(c.getStartPosition())||!c.getEndPosition().isBeforeOrEqual(u))throw new Error("Editing outside of editable range not allowed!")}for(var l=t._toDeltaOperations(r),d=t._getInverseEditRanges(l),h=[],o=0;o<r.length;o++)h[o]={identifier:r[o].identifier,range:d[o],text:this.getValueInRange(r[o].range),forceMoveMarkers:r[o].forceMoveMarkers};return this._applyEdits(l),h},t._toDeltaOperation=function(e,t){var n=t.range.startLineNumber-(e?e.range.endLineNumber:0),r=t.range.startColumn-(0===n?e.range.endColumn:0),o=t.range.endLineNumber-(e?e.range.endLineNumber:0),i=t.range.endColumn-(0===o?e.range.endColumn:0);return{original:t,isNoOp:t.range.startLineNumber===t.range.endLineNumber&&t.range.startColumn===t.range.endColumn&&(!t.lines||0===t.lines.length),deltaStartLineNumber:n,deltaStartColumn:r,deltaEndLineNumber:o,deltaEndColumn:i}},t._getInverseEditRanges=function(e){for(var t=0,r=0,o=[],i=0,s=e.length;s>i;i++){var a,u=e[i],c=u.deltaStartLineNumber+t,l=u.deltaStartColumn+(0===u.deltaStartLineNumber?r:0);a=u.original.lines&&u.original.lines.length>0?1===u.original.lines.length?new n.Range(c,l,c,l+u.original.lines[0].length):new n.Range(c,l,c+u.original.lines.length-1,u.original.lines[u.original.lines.length-1].length+1):new n.Range(c,l,c,l),t=a.endLineNumber,r=a.endColumn,o.push(a)}return o},t.prototype._generateSequentialEdits=function(e){for(var t=[],r=0,o=0,i=0,s=e.length;s>i;i++){var a=e[i],u=a.deltaStartLineNumber+r,c=a.deltaStartColumn+(0===a.deltaStartLineNumber?o:0),l=a.deltaEndLineNumber+r,d=a.deltaEndColumn+(0===a.deltaEndLineNumber?o:0),h=new n.Range(u,c,l,d),p=this.getValueLengthInRange(h);
t.push({range:h,rangeLength:p,text:a.original.lines?a.original.lines.join(this.getEOL()):""}),a.original.lines&&a.original.lines.length>0?1===a.original.lines.length?(r=u,o=c+a.original.lines[0].length):(r=u+a.original.lines.length-1,o=a.original.lines[a.original.lines.length-1].length+1):(r=u,o=c)}return t},t.prototype._applyEdits=function(e){var t=this,n=this._generateSequentialEdits(e);this._withDeferredEvents(function(r){for(var i=0,s=0,a=0,u=0,c=[],l=0,d=function(e,n){if(0!==n)for(var o=u+1;e>=o;o++)t._lines[o-1].updateLineNumber(r.changedMarkers,o);u=e},h=function(e,n,o,i,s){e!==l&&(c.length>0&&(t._applyLineEdits(r,l,c),c=[]),l=e),(n!==o||0!==i.length)&&c.push({startColumn:n,endColumn:o,text:i,forceMoveMarkers:s})},p=function(){var e=0;return c.length>0&&(e=t._applyLineEdits(r,l,c),c=[]),l=0,e},f=t.getVersionId(),m=0,g=e.length-1;g>=0;g--)if(!e[g].isNoOp){m=g;break}for(var g=0,v=e.length;v>g;g++){var _=e[g],y=_.deltaStartLineNumber+i,k=_.deltaStartColumn+(0===_.deltaStartLineNumber?s:0),b=_.deltaEndLineNumber+i,E=_.deltaEndColumn+(0===_.deltaEndLineNumber?s:0);if(i=y+(_.original.lines?_.original.lines.length-1:0),s=E,!_.isNoOp){for(var T=b-y,S=_.original.lines?_.original.lines.length-1:0,C=Math.min(T,S),M=0,w=0,I=0;C>=I;I++){var x=y+I,L=x===y?k:1,N=x===b?E:t.getLineMaxColumn(x),R=_.original.lines?_.original.lines[I]:"";h(x,L,N,R,_.original.forceMoveMarkers),I===C&&(M=N)}if(T>C){w=p();var A=M+w;s=A;var O=t._lines[b-1].split(r.changedMarkers,E,!1);t._invalidateLine(y+C-1);var P=y+C,D=T-C;d(y+C,a),a-=D;for(var B=[],I=0;D>I;I++){var W=P+I;B=B.concat(t._lines[W].deleteLine(r.changedMarkers,A,W+1))}t._lines.splice(P,D),t._lines[P-1].append(r.changedMarkers,O),t._lines[P-1].addMarkers(B),t.emitModelContentChangedLineChangedEvent(P),t.emitModelContentChangedLinesDeletedEvent(P+1,P+D)}if(S>C){w=p();var A=M+w,F=t._lines[y+C-1].split(r.changedMarkers,A,_.original.forceMoveMarkers);t.emitModelContentChangedLineChangedEvent(y+C),t._invalidateLine(y+C-1),s=_.original.lines[_.original.lines.length-1].length+1,d(y+C,a),a+=S-C;for(var z=[],I=C+1;S>=I;I++){var x=y+I;t._lines.splice(x-1,0,new o.ModelLine(x,_.original.lines[I])),z.push(_.original.lines[I])}z[z.length-1]+=F.text,t._lines[y+S-1].append(r.changedMarkers,F),t.emitModelContentChangedLinesInsertedEvent(y+C+1,y+S,z.join("\n"))}g===m&&p();var U=n[g];t.getVersionId()===f&&t._increaseVersionId(),f=t.getVersionId(),t._emitContentChanged2(U.range.startLineNumber,U.range.startColumn,U.range.endLineNumber,U.range.endColumn,U.rangeLength,U.text,t._isUndoing,t._isRedoing)}}d(t._lines.length,a)})},t.prototype._assertLineNumbersOK=function(){for(var e=0,t=0,n=this._lines.length;n>t;t++){var r=this._lines[t],o=t+1;if(r.lineNumber!==o)throw new Error("Invalid lineNumber at line: "+o+"; text is: "+this.getValue());for(var i=r.getMarkers(),s=0,a=i.length;a>s;s++){e++;var u=i[s].id,c=this._markerIdToMarker[u];if(c.line!==r)throw new Error("Misplaced marker with id "+u)}}var l=Object.keys(this._markerIdToMarker).length;if(l!==e)throw new Error("There are misplaced markers!")},t.prototype._applyLineEdits=function(e,t,n){this._invalidateLine(t-1);var r=this._lines[t-1].applyEdits(e.changedMarkers,n);return this.emitModelContentChangedLineChangedEvent(t),r},t._toDeltaOperations=function(e){for(var n=[],r=0;r<e.length;r++)n[r]=t._toDeltaOperation(r>0?e[r-1]:null,e[r]);return n},t.prototype.undo=function(){var e=this;if(this._isDisposed)throw new Error("EditableTextModel.undo: Model is disposed");return this._withDeferredEvents(function(){e._isUndoing=!0;var t=e._commandManager.undo();return e._isUndoing=!1,t?(e._overwriteAlternativeVersionId(t.recordedVersionId),t.selections):null})},t.prototype.redo=function(){var e=this;if(this._isDisposed)throw new Error("EditableTextModel.redo: Model is disposed");return this._withDeferredEvents(function(){e._isRedoing=!0;var t=e._commandManager.redo();return e._isRedoing=!1,t?(e._overwriteAlternativeVersionId(t.recordedVersionId),t.selections):null})},t.prototype.setEditableRange=function(e){if(this._isDisposed)throw new Error("EditableTextModel.setEditableRange: Model is disposed");this._commandManager.clear(),this._hasEditableRange&&(this.removeTrackedRange(this._editableRangeId),this._editableRangeId=null,this._hasEditableRange=!1),e&&(this._hasEditableRange=!0,this._editableRangeId=this.addTrackedRange(e,s.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges))},t.prototype.hasEditableRange=function(){if(this._isDisposed)throw new Error("EditableTextModel.hasEditableRange: Model is disposed");return this._hasEditableRange},t.prototype.getEditableRange=function(){if(this._isDisposed)throw new Error("EditableTextModel.getEditableRange: Model is disposed");return this._hasEditableRange?this.getTrackedRange(this._editableRangeId):this.getFullModelRange()},t.prototype._updateLineNumbers=function(e,t){var n,r,o=this._lines;for(n=t-1,r=o.length;r>n;n++)o[n].updateLineNumber(e,n+1)},t.prototype.emitModelContentChangedLineChangedEvent=function(e){this._increaseVersionId();var t={changeType:s.EventType.ModelContentChangedLineChanged,lineNumber:e,detail:this._lines[e-1].text,versionId:this.getVersionId(),isUndoing:this._isUndoing,isRedoing:this._isRedoing};this._isDisposing||this.emit(s.EventType.ModelContentChanged,t)},t.prototype.emitModelContentChangedLinesDeletedEvent=function(e,t){this._increaseVersionId();var n={changeType:s.EventType.ModelContentChangedLinesDeleted,fromLineNumber:e,toLineNumber:t,versionId:this.getVersionId(),isUndoing:this._isUndoing,isRedoing:this._isRedoing};this._isDisposing||this.emit(s.EventType.ModelContentChanged,n)},t.prototype.emitModelContentChangedLinesInsertedEvent=function(e,t,n){this._increaseVersionId();var r={changeType:s.EventType.ModelContentChangedLinesInserted,fromLineNumber:e,toLineNumber:t,detail:n,versionId:this.getVersionId(),isUndoing:this._isUndoing,isRedoing:this._isRedoing};this._isDisposing||this.emit(s.EventType.ModelContentChanged,r)},t}(i.TextModelWithDecorations);t.EditableTextModel=a});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/model/model",["require","exports","vs/editor/common/model/textModel","vs/editor/common/model/editableTextModel","vs/editor/common/editorCommon","vs/base/common/network","vs/base/common/objects"],function(e,t,n,r,o,i,s){var a=0,u={},c=function(e){function t(t,r,s){if(void 0===s&&(s=null),e.call(this,[o.EventType.ModelPropertiesChanged,o.EventType.ModelDispose],n.TextModel.toRawText(t),r),a++,this.id="$model"+a,("undefined"==typeof s||null===s)&&(s=new i.URL("inmemory://model/"+a)),this._associatedResource=s,u[String(this._associatedResource)])throw new Error("Cannot instantiate a second Model with the same URI!");this._extraProperties={},this._attachedEditorCount=0,u[String(this._associatedResource)]=!0}return __extends(t,e),t.prototype.getURL=function(){return this._associatedResource},t.prototype.getModeId=function(){return this.getMode().getId()},t.prototype.destroy=function(){this.dispose()},t.prototype.dispose=function(){this._isDisposing=!0,delete u[String(this._associatedResource)],this.emit(o.EventType.ModelDispose),e.prototype.dispose.call(this),this._isDisposing=!1},t.prototype.onBeforeAttached=function(){if(this._isDisposed)throw new Error("Model.onBeforeAttached: Model is disposed");this._attachedEditorCount++,this._warmUpTokens()},t.prototype.onBeforeDetached=function(){if(this._isDisposed)throw new Error("Model.onBeforeDetached: Model is disposed");this._attachedEditorCount--},t.prototype.isAttachedToEditor=function(){return this._attachedEditorCount>0},t.prototype.getAssociatedResource=function(){if(this._isDisposed)throw new Error("Model.getAssociatedResource: Model is disposed");return this._associatedResource},t.prototype.setProperty=function(e,t){if(this._isDisposed)throw new Error("Model.setProperty: Model is disposed");this._extraProperties[e]=t,this.emitModelPropertiesChangedEvent()},t.prototype.getProperty=function(e){if(this._isDisposed)throw new Error("Model.getProperty: Model is disposed");return this._extraProperties.hasOwnProperty(e)?this._extraProperties[e]:null},t.prototype.getProperties=function(){if(this._isDisposed)throw new Error("Model.getProperties: Model is disposed");return s.clone(this._extraProperties)},t.prototype.emitModelPropertiesChangedEvent=function(){var e={properties:this._extraProperties};this._isDisposing||this.emit(o.EventType.ModelPropertiesChanged,e)},t}(r.EditableTextModel);t.Model=c}),define("vs/nls!vs/editor/common/modes/languageExtensionPoint",["vs/nls","vs/nls!vs/editor/common/worker/editorWorkerServer"],function(e,t){return e.create("vs/editor/common/modes/languageExtensionPoint",t)}),define("vs/nls!vs/platform/configuration/common/configurationRegistry",["vs/nls","vs/nls!vs/editor/common/worker/editorWorkerServer"],function(e,t){return e.create("vs/platform/configuration/common/configurationRegistry",t)}),define("vs/nls!vs/platform/plugins/common/abstractPluginService",["vs/nls","vs/nls!vs/editor/common/worker/editorWorkerServer"],function(e,t){return e.create("vs/platform/plugins/common/abstractPluginService",t)}),define("vs/nls!vs/platform/plugins/common/pluginsRegistry",["vs/nls","vs/nls!vs/editor/common/worker/editorWorkerServer"],function(e,t){return e.create("vs/platform/plugins/common/pluginsRegistry",t)});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/platform/instantiation/common/descriptors",["require","exports","vs/base/common/errors","vs/base/common/marshalling","vs/base/common/hash"],function(e,t,n,r,o){var i=function(){function e(e){this._staticArguments=e}return e.prototype.appendStaticArguments=function(e){this._staticArguments.push.apply(this._staticArguments,e)},e.prototype.staticArguments=function(e){return isNaN(e)?this._staticArguments.slice(0):this._staticArguments[e]},e.prototype._validate=function(e){if(!e)throw n.illegalArgument("can not be falsy")},e}();t.AbstractDescriptor=i;var s=function(e){function t(t){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];e.call(this,n),this._ctor=t}return __extends(t,e),Object.defineProperty(t.prototype,"ctor",{get:function(){return this._ctor},enumerable:!0,configurable:!0}),t.prototype.equals=function(e){return e===this?!0:e instanceof t?e.ctor===this.ctor:!1},t.prototype.hashCode=function(){return 61*(1+this.ctor.length)},t.prototype.bind=function(){for(var e=[],n=0;n<arguments.length;n++)e[n-0]=arguments[n];var r=[];return r=r.concat(this.staticArguments()),r=r.concat(e),new(t.bind.apply(t,[void 0].concat([this._ctor],r)))},t}(i);t.SyncDescriptor=s,t.createSyncDescriptor=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return new(s.bind.apply(s,[void 0].concat([e],t)))},r.registerMarshallingContribution({canSerialize:function(e){return e instanceof a},serialize:function(e,t){return{$isAsyncDescriptor:!0,$moduleName:e.moduleName,$ctorName:e.ctorName,$staticArguments:t(e.staticArguments())}},canDeserialize:function(e){return e.$isAsyncDescriptor},deserialize:function(e,t){var n=new a(e.$moduleName,e.$ctorName);return n.appendStaticArguments(t(e.$staticArguments)),n}});var a=function(e){function t(t,n){for(var r=[],o=2;o<arguments.length;o++)r[o-2]=arguments[o];e.call(this,r),this._moduleName=t,this._ctorName=n}return __extends(t,e),t.create=function(e,n){return new t(e,n)},Object.defineProperty(t.prototype,"moduleName",{get:function(){return this._moduleName},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ctorName",{get:function(){return this._ctorName},enumerable:!0,configurable:!0}),t.prototype.equals=function(e){return e===this?!0:e instanceof t?e.moduleName===this.moduleName&&e.ctorName===this.ctorName:!1},t.prototype.hashCode=function(){return o.computeMurmur2StringHashCode(this.moduleName)*o.computeMurmur2StringHashCode(this.ctorName)},t.prototype.bind=function(){for(var e=[],n=0;n<arguments.length;n++)e[n-0]=arguments[n];var r=[];return r=r.concat(this.staticArguments()),r=r.concat(e),new(t.bind.apply(t,[void 0].concat([this.moduleName,this.ctorName],r)))},t}(i);t.AsyncDescriptor=a;var u=function(e,t){for(var n=[],r=2;r<arguments.length;r++)n[r-2]=arguments[r];return new(a.bind.apply(a,[void 0].concat([e,t],n)))};t.createAsyncDescriptor0=u,t.createAsyncDescriptor1=u,t.createAsyncDescriptor2=u,t.createAsyncDescriptor3=u,t.createAsyncDescriptor4=u,t.createAsyncDescriptor5=u,t.createAsyncDescriptor6=u,t.createAsyncDescriptor7=u}),define("vs/platform/instantiation/common/instantiation",["require","exports"],function(e,t){function n(e){var t=function(t,n,r){if(3!==arguments.length)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t[o.DI_TARGET]===t?t[o.DI_DEPENDENCIES].push({serviceId:e,index:r}):(t[o.DI_DEPENDENCIES]=[{serviceId:e,index:r}],t[o.DI_TARGET]=t)};return t[o.DI_PROVIDES]=e,t}function r(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];for(var n=[],r=0;r<e.length;r++){var i=e[r];n.push({serviceId:o.getServiceId(i)})}return function(e){var t=e[o.DI_DEPENDENCIES_USES];return t?t.push.apply(t,n):e[o.DI_DEPENDENCIES_USES]=n,e}}var o;!function(e){function t(t){return t[e.DI_PROVIDES]}function n(t){var n=t[e.DI_DEPENDENCIES],r=t[e.DI_DEPENDENCIES_USES];return n?r?n.slice(0).concat(r):n:r}e.DI_TARGET="$di$target",e.DI_DEPENDENCIES="$di$dependencies",e.DI_DEPENDENCIES_USES="$di$dependencies_uses",e.DI_PROVIDES="$di$provides_service",e.getServiceId=t,e.getServiceDependencies=n}(o=t._util||(t._util={})),t.IInstantiationService=n("instantiationService"),t.createDecorator=n,t.Uses=r,t.INullService=n("nullService")}),define("vs/editor/common/services/modeService",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.IModeService=n.createDecorator("modeService")}),define("vs/editor/common/services/modelService",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.IModelService=n.createDecorator("modelService")}),define("vs/editor/common/services/resourceService",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.ResourceEvents={ADDED:"resource.added",REMOVED:"resource.removed",CHANGED:"resource.changed"},t.IResourceService=n.createDecorator("resourceService")});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/services/resourceServiceImpl",["require","exports","vs/base/common/eventEmitter","vs/editor/common/services/resourceService"],function(e,t,n,r){var o=function(e){function t(){e.call(this),this.serviceId=r.IResourceService,this.data={},this.unbinds={}}return __extends(t,e),t.prototype.addListener_=function(t,n){return e.prototype.addListener.call(this,t,n)},t.prototype.addListener2_=function(t,n){return e.prototype.addListener2.call(this,t,n)},t.prototype._anonymousModelId=function(e){for(var t="",n=0;n<e.length;n++){var r=e[n];t+=r>="0"&&"9">=r?"0":r>="a"&&"z">=r?"a":r>="A"&&"Z">=r?"A":r}return t},t.prototype.insert=function(e,t){var n=this;if(this.contains(e))throw new Error("ResourceService: Cannot add model "+this._anonymousModelId(e.toString())+" because it already exists!");var o=e.toString();this.data[o]=t,this.unbinds[o]=[],this.unbinds[o].push(t.addBulkListener(function(t){n.emit(r.ResourceEvents.CHANGED,{url:e,originalEvents:t})})),this.emit(r.ResourceEvents.ADDED,{url:e,addedElement:t})},t.prototype.get=function(e){return this.data[e.toString()]?this.data[e.toString()]:null},t.prototype.all=function(){var e=this;return Object.keys(this.data).map(function(t){return e.data[t]})},t.prototype.contains=function(e){return!!this.data[e.toString()]},t.prototype.remove=function(e){if(this.contains(e)){for(var t=e.toString(),n=this.data[t];this.unbinds[t].length>0;)this.unbinds[t].pop()();delete this.unbinds[t],delete this.data[t],this.emit(r.ResourceEvents.REMOVED,{url:e,removedElement:n})}},t}(n.EventEmitter);t.ResourceService=o}),define("vs/editor/common/worker/validationHelper",["require","exports","vs/editor/common/services/resourceService","vs/base/common/async","vs/base/common/lifecycle"],function(e,t,n,r,o){var i=function(){function e(e,t){var n=this;this._toDispose=[],this._changeCallback=t,this._model=e,this._isDirty=!1,this._toDispose.push({dispose:e.addBulkListener(function(e){return n._onModelChanged(e)})})}return e.prototype.dispose=function(){this._toDispose=o.disposeAll(this._toDispose),this._changeCallback=null},e.prototype.markAsClean=function(){this._isDirty=!1},e.prototype.markAsDirty=function(){this._isDirty=!0},e.prototype.isDirty=function(){return this._isDirty},e.prototype.getMirrorModel=function(){return this._model},e.prototype._onModelChanged=function(e){for(var t=!1,n=0;!t&&n<e.length;n++)"changed"===e[n].getType()&&(t=!0);t&&this._changeCallback(this)},e}(),s=function(){function e(e,t,o,i){var s=this;void 0===i&&(i=500),this._toDispose=[],this._resourceService=e,this._callback=t,this._filter=o,this._validationDelay=i,this._models={},this._isDueToConfigurationChange=!1,this._toDispose.push(this._resourceService.addListener2_(n.ResourceEvents.ADDED,function(e){s._onResourceAdded(e)})),this._toDispose.push(this._resourceService.addListener2_(n.ResourceEvents.REMOVED,function(e){s._onResourceRemoved(e)})),this._validate=new r.RunOnceScheduler(function(){return s._invokeCallback()},this._validationDelay),this._toDispose.push(this._validate),this._resourceService.all().forEach(function(e){return s._addElement(e)})}return e.prototype.dispose=function(){var e=this;this._toDispose=o.disposeAll(this._toDispose),o.disposeAll(Object.keys(this._models).map(function(t){return e._models[t]})),this._models=null},e.prototype.trigger=function(){this._validate.schedule()},e.prototype.triggerDueToConfigurationChange=function(){this._isDueToConfigurationChange=!0,this._validate.schedule()},e.prototype._addElement=function(e){var t=this;if(this._filter(e)){var n=e,r=new i(n,function(e){return t._onChanged(e)});this._models[n.getAssociatedResource().toString()]=r,this._onChanged(r)}},e.prototype._onResourceAdded=function(e){var t=e.url.toString();this._models.hasOwnProperty(t)&&this._models[t].dispose(),this._addElement(e.addedElement)},e.prototype._onResourceRemoved=function(e){var t=e.url.toString();this._models.hasOwnProperty(t)&&(this._models[t].dispose(),delete this._models[t])},e.prototype._onChanged=function(e){e.markAsDirty(),this._validate.schedule()},e.prototype._invokeCallback=function(){var e=this;if(this._isEnabled){var t=[],n=[];Object.keys(this._models).map(function(t){return e._models[t]}).forEach(function(e){e.isDirty()?(t.push(e.getMirrorModel().getAssociatedResource()),e.markAsClean()):n.push(e.getMirrorModel().getAssociatedResource())});var r=this._isDueToConfigurationChange;this._isDueToConfigurationChange=!1,this._callback(t,n,r)}},e.prototype.enable=function(){this._isEnabled=!0,this.trigger()},e}();t.ValidationHelper=s}),define("vs/platform/event/common/event",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.IEventService=n.createDecorator("eventService")});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/platform/event/common/eventService",["require","exports","vs/base/common/eventEmitter","./event"],function(e,t,n,r){var o=function(e){function t(){e.call(this),this.serviceId=r.IEventService}return __extends(t,e),t}(n.EventEmitter);t.EventService=o});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/platform/files/common/files",["require","exports","vs/base/common/paths","vs/base/common/events","vs/platform/instantiation/common/instantiation"],function(e,t,n,r,o){t.IFileService=o.createDecorator("fileService"),function(e){e[e.UPDATED=0]="UPDATED",e[e.ADDED=1]="ADDED",e[e.DELETED=2]="DELETED"}(t.FileChangeType||(t.FileChangeType={}));var i=t.FileChangeType;t.EventType={FILE_CHANGES:"files:fileChanges"};var s=function(e){function t(t){e.call(this),this._changes=t}return __extends(t,e),Object.defineProperty(t.prototype,"changes",{get:function(){return this._changes},enumerable:!0,configurable:!0}),t.prototype.contains=function(e,t){return e?this.containsAny([e],t):!1},t.prototype.containsAny=function(e,t){return e&&e.length?this._changes.some(function(r){return r.type!==t?!1:t===i.DELETED?e.some(function(e){return e?n.isEqualOrParent(e.fsPath,r.resource.fsPath):!1}):e.some(function(e){return e?e.fsPath===r.resource.fsPath:!1})}):!1},t.prototype.getAdded=function(){return this.getOfType(i.ADDED)},t.prototype.gotAdded=function(){return this.hasType(i.ADDED)},t.prototype.getDeleted=function(){return this.getOfType(i.DELETED)},t.prototype.gotDeleted=function(){return this.hasType(i.DELETED)},t.prototype.getUpdated=function(){return this.getOfType(i.UPDATED)},t.prototype.gotUpdated=function(){return this.hasType(i.UPDATED)},t.prototype.getOfType=function(e){return this._changes.filter(function(t){return t.type===e})},t.prototype.hasType=function(e){return this._changes.some(function(t){return t.type===e})},t}(r.Event);t.FileChangesEvent=s,function(e){e[e.FILE_IS_BINARY=0]="FILE_IS_BINARY",e[e.FILE_IS_DIRECTORY=1]="FILE_IS_DIRECTORY",e[e.FILE_NOT_FOUND=2]="FILE_NOT_FOUND",e[e.FILE_NOT_MODIFIED_SINCE=3]="FILE_NOT_MODIFIED_SINCE",e[e.FILE_MODIFIED_SINCE=4]="FILE_MODIFIED_SINCE",e[e.FILE_MOVE_CONFLICT=5]="FILE_MOVE_CONFLICT",e[e.FILE_READ_ONLY=6]="FILE_READ_ONLY",e[e.FILE_TOO_LARGE=7]="FILE_TOO_LARGE"}(t.FileOperationResult||(t.FileOperationResult={}));t.FileOperationResult}),define("vs/platform/instantiation/common/instantiationService",["require","exports","vs/base/common/winjs.base","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/base/common/collections","./descriptors","vs/base/common/graph","./instantiation"],function(e,t,n,r,o,i,s,a,u,c){function l(e){void 0===e&&(e=Object.create(null));var t=new m(e,new p);return t}function d(){function e(e,t){"string"==typeof t?n[t]=e:n[c._util.getServiceId(t)]=e}function t(e){var t=e[c._util.DI_PROVIDES];if(!t)throw new Error("@ServiceName decoration expected");var r=n[t];if(!r)throw new Error("service '"+t+"' not found. @Uses-decorator incomplete?");return r}var n=Object.create(null);return{get:t,add:e}}var h=c.IInstantiationService;t.create=l,t.createContext=d;var p=function(){function e(){this._value=0}return Object.defineProperty(e.prototype,"locked",{get:function(){return 0===this._value},enumerable:!0,configurable:!0}),e.prototype.runUnlocked=function(e){this._value++;try{return e()}finally{this._value--}},e}(),f=function(){function e(e,t){var n=this;this._services=e,this._lock=t,s.forEach(this._services,function(e){n.registerService(e.key,e.value)})}return e.prototype.registerService=function(e,t){var n=this;Object.defineProperty(this,e,{get:function(){if(n._lock.locked)throw r.illegalState("the services map can only be used during construction");if(!t)throw r.illegalArgument(o.format("service with '{0}' not found",e));if(t instanceof a.SyncDescriptor){var i=n._services[e];i instanceof a.SyncDescriptor?(n._ensureInstances(e,t),t=n._services[e]):t=i}return t},set:function(e){throw r.illegalState("services cannot be changed")},configurable:!1,enumerable:!1}),this._services[e]=t},Object.defineProperty(e.prototype,"lock",{get:function(){return this._lock},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"services",{get:function(){return this._services},enumerable:!0,configurable:!0}),e.prototype._ensureInstances=function(e,t){for(var n=Object.create(null),r=new u.Graph(function(e){return e.serviceId}),o=[{serviceId:e,desc:t}];o.length;){var i=o.pop();if(r.lookupOrInsertNode(i),n[i.serviceId])throw new Error("[createInstance] cyclic dependency: "+Object.keys(n).join(">>"));n[i.serviceId]=!0;var s=c._util.getServiceDependencies(i.desc.ctor);if(Array.isArray(s))for(var l=0;l<s.length;l++){var d=s[l],h=this.services[d.serviceId];if(!h)throw new Error("[createInstance] "+e+" depends on "+d.serviceId+" which is NOT registered.");if(h instanceof a.SyncDescriptor){var p={serviceId:d.serviceId,desc:h};o.push(p),r.insertEdge(i,p)}}}for(;;){var f=r.roots();if(0===f.length){if(0!==r.length)throw new Error("[createInstance] cyclinc dependency!");break}for(var m=0;m<f.length;m++){var g=f[m],v=this.createInstance(g.data.desc,[]);this._services[g.data.serviceId]=v,r.removeNode(g.data)}}},e.prototype.invokeFunction=function(e,t){var n=this;return this._lock.runUnlocked(function(){var r={get:function(e){var t=c._util.getServiceId(e);return n[t]}};return e.apply(void 0,[r].concat(t))})},e.prototype.createInstance=function(e,t){var n=this,r=[],o=c._util.getServiceDependencies(e.ctor);if(Array.isArray(o)){var s,a=e.staticArguments().concat(t),u=a.length,l=Number.MAX_VALUE;o.forEach(function(e){var t=e.serviceId,o=e.index,i=n._lock.runUnlocked(function(){return n[t]});void 0===o?(s||(s=d(),r[0]=s,u+=1),s.add(i,t)):(r[o]=i,l=Math.min(l,e.index))});for(var h=s?1:0,p=0;p<a.length;p++){var f=a[p],m=void 0!==r[h];m||(r[h]=f),h+=1}if(r.unshift(e.ctor),l!==Number.MAX_VALUE&&l!==u){var g="[createInstance] constructor '"+e.ctor.name+"' has first service dependency at position "+(l+1)+" but is called with "+(u-1)+" static arguments that are expected to come first";console.warn(g)}}else r=[e.ctor,this],r.push.apply(r,e.staticArguments()),r.push.apply(r,t);return this._lock.runUnlocked(function(){var t=i.create.apply(null,r);return e._validate(t),t})},e}(),m=function(){function t(e,t){this.serviceId=h,e.instantiationService=this,this._servicesMap=new f(e,t)}return t.prototype.createChild=function(e){var n={};return s.forEach(this._servicesMap.services,function(e){n[e.key]=e.value}),s.forEach(e,function(e){n[e.key]=e.value}),new t(n,this._servicesMap.lock)},t.prototype.registerService=function(e,t){this._servicesMap.registerService(e,t)},t.prototype.addSingleton=function(e,t){var n=c._util.getServiceId(e);this._servicesMap.registerService(n,t)},t.prototype.getInstance=function(e){var t=this,n=c._util.getServiceId(e),r=this._servicesMap.lock.runUnlocked(function(){return t._servicesMap[n]});return r},t.prototype.createInstance=function(e){for(var t=new Array(arguments.length-1),n=1,r=arguments.length;r>n;n++)t[n-1]=arguments[n];return e instanceof a.SyncDescriptor?this._servicesMap.createInstance(e,t):e instanceof a.AsyncDescriptor?this._createInstanceAsync(e,t):this._servicesMap.createInstance(new a.SyncDescriptor(e),t)},t.prototype._createInstanceAsync=function(t,o){var i,s=this;return new n.TPromise(function(n,u,c){e([t.moduleName],function(e){if(i&&u(i),!e)return u(r.illegalArgument("module not found: "+t.moduleName));var c;if(c=t.ctorName?e[t.ctorName]:e,"function"!=typeof c)return u(r.illegalArgument("not a function: "+t.ctorName||t.moduleName));try{o.unshift.apply(o,t.staticArguments()),n(s._servicesMap.createInstance(new a.SyncDescriptor(c),o))}catch(l){return u(l)}},u)},function(){i=r.canceled()})},t.prototype.invokeFunction=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return this._servicesMap.invokeFunction(e,t)},t}()}),define("vs/platform/markers/common/markers",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.IMarkerService=n.createDecorator("markerService"),function(e){e[e["transient"]=1]="transient",e[e.permanent=2]="permanent"}(t.MarkerType||(t.MarkerType={}));t.MarkerType});var __decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return void(r&&r(t,n))},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/editor/common/modes/abstractModeWorker",["require","exports","vs/platform/markers/common/markers","vs/editor/common/services/resourceService","vs/editor/common/modes/linkComputer","vs/editor/common/diff/diffComputer","vs/editor/common/modes/modesFilters","vs/editor/common/model/textModel","vs/editor/common/modes/supports","vs/editor/common/worker/validationHelper","vs/base/common/winjs.base"],function(e,t,n,r,o,i,s,a,u,c,l){function d(e){return"function"==typeof e.validate}function h(e){return"function"==typeof e.suggest||"function"==typeof e.filter}var p=function(){function e(e,t,n,r){var o=this;this._validationParticipants=[],this._suggestParticipants=[],this._participants=[],this._mode=e,this._participants=t,this.resourceService=n,this.markerService=r,this._validationHelper=new c.ValidationHelper(this.resourceService,function(e,t,n){return o._newValidate(e,t,n)},function(e){return o._shouldIncludeModelInValidation(e)},500),this._validationParticipants=this._getWorkerParticipants(function(e){return d(e)}),this._suggestParticipants=this._getWorkerParticipants(function(e){return h(e)}),this.inplaceReplaceSupport=this._createInPlaceReplaceSupport()}return e.prototype._createInPlaceReplaceSupport=function(){return new u.WorkerInplaceReplaceSupport(this.resourceService)},e.prototype._getMode=function(){return this._mode},e.prototype._getWorkerParticipants=function(e){return this._participants.filter(e)},e.prototype._shouldIncludeModelInValidation=function(e){return e.getMode().getId()===this._mode.getId()},e.prototype.enableValidator=function(){return this._validationHelper.enable(),l.TPromise.as(null)},e.prototype._newValidate=function(e,t,n){this.doValidateOnChange(e,t,n);for(var r=0;r<e.length;r++)this.triggerValidateParticipation(e[r],this._getContextForValidationParticipants(e[r]))},e.prototype._getContextForValidationParticipants=function(e){return null},e.prototype.doValidateOnChange=function(e,t,n){if(n){for(var r=0;r<e.length;r++)this.doValidate(e[r]);for(var r=0;r<t.length;r++)this.doValidate(t[r])}else for(var r=0;r<e.length;r++)this.doValidate(e[r])},e.prototype.triggerValidateParticipation=function(e,t){var n=this;void 0===t&&(t=null);var r=this.resourceService.get(e);this._validationParticipants.forEach(function(e){try{e.validate(r,n.markerService,t)}catch(o){}})},e.prototype.doValidate=function(e){return null},e.prototype.suggest=function(e,t){var n=this;return this._getSuggestContext(e).then(function(r){var o=[n.doSuggest(e,t)];return o.push.apply(o,n._participantSuggests(e,t,r)),l.TPromise.join(o)}).then(function(e){for(var t=n.getSuggestionFilterMain(),r=[],o=0,i=e.length;i>o;o++){var s=e[o];s&&r.push({currentWord:s.currentWord,suggestions:s.suggestions.filter(function(n){return t(e[o].currentWord,n)}),incomplete:s.incomplete,overwriteBefore:s.overwriteBefore,overwriteAfter:s.overwriteAfter})}return r},function(e){return[{currentWord:"",suggestions:[]}]})},e.prototype._participantSuggests=function(e,t,n){return this._suggestParticipants.map(function(r){try{return r.suggest(e,t,n)}catch(o){}})},e.prototype._getSuggestContext=function(e){return l.TPromise.as(void 0)},e.prototype.doSuggest=function(e,t){var n=this.resourceService.get(e),r=n.getWordUntilPosition(t).word,o={currentWord:r,suggestions:[]};return o.suggestions.push.apply(o.suggestions,this.suggestWords(e,t,!1)),o.suggestions.push.apply(o.suggestions,this.suggestSnippets(e,t)),l.TPromise.as(o)},e.prototype.suggestWords=function(e,t,n){var r=this.resourceService.get(e),o=r.getWordUntilPosition(t).word,i=r.getAllUniqueWords(o);
return n&&!o?[]:i.filter(function(e){return!/^-?\d*\.?\d/.test(e)}).map(function(e){return{type:"text",label:e,codeSnippet:e,noAutoAccept:!0}})},e.prototype.suggestSnippets=function(e,t){return[]},e.prototype.getSuggestionFilterMain=function(){var e=this.getSuggestionFilter();return this._suggestParticipants.forEach(function(t){"function"==typeof t.filter&&(e=s.and(e,t.filter))}),e},e.prototype.getSuggestionFilter=function(){return e.filter},e.prototype.findOccurrences=function(e,t,n){for(var r=this.resourceService.get(e),o=r.getWordAtPosition(t),i=o?o.word:"",s=[],a=r.getAllWordsWithRange(),u=Math.min(1e3,a.length),c=0;u>c;c++)a[c].text===i&&s.push({range:a[c].range,kind:"text"});return l.TPromise.as(s)},e.prototype.computeDiff=function(e,t,n){var r=this.resourceService.get(e),o=this.resourceService.get(t);if(null!==r&&null!==o){var s=r.getLinesContent(),a=o.getLinesContent(),u=new i.DiffComputer(s,a,{shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:n,shouldConsiderTrimWhitespaceInEmptyCase:!0});return l.TPromise.as(u.computeDiff())}return l.TPromise.as(null)},e.prototype.computeDirtyDiff=function(e,t){var n=this.resourceService.get(e),r=n.getProperty("original");if(r&&null!==n){var o=a.TextModel.toRawText(r),s=o.lines,u=n.getLinesContent(),c=new i.DiffComputer(s,u,{shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:t,shouldConsiderTrimWhitespaceInEmptyCase:!1});return l.TPromise.as(c.computeDiff())}return l.TPromise.as([])},e.prototype.computeLinks=function(e){var t=this.resourceService.get(e),n=o.computeLinks(t);return l.TPromise.as(n)},e.prototype.configure=function(e){var t=this,n=this._doConfigure(e);return n?n.then(function(e){return e&&t._validationHelper.triggerDueToConfigurationChange(),!0}):void 0},e.prototype._doConfigure=function(e){return l.TPromise.as(!0)},e.filter=s.DefaultFilter,e=__decorate([__param(2,r.IResourceService),__param(3,n.IMarkerService)],e)}();t.AbstractModeWorker=p}),define("vs/platform/platform",["require","exports","vs/base/common/types","vs/base/common/assert"],function(e,t,n,r){var o=function(){function e(){this.data={}}return e.prototype.add=function(e,t){r.ok(n.isString(e)),r.ok(n.isObject(t)),r.ok(!this.data.hasOwnProperty(e),"There is already an extension with this id"),this.data[e]=t},e.prototype.knows=function(e){return this.data.hasOwnProperty(e)},e.prototype.as=function(e){return this.data[e]||null},e}();t.Registry=new o;var i=function(){function e(){this.toBeInstantiated=[],this.instances=[]}return e.prototype.setInstantiationService=function(e){for(this.instantiationService=e;this.toBeInstantiated.length>0;){var t=this.toBeInstantiated.shift();this.instantiate(t)}},e.prototype.instantiate=function(e){var t=this.instantiationService.createInstance(e);this.instances.push(t)},e.prototype._register=function(e){this.instantiationService?this.instantiate(e):this.toBeInstantiated.push(e)},e.prototype._getInstances=function(){return this.instances.slice(0)},e.prototype._setInstances=function(e){this.instances=e},e}();t.BaseRegistry=i}),define("vs/languages/json/common/jsonContributionRegistry",["require","exports","vs/platform/platform","vs/base/common/eventEmitter"],function(e,t,n,r){function o(e){return e.length>0&&"#"===e.charAt(e.length-1)?e.substring(0,e.length-1):e}t.Extensions={JSONContribution:"base.contributions.json"};var i=function(){function e(){this.schemasById={},this.schemaAssociations={},this.eventEmitter=new r.EventEmitter}return e.prototype.addRegistryChangedListener=function(e){return this.eventEmitter.addListener2("registryChanged",e)},e.prototype.registerSchema=function(e,t){this.schemasById[o(e)]=t,this.eventEmitter.emit("registryChanged",{})},e.prototype.addSchemaFileAssociation=function(e,t){var n=this.schemaAssociations[e];n||(n=[],this.schemaAssociations[e]=n),n.push(t),this.eventEmitter.emit("registryChanged",{})},e.prototype.getSchemaContributions=function(){return{schemas:this.schemasById,schemaAssociations:this.schemaAssociations}},e}(),s=new i;n.Registry.add(t.Extensions.JSONContribution,s)}),define("vs/platform/plugins/common/plugins",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.IPluginService=n.createDecorator("pluginService"),t.INSTANCE=null}),define("vs/platform/plugins/common/pluginsRegistry",["require","exports","vs/platform/platform","vs/base/common/errors","vs/languages/json/common/jsonContributionRegistry","vs/nls!vs/platform/plugins/common/pluginsRegistry","vs/base/common/paths","vs/base/common/severity"],function(e,t,n,r,o,i,s,a){function u(e,t,n){if(!t)return n.push(i.localize(0,null)),!1;if("string"!=typeof t.publisher)return n.push(i.localize(1,null,"publisher")),!1;if("string"!=typeof t.name)return n.push(i.localize(2,null,"name")),!1;if(!t.engines)return n.push(i.localize(3,null,"engines")),!1;if("string"!=typeof t.engines.vscode)return n.push(i.localize(4,null,"engines.vscode")),!1;if("undefined"!=typeof t.extensionDependencies&&!c(t.extensionDependencies))return n.push(i.localize(5,null,"extensionDependencies")),!1;if("undefined"!=typeof t.activationEvents){if(!c(t.activationEvents))return n.push(i.localize(6,null,"activationEvents")),!1;if("undefined"==typeof t.main)return n.push(i.localize(7,null,"activationEvents","main")),!1}if("undefined"!=typeof t.main){if("string"!=typeof t.main)return n.push(i.localize(8,null,"main")),!1;var r=s.normalize(s.join(e,t.main));if(r.indexOf(e)&&n.push(i.localize(9,null,r,e)),"undefined"==typeof t.activationEvents)return n.push(i.localize(10,null,"activationEvents","main")),!1}return!0}function c(e){if(!Array.isArray(e))return!1;for(var t=0,n=e.length;n>t;t++)if("string"!=typeof e[t])return!1;return!0}var l=function(){function e(e,t){this._scope=e,this._actual=t}return e.prototype.error=function(e){this._actual.error(this._scope,e)},e.prototype.warn=function(e){this._actual.warn(this._scope,e)},e.prototype.info=function(e){this._actual.info(this._scope,e)},e}(),d=function(){function e(e){this._handler=e}return e.prototype._pushMessage=function(e,t,n){this._handler(e,t,this._ensureString(n))},e.prototype._ensureString=function(e){return e&&e.message&&e.stack?e.message+"\n\n"+e.stack:String(e)},e.prototype.error=function(e,t){this._pushMessage(a["default"].Error,e,t)},e.prototype.warn=function(e,t){this._pushMessage(a["default"].Warning,e,t)},e.prototype.info=function(e,t){this._pushMessage(a["default"].Info,e,t)},e.prototype.scopeTo=function(e){return new l(e,this)},e}(),h=function(){function e(){this._messages=[]}return e.prototype.getMessages=function(){return this._messages},e.prototype._pushMessage=function(e,t,n){this._messages.push({type:e,message:this._ensureString(n),source:t})},e.prototype._ensureString=function(e){return e&&e.message&&e.stack?e.message+"\n\n"+e.stack:String(e)},e.prototype.error=function(e,t){this._pushMessage(a["default"].Error,e,t)},e.prototype.warn=function(e,t){this._pushMessage(a["default"].Warning,e,t)},e.prototype.info=function(e,t){this._pushMessage(a["default"].Info,e,t)},e.prototype.scopeTo=function(e){return new l(e,this)},e}();t.PluginsMessageCollector=h,t.isValidPluginDescription=u;var p=Object.hasOwnProperty,f=n.Registry.as(o.Extensions.JSONContribution),m=function(){function e(e,t){this.name=e,this._registry=t,this._handler=null,this._collector=null}return e.prototype.setHandler=function(e){if(this._handler)throw new Error("Handler already set!");this._handler=e,this._handle()},e.prototype.handle=function(e){this._collector=e,this._handle()},e.prototype._handle=function(){var e=this;this._handler&&this._collector&&this._registry.registerPointListener(this.name,function(t){var n=t.map(function(t){return{description:t,value:t.contributes[e.name],collector:e._collector.scopeTo(t.extensionFolderPath)}});e._handler(n)})},e}(),g=function(){function e(){this._pluginsMap={},this._pluginsArr=[],this._activationMap={},this._pointListeners=[],this._extensionPoints={},this._oneTimeActivationEventListeners={}}return e.prototype.registerPointListener=function(t,n){var r={extensionPoint:t,listener:n};this._pointListeners.push(r),this._triggerPointListener(r,e._filterWithExtPoint(this.getAllPluginDescriptions(),t))},e.prototype.registerExtensionPoint=function(e,t){if(p.call(this._extensionPoints,e))throw new Error("Duplicate extension point: "+e);var n=new m(e,this);return this._extensionPoints[e]=n,y.properties.contributes.properties[e]=t,f.registerSchema(_,y),n},e.prototype.handleExtensionPoints=function(e){var t=this,n=new d(e);Object.keys(this._extensionPoints).forEach(function(e){t._extensionPoints[e].handle(n)})},e.prototype._triggerPointListener=function(e,t){if(t&&0!==t.length)try{e.listener(t)}catch(n){r.onUnexpectedError(n)}},e.prototype.registerPlugins=function(t){for(var n=0,r=t.length;r>n;n++){var o=t[n];if(p.call(this._pluginsMap,o.id))console.error("Plugin `"+o.id+"` is already registered");else if(this._pluginsMap[o.id]=o,this._pluginsArr.push(o),Array.isArray(o.activationEvents))for(var i=0,s=o.activationEvents.length;s>i;i++){var a=o.activationEvents[i];this._activationMap[a]=this._activationMap[a]||[],this._activationMap[a].push(o)}}for(var n=0,r=this._pointListeners.length;r>n;n++){var u=this._pointListeners[n],c=e._filterWithExtPoint(t,u.extensionPoint);this._triggerPointListener(u,c)}},e._filterWithExtPoint=function(e,t){return e.filter(function(e){return e.contributes&&p.call(e.contributes,t)})},e.prototype.getPluginDescriptionsForActivationEvent=function(e){return p.call(this._activationMap,e)?this._activationMap[e].slice(0):[]},e.prototype.getAllPluginDescriptions=function(){return this._pluginsArr.slice(0)},e.prototype.getPluginDescription=function(e){return p.call(this._pluginsMap,e)?this._pluginsMap[e]:null},e.prototype.registerOneTimeActivationEventListener=function(e,t){p.call(this._oneTimeActivationEventListeners,e)||(this._oneTimeActivationEventListeners[e]=[]),this._oneTimeActivationEventListeners[e].push(t)},e.prototype.triggerActivationEventListeners=function(e){if(p.call(this._oneTimeActivationEventListeners,e)){var t=this._oneTimeActivationEventListeners[e];delete this._oneTimeActivationEventListeners[e];for(var n=0,o=t.length;o>n;n++){var i=t[n];try{i()}catch(s){r.onUnexpectedError(s)}}}},e}(),v={PluginsRegistry:"PluginsRegistry"};n.Registry.add(v.PluginsRegistry,new g),t.PluginsRegistry=n.Registry.as(v.PluginsRegistry);var _="local://schemas/vscode-extension",y={"default":{name:"{{name}}",description:"{{description}}",author:"{{author}}",version:"{{1.0.0}}",main:"{{pathToMain}}",dependencies:{}},properties:{publisher:{description:i.localize(11,null),type:"string"},activationEvents:{description:i.localize(12,null),type:"array",items:{type:"string"}},extensionDependencies:{description:i.localize(13,null),type:"array",items:{type:"string"}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(14,null),type:"string"}}},contributes:{description:i.localize(15,null),type:"object","default":{languages:[{id:"",extensions:[]}]},properties:{outputChannels:{description:i.localize(16,null),type:"array",items:{type:"string",description:i.localize(17,null)}}}}},definitions:{}};f.registerSchema(_,y),f.addSchemaFileAssociation("/package.json",_)}),define("vs/platform/configuration/common/configurationRegistry",["require","exports","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/base/common/event","vs/platform/platform","vs/base/common/objects","vs/base/common/strings","vs/platform/plugins/common/pluginsRegistry","vs/languages/json/common/jsonContributionRegistry"],function(e,t,n,r,o,i,s,a,u){t.Extensions={Configuration:"base.contributions.configuration"};var c=function(){function e(){this.configurationContributors=[],this.hasJSONContributions=!1,this._onDidRegisterConfiguration=new r.Emitter}return Object.defineProperty(e.prototype,"onDidRegisterConfiguration",{get:function(){return this._onDidRegisterConfiguration.event},enumerable:!0,configurable:!0}),e.prototype.registerConfiguration=function(e){this.configurationContributors.push(e),this.registerJSONConfiguration(e),this._onDidRegisterConfiguration.fire(this)},e.prototype.getConfigurations=function(){return this.configurationContributors.slice(0)},e.prototype.registerJSONConfiguration=function(e){var t=s.format("local://schemas/settings/{0}",e.id),n=i.clone(e);n.id=t;var r=o.Registry.as(u.Extensions.JSONContribution);r.registerSchema(t,n),r.addSchemaFileAssociation("inmemory://defaults/settings.json",t),r.addSchemaFileAssociation("%APP_SETTINGS_HOME%/settings.json",t),r.addSchemaFileAssociation("/.vscode/settings.json",t)},e}(),l=new c;o.Registry.add(t.Extensions.Configuration,l);var d=a.PluginsRegistry.registerExtensionPoint("configuration",{description:n.localize(0,null),type:"object","default":{title:"",type:"object",properties:{}},properties:{title:{description:n.localize(1,null),type:"string"},type:{description:n.localize(2,null),"enum":["object"]},properties:{description:n.localize(3,null),type:"object"}}});d.setHandler(function(e){for(var t=0;t<e.length;t++){var n=e[t].value,r=i.clone(n);r.id=e[t].description.id,l.registerConfiguration(r)}})}),define("vs/platform/plugins/common/abstractPluginService",["require","exports","vs/nls!vs/platform/plugins/common/abstractPluginService","vs/platform/plugins/common/plugins","vs/base/common/winjs.base","vs/platform/plugins/common/pluginsRegistry","vs/base/common/severity"],function(e,t,n,r,o,i,s){function a(t){return new o.TPromise(function(n,r,o){e([t],function(e){n(e)},r)})}var u=Object.hasOwnProperty,c=this,l=function(){function e(e,t,n,r){this.activationFailed=e,this.module=t,this.exports=n,this.subscriptions=r}return e}();t.ActivatedPlugin=l;var d=function(){function e(e){var t=this;this.serviceId=r.IPluginService,e?(this._onReady=o.TPromise.as(!0),this._onReadyC=function(e){}):this._onReady=new o.TPromise(function(e,n,r){t._onReadyC=e},function(){console.warn("You should really not try to cancel this ready promise!")}),this.activatingPlugins={},this.activatedPlugins={}}return e.prototype.showMessage=function(e,t,n){this._showMessage(e,(t?"["+t+"]: ":"")+n)},e.prototype.registrationDone=function(e){var t=this;e.forEach(function(e){t.showMessage(e.type,e.source,e.message)}),this._onReadyC(!0)},e.prototype.registerOneTimeActivationEventListener=function(e,t){i.PluginsRegistry.registerOneTimeActivationEventListener(e,t)},e.prototype.onReady=function(){return this._onReady},e.prototype.get=function(e){if(!u.call(this.activatedPlugins,e))throw new Error("Plugin `"+e+"` is not known or not activated");return this.activatedPlugins[e].exports},e.prototype.isActivated=function(e){return u.call(this.activatedPlugins,e)},e.prototype.activateByEvent=function(e){var t=this;return this._onReady.then(function(){i.PluginsRegistry.triggerActivationEventListeners(e);var n=i.PluginsRegistry.getPluginDescriptionsForActivationEvent(e);return t._activatePlugins(n,0)})},e.prototype.activateAndGet=function(e){var t=this;return this._onReady.then(function(){var n=i.PluginsRegistry.getPluginDescription(e);if(!n)throw new Error("Plugin `"+e+"` is not known");return t._activatePlugins([n],0).then(function(){return t.get(e)})})},e.prototype._handleActivateRequest=function(e,t,r){for(var o="undefined"==typeof e.extensionDependencies?[]:e.extensionDependencies,a=!0,c=0,d=o.length;d>c;c++){var h=o[c],p=i.PluginsRegistry.getPluginDescription(h);if(!p)return this._showMessage(s["default"].Error,n.localize(0,null,h,e.id)),void(this.activatedPlugins[e.id]=new l(!0,{activate:void 0,deactivate:void 0},{},[]));if(u.call(this.activatedPlugins,h)){var f=this.activatedPlugins[h];if(f.activationFailed)return this._showMessage(s["default"].Error,n.localize(1,null,h,e.id)),void(this.activatedPlugins[e.id]=new l(!0,{activate:void 0,deactivate:void 0},{},[]))}else a=!1,t[h]=p}a?t[e.id]=e:r.push(e)},e.prototype._activatePlugins=function(e,t){var r=this;if(0===e.length)return o.TPromise.as(void 0);if(e=e.filter(function(e){return!u.call(r.activatedPlugins,e.id)}),0===e.length)return o.TPromise.as(void 0);if(t>10){for(var i=0,a=e.length;a>i;i++)this._showMessage(s["default"].Error,n.localize(2,null,e[i].id)),this.activatedPlugins[e[i].id]=new l(!0,{activate:void 0,deactivate:void 0},{},[]);return o.TPromise.as(void 0)}for(var c=Object.create(null),d=[],i=0,a=e.length;a>i;i++)this._handleActivateRequest(e[i],c,d);for(var i=0,a=d.length;a>i;i++)c[d[i].id]&&delete c[d[i].id];var h=Object.keys(c).map(function(e){return c[e]});return 0===d.length?o.TPromise.join(h.map(function(e){return r._activatePlugin(e)})).then(function(e){}):this._activatePlugins(h,t+1).then(function(e){return r._activatePlugins(d,t+1)})},e.prototype._activatePlugin=function(e){var t=this;return u.call(this.activatedPlugins,e.id)?o.TPromise.as(this.activatedPlugins[e.id].exports):u.call(this.activatingPlugins,e.id)?this.activatingPlugins[e.id]:(this.activatingPlugins[e.id]=this._actualActivatePlugin(e).then(null,function(r){return t._showMessage(s["default"].Error,n.localize(3,null,e.id,r.message)),console.error("Activating extension `"+e.id+"` failed: ",r.message),console.log("Here is the error stack: ",r.stack),new l(!0,{activate:void 0,deactivate:void 0},{},[])}).then(function(n){return t.activatedPlugins[e.id]=n,delete t.activatingPlugins[e.id],n.exports}),this.activatingPlugins[e.id])},e.prototype._actualActivatePlugin=function(t){var n=this;return t.main?this._loadPluginModule(t).then(function(r){return n._loadPluginContext(t).then(function(t){return e._callActivate(r,t)})}):o.TPromise.as(new l(!1,{activate:void 0,deactivate:void 0},{},[]))},e.prototype._loadPluginModule=function(e){return a(e.main)},e.prototype._loadPluginContext=function(e){return o.TPromise.as(void 0)},e._callActivate=function(e,t){return e=e||{activate:void 0,deactivate:void 0},this._callActivateOptional(e,t).then(function(n){return new l(!1,e,n,t.subscriptions)})},e._callActivateOptional=function(e,t){if("function"!=typeof e.activate)return o.TPromise.as(e);try{return o.TPromise.as(e.activate.apply(c,[t]))}catch(n){return o.TPromise.wrapError(n)}},e}();t.AbstractPluginService=d,t.loadAMDModule=a}),define("vs/platform/request/common/request",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.IRequestService=n.createDecorator("requestService")}),define("vs/platform/request/common/baseRequestService",["require","exports","vs/base/common/network","vs/base/common/strings","vs/base/common/timer","vs/base/common/async","vs/base/common/http","vs/base/common/winjs.base","vs/base/common/objects","vs/platform/request/common/request"],function(e,t,n,r,o,i,s,a,u,c){var l=function(){function e(e,t){this.serviceId=c.IRequestService;var n=null,e=e,o=e.getWorkspace();this._serviceMap=o||Object.create(null),this._telemetryService=t,o&&(n=r.rtrim(o.resource.toString(),"/")+"/"),this.computeOrigin(n)}return e.prototype.computeOrigin=function(e){if(e){this._origin=e;var t=new n.URL(this._origin).getPath();t&&t.length>0&&(this._origin=this._origin.substring(0,this._origin.length-t.length+1)),r.endsWith(this._origin,"/")||(this._origin+="/")}else this._origin="/"},e.prototype.getRequestUrl=function(e,t,o){if(this._serviceMap[e]){var i=this._serviceMap[e]+r.normalizePath(t),s=new n.URL(i);return s.getScheme()?i:o?this._origin+r.ltrim(i,"/"):i}return null},e.prototype.getPath=function(e,t){var n=this.getRequestUrl(e,"/",!0);if(!n)return null;var r=t.toString().indexOf(n);return 0===r?t.toString().substr(n.length-1):null},e.prototype.makeCrossOriginRequest=function(e){return null},e.prototype.makeRequest=function(e){var t=o.nullEvent,n=!1,s=e.url;if(!s)throw new Error("IRequestService.makeRequest: Url is required");if((r.startsWith(s,"http://")||r.startsWith(s,"https://"))&&this._origin&&!r.startsWith(s,this._origin)){var c=this.makeCrossOriginRequest(e);if(c)return c;n=!0}var l=e;if(!n){var d={};this._telemetryService&&(d["X-TelemetrySession"]=this._telemetryService.getSessionId()),d["X-Requested-With"]="XMLHttpRequest",l.headers=u.mixin(l.headers,d)}return e.timeout&&(l.customRequestInitializer=function(t){t.timeout=e.timeout}),i.always(a.xhr(l),function(e){t.data&&(t.data.status=e.status),t.stop()})},e.prototype.makeChunkedRequest=function(e){var t,n,r,o=this,i=0,u=!1;return new a.TPromise(function(a,u,c){t=a,n=u,r=c,o.makeRequest(e).done(function(e){var n={request:e,chunks:[]};i=s.parseChunkedData(e,n.chunks,i),t(n)},function(e){n(e)},function(e){})},function(){u=!0})},e}();t.BaseRequestService=l}),define("vs/platform/search/common/search",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.ID="searchService",t.ISearchService=n.createDecorator(t.ID),function(e){e[e.File=1]="File",e[e.Text=2]="Text"}(t.QueryType||(t.QueryType={}));var r=(t.QueryType,function(){function e(e){this.resource=e,this.lineMatches=[]}return e}());t.FileMatch=r;var o=function(){function e(e,t,n){this.preview=e,this.lineNumber=t,this.offsetAndLengths=n}return e}();t.LineMatch=o}),define("vs/platform/telemetry/common/telemetry",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){function r(e){if(!e)return e;for(var t="",n=0;n<e.length;n++){var r=e[n];t+=r>="0"&&"9">=r?"0":r>="a"&&"z">=r?"a":r>="A"&&"Z">=r?"A":r}return t}t.ID="telemetryService",t.ITelemetryService=n.createDecorator(t.ID),t.anonymize=r}),define("vs/platform/telemetry/common/abstractTelemetryService",["require","exports","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/base/common/timer","vs/base/common/objects","vs/platform/platform","vs/platform/telemetry/common/telemetry"],function(e,t,n,r,o,i,s,a,u){var c=function(){function e(){var e=this;this.serviceId=u.ITelemetryService,this.sessionId="SESSION_ID_NOT_SET",this.timeKeeper=new i.TimeKeeper,this.toUnbind=[],this.appenders=[],this.timeKeeperListener=function(t){return e.onTelemetryTimerEventStop(t)},this.timeKeeper.addListener(this.timeKeeperListener),this.toUnbind.push(n.errorHandler.addListener(this.onErrorEvent.bind(this))),this.errorBuffer=Object.create(null),this.enableGlobalErrorHandler(),this.errorFlushTimeout=-1}return e.prototype._safeStringify=function(e){return s.safeStringify(e)},e.prototype.onTelemetryTimerEventStop=function(e){for(var t=0;t<e.length;t++){var n=e[t],r=n.data||{};r.duration=n.timeTaken(),this.publicLog(n.name,r)}},e.prototype.onErrorEvent=function(e){Array.isArray(e.stack)&&(e.stack=e.stack.join("\n")),e.detail&&e.detail.stack&&(e=e.detail),e.stack&&(e.message||(e.message=this._safeStringify(e)),e.message=this.cleanupInfo(e.message),e.stack=this.cleanupInfo(e.stack),this.addErrortoBuffer(e))},e.prototype.addErrortoBuffer=function(e){this.errorBuffer[e.stack]?this.errorBuffer[e.stack].count++:(e.count=1,this.errorBuffer[e.stack]=e),this.tryScheduleErrorFlush()},e.prototype.tryScheduleErrorFlush=function(){var t=this;-1===this.errorFlushTimeout&&(this.errorFlushTimeout=setTimeout(function(){return t.flushErrorBuffer()},e.ERROR_FLUSH_TIMEOUT))},e.prototype.flushErrorBuffer=function(){if(this.errorBuffer)for(var e in this.errorBuffer)this.publicLog("UnhandledError",this.errorBuffer[e]);this.errorBuffer=Object.create(null),this.errorFlushTimeout=-1},e.prototype.cleanupInfo=function(e){var t=/file:\/\/\/.*?\/resources\/app\//gi;return e=e.replace(t,""),t=/file:\/\/\/.*/gi,e=e.replace(t,""),t=/ENOENT: no such file or directory.*?\'([^\']+)\'/gi,e=e.replace(t,"ENOENT: no such file or directory")},e.prototype.enableGlobalErrorHandler=function(){r.isFunction(o.globals.onerror)&&(this.oldOnError=o.globals.onerror);var e=this,t=function(t,n,r,o,i){e.onUncaughtError(t,n,r,o,i),e.oldOnError&&e.oldOnError.apply(this,arguments)};o.globals.onerror=t},e.prototype.onUncaughtError=function(e,t,n,r,o){t=this.cleanupInfo(t),e=this.cleanupInfo(e);var i={message:e,filename:t,line:n,column:r};o&&(i.error={name:o.name,message:o.message},o.stack&&(Array.isArray(o.stack)&&(o.stack=o.stack.join("\n")),i.stack=this.cleanupInfo(o.stack))),i.stack||(i.stack=i.message),this.addErrortoBuffer(i)},e.prototype.loadTelemetryAppendersFromRegistery=function(){for(var e=a.Registry.as(t.Extenstions.TelemetryAppenders).getTelemetryAppenderDescriptors(),n=0;n<e.length;n++){var r=e[n],o=this.instantiationService.createInstance(r);this.addTelemetryAppender(o)}},e.prototype.getSessionId=function(){return this.sessionId},e.prototype.getMachineId=function(){return this.machineId},e.prototype.getInstanceId=function(){return this.instanceId},e.prototype.getTelemetryInfo=function(){return Promise.resolve({instanceId:this.instanceId,sessionId:this.sessionId,machineId:this.machineId})},e.prototype.dispose=function(){for(-1!==this.errorFlushTimeout&&(clearTimeout(this.errorFlushTimeout),this.flushErrorBuffer());this.toUnbind.length;)this.toUnbind.pop()();this.timeKeeper.removeListener(this.timeKeeperListener),this.timeKeeper.dispose();for(var e=0;e<this.appenders.length;e++)this.appenders[e].dispose()},e.prototype.start=function(e,t){var n="public",r=this.timeKeeper.start(n,e);return t&&(r.data=t),r},e.prototype.publicLog=function(e,t){this.handleEvent(e,t)},e.prototype.getAppendersCount=function(){return this.appenders.length},e.prototype.getAppenders=function(){return this.appenders},e.prototype.addTelemetryAppender=function(e){this.appenders.push(e)},e.prototype.removeTelemetryAppender=function(e){var t=this.appenders.indexOf(e);t>-1&&this.appenders.splice(t,1)},e.prototype.setInstantiationService=function(e){this.instantiationService=e,this.instantiationService&&this.loadTelemetryAppendersFromRegistery()},e.prototype.handleEvent=function(e,t){throw new Error("Not implemented!")},e.ERROR_FLUSH_TIMEOUT=5e3,e}();t.AbstractTelemetryService=c,t.Extenstions={TelemetryAppenders:"telemetry.appenders"};var l=function(){function e(){this.telemetryAppenderDescriptors=[]}return e.prototype.registerTelemetryAppenderDescriptor=function(e){this.telemetryAppenderDescriptors.push(e)},e.prototype.getTelemetryAppenderDescriptors=function(){return this.telemetryAppenderDescriptors},e}();a.Registry.add(t.Extenstions.TelemetryAppenders,new l)}),define("vs/platform/thread/common/thread",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.IThreadService=n.createDecorator("threadService");var r=function(){function e(){}return e}();t.IRemotableCtorMap=r;var o=function(){function e(){}return e}();t.IRemotableCtorAffinityMap=o;var i=function(){function e(){}return e.getId=function(t){return t[e.PROP_NAME]||null},e.MainContext=function(t){return function(n){e._ensureUnique(t),e.Registry.MainContext[t]=n,n[e.PROP_NAME]=t}},e.PluginHostContext=function(t){return function(n){e._ensureUnique(t),e.Registry.PluginHostContext[t]=n,n[e.PROP_NAME]=t}},e.WorkerContext=function(t,n){return function(r){e._ensureUnique(t),e.Registry.WorkerContext[t]={ctor:r,affinity:n},r[e.PROP_NAME]=t}},e._ensureUnique=function(t){if(e.Registry.MainContext[t]||e.Registry.PluginHostContext[t]||e.Registry.WorkerContext[t])throw new Error("Duplicate Remotable identifier found")},e.PROP_NAME="$__REMOTABLE_ID",e.Registry={MainContext:Object.create(null),PluginHostContext:Object.create(null),WorkerContext:Object.create(null)},e}();t.Remotable=i,function(e){e[e.None=0]="None",e[e.Group1=1]="Group1",e[e.Group2=2]="Group2",e[e.Group3=3]="Group3",e[e.Group4=4]="Group4",e[e.Group5=5]="Group5",e[e.Group6=6]="Group6",e[e.Group7=7]="Group7",e[e.Group8=8]="Group8",e[e.Group9=9]="Group9",e[e.All=10]="All"}(t.ThreadAffinity||(t.ThreadAffinity={}));t.ThreadAffinity});var __decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return void(r&&r(t,n))},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/editor/common/services/modelServiceImpl",["require","exports","vs/editor/common/services/modeService","vs/editor/common/model/mirrorModel","vs/editor/common/core/range","vs/editor/common/editorCommon","vs/editor/common/services/resourceService","vs/editor/common/services/modelService","vs/platform/thread/common/thread","vs/base/common/eventSource","vs/base/common/uri","vs/base/common/network","vs/base/common/severity","vs/base/common/errors","vs/platform/telemetry/common/telemetry","vs/editor/common/model/model"],function(e,t,n,r,o,i,s,a,u,c,l,d,h,p,f,m){var g=function(){function e(e){this.model=e,this.toUnbind=null}return e.prototype.dispose=function(){this._decorationIds=this.model.deltaDecorations(this._decorationIds,[]),this.model=null,this.toUnbind&&(this.toUnbind(),this.toUnbind=null)},e.prototype.deltaMarkers=function(e){var t=this;e=e.slice(0,500);var n=e.map(function(e){return{range:t._createDecorationRange(e),options:t._createDecorationOption(e)}});this._decorationIds=this.model.deltaDecorations(this._decorationIds,n)},e.prototype._createDecorationRange=function(e){var t=this.model.validateRange(new o.Range(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn)),n=new o.Range(t.startLineNumber,t.startColumn,t.endLineNumber,t.endColumn);if(n.isEmpty()){var r=this.model.getWordAtPosition(n.getStartPosition());if(r)n.startColumn=r.startColumn,n.endColumn=r.endColumn;else{var i=this.model.getLineLastNonWhitespaceColumn(t.startLineNumber)||this.model.getLineMaxColumn(t.startLineNumber);1===i||(n.endColumn>=i?(n.endColumn=i,n.startColumn=i-1):n.endColumn+=1)}}else if(e.endColumn===Number.MAX_VALUE&&1===e.startColumn&&n.startLineNumber===n.endLineNumber){var s=this.model.getLineFirstNonWhitespaceColumn(e.startLineNumber);s<n.endColumn&&(n.startColumn=s,e.startColumn=s)}return n},e.prototype._createDecorationOption=function(e){var t,n,r,o=null;switch(e.severity){case h["default"].Ignore:break;case h["default"].Warning:case h["default"].Info:t=i.ClassName.EditorWarningDecoration,n="rgba(18,136,18,0.7)",r="rgba(18,136,18,0.7)";break;case h["default"].Error:default:t=i.ClassName.EditorErrorDecoration,n="rgba(255,18,18,0.7)",r="rgba(255,18,18,0.7)"}return"string"==typeof e.message?o=[{isText:!0,text:e.message}]:Array.isArray(e.message)?o=e.message:e.message&&(o=[e.message]),{stickiness:i.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges,className:t,htmlMessage:o,overviewRuler:{color:n,darkColor:r,position:i.OverviewRulerLane.Right}}},e}(),v=function(){function e(e,t){this.serviceId=a.IModelService,this._threadService=e,this._markerService=t,this._workerHelper=this._threadService.getRemotable(_),this._models={},this._onModelAdded=new c.EventSource,this._onModelRemoved=new c.EventSource,this._onModelModeChanged=new c.EventSource,this._markerService&&(this._markerServiceSubscription=this._markerService.onMarkerChanged(this._handleMarkerChange,this)),this._accumulatedModelEvents={},this._lastSentModelEventsTime=-1,this._sendModelEventsTimerId=-1}return e.prototype.dispose=function(){this._markerServiceSubscription&&this._markerServiceSubscription.dispose(),-1!==this._sendModelEventsTimerId&&(clearTimeout(this._sendModelEventsTimerId),this._sendModelEventsTimerId=-1)},e.prototype._sendModelEvents=function(e,t){var n=e.toString();this._accumulatedModelEvents[n]=this._accumulatedModelEvents[n]||[],this._accumulatedModelEvents[n]=this._accumulatedModelEvents[n].concat(t),this._sendModelEventsNow()},e.prototype._sendModelEventsNow=function(){this._lastSentModelEventsTime=Date.now();var e=this._accumulatedModelEvents;this._accumulatedModelEvents={},this._workerHelper.$onModelsEvents(e)},e.prototype._handleMarkerChange=function(e){var t=this;e.forEach(function(e){var n=t._models[e.toString()];n&&n.deltaMarkers(t._markerService.read({resource:e,take:500}))})},e.prototype.createModel=function(e,t,n){var r=new m.Model(e,t,n);return this.addModel(r),r},e.prototype.addModel=function(t){var n=this,r=t.getAssociatedResource().toString();if(this._models[r])throw new Error("BoundModels: Cannot add model "+f.anonymize(r)+" because it already exists!");
var o=new g(t);o.toUnbind=t.addBulkListener(function(e){return n._onModelEvents(r,e)}),this._markerService&&o.deltaMarkers(this._markerService.read({resource:t.getAssociatedResource()})),this._models[r]=o,this._workerHelper.$createModel(e._getBoundModelData(t)),this._onModelAdded.fire(t)},e.prototype.removeModel=function(e){var t=this,n=e.getAssociatedResource().toString();if(this._accumulatedModelEvents[n]&&delete this._accumulatedModelEvents[n],!this._models[n])throw new Error("BoundModels: Cannot remove model "+f.anonymize(n)+" because it doesn't exist!");if(this._workerHelper.$disposeModel(e.getAssociatedResource()),this._models[n].dispose(),delete this._models[n],this._markerService){var r=this._markerService.read({resource:e.getAssociatedResource()}),o=Object.create(null);r.forEach(function(e){return o[e.owner]=t}),Object.keys(o).forEach(function(n){return t._markerService.changeOne(n,e.getAssociatedResource(),[])})}this._onModelRemoved.fire(e)},e.prototype.destroyModel=function(e){var t=this.getModel(e);t&&t.destroy()},e.prototype.getModels=function(){var e=[];for(var t in this._models)this._models.hasOwnProperty(t)&&e.push(this._models[t].model);return e},e.prototype.getModel=function(e){var t=this._models[e.toString()];return t?t.model:null},Object.defineProperty(e.prototype,"onModelAdded",{get:function(){return this._onModelAdded?this._onModelAdded.value:null},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onModelRemoved",{get:function(){return this._onModelRemoved?this._onModelRemoved.value:null},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onModelModeChanged",{get:function(){return this._onModelModeChanged?this._onModelModeChanged.value:null},enumerable:!0,configurable:!0}),e._getBoundModelData=function(e){return{url:e.getAssociatedResource(),versionId:e.getVersionId(),properties:e.getProperties(),value:e.toRawText(),modeId:e.getMode().getId()}},e.prototype._onModelEvents=function(e,t){var n,r,o=[],s=!1;for(n=0,r=t.length;r>n;n++){var a=t[n],u=a.getData();switch(a.getType()){case i.EventType.ModelDispose:return void this.removeModel(this._models[e].model);case i.EventType.ModelContentChanged:switch(u.changeType){case i.EventType.ModelContentChangedFlush:o.push(this._mixinProperties({type:a.getType()},u,["changeType","detail","versionId"]));break;case i.EventType.ModelContentChangedLinesDeleted:o.push(this._mixinProperties({type:a.getType()},u,["changeType","fromLineNumber","toLineNumber","versionId"]));break;case i.EventType.ModelContentChangedLinesInserted:o.push(this._mixinProperties({type:a.getType()},u,["changeType","fromLineNumber","toLineNumber","detail","versionId"]));break;case i.EventType.ModelContentChangedLineChanged:o.push(this._mixinProperties({type:a.getType()},u,["changeType","lineNumber","detail","versionId"]))}s=!0;break;case i.EventType.ModelPropertiesChanged:o.push(this._mixinProperties({type:a.getType()},u,["properties"]));break;case i.EventType.ModelModeChanged:var c=u;this._workerHelper.$onModelModeChanged(e,c.oldMode.getId(),c.newMode.getId()),this._onModelModeChanged.fire(this._models[e].model,c.oldMode.getId())}}o.length>0&&this._sendModelEvents(this._models[e].model.getAssociatedResource(),o)},e.prototype._mixinProperties=function(e,t,n){for(var r=0;r<n.length;r++)e[n[r]]=t[n[r]];return e},e}();t.ModelServiceImpl=v;var _=function(){function e(e,t){this._resourceService=e,this._modeService=t}return e.prototype.$createModel=function(e){var t=this,n=new r.MirrorModel(this._resourceService,e.versionId,e.value,null,e.url,e.properties);return this._resourceService.insert(n.getAssociatedResource(),n),this._modeService.getOrCreateMode(e.modeId).then(function(e){t._resourceService.remove(n.getAssociatedResource()),n.setMode(e),t._resourceService.insert(n.getAssociatedResource(),n)})},e.prototype.$onModelModeChanged=function(e,t,n){var r=this,o=this._resourceService.get(l["default"].parse(e));return this._modeService.getOrCreateMode(n).then(function(e){r._resourceService.remove(o.getAssociatedResource()),o.setMode(e),r._resourceService.insert(o.getAssociatedResource(),o)})},e.prototype.$disposeModel=function(e){var t=this._resourceService.get(e);this._resourceService.remove(e),t&&t.dispose()},e.prototype.$onModelsEvents=function(e){var t=this,n=[];if(Object.keys(e).forEach(function(r){var o=t._resourceService.get(new d.URL(r));if(!o)return void n.push(r);try{o.onEvents(e[r])}catch(i){p.onUnexpectedError(i)}}),n.length>0)throw new Error("Received model events for missing models "+n.map(f.anonymize).join(" AND "))},e=__decorate([u.Remotable.WorkerContext("ModelServiceWorkerHelper",u.ThreadAffinity.All),__param(0,s.IResourceService),__param(1,n.IModeService)],e)}();t.ModelServiceWorkerHelper=_});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return void(r&&r(t,n))},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/platform/telemetry/common/abstractRemoteTelemetryService",["require","exports","vs/platform/telemetry/common/abstractTelemetryService","vs/platform/telemetry/common/telemetry","vs/platform/thread/common/thread"],function(e,t,n,r,o){var i=function(){function e(e){this._telemetryService=e}return e.prototype._handleRemoteTelemetryEvent=function(e,t){this._telemetryService.publicLog(e,t)},e.prototype.getTelemetryInfo=function(){return this._telemetryService.getTelemetryInfo()},e=__decorate([o.Remotable.MainContext("RemoteTelemetryServiceHelper"),__param(0,r.ITelemetryService)],e)}();t.RemoteTelemetryServiceHelper=i;var s=function(e){function t(t){e.call(this),this._proxy=t.getRemotable(i)}return __extends(t,e),t.prototype.getTelemetryInfo=function(){return this._proxy.getTelemetryInfo()},t.prototype.addTelemetryAppender=function(e){throw new Error("Telemetry appenders are not supported in this execution envirnoment")},t.prototype.handleEvent=function(e,t){this._proxy._handleRemoteTelemetryEvent(e,t)},t}(n.AbstractTelemetryService);t.AbstractRemoteTelemetryService=s});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/platform/telemetry/common/workerTelemetryService",["require","exports","vs/platform/telemetry/common/abstractRemoteTelemetryService"],function(e,t,n){var r=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.handleEvent=function(t,n){var n=n||{};n.workerTelemetry=!0,e.prototype.handleEvent.call(this,t,n)},t}(n.AbstractRemoteTelemetryService);t.WorkerTelemetryService=r}),define("vs/platform/thread/common/threadService",["require","exports","vs/platform/platform","vs/base/common/winjs.base","./thread"],function(e,t,n,r,o){function i(e,t){for(var n in e)if(e[n]===t)return n;throw new Error("Member not found in prototype")}function s(e){var n=e[t.THREAD_SERVICE_PROPERTY_NAME];if(!n)throw new Error("Objects that use thread attributes must be instantiated with the thread service");return n}function a(e,t){var n=i(e.prototype,t);e.prototype[n]=function(){for(var e=[],r=0;r<arguments.length;r++)e[r-0]=arguments[r];return s(this).MainThread(this,n,t,e)}}function u(e,t,n,a){void 0===a&&(a=o.ThreadAffinity.None);var u,c=i(e.prototype,t);"function"==typeof n?u=n:"undefined"!=typeof n&&(a=n),e.prototype[c]=function(){for(var e=[],n=0;n<arguments.length;n++)e[n-0]=arguments[n];if(u){var o=this,i=u.call(o);return r.Promise.is(i)||(i=r.Promise.as(i)),i.then(function(){return s(o).OneWorker(o,c,t,e,a)})}return s(this).OneWorker(this,c,t,e,a)}}function c(e,t){var n=i(e.prototype,t);e.prototype[n]=function(){for(var e=[],r=0;r<arguments.length;r++)e[r-0]=arguments[r];return s(this).AllWorkers(this,n,t,e)}}function l(e,t){var n=i(e.prototype,t);e.prototype[n]=function(){for(var e=[],r=0;r<arguments.length;r++)e[r-0]=arguments[r];return s(this).Everywhere(this,n,t,e)}}function d(e){var r=n.Registry.as(t.Extensions.SynchronizableObjects);r.register(e)}function h(){var e=n.Registry.as(t.Extensions.SynchronizableObjects);return e.read()}t.THREAD_SERVICE_PROPERTY_NAME="__$$__threadService",t.MainThreadAttr=a,t.OneWorkerAttr=u,t.AllWorkersAttr=c,t.EverywhereAttr=l;var p=function(){function e(){this._list=[],this._list=[]}return e.prototype.register=function(e){this._list.push(e)},e.prototype.read=function(){return this._list},e}();t.Extensions={SynchronizableObjects:"SynchronizableObjects"},n.Registry.add(t.Extensions.SynchronizableObjects,new p),t.registerThreadSynchronizableObject=d,t.readThreadSynchronizableObjects=h});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return void(r&&r(t,n))},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/editor/common/modes/abstractMode",["require","exports","vs/base/common/eventEmitter","vs/editor/common/modes/modesFilters","vs/editor/common/modes/nullMode","vs/editor/common/modes/supports","vs/base/common/winjs.base","vs/platform/instantiation/common/instantiation","vs/platform/thread/common/thread","vs/platform/thread/common/threadService","vs/platform/instantiation/common/descriptors"],function(e,t,n,r,o,i,s,a,u,c,l){function d(e){return void 0===e&&(e=""),o.NullMode.createWordRegExp(e)}function h(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];var n={codeLensSupport:!1,tokenizationSupport:!1,occurrencesSupport:!1,declarationSupport:!1,typeDeclarationSupport:!1,navigateTypesSupport:!1,referenceSupport:!1,suggestSupport:!1,parameterHintsSupport:!1,extraInfoSupport:!1,outlineSupport:!1,logicalSelectionSupport:!1,formattingSupport:!1,inplaceReplaceSupport:!1,diffSupport:!1,dirtyDiffSupport:!1,emitOutputSupport:!1,linkSupport:!1,configSupport:!1,electricCharacterSupport:!1,commentsSupport:!1,characterPairSupport:!1,tokenTypeClassificationSupport:!1,quickFixSupport:!1,onEnterSupport:!1};return e.forEach(function(e){return n[e]=!0}),n}t.createWordRegExp=d;var p=function(){function t(e,t,r){this._eventEmitter=new n.EventEmitter,this._instantiationService=t,this._threadService=r,this._descriptor=e,this._options=null,this.autoValidateDelay=500,this.occurrencesSupport=this,this.suggestSupport=this,this.inplaceReplaceSupport=this,this.diffSupport=this,this.dirtyDiffSupport=this,this.linkSupport=this,this.configSupport=this,this.commentsSupport=this,this.tokenTypeClassificationSupport=this,this._workerPiecePromise=null}return t.prototype.getId=function(){return this._descriptor.id},t.prototype.creationDone=function(){this._threadService.isInMainThread&&this._pickAWorkerToValidate()},t.prototype._getOrCreateWorker=function(){var e=this;if(!this._workerPiecePromise){var n=this._getWorkerDescriptor();this._workerPiecePromise=t._loadModule(n.moduleName).then(function(){var t=e._descriptor.workerParticipants;return s.TPromise.join(t.map(function(t){return e._instantiationService.createInstance(t)}))}).then(function(t){return e._instantiationService.createInstance(n,e,t)})}return this._workerPiecePromise},t._loadModule=function(t){return new s.TPromise(function(n,r,o){e([t],n,r)},function(){})},t.prototype._getWorkerDescriptor=function(){return l.createAsyncDescriptor2("vs/editor/common/modes/nullWorker","NullWorker")},t.prototype._worker=function(e){return this._getOrCreateWorker().then(e)},t.prototype._pickAWorkerToValidate=function(){return this._worker(function(e){return e.enableValidator()})},t.prototype.getFilter=function(){return r.StrictPrefix},t.prototype.addSupportChangedListener=function(e){return this._eventEmitter.addListener2("modeSupportChanged",e)},t.prototype.registerSupport=function(e,t){var n=this,r=t(this);return this[e]=r,this._eventEmitter.emit("modeSupportChanged",h(e)),{dispose:function(){n[e]===r&&(delete n[e],n._eventEmitter.emit("modeSupportChanged",h(e)))}}},t.prototype.suggest=function(e,t){return this._worker(function(n){return n.suggest(e,t)})},t.prototype.getTriggerCharacters=function(){return[]},t.prototype.shouldAutotriggerSuggest=function(e,n,r){return i.handleEvent(e,n,function(e,n,o){return e.suggestSupport?e instanceof t?e.shouldAutotriggerSuggestImpl(n,o,r):e.suggestSupport.shouldAutotriggerSuggest(n,o,r):!1})},t.prototype.shouldAutotriggerSuggestImpl=function(e,t,n){return!1},t.prototype.shouldShowEmptySuggestionList=function(){return!0},t.prototype.findOccurrences=function(e,t,n){return void 0===n&&(n=!1),this._worker(function(r){return r.findOccurrences(e,t,n)})},t.prototype.navigateValueSet=function(e,t,n){return this._worker(function(r){return r.inplaceReplaceSupport.navigateValueSet(e,t,n)})},t.prototype.computeDiff=function(e,t,n){return this._worker(function(r){return r.computeDiff(e,t,n)})},t.prototype.computeDirtyDiff=function(e,t){return this._worker(function(n){return n.computeDirtyDiff(e,t)})},t.prototype.computeLinks=function(e){return this._worker(function(t){return t.computeLinks(e)})},t.prototype.configure=function(e){return this._options=e,this._threadService.isInMainThread?this._configureWorkers(e):this._worker(function(t){return t.configure(e)})},t.prototype._configureWorkers=function(e){return this._worker(function(t){return t.configure(e)})},t.prototype.getWordDefinition=function(){return o.NullMode.DEFAULT_WORD_REGEXP},t.prototype.getCommentsConfiguration=function(){return null},t.$_pickAWorkerToValidate=c.OneWorkerAttr(t,t.prototype._pickAWorkerToValidate,u.ThreadAffinity.Group1),t.$suggest=c.OneWorkerAttr(t,t.prototype.suggest),t.$findOccurrences=c.OneWorkerAttr(t,t.prototype.findOccurrences),t.$navigateValueSet=c.OneWorkerAttr(t,t.prototype.navigateValueSet),t.$computeDiff=c.OneWorkerAttr(t,t.prototype.computeDiff),t.$computeDirtyDiff=c.OneWorkerAttr(t,t.prototype.computeDirtyDiff),t.$computeLinks=c.OneWorkerAttr(t,t.prototype.computeLinks),t.$_configureWorkers=c.AllWorkersAttr(t,t.prototype._configureWorkers),t}();t.AbstractMode=p,t.isDigit=function(){var e="0".charCodeAt(0),t="1".charCodeAt(0),n="2".charCodeAt(0),r="3".charCodeAt(0),o="4".charCodeAt(0),i="5".charCodeAt(0),s="6".charCodeAt(0),a="7".charCodeAt(0),u="8".charCodeAt(0),c="9".charCodeAt(0),l="a".charCodeAt(0),d="b".charCodeAt(0),h="c".charCodeAt(0),p="d".charCodeAt(0),f="e".charCodeAt(0),m="f".charCodeAt(0),g="A".charCodeAt(0),v="B".charCodeAt(0),_="C".charCodeAt(0),y="D".charCodeAt(0),k="E".charCodeAt(0),b="F".charCodeAt(0);return function(E,T){var S=E.charCodeAt(0);switch(T){case 1:return S===e;case 2:return S>=e&&t>=S;case 3:return S>=e&&n>=S;case 4:return S>=e&&r>=S;case 5:return S>=e&&o>=S;case 6:return S>=e&&i>=S;case 7:return S>=e&&s>=S;case 8:return S>=e&&a>=S;case 9:return S>=e&&u>=S;case 10:return S>=e&&c>=S;case 11:return S>=e&&c>=S||S===l||S===g;case 12:return S>=e&&c>=S||S>=l&&d>=S||S>=g&&v>=S;case 13:return S>=e&&c>=S||S>=l&&h>=S||S>=g&&_>=S;case 14:return S>=e&&c>=S||S>=l&&p>=S||S>=g&&y>=S;case 15:return S>=e&&c>=S||S>=l&&f>=S||S>=g&&k>=S;default:return S>=e&&c>=S||S>=l&&m>=S||S>=g&&b>=S}}}();var f=function(e){function t(t,n,r){e.call(this,t,n,r)}return __extends(t,e),t=__decorate([__param(1,a.IInstantiationService),__param(2,u.IThreadService)],t)}(p);t.FrankensteinMode=f}),define("vs/editor/common/modes/languageExtensionPoint",["require","exports","vs/nls!vs/editor/common/modes/languageExtensionPoint","vs/base/common/paths","vs/base/common/strings","vs/platform/thread/common/threadService","vs/platform/plugins/common/pluginsRegistry","vs/base/common/mime","vs/base/common/errors","vs/platform/instantiation/common/descriptors","vs/base/common/event"],function(e,t,n,r,o,i,s,a,u,c,l){function d(e){return"undefined"==typeof e?!0:Array.isArray(e)?e.every(function(e){return"string"==typeof e}):!1}function h(e,t){return e?"string"!=typeof e.id?(t.error(n.localize(9,null,"id")),!1):d(e.extensions)?d(e.filenames)?"undefined"!=typeof e.firstLine&&"string"!=typeof e.firstLine?(t.error(n.localize(12,null,"firstLine")),!1):"undefined"!=typeof e.configuration&&"string"!=typeof e.configuration?(t.error(n.localize(13,null,"configuration")),!1):d(e.aliases)?d(e.mimetypes)?!0:(t.error(n.localize(15,null,"mimetypes")),!1):(t.error(n.localize(14,null,"aliases")),!1):(t.error(n.localize(11,null,"filenames")),!1):(t.error(n.localize(10,null,"extensions")),!1):(t.error(n.localize(8,null,p.name)),!1)}var p=s.PluginsRegistry.registerExtensionPoint("languages",{description:n.localize(0,null),type:"array","default":[{id:"",aliases:[],extensions:[]}],items:{type:"object","default":{id:"",extensions:[]},properties:{id:{description:n.localize(1,null),type:"string"},aliases:{description:n.localize(2,null),type:"array",items:{type:"string"}},extensions:{description:n.localize(3,null),"default":[".foo"],type:"array",items:{type:"string"}},filenames:{description:n.localize(4,null),type:"array",items:{type:"string"}},mimetypes:{description:n.localize(5,null),type:"array",items:{type:"string"}},firstLine:{description:n.localize(6,null),type:"string"},configuration:{description:n.localize(7,null),type:"string"}}}}),f=Object.prototype.hasOwnProperty,m=function(){function e(){this._onDidAddMode=new l.Emitter,this.onDidAddMode=this._onDidAddMode.event,this.knownModeIds={},this.mime2LanguageId={},this.name2LanguageId={},this.id2Name={},this.name2Extensions={},this.compatModes={},this.lowerName2Id={},this.id2ConfigurationFiles={},this._isRegisteredWithThreadService=!1}return e.prototype.creationDone=function(){this._isRegisteredWithThreadService=!0},e.prototype.getId=function(){return"LanguageExtensionPointHandler"},e.prototype.getSerializableState=function(){return{knownModeIds:this.knownModeIds,mime2LanguageId:this.mime2LanguageId,name2LanguageId:this.name2LanguageId,name2Extensions:this.name2Extensions,id2Name:this.id2Name,compatModes:this.compatModes,lowerName2Id:this.lowerName2Id}},e.prototype.setData=function(e){this.knownModeIds=e.knownModeIds,this.mime2LanguageId=e.mime2LanguageId,this.name2LanguageId=e.name2LanguageId,this.name2Extensions=e.name2Extensions,this.id2Name=e.id2Name,this.compatModes=e.compatModes,this.lowerName2Id=e.lowerName2Id},e.prototype.registerCompatMode=function(e){this._onLanguage({id:e.id,extensions:e.extensions,filenames:e.filenames,firstLine:e.firstLine,aliases:e.aliases,mimetypes:e.mimetypes}),this.compatModes[e.id]=c.createAsyncDescriptor1(e.moduleId,e.ctorName)},e.prototype._handleLanguagesExtensionPointUsers=function(e){for(var t=[],o=0,i=e.length;i>o;o++){var s=e[o];if(Array.isArray(s.value))for(var a=0,u=s.value.length;u>a;a++)h(s.value[a],s.collector)&&t.push({id:s.value[a].id,extensions:s.value[a].extensions,filenames:s.value[a].filenames,firstLine:s.value[a].firstLine,aliases:s.value[a].aliases,mimetypes:s.value[a].mimetypes,configuration:s.value[a].configuration?r.join(s.description.extensionFolderPath,s.value[a].configuration):s.value[a].configuration});else s.collector.error(n.localize(16,null,p.name))}this._isRegisteredWithThreadService?this._onLanguagesEverywhere(t):this._onLanguagesImpl(t)},e.prototype._onLanguagesEverywhere=function(e){this._onLanguagesImpl(e)},e.prototype._onLanguagesImpl=function(e){for(var t=0;t<e.length;t++)this._onLanguage(e[t])},e.prototype._setMime2LanguageId=function(e,t){this.mime2LanguageId[e]&&this.mime2LanguageId[e]!==t&&console.warn("Overwriting mime <<"+e+">> to now point to modeId <<"+t+">>"),this.mime2LanguageId[e]=t},e.prototype.registerLanguage=function(e){this._onLanguage(e)},e.prototype._onLanguage=function(e){this.knownModeIds[e.id]=!0;var t=null;if("undefined"!=typeof e.mimetypes&&Array.isArray(e.mimetypes))for(var n=0;n<e.mimetypes.length;n++)t||(t=e.mimetypes[n]),this.mime2LanguageId[e.mimetypes[n]]=e.id;if(t||(t="text/x-"+e.id,this.mime2LanguageId[t]=e.id),"undefined"!=typeof e.extensions&&Array.isArray(e.extensions))for(var n=0;n<e.extensions.length;n++)a.registerTextMimeByFilename(e.extensions[n],t);if("undefined"!=typeof e.filenames&&Array.isArray(e.filenames))for(var n=0;n<e.filenames.length;n++)a.registerTextMimeByFilename(e.filenames[n],t);if("string"==typeof e.firstLine&&e.firstLine.length>0){var r=e.firstLine;"^"!==r.charAt(0)&&(r="^"+r);try{var i=new RegExp(r);o.regExpLeadsToEndlessLoop(i)||a.registerTextMimeByFirstLine(i,t)}catch(s){u.onUnexpectedError(s)}}var c=null;if("undefined"!=typeof e.aliases&&Array.isArray(e.aliases))for(var n=0;n<e.aliases.length;n++)e.aliases[n]&&0!==e.aliases[n].length&&(c||(c=e.aliases[n],this.name2LanguageId[e.aliases[n]]=e.id,this.name2Extensions[e.aliases[n]]=e.extensions),this.lowerName2Id[e.aliases[n].toLowerCase()]=e.id);this.id2Name[e.id]=c||"","string"==typeof e.configuration&&(this.id2ConfigurationFiles[e.id]=this.id2ConfigurationFiles[e.id]||[],this.id2ConfigurationFiles[e.id].push(e.configuration)),this._onDidAddMode.fire(e.id)},e.prototype.isRegisteredMode=function(e){return f.call(this.mime2LanguageId,e)?!0:f.call(this.knownModeIds,e)},e.prototype.getRegisteredModes=function(){return Object.keys(this.knownModeIds)},e.prototype.getRegisteredMimetypes=function(){return Object.keys(this.mime2LanguageId)},e.prototype.getRegisteredLanguageNames=function(){return Object.keys(this.name2LanguageId)},e.prototype.getLanguageName=function(e){return this.id2Name[e]||null},e.prototype.getModeIdForLanguageNameLowercase=function(e){return this.lowerName2Id[e]||null},e.prototype.getConfigurationFiles=function(e){return this.id2ConfigurationFiles[e]||[]},e.prototype.getMimeForMode=function(e){for(var t in this.mime2LanguageId)if(this.mime2LanguageId.hasOwnProperty(t)){var n=this.mime2LanguageId[t];if(n===e)return t}return null},e.prototype.extractModeIds=function(e){var t=this;return e?e.split(",").map(function(e){return e.trim()}).map(function(e){return t.mime2LanguageId[e]||e}).filter(function(e){return t.knownModeIds[e]}):[]},e.prototype.getModeIdsFromLanguageName=function(e){return e&&f.call(this.name2LanguageId,e)?[this.name2LanguageId[e]]:[]},e.prototype.getModeIdsFromFilenameOrFirstLine=function(e,t){if(!e&&!t)return[];var n=a.guessMimeTypes(e,t);return this.extractModeIds(n.join(","))},e.prototype.getCompatMode=function(e){return this.compatModes[e]||null},e.prototype.getExtensions=function(e){return this.name2Extensions[e]},e.$_onLanguagesEverywhere=i.EverywhereAttr(e,e.prototype._onLanguagesEverywhere),e}(),g=new m;i.registerThreadSynchronizableObject(g),p.setHandler(function(e){g._handleLanguagesExtensionPointUsers(e)}),t.LanguageExtensions=g}),define("vs/editor/common/modes/modesRegistry",["require","exports","vs/editor/common/modes/languageExtensionPoint","vs/base/common/strings","vs/platform/platform","vs/platform/instantiation/common/descriptors"],function(e,t,n,r,o,i){function s(e){h.registerMode(e)}function a(e,t,n){h.registerWorkerParticipant(e,i.createAsyncDescriptor0(t,n))}function u(e,t){p[e]=(p[e]||[]).concat(t)}function c(e,t,n){var r=f[e];r||(f[e]=r={}),r[t]=n}function l(e,t){var n=e.getWordAtPosition(t),o=n?n.word.substring(0,t.column-n.startColumn):"",i={currentWord:o,suggestions:[]},s=null;if(0===o.length){if(t.column>1){var a=e.getValueInRange({startLineNumber:t.lineNumber,startColumn:t.column-1,endLineNumber:t.lineNumber,endColumn:t.column});if(0!==a.trim().length)return i}}else{var u=o.toLowerCase();s=function(e){return r.startsWith(e.label.toLowerCase(),u)}}var c=e.getMode().getId(),l=[],d=f[c];if(d)for(var h in d)l=l.concat(d[h]);var m=p[c];return m&&(l=l.concat(m)),i.suggestions=s?l.filter(s):l,i}t.Extensions={EditorModes:"editor.modes"};var d=function(){function e(){this.workerParticipants=[]}return e.prototype.registerWorkerParticipant=function(e,t){this.workerParticipants.push({modeId:e,descriptor:t})},e.prototype._getAllWorkerParticipants=function(){return this.workerParticipants},e.prototype._setWorkerParticipants=function(e){this.workerParticipants=e},e.prototype.getWorkerParticipants=function(e){return this.workerParticipants.filter(function(t){return t.modeId===e}).map(function(e){return e.descriptor})},e.prototype.isRegisteredMode=function(e){return n.LanguageExtensions.isRegisteredMode(e)},e.prototype.getRegisteredModes=function(){return n.LanguageExtensions.getRegisteredModes()},e.prototype.getRegisteredMimetypes=function(){return n.LanguageExtensions.getRegisteredMimetypes()},e.prototype.getRegisteredLanguageNames=function(){return n.LanguageExtensions.getRegisteredLanguageNames()},e.prototype.getExtensions=function(e){return n.LanguageExtensions.getExtensions(e)},e.prototype.getMimeForMode=function(e){return n.LanguageExtensions.getMimeForMode(e)},e.prototype.getLanguageName=function(e){return n.LanguageExtensions.getLanguageName(e)},e.prototype.getModeIdForLanguageName=function(e){return n.LanguageExtensions.getModeIdForLanguageNameLowercase(e)},e.prototype.registerMode=function(e){n.LanguageExtensions.registerCompatMode(e)},e.prototype.getModeId=function(e){var t=n.LanguageExtensions.extractModeIds(e);return t.length>0?t[0]:null},e}(),h=new d;o.Registry.add(t.Extensions.EditorModes,h),t.registerMode=s,t.registerWorkerParticipant=a;var p=Object.create(null),f=Object.create(null);t.registerDefaultSnippets=u,t.registerSnippets=c,t.getSnippets=l}),define("vs/editor/common/modes/monarch/monarchDefinition",["require","exports","vs/base/common/winjs.base","vs/editor/common/modes/abstractMode"],function(e,t,n,r){function o(e){return{commentsConfiguration:{lineCommentTokens:[e.lineComment],blockCommentStartToken:e.blockCommentStart,blockCommentEndToken:e.blockCommentEnd}}}function i(e){return{brackets:e.standardBrackets,regexBrackets:e.enhancedBrackets,caseInsensitive:e.ignoreCase,embeddedElectricCharacters:e.outdentTriggers.split("")}}function s(e){return{wordDefinition:e.wordDefinition}}function a(e){return{autoClosingPairs:e.autoClosingPairs}}function u(e,t,n,r){var o=n.suggestSupport.snippets;return o&&0!==o.length?(r||(r=[]),r.push({currentWord:e.getWordUntilPosition(t).word,suggestions:o.slice(0)}),r):r}function c(e){return{brackets:e.standardBrackets}}function l(e,t,o){return o.suggestSupport.textualCompletions&&t instanceof r.AbstractMode?{triggerCharacters:o.suggestSupport.triggerCharacters,disableAutoTrigger:o.suggestSupport.disableAutoTrigger,excludeTokens:[],suggest:function(e,n){return t.suggest(e,n)},composeSuggest:function(t,r,i){return n.TPromise.as(u(e.getModel(t),r,o,i))}}:{triggerCharacters:o.suggestSupport.triggerCharacters,disableAutoTrigger:o.suggestSupport.disableAutoTrigger,excludeTokens:[],suggest:function(t,r){return n.TPromise.as(u(e.getModel(t),r,o,null))},composeSuggest:function(e,t,r){return n.TPromise.as(r)}}}t.createCommentsSupport=o,t.createBracketElectricCharacterContribution=i,t.createTokenTypeClassificationSupportContribution=s,t.createCharacterPairContribution=a,t.createOnEnterSupportOptions=c,t.createSuggestSupport=l});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/modes/monarch/monarchLexer",["require","exports","vs/editor/common/modes/abstractState","vs/editor/common/modes/lineStream","vs/editor/common/modes/modesRegistry","vs/editor/common/modes/supports","vs/editor/common/modes/monarch/monarchCommon","vs/editor/common/modes","vs/platform/platform"],function(e,t,n,r,o,i,s,a,u){function c(e,t){if(!t)return null;t=s.fixCase(e,t);for(var n=e.brackets,r=0;r<n.length;r++){var o=n[r];if(o.open===t)return{token:o.token,bracketType:a.Bracket.Open};if(o.close===t)return{token:o.token,bracketType:a.Bracket.Close}}return null}function l(e,t,n){return new i.TokenizationSupport(t,{getInitialState:function(){return new h(t,n)},enterNestedMode:function(e){return e instanceof h?e.embeddedEntered:!1},getNestedMode:function(t){var n=t.embeddedMode;if(!d.isRegisteredMode(n))return{mode:e.getMode("text/plain"),missingModePromise:null};var r=e.getMode(n);return r?{mode:r,missingModePromise:null}:{mode:e.getMode("text/plain"),missingModePromise:e.getOrCreateMode(n).then(function(){return null})}},getLeavingNestedModeData:function(e,t){for(var n=t.clone(),o=new r.LineStream(e);!o.eos()&&n.embeddedMode;)n.tokenize(o,!0);if(n.embeddedMode)return null;var i=o.pos();return{nestedModeBuffer:e.substring(0,i),bufferAfterNestedMode:e.substring(i),stateAfterNestedMode:n}}},n.usesEmbedded,!1)}var d=u.Registry.as(o.Extensions.EditorModes),h=function(e){function t(n,r,o,i){e.call(this,n),this.id=t.ID++,this.lexer=r,this.stack=o?o:[r.start],this.embeddedMode=i?i:null,this.embeddedEntered=!1,this.groupActions=null,this.groupMatches=null,this.groupMatched=null,this.groupRule=null}return __extends(t,e),t.prototype.makeClone=function(){return new t(this.getMode(),this.lexer,this.stack.slice(0),this.embeddedMode)},t.prototype.equals=function(n){if(!e.prototype.equals.call(this,n))return!1;if(!(n instanceof t))return!1;var r=n;if(this.stack.length!==r.stack.length||this.lexer.name!==r.lexer.name||this.embeddedMode!==r.embeddedMode)return!1;var o;for(o in this.stack)if(this.stack.hasOwnProperty(o)&&this.stack[o]!==r.stack[o])return!1;return!0},t.prototype.tokenize=function(e,t){var n=this.stack.length,r=0,o=this.stack[0];this.embeddedEntered=!1;var i=null,u=null,l=null,h=null,p=null;if(this.groupActions)r=this.groupActions.length,i=this.groupMatches,u=this.groupMatched.shift(),l=this.groupActions.shift(),p=this.groupRule,0===this.groupActions.length&&(this.groupActions=null,this.groupMatches=null,this.groupMatched=null,this.groupRule=null);else{if(e.eos())return{type:""};var f=e.advanceToEOS();e.goBack(f.length);var m=this.lexer.tokenizer[o];if(m||(m=s.findRules(this.lexer,o)),m){p=null;var g,v=e.pos();for(g in m)if(m.hasOwnProperty(g)&&(p=m[g],(0===v||!p.matchOnlyAtLineStart)&&(i=f.match(p.regex)))){u=i[0],l=p.action;break}}else s.throwError(this.lexer,"tokenizer state is not defined: "+o)}for(i||(i=[""],u=""),l||(e.eos()||(i=[e.peek()],u=i[0]),l=this.lexer.defaultToken),e.advance(u.length);l.test;){var _=l.test(u,i,o,e.eos());l=_}var y=null;if("string"==typeof l||Array.isArray(l))y=l;else if(l.group)y=l.group;else if(null!==l.token&&void 0!==l.token){if(y=l.token,l.tokenSubst&&(y=s.substituteMatches(this.lexer,y,u,i,o)),l.nextEmbedded)if("@pop"===l.nextEmbedded)this.embeddedMode||s.throwError(this.lexer,"cannot pop embedded mode if not inside one"),this.embeddedMode=null;else if(this.embeddedMode)s.throwError(this.lexer,"cannot enter embedded mode from within an embedded mode");else{this.embeddedMode=s.substituteMatches(this.lexer,l.nextEmbedded,u,i,o);var k=d.getModeIdForLanguageName(this.embeddedMode);this.embeddedMode&&k&&(this.embeddedMode=k),this.embeddedEntered=!0}if(l.goBack&&e.goBack(l.goBack),l.switchTo&&"string"==typeof l.switchTo){var b=s.substituteMatches(this.lexer,l.switchTo,u,i,o);"@"===b[0]&&(b=b.substr(1)),s.findRules(this.lexer,b)?this.stack[0]=b:s.throwError(this.lexer,"trying to switch to a state '"+b+"' that is undefined in rule: "+p.name),h=null}else if(l.transform&&"function"==typeof l.transform)this.stack=l.transform(this.stack),h=null;else if(l.next)if("@push"===l.next)this.stack.length>=this.lexer.maxStack?s.throwError(this.lexer,"maximum tokenizer stack size reached: ["+this.stack[0]+","+this.stack[1]+",...,"+this.stack[this.stack.length-2]+","+this.stack[this.stack.length-1]+"]"):this.stack.unshift(o);else if("@pop"===l.next)this.stack.length<=1?s.throwError(this.lexer,"trying to pop an empty stack in rule: "+p.name):this.stack.shift();else if("@popall"===l.next)this.stack.length>1&&(this.stack=[this.stack[this.stack.length-1]]);else{
var b=s.substituteMatches(this.lexer,l.next,u,i,o);"@"===b[0]&&(b=b.substr(1)),s.findRules(this.lexer,b)?this.stack.unshift(b):s.throwError(this.lexer,"trying to set a next state '"+b+"' that is undefined in rule: "+p.name)}l.log&&"string"==typeof l.log&&s.log(this.lexer,this.lexer.displayName+": "+s.substituteMatches(this.lexer,l.log,u,i,o))}if(null===y&&(s.throwError(this.lexer,"lexer rule has no well-defined action in rule: "+p.name),y=this.lexer.defaultToken),Array.isArray(y)){this.groupActions&&this.groupActions.length>0&&s.throwError(this.lexer,"groups cannot be nested: "+p.name),i.length!==y.length+1&&s.throwError(this.lexer,"matched number of groups does not match the number of actions in rule: "+p.name);for(var E=0,T=1;T<i.length;T++)E+=i[T].length;return E!==u.length&&s.throwError(this.lexer,"with groups, all characters should be matched in consecutive groups in rule: "+p.name),this.groupMatches=i,this.groupMatched=i.slice(1),this.groupActions=y.slice(0),this.groupRule=p,e.goBack(u.length),this.tokenize(e)}if("@rematch"===y&&(e.goBack(u.length),u="",i=null,y=""),0===u.length)if(n!==this.stack.length||o!==this.stack[0]||(this.groupActions?this.groupActions.length:0)!==r){if(!t)return this.tokenize(e)}else s.throwError(this.lexer,"no progress in tokenizer in rule: "+p.name),e.advanceToEOS();if(0===y.indexOf("@brackets")){var S=y.substr("@brackets".length),C=c(this.lexer,u);return C||(s.throwError(this.lexer,"@brackets token returned but no bracket defined as: "+u),C={token:"",bracketType:a.Bracket.None}),{type:s.sanitize(C.token+S),bracket:C.bracketType}}var M=""===y?"":y+this.lexer.tokenPostfix;return{type:s.sanitize(M),bracket:l.bracket}},t.ID=0,t}(n.AbstractState);t.MonarchLexer=h,t.createTokenizationSupport=l});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/modes/monarch/monarch",["require","exports","vs/editor/common/modes/abstractMode","vs/editor/common/modes/supports","vs/editor/common/modes/monarch/monarchDefinition","vs/editor/common/modes/monarch/monarchLexer","vs/editor/common/modes/supports/onEnter"],function(e,t,n,r,o,i,s){var a=function(e){function t(t,n,a,u,c,l){e.call(this,t,a,u),this.tokenizationSupport=i.createTokenizationSupport(c,this,n),this.electricCharacterSupport=new r.BracketElectricCharacterSupport(this,o.createBracketElectricCharacterContribution(n)),this.commentsSupport=new r.CommentsSupport(o.createCommentsSupport(n)),this.tokenTypeClassificationSupport=new r.TokenTypeClassificationSupport(o.createTokenTypeClassificationSupportContribution(n)),this.characterPairSupport=new r.CharacterPairSupport(this,o.createCharacterPairContribution(n)),this.suggestSupport=new r.ComposableSuggestSupport(this,o.createSuggestSupport(l,this,n)),this.onEnterSupport=new s.OnEnterSupport(this.getId(),o.createOnEnterSupportOptions(n))}return __extends(t,e),t}(n.AbstractMode);t.MonarchMode=a});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return void(r&&r(t,n))},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/editor/common/services/modeServiceImpl",["require","exports","vs/base/common/winjs.base","vs/editor/common/services/modeService","vs/editor/common/modes/supports","vs/editor/common/modes/abstractMode","vs/editor/common/modes/languageExtensionPoint","vs/base/common/errors","vs/platform/thread/common/thread","vs/base/common/objects","vs/editor/common/modes/monarch/monarchDefinition","vs/editor/common/modes/monarch/monarchLexer","vs/editor/common/modes/monarch/monarchCompile","vs/platform/platform","vs/editor/common/modes/modesRegistry","vs/editor/common/modes/supports/onEnter","vs/base/common/lifecycle"],function(e,t,n,r,o,i,s,a,u,c,l,d,h,p,f,m,g){var v=function(){function e(e,t){this.serviceId=r.IModeService,this._threadService=e,this._pluginService=t,this._activationPromises={},this._instantiatedModes={},this._frankensteinModes={},this._config={}}return e.prototype.getConfigurationForMode=function(e){return this._config[e]||{}},e.prototype.configureMode=function(e,t){var n=this.getModeId(e);n&&this.configureModeById(n,t)},e.prototype.configureModeById=function(e,t){var n=this._config[e]||{},r=c.mixin(c.clone(n),t);if(!c.equals(n,r)){this._config[e]=r;var o=this.getMode(e);o&&o.configSupport&&o.configSupport.configure(this.getConfigurationForMode(e))}},e.prototype.configureAllModes=function(e){var t=this;if(e){var n=p.Registry.as(f.Extensions.EditorModes),r=n.getRegisteredModes();r.forEach(function(n){var r=e[n];t.configureModeById(n,r)})}},e.prototype.lookup=function(e){for(var t=[],n=s.LanguageExtensions.extractModeIds(e),r=0;r<n.length;r++){var o=n[r];t.push({modeId:o,isInstantiated:this._instantiatedModes.hasOwnProperty(o)})}return t},e.prototype.getMode=function(e){for(var t=s.LanguageExtensions.extractModeIds(e),n=!1,r=0;r<t.length;r++){if(this._instantiatedModes.hasOwnProperty(t[r]))return this._instantiatedModes[t[r]];n=n||"plaintext"===t[r]}if(n){var o=null;return this.getOrCreateMode(e).then(function(e){o=e}).done(null,a.onUnexpectedError),o}},e.prototype.getModeId=function(e){var t=s.LanguageExtensions.extractModeIds(e);return t.length>0?t[0]:null},e.prototype.getModeIdByLanguageName=function(e){var t=s.LanguageExtensions.getModeIdsFromLanguageName(e);return t.length>0?t[0]:null},e.prototype.getModeIdByFilenameOrFirstLine=function(e,t){var n=s.LanguageExtensions.getModeIdsFromFilenameOrFirstLine(e,t);return n.length>0?n[0]:null},e.prototype.getOrCreateMode=function(e){var t=this;return this._pluginService.onReady().then(function(){var n=t.getModeId(e);return t._getOrCreateMode(n||"plaintext")})},e.prototype.getOrCreateModeByLanguageName=function(e){var t=this;return this._pluginService.onReady().then(function(){var n=t.getModeIdByLanguageName(e);return t._getOrCreateMode(n||"plaintext")})},e.prototype.getOrCreateModeByFilenameOrFirstLine=function(e,t){var n=this;return this._pluginService.onReady().then(function(){var r=n.getModeIdByFilenameOrFirstLine(e,t);return n._getOrCreateMode(r||"plaintext")})},e.prototype._getOrCreateMode=function(e){var t=this;if(this._instantiatedModes.hasOwnProperty(e))return n.TPromise.as(this._instantiatedModes[e]);if(this._activationPromises.hasOwnProperty(e))return this._activationPromises[e];var r,o,i=new n.TPromise(function(e,t,n){r=e,o=t});return this._activationPromises[e]=i,this._createMode(e).then(function(n){return t._instantiatedModes[e]=n,delete t._activationPromises[e],t._instantiatedModes[e]}).then(r,o),i},e.prototype._createMode=function(e){var t=this,r="onLanguage:"+e,o=s.LanguageExtensions.getCompatMode(e);if(o)return this._pluginService.activateByEvent(r).then(function(n){var r=t._createModeDescriptor(e);return t._threadService.createInstance(o,r)}).then(function(n){return n.configSupport&&n.configSupport.configure(t.getConfigurationForMode(e)),n});var i=this._getOrCreateFrankensteinMode(e);return this._pluginService.activateByEvent(r).done(null,a.onUnexpectedError),n.TPromise.as(i)},e.prototype._getOrCreateFrankensteinMode=function(e){if(!this._frankensteinModes.hasOwnProperty(e)){var t=this._createModeDescriptor(e);this._frankensteinModes[e]=this._threadService.createInstance(i.FrankensteinMode,t)}return this._frankensteinModes[e]},e.prototype._createModeDescriptor=function(e){var t=p.Registry.as(f.Extensions.EditorModes),n=t.getWorkerParticipants(e);return{id:e,workerParticipants:n}},e.prototype.registerModeSupport=function(e,t,n){var r=this._getOrCreateMode(e).then(function(r){return r.registerSupport?r.registerSupport(t,n):(console.warn("Cannot register support "+t+" on mode "+e+" because it is not a Frankenstein mode"),g.empty)});return{dispose:function(){r.done(function(e){return e.dispose()},null)}}},e.prototype.doRegisterMonarchDefinition=function(e,t){var n=this;return g.combinedDispose(this.registerTokenizationSupport(e,function(e){return d.createTokenizationSupport(n,e,t)}),this.registerDeclarativeCommentsSupport(e,l.createCommentsSupport(t)),this.registerDeclarativeElectricCharacterSupport(e,l.createBracketElectricCharacterContribution(t)),this.registerDeclarativeTokenTypeClassificationSupport(e,l.createTokenTypeClassificationSupportContribution(t)),this.registerDeclarativeCharacterPairSupport(e,l.createCharacterPairContribution(t)),this.registerDeclarativeOnEnterSupport(e,l.createOnEnterSupportOptions(t)))},e.prototype.registerMonarchDefinition=function(e,t){var n=h.compile(c.clone(t));return this.doRegisterMonarchDefinition(e,n)},e.prototype.registerDeclarativeCharacterPairSupport=function(e,t){return this.registerModeSupport(e,"characterPairSupport",function(e){return new o.CharacterPairSupport(e,t)})},e.prototype.registerCodeLensSupport=function(e,t){return this.registerModeSupport(e,"codeLensSupport",function(e){return t})},e.prototype.registerDeclarativeCommentsSupport=function(e,t){return this.registerModeSupport(e,"commentsSupport",function(e){return new o.CommentsSupport(t)})},e.prototype.registerDeclarativeDeclarationSupport=function(e,t){return this.registerModeSupport(e,"declarationSupport",function(e){return new o.DeclarationSupport(e,t)})},e.prototype.registerDeclarativeElectricCharacterSupport=function(e,t){return this.registerModeSupport(e,"electricCharacterSupport",function(e){return new o.BracketElectricCharacterSupport(e,t)})},e.prototype.registerExtraInfoSupport=function(e,t){return this.registerModeSupport(e,"extraInfoSupport",function(e){return t})},e.prototype.registerFormattingSupport=function(e,t){return this.registerModeSupport(e,"formattingSupport",function(e){return t})},e.prototype.registerInplaceReplaceSupport=function(e,t){return this.registerModeSupport(e,"inplaceReplaceSupport",function(e){return t})},e.prototype.registerOccurrencesSupport=function(e,t){return this.registerModeSupport(e,"occurrencesSupport",function(e){return t})},e.prototype.registerOutlineSupport=function(e,t){return this.registerModeSupport(e,"outlineSupport",function(e){return t})},e.prototype.registerDeclarativeParameterHintsSupport=function(e,t){return this.registerModeSupport(e,"parameterHintsSupport",function(e){return new o.ParameterHintsSupport(e,t)})},e.prototype.registerQuickFixSupport=function(e,t){return this.registerModeSupport(e,"quickFixSupport",function(e){return t})},e.prototype.registerDeclarativeReferenceSupport=function(e,t){return this.registerModeSupport(e,"referenceSupport",function(e){return new o.ReferenceSupport(e,t)})},e.prototype.registerRenameSupport=function(e,t){return this.registerModeSupport(e,"renameSupport",function(e){return t})},e.prototype.registerDeclarativeSuggestSupport=function(e,t){return this.registerModeSupport(e,"suggestSupport",function(e){return new o.SuggestSupport(e,t)})},e.prototype.registerTokenizationSupport=function(e,t){return this.registerModeSupport(e,"tokenizationSupport",t)},e.prototype.registerDeclarativeTokenTypeClassificationSupport=function(e,t){return this.registerModeSupport(e,"tokenTypeClassificationSupport",function(e){return new o.TokenTypeClassificationSupport(t)})},e.prototype.registerDeclarativeOnEnterSupport=function(e,t){return this.registerModeSupport(e,"onEnterSupport",function(n){return new m.OnEnterSupport(e,t)})},e}();t.ModeServiceImpl=v;var _=function(e){function t(t,n,r){e.call(this,t,n),this._modelService=r,this._hasInitialized=!1}return __extends(t,e),t.prototype._getModeServiceWorkerHelper=function(){var e=this._threadService.getRemotable(y);if(!this._hasInitialized){this._hasInitialized=!0;var t=p.Registry.as(f.Extensions.EditorModes);e.initialize(t._getAllWorkerParticipants())}return e},t.prototype.configureModeById=function(t,n){this._getModeServiceWorkerHelper().configureModeById(t,n),e.prototype.configureModeById.call(this,t,n)},t.prototype._createMode=function(t){return this._getModeServiceWorkerHelper().instantiateMode(t),e.prototype._createMode.call(this,t)},t.prototype.registerModeSupport=function(t,n,r){return this._getModeServiceWorkerHelper().instantiateMode(t),e.prototype.registerModeSupport.call(this,t,n,r)},t.prototype.registerMonarchDefinition=function(t,n){var r=this;this._getModeServiceWorkerHelper().registerMonarchDefinition(t,n);var i=h.compile(c.clone(n));return g.combinedDispose(e.prototype.doRegisterMonarchDefinition.call(this,t,i),this.registerModeSupport(t,"suggestSupport",function(e){return new o.ComposableSuggestSupport(e,l.createSuggestSupport(r._modelService,e,i))}))},t}(v);t.MainThreadModeServiceImpl=_;var y=function(){function e(e){this._modeService=e}return e.prototype.initialize=function(e){var t=p.Registry.as(f.Extensions.EditorModes);t._setWorkerParticipants(e)},e.prototype.instantiateMode=function(e){this._modeService.getOrCreateMode(e).done(null,a.onUnexpectedError)},e.prototype.configureModeById=function(e,t){this._modeService.configureMode(e,t)},e.prototype.registerMonarchDefinition=function(e,t){this._modeService.registerMonarchDefinition(e,t)},e=__decorate([u.Remotable.WorkerContext("ModeServiceWorkerHelper",u.ThreadAffinity.All),__param(0,r.IModeService)],e)}();t.ModeServiceWorkerHelper=y});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return void(r&&r(t,n))},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/languages/plaintext/common/plaintext",["require","exports","vs/editor/common/modes/supports","vs/editor/common/modes/abstractMode","vs/editor/common/modes/abstractState","vs/platform/instantiation/common/instantiation","vs/platform/thread/common/thread"],function(e,t,n,r,o,i,s){var a=function(e){function t(t){e.call(this,t)}return __extends(t,e),t.prototype.makeClone=function(){return this},t.prototype.equals=function(n){return n instanceof t?e.prototype.equals.call(this,n):!1},t.prototype.tokenize=function(e){return e.advanceToEOS(),{type:""}},t}(o.AbstractState),u=function(e){function t(t,r,o){var i=this;e.call(this,t,r,o),this.tokenizationSupport=new n.TokenizationSupport(this,{getInitialState:function(){return new a(i)}},!1,!1)}return __extends(t,e),t=__decorate([__param(1,i.IInstantiationService),__param(2,s.IThreadService)],t)}(r.AbstractMode);t.Mode=u}),define("vs/platform/markers/common/markerService",["require","exports","vs/base/common/network","vs/base/common/arrays","vs/base/common/strings","vs/base/common/collections","vs/base/common/event","vs/base/common/severity","vs/platform/thread/common/threadService","./markers"],function(e,t,n,r,o,i,s,a,u,c){var l;!function(e){function t(e){var t=/^(.*)→(.*)$/.exec(e);return{owner:t[1],resource:n.URL.fromValue(t[2])}}function r(e){return e.owner+"→"+e.resource}function i(e,t){return new RegExp(o.format(a,e?o.escapeRegExpCharacters(e):".*",t?o.escapeRegExpCharacters(t.toString()):".*"))}function s(e,t){return e+"→"+t}e.fromValue=t,e.valueOf=r;var a="^({0})→({1})$";e.selector=i,e.raw=s}(l||(l={}));var d=function(){function e(e){this.serviceId=c.IMarkerService,this._data=Object.create(null),this._stats=this._emptyStats(),this._onMarkerChanged=new s.Emitter,e.registerInstance(this)}return e.prototype.getId=function(){return"__markerService"},e.prototype.getSerializableState=function(){return this._data},e.prototype.setData=function(e){this._data=e},e.prototype.getStatistics=function(){return this._stats},Object.defineProperty(e.prototype,"onMarkerChanged",{get:function(){return this._onMarkerChanged?this._onMarkerChanged.event:null},enumerable:!0,configurable:!0}),e.prototype.changeOne=function(e,t,n){this._doChangeOne(e,t,n)&&this._onMarkerChanged.fire([t])},e.prototype.remove=function(e,t){if(!r.isFalsyOrEmpty(t)){for(var n,o=0;o<t.length;o++){var i=t[o];this._doChangeOne(e,i,void 0)&&(n||(n=[]),n.push(i))}n&&this._onMarkerChanged.fire(n)}},e.prototype._doChangeOne=function(e,t,n){var o=l.raw(e,t),i=this._data[o],s=!r.isFalsyOrEmpty(i),a=!r.isFalsyOrEmpty(n),u=this._computeStats(i),c=this._computeStats(n);if(s||a)return a?this._data[o]=n:s&&delete this._data[o],this._isStatRelevant(t)&&(this._updateStatsMinus(u),this._updateStatsPlus(c)),!0},e.prototype.changeAll=function(e,t){var n=this,o=Object.create(null),s=this._emptyStats();if(this._forEach(e,void 0,void 0,-1,function(e,t){var r=l.fromValue(e.key).resource;n._isStatRelevant(r)&&n._updateStatsPlus(s,n._computeStats(e.value)),o[r.toString()]=r,t()}),this._updateStatsMinus(s),!r.isFalsyOrEmpty(t)){var a=this._emptyStats();t.forEach(function(t){o[t.resource.toString()]=t.resource,i.lookupOrInsert(n._data,l.raw(e,t.resource),[]).push(t.marker),n._isStatRelevant(t.resource)&&n._updateStatsMarker(a,t.marker)}),this._updateStatsPlus(a)}this._onMarkerChanged.fire(i.values(o))},e.prototype.read=function(e){var t=this;void 0===e&&(e=Object.create(null));var n=[];return this._forEach(e.owner,e.resource,e.selector,e.take,function(e){return t._fromEntry(e,n)}),n},e.prototype._isStatRelevant=function(e){return e.scheme!==n.schemas.inMemory},e.prototype._forEach=function(e,t,n,r,o){var s=n||l.selector(e,t),a=0;i.forEach(this._data,function(e,t){return s.test(e.key)&&(o(e,t),r>0&&a++>=r)?!1:void 0})},e.prototype._fromEntry=function(t,n){var r=l.fromValue(t.key);t.value.forEach(function(t){e._sanitize(t),n.push({owner:r.owner,resource:r.resource,code:t.code,message:t.message,severity:t.severity,startLineNumber:t.startLineNumber,startColumn:t.startColumn,endLineNumber:t.endLineNumber,endColumn:t.endColumn})})},e.prototype._computeStats=function(e){var t=0,n=0,r=0,o=0;if(e)for(var i=0;i<e.length;i++){var s=e[i];if(s.severity)switch(s.severity){case a["default"].Error:t++;break;case a["default"].Warning:n++;break;case a["default"].Info:r++;break;default:o++}else o++}return{errors:t,warnings:n,infos:r,unknwons:o}},e.prototype._emptyStats=function(){return{errors:0,warnings:0,infos:0,unknwons:0}},e.prototype._updateStatsPlus=function(e,t){t||(t=e,e=this._stats),e.errors+=t.errors,e.warnings+=t.warnings,e.infos+=t.infos,e.unknwons+=t.unknwons},e.prototype._updateStatsMinus=function(e,t){t||(t=e,e=this._stats),e.errors-=t.errors,e.warnings-=t.warnings,e.infos-=t.infos,e.unknwons-=t.unknwons},e.prototype._updateStatsMarker=function(e,t){switch(t.severity){case a["default"].Error:e.errors++;break;case a["default"].Warning:e.warnings++;break;case a["default"].Info:e.infos++;break;default:e.unknwons++}},e._sanitize=function(e){e.code=e.code||null,e.startLineNumber=e.startLineNumber>0?e.startLineNumber:1,e.startColumn=e.startColumn>0?e.startColumn:1,e.endLineNumber=e.endLineNumber>=e.startLineNumber?e.endLineNumber:e.startLineNumber,e.endColumn=e.endColumn>0?e.endColumn:e.startColumn},e.$changeOne=u.MainThreadAttr(e,e.prototype.changeOne),e.$changeAll=u.MainThreadAttr(e,e.prototype.changeAll),e}();t.MarkerService=d}),define("vs/platform/thread/common/abstractThreadService",["require","exports","vs/base/common/winjs.base","vs/base/common/remote","vs/base/common/types","vs/platform/thread/common/thread","vs/platform/thread/common/threadService","vs/platform/instantiation/common/descriptors"],function(e,t,n,r,o,i,s,a){var u=function(){function e(e,t){this._proxyDefinition=e,this._disposeDelegate=t}return e.prototype.dispose=function(){return this._disposeDelegate()},e.prototype.getProxyDefinition=function(){return this._proxyDefinition},e}(),c=function(){function e(e){this.isInMainThread=e,this._boundObjects={},this._pendingObjects=[],this._localObjMap=Object.create(null),this._proxyObjMap=Object.create(null)}return e.generateDynamicProxyId=function(){return String(++this._LAST_DYNAMIC_PROXY_ID)},e.prototype.setInstantiationService=function(e){this._instantiationService=e},e.prototype.createInstance=function(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return this._doCreateInstance(e)},e.prototype._doCreateInstance=function(e){var t=this,r=this._instantiationService.createInstance.apply(this._instantiationService,e);if(n.Promise.is(r)){var o=r.then(function(e){if(e.asyncCtor){var t=e.asyncCtor();if(n.Promise.is(t))return t.then(function(){return e})}return e});return this._pendingObjects.push(o),o.then(function(e){for(var n=t._finishInstance(e),r=0;r<t._pendingObjects.length;r++)if(t._pendingObjects[r]===o){t._pendingObjects.splice(r,1);break}return n})}return this._finishInstance(r)},e.prototype._finishInstance=function(e){return e[s.THREAD_SERVICE_PROPERTY_NAME]=this,this._boundObjects[e.getId()]=e,e.creationDone&&e.creationDone(),e},e.prototype.registerInstance=function(e){this._finishInstance(e)},e.prototype.handle=function(e,t,n){if(!this._localObjMap[e])throw new Error("Unknown actor "+e);var r=this._localObjMap[e];return r[t].apply(r,n)},e.prototype._getOrCreateProxyInstance=function(e,t,n){if(this._proxyObjMap[t])return this._proxyObjMap[t];var o=r.createProxyFromCtor(e,t,n.ctor);return this._proxyObjMap[t]=o,o},e.prototype._registerLocalInstance=function(e,t){this._localObjMap[e]=t},e.prototype._getOrCreateLocalInstance=function(e,t){if(this._localObjMap[e])return this._localObjMap[e];var n=this._instantiationService.createInstance(t);return this._registerLocalInstance(e,n),n},e.prototype.createDynamicProxyFromMethods=function(t){var n=this,r=e.generateDynamicProxyId(),o=this._proxifyMethods(r,t);return new u(o,function(){delete n._localObjMap[r]})},e.prototype.createDynamicProxyFromMembers=function(t,n){var r=this,o=e.generateDynamicProxyId(),i=this._proxifyMembers(o,t,n);return new u(i,function(){delete r._localObjMap[o]})},e.prototype._proxifyMethods=function(e,t){if(!o.isObject(t))return null;this._localObjMap[e]=t;var n={$__CREATE__PROXY__REQUEST:e};for(var r in t)"function"==typeof t[r]&&(n[r]=t[r].bind(t));return n},e.prototype._proxifyMembers=function(e,t,n){if(!o.isObject(t))return null;this._localObjMap[e]=t;var r={$__CREATE__PROXY__REQUEST:e};for(var i in t)-1!==n.indexOf(i)&&("function"==typeof t[i]?r[i]=t[i].bind(t):r[i]=t[i]);return r},e.prototype.isProxyObject=function(e){return e&&!!e.$__IS_REMOTE_OBJ},e.prototype.getRemotable=function(e){var t=i.Remotable.getId(e);if(!t)throw new Error("Unknown Remotable: <<"+t+">>");var n=a.createSyncDescriptor(e);if(i.Remotable.Registry.MainContext[t])return this._registerAndInstantiateMainProcessActor(t,n);if(i.Remotable.Registry.PluginHostContext[t])return this._registerAndInstantiatePluginHostActor(t,n);if(i.Remotable.Registry.WorkerContext[t])return this._registerAndInstantiateWorkerActor(t,n,i.Remotable.Registry.WorkerContext[t].affinity);throw new Error("Unknown Remotable: <<"+t+">>")},e.prototype.registerRemotableInstance=function(e,t){var n=i.Remotable.getId(e);if(!n)throw new Error("Unknown Remotable: <<"+n+">>");if(i.Remotable.Registry.MainContext[n])return this._registerMainProcessActor(n,t);if(i.Remotable.Registry.PluginHostContext[n])return this._registerPluginHostActor(n,t);if(i.Remotable.Registry.WorkerContext[n])return this._registerWorkerActor(n,t);throw new Error("Unknown Remotable: <<"+n+">>")},e._LAST_DYNAMIC_PROXY_ID=0,e}();t.AbstractThreadService=c});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/platform/thread/common/workerThreadService",["require","exports","vs/base/common/winjs.base","./threadService","vs/platform/thread/common/abstractThreadService","vs/platform/thread/common/thread"],function(e,t,n,r,o,i){var s=function(e){function t(t,n,o){var s=this;e.call(this,!1),this.serviceId=i.IThreadService,this._mainThreadData=t,this._remoteCom=n,this._remoteCom.registerBigHandler(this),this._publisher=o,r.readThreadSynchronizableObjects().forEach(function(e){return s.registerInstance(e)})}return __extends(t,e),t.prototype._handleRequest=function(e,t,r){var o=this;if(!this._boundObjects.hasOwnProperty(e))return n.Promise.join(this._pendingObjects.slice(0)).then(function(){if(!o._boundObjects.hasOwnProperty(e))return n.Promise.wrapError(new Error("Bound object `"+e+"` was not found."));var i=o._boundObjects[e];return n.Promise.as(i[t].apply(i,r))});var i=this._boundObjects[e];return n.Promise.as(i[t].apply(i,r))},t.prototype.dispatch=function(e){try{var t=e.payload,r=this._handleRequest(t[0],t[1],t[2]);return n.Promise.is(r)?r:n.Promise.as(r)}catch(o){return n.Promise.wrapError(o)}},t.prototype._finishInstance=function(t){var n=t.getId();if(this._mainThreadData.hasOwnProperty(n)){var r=this._mainThreadData[n];delete this._mainThreadData[n],t.setData||console.log("BROKEN INSTANCE!!! "+n),t.setData(r)}return e.prototype._finishInstance.call(this,t)},t.prototype.MainThread=function(e,t,n,r){return this._publisher("threadService",{identifier:e.getId(),memberName:t,args:r})},t.prototype.OneWorker=function(e,t,n,r,o){return n.apply(e,r)},t.prototype.AllWorkers=function(e,t,n,r){return n.apply(e,r)},t.prototype.Everywhere=function(e,t,n,r){return n.apply(e,r)},t.prototype.ensureWorkers=function(){},t.prototype.addStatusListener=function(e){},t.prototype.removeStatusListener=function(e){},t.prototype._registerAndInstantiateMainProcessActor=function(e,t){return this._getOrCreateProxyInstance(this._remoteCom,e,t)},t.prototype._registerMainProcessActor=function(e,t){throw new Error("Not supported in this runtime context!")},t.prototype._registerAndInstantiatePluginHostActor=function(e,t){throw new Error("Not supported in this runtime context: Cannot communicate from Worker directly to Plugin Host!")},t.prototype._registerPluginHostActor=function(e,t){throw new Error("Not supported in this runtime context!")},t.prototype._registerAndInstantiateWorkerActor=function(e,t,n){return this._getOrCreateLocalInstance(e,t)},t.prototype._registerWorkerActor=function(e,t){this._registerLocalInstance(e,t)},t}(o.AbstractThreadService);t.WorkerThreadService=s}),define("vs/platform/workspace/common/workspace",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.IWorkspaceContextService=n.createDecorator("contextService")}),require.config({ignoreDuplicateModules:["vs/languages/typescript/common/features/tokenization","vs/languages/typescript/common/features/quickFixMainActions","vs/nls!vs/languages/typescript/common/features/quickFixMainActions","vs/languages/typescript/common/typescript","vs/languages/typescript/common/typescriptMode","vs/nls!vs/languages/typescript/common/typescriptMode","vs/languages/javascript/common/javascript.extensions","vs/languages/html/common/htmlTokenTypes"]}),define("vs/editor/common/languages.common",["vs/base/common/json","vs/base/common/uri","vs/base/common/network","vs/base/common/arrays","vs/base/common/collections","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/glob","vs/base/common/events","vs/platform/configuration/common/configurationRegistry","vs/platform/files/common/files","vs/platform/search/common/search","vs/platform/request/common/request","vs/platform/workspace/common/workspace","vs/platform/telemetry/common/telemetry","vs/editor/common/editorCommon","vs/editor/common/modes/modesRegistry","vs/editor/common/modes/monarch/monarch","vs/editor/common/modes/monarch/monarchCompile","vs/editor/common/modes/textToHtmlTokenizer","vs/editor/common/services/modeService","vs/editor/common/services/modelService","vs/languages/plaintext/common/plaintext"],function(){}),define("vs/platform/workspace/common/baseWorkspaceContextService",["require","exports","vs/base/common/uri","vs/base/common/paths","./workspace"],function(e,t,n,r,o){var i=function(){function e(e,t,n){void 0===n&&(n={}),this.serviceId=o.IWorkspaceContextService,this.workspace=e,this.configuration=t,this.options=n}return e.prototype.getWorkspace=function(){return this.workspace},e.prototype.getConfiguration=function(){return this.configuration},e.prototype.getOptions=function(){return this.options},e.prototype.isInsideWorkspace=function(e){return e&&this.workspace?r.isEqualOrParent(e.fsPath,this.workspace.resource.fsPath):!1},e.prototype.toWorkspaceRelativePath=function(e){return this.isInsideWorkspace(e)?r.normalize(r.relative(this.workspace.resource.fsPath,e.fsPath)):null},e.prototype.toResource=function(e){return"string"==typeof e&&this.workspace?n["default"].file(r.join(this.workspace.resource.fsPath,e)):null},e}();t.BaseWorkspaceContextService=i});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/worker/editorWorkerServer",["require","exports","vs/platform/markers/common/markerService","vs/platform/thread/common/workerThreadService","vs/platform/instantiation/common/instantiationService","vs/platform/event/common/eventService","vs/platform/telemetry/common/workerTelemetryService","vs/base/common/winjs.base","vs/editor/common/services/resourceServiceImpl","vs/platform/workspace/common/baseWorkspaceContextService","vs/editor/common/services/modelServiceImpl","vs/base/common/async","vs/platform/instantiation/common/descriptors","vs/platform/request/common/baseRequestService","vs/platform/plugins/common/abstractPluginService","vs/editor/common/services/modeServiceImpl","vs/base/common/severity","vs/editor/common/modes/abstractModeWorker","vs/editor/common/languages.common"],function(e,t,n,r,o,i,s,a,u,c,l,d,h,p,f,m,g){var v=function(e){function t(){e.call(this,!0)}return __extends(t,e),t.prototype._showMessage=function(e,t){switch(e){case g["default"].Error:console.error(t);break;case g["default"].Warning:console.warn(t);break;case g["default"].Info:console.info(t);break;default:console.log(t)}},t}(f.AbstractPluginService),_=function(){function e(){}return e.prototype.initialize=function(e,t,f,g,_){var y=this,k=new v,b=new c.BaseWorkspaceContextService(_.contextService.workspace,_.contextService.configuration,_.contextService.options);this.threadService=new r.WorkerThreadService(_.threadService,e.getRemoteCom(),function(t,n){return e.request(t,n)}),this.threadService.setInstantiationService(o.create({threadService:this.threadService}));var E=new s.WorkerTelemetryService(this.threadService),T=new u.ResourceService,S=new n.MarkerService(this.threadService),C=new m.ModeServiceImpl(this.threadService,k),M=new d.PromiseSource,w=new p.BaseRequestService(b,E),I={threadService:this.threadService,pluginService:k,modeService:C,contextService:b,eventService:new i.EventService,resourceService:T,markerService:S,telemetryService:E,requestService:w},x=a.TPromise.as(null),L=b.getConfiguration().additionalWorkerServices;L&&L.forEach(function(e){x=x.then(function(t){var n=h.AsyncDescriptor.create(e.moduleName,e.ctorName);return o.create(I).createInstance(n).then(function(t){I[e.serviceId]=t})})}),x.then(function(e){var n=o.create(I);y.threadService.setInstantiationService(n),y.threadService.getRemotable(m.ModeServiceWorkerHelper),y.threadService.getRemotable(l.ModelServiceWorkerHelper),M.complete(),t(void 0)})},e.prototype.request=function(e,t,n,r,o){this.threadService.dispatch(o).then(t,n,r)},e}();t.EditorWorkerServer=_,
t.value=new _});