/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/html/common/htmlTokenTypes",["require","exports","vs/base/common/strings"],function(t,e,n){function r(t){return n.startsWith(t,o)}function i(t){return o+t}e.DELIM_END="punctuation.tag.end.html",e.DELIM_START="punctuation.tag.begin.html",e.DELIM_ASSIGN="tag.assign.html",e.ATTRIB_NAME="entity.other.attribute-name.html",e.ATTRIB_VALUE="string.html",e.COMMENT="comment.html.content",e.DELIM_COMMENT="comment.html",e.DOCTYPE="storage.content.html",e.DELIM_DOCTYPE="storage.html";var o="entity.name.tag.tag-";e.isTag=r,e.getTag=i});var __extends=this&&this.__extends||function(t,e){function n(){this.constructor=t}for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r]);t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)},__decorate=this&&this.__decorate||function(t,e,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(t,e,n,r);switch(arguments.length){case 2:return t.reduceRight(function(t,e){return e&&e(t)||t},e);case 3:return t.reduceRight(function(t,r){return void(r&&r(e,n))},void 0);case 4:return t.reduceRight(function(t,r){return r&&r(e,n,t)||t},r)}},__param=this&&this.__param||function(t,e){return function(n,r){e(n,r,t)}};define("vs/languages/html/common/html",["require","exports","vs/editor/common/modes/modesRegistry","vs/editor/common/modes/supports","vs/base/common/arrays","vs/platform/platform","vs/platform/instantiation/common/descriptors","vs/base/common/winjs.base","vs/editor/common/modes","vs/editor/common/modes/abstractMode","vs/editor/common/modes/abstractState","vs/platform/thread/common/threadService","vs/editor/common/services/modeService","vs/editor/common/modes/supports/onEnter","vs/platform/instantiation/common/instantiation","vs/platform/thread/common/thread","vs/languages/html/common/htmlTokenTypes"],function(t,e,n,r,i,o,a,s,u,c,p,h,d,l,m,g,f){e.htmlTokenTypes=f,function(t){t[t.Content=0]="Content",t[t.OpeningStartTag=1]="OpeningStartTag",t[t.OpeningEndTag=2]="OpeningEndTag",t[t.WithinDoctype=3]="WithinDoctype",t[t.WithinTag=4]="WithinTag",t[t.WithinComment=5]="WithinComment",t[t.WithinEmbeddedContent=6]="WithinEmbeddedContent",t[t.AttributeName=7]="AttributeName",t[t.AttributeValue=8]="AttributeValue"}(e.States||(e.States={}));var T=e.States,k=["script","style"],y=function(t){function e(e,n,r,i,o,a,s){t.call(this,e),this.kind=n,this.lastTagName=r,this.lastAttributeName=i,this.embeddedContentType=o,this.attributeValueQuote=a,this.attributeValue=s}return __extends(e,t),e.escapeTagName=function(t){return f.getTag(t.replace(/[:_]/g,"-"))},e.prototype.makeClone=function(){return new e(this.getMode(),this.kind,this.lastTagName,this.lastAttributeName,this.embeddedContentType,this.attributeValueQuote,this.attributeValue)},e.prototype.equals=function(n){return n instanceof e?t.prototype.equals.call(this,n)&&this.kind===n.kind&&this.lastTagName===n.lastTagName&&this.lastAttributeName===n.lastAttributeName&&this.embeddedContentType===n.embeddedContentType&&this.attributeValueQuote===n.attributeValueQuote&&this.attributeValue===n.attributeValue:!1},e.prototype.nextName=function(t){return t.advanceIfRegExp(/^[_:\w][_:\w-.\d]*/).toLowerCase()},e.prototype.tokenize=function(t){switch(this.kind){case T.WithinComment:if(t.advanceUntilString2("-->",!1))return{type:f.COMMENT};if(t.advanceIfString2("-->"))return this.kind=T.Content,{type:f.DELIM_COMMENT,bracket:u.Bracket.Close};break;case T.WithinDoctype:if(t.advanceUntilString2(">",!1))return{type:f.DOCTYPE};if(t.advanceIfString2(">"))return this.kind=T.Content,{type:f.DELIM_DOCTYPE,bracket:u.Bracket.Close};break;case T.Content:if(t.advanceIfCharCode2("<".charCodeAt(0))){if(!t.eos()&&"!"===t.peek()){if(t.advanceIfString2("!--"))return this.kind=T.WithinComment,{type:f.DELIM_COMMENT,bracket:u.Bracket.Open};if(t.advanceIfStringCaseInsensitive2("!DOCTYPE"))return this.kind=T.WithinDoctype,{type:f.DELIM_DOCTYPE,bracket:u.Bracket.Open}}return t.advanceIfCharCode2("/".charCodeAt(0))?(this.kind=T.OpeningEndTag,{type:f.DELIM_END,bracket:u.Bracket.Open}):(this.kind=T.OpeningStartTag,{type:f.DELIM_START,bracket:u.Bracket.Open})}break;case T.OpeningEndTag:var n=this.nextName(t);return n.length>0?{type:e.escapeTagName(n)}:t.advanceIfString2(">")?(this.kind=T.Content,{type:f.DELIM_END,bracket:u.Bracket.Close}):(t.advanceUntilString2(">",!1),{type:""});case T.OpeningStartTag:if(this.lastTagName=this.nextName(t),this.lastTagName.length>0)return this.lastAttributeName=null,("script"===this.lastTagName||"style"===this.lastTagName)&&(this.lastAttributeName=null,this.embeddedContentType=null),this.kind=T.WithinTag,{type:e.escapeTagName(this.lastTagName)};break;case T.WithinTag:if(t.skipWhitespace2()||t.eos())return{type:""};var r=this.nextName(t);return r.length>0?(this.lastAttributeName=r,this.kind=T.AttributeName,{type:f.ATTRIB_NAME}):t.advanceIfString2("/>")?(this.kind=T.Content,{type:f.DELIM_START,bracket:u.Bracket.Close}):t.advanceIfCharCode2(">".charCodeAt(0))?-1!==k.indexOf(this.lastTagName)?(this.kind=T.WithinEmbeddedContent,{type:f.DELIM_START,bracket:u.Bracket.Close}):(this.kind=T.Content,{type:f.DELIM_START,bracket:u.Bracket.Close}):(t.next2(),{type:""});case T.AttributeName:return t.skipWhitespace2()||t.eos()?{type:""}:t.advanceIfCharCode2("=".charCodeAt(0))?(this.kind=T.AttributeValue,{type:f.DELIM_ASSIGN}):(this.kind=T.WithinTag,this.tokenize(t));case T.AttributeValue:if(t.eos())return{type:""};if(t.skipWhitespace2())return'"'===this.attributeValueQuote||"'"===this.attributeValueQuote?{type:f.ATTRIB_VALUE}:{type:""};if('"'!==this.attributeValueQuote&&"'"!==this.attributeValueQuote){var i=t.peek();return"'"===i||'"'===i?(this.attributeValueQuote=i,this.attributeValue=i,t.next2(),{type:f.ATTRIB_VALUE}):(this.kind=T.WithinTag,this.tokenize(t))}if(this.attributeValue!==this.attributeValueQuote||"script"!==this.lastTagName&&"style"!==this.lastTagName||"type"!==this.lastAttributeName){if(t.advanceIfCharCode2(this.attributeValueQuote.charCodeAt(0)))this.kind=T.WithinTag,this.attributeValue="",this.attributeValueQuote="";else{var o=t.next();this.attributeValue+=o}return{type:f.ATTRIB_VALUE}}if(this.attributeValue=t.advanceUntilString(this.attributeValueQuote,!0),this.attributeValue.length>0)return this.embeddedContentType=this.unquote(this.attributeValue),this.kind=T.WithinTag,this.attributeValue="",this.attributeValueQuote="",{type:f.ATTRIB_VALUE}}return t.next2(),this.kind=T.Content,{type:""}},e.prototype.unquote=function(t){var e=0,n=t.length;return'"'===t[0]&&e++,'"'===t[n-1]&&n--,t.substring(e,n)},e}(p.AbstractState);e.State=y;var b=function(t){function e(e,n,i,o){var a=this;t.call(this,e,n,i),this.modeService=o,this.tokenizationSupport=new r.TokenizationSupport(this,this,!0,!0),this.electricCharacterSupport=new r.BracketElectricCharacterSupport(this,{brackets:[],regexBrackets:[{tokenType:f.getTag("$1"),open:/<(?!(?:area|base|basefont|br|col|command|embed|frame|hr|img|input|link|meta|param|source|track|wbr))(\w[\w\d]*)([^\/>]*(?!\/)>)[^<]*$/i,closeComplete:"</$1>",close:/<\/(\w[\w\d]*)\s*>$/i}],caseInsensitive:!0,embeddedElectricCharacters:["*","}","]",")"]}),this.formattingSupport=this,this.extraInfoSupport=this,this.referenceSupport=new r.ReferenceSupport(this,{tokens:["invalid"],findReferences:function(t,e,n){return a.findReferences(t,e,n)}}),this.logicalSelectionSupport=this,this.parameterHintsSupport=new r.ParameterHintsSupport(this,{triggerCharacters:["(",","],excludeTokens:["*"],getParameterHints:function(t,e){return a.getParameterHints(t,e)}}),this.suggestSupport=new r.SuggestSupport(this,{triggerCharacters:[".",":","<",'"',"=","/"],excludeTokens:["comment"],suggest:function(t,e){return a.suggest(t,e)}}),this.onEnterSupport=new l.OnEnterSupport(this.getId(),{brackets:[{open:"<!--",close:"-->"}]})}return __extends(e,t),e.prototype.asyncCtor=function(){var t=this;return s.Promise.join([this.modeService.getOrCreateMode("text/javascript"),this.modeService.getOrCreateMode("text/css")]).then(function(e){var n=t._getAutoClosingPairs(e);t.characterPairSupport=new r.CharacterPairSupport(t,{autoClosingPairs:n.slice(0),surroundingPairs:[{open:'"',close:'"'},{open:"'",close:"'"}]})})},e.prototype._getAutoClosingPairs=function(t){var e=this,n={'"':'"',"'":"'"};t.forEach(function(t){return e._collectAutoClosingPairs(n,t)});var r,i=[];for(r in n)i.push({open:r,close:n[r]});return i},e.prototype._collectAutoClosingPairs=function(t,e){if(e&&e.characterPairSupport){var n=e.characterPairSupport.getAutoClosingPairs();if(null!==n)for(var r=0;r<n.length;r++)t[n[r].open]=n[r].close}},e.prototype.getInitialState=function(){return new y(this,T.Content,"","","","","")},e.prototype.enterNestedMode=function(t){return t instanceof y&&t.kind===T.WithinEmbeddedContent},e.prototype.getNestedMode=function(t){var e=null,n=t,r=null;if(null!==n.embeddedContentType)C.isRegisteredMode(n.embeddedContentType)&&(e=this.modeService.getMode(n.embeddedContentType),e||(r=this.modeService.getOrCreateMode(n.embeddedContentType)));else{var i=null;i="script"===n.lastTagName?"text/javascript":"style"===n.lastTagName?"text/css":"text/plain",e=this.modeService.getMode(i)}return null===e&&(e=this.modeService.getMode("text/plain")),{mode:e,missingModePromise:r}},e.prototype.getLeavingNestedModeData=function(t,e){var n=e.lastTagName,r=new RegExp("<\\/"+n+"\\s*>","i"),i=r.exec(t);return null!==i?{nestedModeBuffer:t.substring(0,i.index),bufferAfterNestedMode:t.substring(i.index),stateAfterNestedMode:new y(this,T.Content,"","","","","")}:null},e.prototype.getWordDefinition=function(){return e.WORD_DEFINITION},e.prototype.getCommentsConfiguration=function(){return{blockCommentStartToken:"<!--",blockCommentEndToken:"-->"}},e.prototype._getWorkerDescriptor=function(){return a.createAsyncDescriptor2("vs/languages/html/common/htmlWorker","HTMLWorker")},e.prototype.formatDocument=function(t,e){return this._worker(function(n){return n.format(t,null,e)})},e.prototype.formatRange=function(t,e,n){return this._worker(function(r){return r.format(t,e,n)})},e.prototype.computeInfo=function(t,e){return this._worker(function(n){return n.computeInfo(t,e)})},e.prototype.findReferences=function(t,e,n){return this._worker(function(r){return r.findReferences(t,e,n)})},e.prototype.getRangesToPosition=function(t,e){return this._worker(function(n){return n.getRangesToPosition(t,e)})},e.prototype.findDeclaration=function(t,e){return this._worker(function(n){return n.findDeclaration(t,e)})},e.prototype.findOccurrences=function(t,e,n){return void 0===n&&(n=!1),this._worker(function(r){return r.findOccurrences(t,e,n)})},e.prototype.suggest=function(t,e){return this._worker(function(n){return n.suggest(t,e)})},e.prototype.findColorDeclarations=function(t){return this._worker(function(e){return e.findColorDeclarations(t)})},e.prototype.getParameterHints=function(t,e){return this._worker(function(n){return n.getParameterHints(t,e)})},e.WORD_DEFINITION=c.createWordRegExp("#-?%"),e.$formatDocument=h.OneWorkerAttr(e,e.prototype.formatDocument),e.$formatRange=h.OneWorkerAttr(e,e.prototype.formatRange),e.$computeInfo=h.OneWorkerAttr(e,e.prototype.computeInfo),e.$findReferences=h.OneWorkerAttr(e,e.prototype.findReferences),e.$getRangesToPosition=h.OneWorkerAttr(e,e.prototype.getRangesToPosition),e.$findDeclaration=h.OneWorkerAttr(e,e.prototype.findDeclaration),e.$findOccurrences=h.OneWorkerAttr(e,e.prototype.findOccurrences),e.$suggest=h.OneWorkerAttr(e,e.prototype.suggest),e.$findColorDeclarations=h.OneWorkerAttr(e,e.prototype.findColorDeclarations),e.$getParameterHints=h.OneWorkerAttr(e,e.prototype.getParameterHints),e=__decorate([__param(1,m.IInstantiationService),__param(2,g.IThreadService),__param(3,d.IModeService)],e)}(c.AbstractMode);e.HTMLMode=b;var C=o.Registry.as(n.Extensions.EditorModes)});