/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
define("vs/languages/html/common/htmlTags",["require","exports","vs/base/common/strings","vs/base/common/arrays"],function(e,t,n,o){function r(e){return o.binarySearch(s,e,function(e,t){return e.localeCompare(t)})>=0}function a(){var e=[],t={html:["manifest"],head:e,title:e,noscript:e,section:e,nav:e,article:e,aside:e,h1:e,h2:e,h3:e,h4:e,h5:e,h6:e,hgroup:e,header:e,footer:e,address:e,p:e,hr:e,pre:e,blockquote:["cite"],ol:["reversed:v","start"],ul:e,li:["value"],dl:e,dt:e,dd:e,figure:e,figcaption:e,div:e,a:["href","target","ping","rel","media","hreflang","type"],em:e,strong:e,small:e,s:e,cite:e,q:["cite"],dfn:e,abbr:e,data:["value"],time:["datetime","pubdate"],code:e,"var":e,samp:e,kbd:e,sub:e,sup:e,i:e,b:e,u:e,mark:e,ruby:e,rt:e,rp:e,bdi:e,bdo:e,span:e,br:e,wbr:e,ins:["cite","datetime"],del:["cite","datetime"],img:["alt","src","srcset","crossorigin:xo","usemap","ismap:v","width","height"],iframe:["src","srcdoc","name","sandbox","seamless","width","height"],embed:["src","type","width","height"],object:["data","type","typemustmatch:v","name","usemap","form","width","height"],param:["name","value"],video:["src","crossorigin:xo","poster","preload","autoplay:v","mediagroup","loop:v","muted:v","controls:v","width","height"],audio:["src","crossorigin:xo","preload","autoplay:v","mediagroup","loop:v","muted:v","controls:v"],source:["src","type","media"],track:["default:v","kind","label","src","srclang"],canvas:["width","height"],map:["name"],area:["alt","coords","shape","href","target","ping","rel","media","hreflang","type"],base:["href","target"],link:["href","rel","media","hreflang","type","sizes"],meta:["name","http-equiv","content","charset"],style:["media","type","scoped:v"],script:["src","async:v","defer:v","type","charset"],body:["onafterprint","onbeforeprint","onbeforeunload","onblur","onerror","onfocus","onhashchange","onload","onmessage","onoffline","ononline","onpagehide","onpageshow","onpopstate","onresize","onscroll","onstorage","onunload"],table:e,caption:e,colgroup:["span"],col:["span"],tbody:e,thead:e,tfoot:e,tr:e,td:["colspan","rowspan","headers"],th:["colspan","rowspan","headers","scope","abbr"],form:["accept-charset","action","autocomplete:o","enctype","method:m","name","novalidate:v","target"],fieldset:["disabled:v","form","name"],legend:e,label:["form","for"],input:["accept","alt","autocomplete:o","autofocus:v","checked:v","dirname","disabled:v","form","formaction","formenctype","formmethod:m","formnovalidate:v","formtarget","height","inputmode","list","max","maxlength","min","multiple:v","name","pattern","placeholder","readonly:v","required","size","src","step","type:t","value","width"],button:["autofocus:v","disabled:v","form","formaction","formenctype","formmethod:m","formnovalidate:v","formtarget","name","type:bt","value"],select:["autofocus:v","disabled:v","form","multiple:v","name","required:v","size"],datalist:["option"],optgroup:["disabled:v","label"],option:["disabled:v","label","selected:v","value"],textarea:["autocomplete:o","autofocus:v","cols","dirname","disabled:v","form","inputmode","maxlength","name","placeholder","readonly:v","required:v","rows","wrap"],keygen:["autofocus:v","challenge","disabled:v","form","keytype","name"],output:["for","form","name"],progress:["value","max"],meter:["value","min","max","low","high","optimum"],details:["open:v"],summary:e,command:["type","label","icon","disabled:v","checked:v","radiogroup","command"],menu:["type","label"],dialog:["open:v"]},o=["accesskey","class","contenteditable:b","contextmenu","dir:d","draggable:a","dropzone","hidden:v","id","inert:v","itemid","itemprop","itemref","itemscope:v","itemtype","lang","role","spellcheck:b","style","tabindex","title","translate"],r=["onabort","onblur","oncanplay","oncanplaythrough","onchange","onclick","oncontextmenu","ondblclick","ondrag","ondragend","ondragenter","ondragleave","ondragover","ondragstart","ondrop","ondurationchange","onemptied","onended","onerror","onfocus","onformchange","onforminput","oninput","oninvalid","onkeydown","onkeypress","onkeyup","onload","onloadeddata","onloadedmetadata","onloadstart","onmousedown","onmousemove","onmouseout","onmouseover","onmouseup","onmousewheel","onpause","onplay","onplaying","onprogress","onratechange","onreset","onreadystatechange","onseeked","onseeking","onselect","onshow","onstalled","onsubmit","onsuspend","ontimeupdate","onvolumechange","onwaiting"],a={b:["true","false"],a:["true","false","auto"],d:["ltr","rtl"],m:["get","post"],o:["on","off"],t:["hidden","text","search","tel","url","email","password","datetime","date","month","week","time","datetime-local","number","range","color","checkbox","radio","file","submit","image","reset","button"],bt:["button","submit","reset"],xo:["anonymous","use-credentials"]};return{collectTags:function(e){for(var n in t)e(n)},collectAttributes:function(e,n){if(o.forEach(function(e){var t=e.split(":");n(t[0],t[1])}),r.forEach(function(e){n(e,"event")}),e){var a=t[e];a&&a.forEach(function(e){var t=e.split(":");n(t[0],t[1])})}},collectValues:function(e,r,i){var s=r+":",c=function(e){e.forEach(function(e){if(e.length>s.length&&n.startsWith(e,s)){var t=e.substr(s.length);if("v"===t)i(r);else{var o=a[t];o&&o.forEach(i)}}})},u=t[e];u&&c(u),c(o)}}}function i(){var e={input:["ng-model","ng-required","ng-minlength","ng-maxlength","ng-pattern","ng-trim"],select:["ng-model"],textarea:["ng-model","ng-required","ng-minlength","ng-maxlength","ng-pattern","ng-trim"]},t=["ng-app","ng-bind","ng-bindhtml","ng-bindtemplate","ng-blur","ng-change","ng-checked","ng-class","ng-classeven","ng-classodd","ng-click","ng-cloak","ng-controller","ng-copy","ng-csp","ng-cut","ng-dblclick","ng-disabled","ng-focus","ng-form","ng-hide","ng-href","ng-if","ng-include","ng-init","ng-jq","ng-keydown","ng-keypress","ng-keyup","ng-list","ng-modelOptions","ng-mousedown","ng-mouseenter","ng-mouseleave","ng-mousemove","ng-mouseover","ng-mouseup","ng-nonbindable","ng-open","ng-options","ng-paste","ng-pluralize","ng-readonly","ng-repeat","ng-selected","ng-show","ng-src","ng-srcset","ng-style","ng-submit","ng-switch","ng-transclude","ng-value"];return{collectTags:function(e){},collectAttributes:function(n,o){if(n){var r=e[n];r&&r.forEach(function(e){o(e,null),o("data-"+e,null)})}t.forEach(function(e){o(e,null),o("data-"+e,null)})},collectValues:function(e,t,n){}}}var s=["area","base","basefont","br","col","command","embed","frame","hr","img","input","isindex","keygen","link","meta","param","source","track","wbr"];t.isEmptyElement=r,t.getHTML5TagProvider=a,t.getAngularTagProvider=i}),define("vs/languages/html/common/htmlScanner",["require","exports","vs/languages/html/common/htmlTokenTypes"],function(e,t,n){function o(e){switch(e){case n.DELIM_START:case n.DELIM_END:case n.DELIM_ASSIGN:return!0}return!1}function r(e){switch(e){case n.DELIM_START:case n.DELIM_END:case n.DELIM_ASSIGN:case n.ATTRIB_NAME:case n.ATTRIB_VALUE:return!0}return n.isTag(e)}function a(e,t){var n=t.column-1,a=t.lineNumber,i=e.getLineTokens(a),s=e.getLineContent(a),c=i.findIndexOfOffset(n),u=i.getTokenCount(),g=i.getTokenType(c),l=i.getTokenStartIndex(c),d=i.getTokenEndIndex(c,s.length);return""!==g&&!o(g)||l!==n||(c--,c>=0?(g=i.getTokenType(c),l=i.getTokenStartIndex(c),d=i.getTokenEndIndex(c,s.length)):(g="",l=d=0)),{getTokenType:function(){return g},isAtTokenEnd:function(){return n===d},isAtTokenStart:function(){return n===l},getTokenContent:function(){return s.substring(l,d)},isOpenBrace:function(){return d>l&&"<"===s.charAt(l)},getTokenPosition:function(){return{lineNumber:a,column:l+1}},getTokenRange:function(){return{startLineNumber:a,startColumn:l+1,endLineNumber:a,endColumn:d+1}},getModel:function(){return e},scanBack:function(){if(0>=a)return!1;c--;do{for(;c>=0;){if(g=i.getTokenType(c),l=i.getTokenStartIndex(c),d=i.getTokenEndIndex(c,s.length),r(g))return!0;c--}a--,a>0&&(i=e.getLineTokens(a),s=e.getLineContent(a),u=i.getTokenCount(),c=u-1)}while(a>0);return i=null,g=s="",l=d=u=0,!1},scanForward:function(){if(a>e.getLineCount())return!1;c++;do{for(;u>c;){if(g=i.getTokenType(c),l=i.getTokenStartIndex(c),d=i.getTokenEndIndex(c,s.length),r(g))return!0;c++}a++,c=0,a<=e.getLineCount()&&(i=e.getLineTokens(a),s=e.getLineContent(a),u=i.getTokenCount())}while(a<=e.getLineCount());return g=s="",l=d=u=0,!1}}}t.getScanner=a});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var o in t)t.hasOwnProperty(o)&&(e[o]=t[o]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},__decorate=this&&this.__decorate||function(e,t,n,o){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,o);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,o){return void(o&&o(t,n))},void 0);case 4:return e.reduceRight(function(e,o){return o&&o(t,n,e)||e},o)}},__param=this&&this.__param||function(e,t){return function(n,o){t(n,o,e)}};define("vs/languages/html/common/htmlWorker",["require","exports","vs/base/common/winjs.base","vs/editor/common/modes/abstractModeWorker","vs/languages/lib/common/beautify-html","vs/languages/html/common/htmlTags","vs/base/common/network","vs/base/common/strings","vs/editor/common/core/range","vs/editor/common/core/position","vs/platform/workspace/common/workspace","vs/platform/markers/common/markers","vs/editor/common/services/resourceService","vs/languages/html/common/htmlScanner","vs/languages/html/common/htmlTokenTypes"],function(e,t,n,o,r,a,i,s,c,u,g,l,d,p,f){function m(e){return/^\s*$/.test(e)}var h;!function(e){e[e.LOOKING_FOR_HREF_OR_SRC=1]="LOOKING_FOR_HREF_OR_SRC",e[e.AFTER_HREF_OR_SRC=2]="AFTER_HREF_OR_SRC"}(h||(h={}));var T=function(e){function t(t,n,o,r,i){e.call(this,t,n,o,r),this._contextService=i,this._tagProviders=[],this._tagProviders.push(a.getHTML5TagProvider()),this.addCustomTagProviders(this._tagProviders)}return __extends(t,e),t.prototype.addCustomTagProviders=function(e){e.push(a.getAngularTagProvider())},t.prototype.format=function(e,t,n){var o=this;return this._delegateToModeAtPosition(e,u.Position.startPosition(t),function(r,a){return r&&a.getMode().formattingSupport?a.getMode().formattingSupport.formatRange(a.getAssociatedResource(),t,n):o.formatHTML(e,t,n)})},t.prototype.formatHTML=function(e,t,o){var a=this.resourceService.get(e),i=t?a.getValueInRange(t):a.getValue(),s=r.html_beautify(i,{indent_size:o.insertSpaces?o.tabSize:1,indent_char:o.insertSpaces?" ":"	",wrap_line_length:120});return n.TPromise.as([{range:t,text:s}])},t.prototype._delegateToModeAtPosition=function(e,t,n){var o=this.resourceService.get(e);if(!o)return null;var r=o.getEmbeddedAtPosition(t);if(!r)return n(!1,o);var a=r.getMode();return n(a.getId()!==this._getMode().getId(),r)},t.prototype._delegateToAllModes=function(e,t){var n=this.resourceService.get(e);return n?t(n.getAllEmbedded()):null},t.prototype.computeInfo=function(e,t){return this._delegateToModeAtPosition(e,t,function(e,n){return e&&n.getMode().extraInfoSupport?n.getMode().extraInfoSupport.computeInfo(n.getAssociatedResource(),t):void 0})},t.prototype.findReferences=function(e,t,n){return this._delegateToModeAtPosition(e,t,function(e,o){return e&&o.getMode().referenceSupport?o.getMode().referenceSupport.findReferences(o.getAssociatedResource(),t,n):void 0})},t.prototype.getRangesToPosition=function(e,t){return this._delegateToModeAtPosition(e,t,function(e,n){return e&&n.getMode().logicalSelectionSupport?n.getMode().logicalSelectionSupport.getRangesToPosition(n.getAssociatedResource(),t):void 0})},t.prototype.findDeclaration=function(e,t){return this._delegateToModeAtPosition(e,t,function(e,n){return e&&n.getMode().declarationSupport?n.getMode().declarationSupport.findDeclaration(n.getAssociatedResource(),t):void 0})},t.prototype.findColorDeclarations=function(e){return this._delegateToAllModes(e,function(e){var t=[];return t=e.filter(function(e){return"function"==typeof e.getMode().findColorDeclarations}).map(function(e){return e.getMode().findColorDeclarations(e.getAssociatedResource())}),n.TPromise.join(t).then(function(e){var t=[];return e.forEach(function(e){return t=t.concat(e)}),t})})},t.prototype.getParameterHints=function(e,t){return this._delegateToModeAtPosition(e,t,function(e,n){return e&&n.getMode().parameterHintsSupport?n.getMode().parameterHintsSupport.getParameterHints(n.getAssociatedResource(),t):void 0})},t.prototype.findMatchingOpenTag=function(e){for(var t={},n=!1;e.scanBack();)if(f.isTag(e.getTokenType())&&!n){var o=e.getTokenContent();if(e.scanBack(),e.getTokenType()===f.DELIM_END)t[o]=(t[o]||0)+1;else if(!a.isEmptyElement(o)){if(!t[o])return o;t[o]--}}else e.getTokenType()===f.DELIM_START&&(n="/>"===e.getTokenContent());return null},t.prototype.collectTagSuggestions=function(e,t,n){var o=this,r=e.getModel(),a=r.getLineContent(t.lineNumber).substr(t.column-1),i=m(a)||s.startsWith(a,"<")?">":"",c=function(a){var s=e.getTokenPosition(),c=o.findMatchingOpenTag(e);if(c){var u={label:"/"+c,codeSnippet:"/"+c+i,type:"property"};if(n.suggestions.push(u),a){var g=e.getTokenPosition();if(s.lineNumber!==g.lineNumber){var l=r.getLineContent(g.lineNumber).substring(0,g.column-1),d=r.getLineContent(s.lineNumber).substring(0,s.column-1);m(l)&&m(d)&&(n.overwriteBefore=t.column-1,u.codeSnippet=l+"</"+c+i)}}return!0}return!1};if(e.getTokenType()===f.DELIM_END){n.overwriteBefore=n.currentWord.length+1;var u=c(!0);u||(n.overwriteBefore=n.currentWord.length+1,this._tagProviders.forEach(function(e){e.collectTags(function(e){n.suggestions.push({label:"/"+e,codeSnippet:"/"+e+i,type:"property"})})}))}else c(!1),this._tagProviders.forEach(function(e){e.collectTags(function(e){n.suggestions.push({label:e,codeSnippet:e,type:"property"})})})},t.prototype.collectContentSuggestions=function(e){},t.prototype.collectAttributeSuggestions=function(e,t){var n=null;do{if(f.isTag(e.getTokenType())){n=e.getTokenContent();break}if(e.getTokenType()===f.DELIM_START)break}while(e.scanBack());this._tagProviders.forEach(function(e){e.collectAttributes(n,function(e,n){var o=e;"v"!==n&&(o+='="{{}}"'),t.suggestions.push({label:e,codeSnippet:o,type:"handler"===n?"function":"value"})})})},t.prototype.collectAttributeValueSuggestions=function(e,t){for(var n=e.getTokenType()===f.DELIM_ASSIGN,o=null,r=null;e.scanBack();)if(e.getTokenType()===f.ATTRIB_NAME){o=e.getTokenContent();break}for(;e.scanBack();){if(f.isTag(e.getTokenType())){r=e.getTokenContent();break}if(e.getTokenType()===f.DELIM_START)return}this._tagProviders.forEach(function(e){e.collectValues(r,o,function(e){t.suggestions.push({label:e,codeSnippet:n?'"'+e+'"':e,type:"unit"})})})},t.prototype.suggest=function(e,t,n){var o=this;return this._delegateToModeAtPosition(e,t,function(r,a){return r&&a.getMode().suggestSupport?a.getMode().suggestSupport.suggest(a.getAssociatedResource(),t,n):o.suggestHTML(e,t)})},t.prototype.suggestHTML=function(t,n){return e.prototype.suggest.call(this,t,n)},t.prototype.doSuggest=function(e,t){var o=this.resourceService.get(e),r=o.getWordUntilPosition(t).word,a={currentWord:r,suggestions:[]},i=p.getScanner(o,t);switch(i.getTokenType()){case f.DELIM_START:case f.DELIM_END:i.isOpenBrace()?this.collectTagSuggestions(i,t,a):this.collectContentSuggestions(a);break;case f.ATTRIB_NAME:this.collectAttributeSuggestions(i,a);break;case f.ATTRIB_VALUE:this.collectAttributeValueSuggestions(i,a);break;case f.DELIM_ASSIGN:i.isAtTokenEnd()&&this.collectAttributeValueSuggestions(i,a);break;case"":if(m(i.getTokenContent())&&i.scanBack())switch(i.getTokenType()){case f.ATTRIB_VALUE:case f.ATTRIB_NAME:this.collectAttributeSuggestions(i,a);break;case f.DELIM_ASSIGN:this.collectAttributeValueSuggestions(i,a);break;case f.DELIM_START:case f.DELIM_END:i.isOpenBrace()?this.collectTagSuggestions(i,t,a):this.collectContentSuggestions(a);break;default:f.isTag(i.getTokenType())&&this.collectAttributeSuggestions(i,a)}else this.collectContentSuggestions(a);break;default:f.isTag(i.getTokenType())&&(i.scanBack(),this.collectTagSuggestions(i,t,a))}return n.Promise.as(a)},t.prototype.findMatchingBracket=function(e,t){if(a.isEmptyElement(e))return null;var n=0;if(t.scanBack(),t.getTokenType()===f.DELIM_END)for(var o=!1;t.scanBack();)if(f.isTag(t.getTokenType())&&t.getTokenContent()===e&&!o){var r=t.getTokenRange();if(t.scanBack(),t.getTokenType()===f.DELIM_START){if(0===n)return r;n--}else n++}else t.getTokenType()===f.DELIM_START&&(o="/>"===t.getTokenContent());else for(var i=!1;t.scanForward();)if(f.isTag(t.getTokenType())&&t.getTokenContent()===e)if(i){if(n--,0>=n)return t.getTokenRange()}else if(t.scanForward(),t.getTokenType()===f.DELIM_START&&"/>"===t.getTokenContent()){if(0>=n)return null}else n++;else t.getTokenType()===f.DELIM_START?i=!1:t.getTokenType()===f.DELIM_END&&(i=!0);return null},t.prototype.findOccurrences=function(e,t,n){var o=this;return void 0===n&&(n=!1),this._delegateToModeAtPosition(e,t,function(r,a){return r&&a.getMode().occurrencesSupport?a.getMode().occurrencesSupport.findOccurrences(a.getAssociatedResource(),t,n):o.findOccurrencesHTML(e,t,n)})},t.prototype.findOccurrencesHTML=function(e,t,o){var r=this.resourceService.get(e),a=r.getWordAtPosition(t),i=a?a.word:"",s=[],c=p.getScanner(r,t);if(f.isTag(c.getTokenType())){var u=c.getTokenContent();s.push({range:c.getTokenRange()});var g=this.findMatchingBracket(u,c);g&&s.push({range:g})}else for(var l=r.getAllWordsWithRange(),d=Math.min(1e3,l.length),m=0;d>m;m++)l[m].text===i&&s.push({range:l[m].range});return n.TPromise.as(s)},t._stripQuotes=function(e){return e.replace(/^'([^']+)'$/,function(e,t){return t}).replace(/^"([^"]+)"$/,function(e,t){return t})},t._getWorkspaceUrl=function(e,n,o){if(o=t._stripQuotes(o),/^\s*javascript\:/i.test(o)||/^\s*\#/i.test(o))return null;if(/^\s*https?:\/\//i.test(o)||/^\s*file:\/\//i.test(o))return o.replace(/^\s*/g,"");if(/^\s*\/\//i.test(o)){var r=e.getScheme(),a="http";return r===i.schemas.https&&(a=i.schemas.https),a+":"+o.replace(/^\s*/g,"")}try{var c=e.combine(o).toString()}catch(u){return null}if(n&&e.startsWith(n)){var g=n.toString(),l=s.commonPrefixLength(g,c);return s.endsWith(g,"/")&&(l=c.lastIndexOf("/",l)+1),g+c.substr(l)}return c},t.prototype.createLink=function(e,n,o,r,a,i){var s=t._getWorkspaceUrl(e,n,o);return s?{range:{startLineNumber:r,startColumn:a,endLineNumber:r,endColumn:i},url:s}:null},t.prototype._computeHTMLLinks=function(e){var t,n,o,r,a,s,c,u,g,l,d=e.getLineCount(),p=[],m=h.LOOKING_FOR_HREF_OR_SRC,T=e.getAssociatedResource(),v=null,k=this._contextService.getWorkspace();if(k){var b=String(k.resource);v="/"===b.charAt(b.length-1)?new i.URL(b):new i.URL(b+"/")}for(t=1;d>=t;t++)for(n=e.getLineContent(t),o=n.length,r=e.getLineTokens(t),c=0,s=r.getTokenCount();s>c;c++)switch(a=r.getTokenType(c)){case f.DELIM_ASSIGN:case"":break;case f.ATTRIB_NAME:m===h.LOOKING_FOR_HREF_OR_SRC&&(u=r.getTokenEndIndex(c,o),g=n.substring(r.getTokenStartIndex(c),u).toLowerCase(),("src"===g||"href"===g)&&(m=h.AFTER_HREF_OR_SRC));break;case f.ATTRIB_VALUE:m===h.AFTER_HREF_OR_SRC&&(u=r.getTokenEndIndex(c,o),g=n.substring(r.getTokenStartIndex(c),u),l=this.createLink(T,v,g,t,r.getTokenStartIndex(c)+2,u),l&&p.push(l),m=h.LOOKING_FOR_HREF_OR_SRC);default:f.isTag(a)?m=h.LOOKING_FOR_HREF_OR_SRC:m===h.AFTER_HREF_OR_SRC&&(m=h.LOOKING_FOR_HREF_OR_SRC)}return p},t.prototype.computeLinks=function(t){var n=this;return e.prototype.computeLinks.call(this,t).then(function(e){var o,r,a,i,s,u,g,l=n.resourceService.get(t),d=n._computeHTMLLinks(l),p=[];for(o=0,a=0,r=e.length,i=d.length;r>o&&i>a;)s=e[o],u=d[a],c.Range.areIntersectingOrTouching(s.range,u.range)?o++:(g=c.Range.compareRangesUsingStarts(s.range,u.range),0>g?(p.push(s),o++):(p.push(u),a++));for(;r>o;o++)p.push(e[o]);for(;i>a;a++)p.push(d[a]);return p})},t=__decorate([__param(2,d.IResourceService),__param(3,l.IMarkerService),__param(4,g.IWorkspaceContextService)],t)}(o.AbstractModeWorker);t.HTMLWorker=T});