/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/typescript/common/js/shebangRewriter",["require","exports"],function(e,t){var r=function(){function e(){}return Object.defineProperty(e.prototype,"name",{get:function(){return"rewriter.shebang"},enumerable:!0,configurable:!0}),e.prototype.computeEdits=function(t){var r=t.sourceFile.getFullText();if(r.charCodeAt(0)===e._hash&&r.charCodeAt(1)===e._bang){var n=~r.indexOf("\n")||~r.indexOf("\r");n=n?~n:r.length,t.newDelete(0,n)}},e._hash="#".charCodeAt(0),e._bang="!".charCodeAt(0),e}();return r});var __extends=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)},__decorate=this&&this.__decorate||function(e,t,r,n){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,r,n);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,n){return void(n&&n(t,r))},void 0);case 4:return e.reduceRight(function(e,n){return n&&n(t,r,e)||e},n)}},__param=this&&this.__param||function(e,t){return function(r,n){t(r,n,e)}};define("vs/languages/javascript/common/javascriptWorker",["require","exports","vs/base/common/objects","vs/base/common/arrays","vs/base/common/winjs.base","vs/languages/typescript/common/typescriptWorker2","vs/languages/typescript/common/options","vs/languages/typescript/common/js/rewriting","vs/languages/typescript/common/features/suggestions","vs/languages/typescript/common/features/parameterHints","vs/languages/typescript/common/features/occurrences","vs/languages/typescript/common/features/extraInfo","vs/languages/typescript/common/features/references","vs/languages/typescript/common/features/definitions","vs/languages/typescript/common/features/quickFix","vs/languages/typescript/common/features/diagnostics","vs/languages/typescript/common/features/rename","vs/languages/typescript/common/js/shebangRewriter","vs/platform/markers/common/markers","vs/editor/common/services/resourceService"],function(e,t,r,n,a,s,o,i,c,g,u,p,f,l,m,v,h,d,y,_){var j=function(e){function t(t,r,n,a){var s=this;e.call(this,t,r,n,a),this._projectService.defaultRewriter=[new d],this._fancyRewriters=[new d],r.forEach(function(e){"function"==typeof e.computeEdits&&s._fancyRewriters.push(e)})}return __extends(t,e),t.prototype._doConfigure=function(t){return e.prototype._doConfigure.call(this,t,o.javaScriptOptions)},t.prototype.doValidateSemantics=function(e){var t=[],n=this._projectService.getProject(e,this._fancyRewriters),a=v.getSemanticDiagnostics(n.languageService,e,this._options);if(a){var s=n.translations.getTranslator(e);return a.markers.forEach(function(e){var n=s.info(e);n.origin?(r.mixin(e,n.origin,!0),t.push(e)):n.isInserted||(r.mixin(e,s.from(e),!0),t.push(e))}),this.markerService.changeOne("/"+this._getMode().getId()+"/semantic",e,t),a.hasMissingFiles}},t.prototype.doSuggest=function(e,t){var r=this._projectService.getProject(e,this._fancyRewriters);t=r.translations.getTranslator(e).to(t);var s=c.computeSuggestions(r.languageService,e,t,this._options);return n.forEach(s.suggestions,function(e,t){i.containsEncodedVariableName(e.label)&&t()}),a.TPromise.as(s)},t.prototype.getSuggestionDetails=function(e,t,r){var n=this._projectService.getProject(e,this._fancyRewriters);t=n.translations.getTranslator(e).to(t);var s=c.getSuggestionDetails(n.languageService,e,t,r,this._options);return s.typeLabel=i.decodeVariableNames(s.typeLabel,n.translations.getOriginal(e)),a.TPromise.as(s)},t.prototype.getParameterHints=function(e,t){var r=this._projectService.getProject(e,this._fancyRewriters);t=r.translations.getTranslator(e).to(t);var n=g.compute(r.languageService,e,t);if(n){for(var s=r.translations.getOriginal(e),o=0,c=n.signatures;o<c.length;o++){var u=c[o];u.label=i.decodeVariableNames(u.label,s);for(var p=0,f=u.parameters;p<f.length;p++){var l=f[p];l.label=i.decodeVariableNames(l.label,s),l.signatureLabelOffset=0,l.signatureLabelEnd=0}}return a.TPromise.as(n)}},t.prototype.findOccurrences=function(e,t,r){var s=this._projectService.getProject(e,this._fancyRewriters),o=s.translations.getTranslator(e);t=o.to(t);var i=u.compute(s.languageService,e,t,r);return n.forEach(i,function(t,r){o.info(t.range).isInserted?r():t.range=s.translations.getTranslator(e).from(t.range)}),a.TPromise.as(i)},t.prototype._findTypeScriptDeclaration=function(e,t){var r=this._projectService.getProject(e,this._fancyRewriters);t=r.translations.getTranslator(e).to(t);var n=l.findDeclaration(r,e,t);if(n){var s=r.translations.getTranslator(n.resource);if(!s.info(n.range).isInserted)return n.range=s.from(n.range),a.TPromise.as(n)}},t.prototype.findReferences=function(e,t,r){var s=this._projectService.getProject(e,this._fancyRewriters);t=s.translations.getTranslator(e).to(t);var o=f.find(s,e,t,r);return n.forEach(o,function(e,t){var r=s.translations.getTranslator(e.resource);r.info(e.range).isInserted?t():e.range=r.from(e.range)}),a.TPromise.as(o)},t.prototype.computeInfo=function(e,t){var r=this._projectService.getProject(e,this._fancyRewriters);t=r.translations.getTranslator(e).to(t);var n=p.compute(r.languageService,e,t);return n&&(n.range=r.translations.getTranslator(e).from(n.range),i.decodeVariableNames(n.htmlContent,r.translations.getOriginal(e))),a.TPromise.as(n)},t.prototype.runQuickFixAction=function(e,t,n){var s=this._projectService.getProject(e,this._fancyRewriters),o=s.translations.getTranslator(e).to(t);r.mixin(o,t,!1);var i=m.evaluate(s.languageService,e,o,n);if(i)for(var c=0,g=i.edits;c<g.length;c++){var u=g[c];u.range=s.translations.getTranslator(u.resource).from(u.range)}return a.TPromise.as(i)},t.prototype.getQuickFixes=function(e,t){var n=this._projectService.getProject(e,this._fancyRewriters),s=n.translations.getTranslator(e).to(t);r.mixin(s,t,!1);var o=m.compute(n.languageService,e,s);return a.TPromise.as(o)},t.prototype.rename=function(e,t,r){for(var n=this._projectService.getProject(e,this._fancyRewriters),s=h(n,e,n.translations.getTranslator(e).to(t),r),o=0;o<s.edits.length;o++){var i=s.edits[o],c=n.translations.getTranslator(i.resource),g=c.info(i.range);if(g.isInserted)s.edits.splice(o,1),o-=1;else if(g.isOverlapping){s.edits=[];break}i.range=c.from(i.range)}return a.TPromise.as(s)},t=__decorate([__param(2,_.IResourceService),__param(3,y.IMarkerService)],t)}(s.TypeScriptWorker2);t.JavaScriptWorker=j});