/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/markdown/common/markdownTokenTypes",["require","exports"],function(t,e){e.TOKEN_HEADER_LEAD="entity.name.type",e.TOKEN_HEADER="entity.name.type",e.TOKEN_EXT_HEADER="entity.other.atribute-name",e.TOKEN_SEPARATOR="meta.separator",e.TOKEN_QUOTE="meta.tag",e.TOKEN_LIST="punctuation.section.embedded",e.TOKEN_BLOCK="string",e.TOKEN_BLOCK_CODE="string.source"}),define("vs/languages/html/common/htmlTokenTypes",["require","exports","vs/base/common/strings"],function(t,e,n){function r(t){return n.startsWith(t,i)}function o(t){return i+t}e.DELIM_END="punctuation.tag.end.html",e.DELIM_START="punctuation.tag.begin.html",e.DELIM_ASSIGN="tag.assign.html",e.ATTRIB_NAME="entity.other.attribute-name.html",e.ATTRIB_VALUE="string.html",e.COMMENT="comment.html.content",e.DELIM_COMMENT="comment.html",e.DOCTYPE="storage.content.html",e.DELIM_DOCTYPE="storage.html";var i="entity.name.tag.tag-";e.isTag=r,e.getTag=o});var __extends=this&&this.__extends||function(t,e){function n(){this.constructor=t}for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r]);t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)},__decorate=this&&this.__decorate||function(t,e,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(t,e,n,r);switch(arguments.length){case 2:return t.reduceRight(function(t,e){return e&&e(t)||t},e);case 3:return t.reduceRight(function(t,r){return void(r&&r(e,n))},void 0);case 4:return t.reduceRight(function(t,r){return r&&r(e,n,t)||t},r)}},__param=this&&this.__param||function(t,e){return function(n,r){e(n,r,t)}};define("vs/languages/html/common/html",["require","exports","vs/editor/common/modes/modesRegistry","vs/editor/common/modes/supports","vs/base/common/arrays","vs/platform/platform","vs/platform/instantiation/common/descriptors","vs/base/common/winjs.base","vs/editor/common/modes","vs/editor/common/modes/abstractMode","vs/editor/common/modes/abstractState","vs/platform/thread/common/threadService","vs/editor/common/services/modeService","vs/editor/common/modes/supports/onEnter","vs/platform/instantiation/common/instantiation","vs/platform/thread/common/thread","vs/languages/html/common/htmlTokenTypes"],function(t,e,n,r,o,i,a,s,c,u,p,m,d,h,l,g,T){e.htmlTokenTypes=T,function(t){t[t.Content=0]="Content",t[t.OpeningStartTag=1]="OpeningStartTag",t[t.OpeningEndTag=2]="OpeningEndTag",t[t.WithinDoctype=3]="WithinDoctype",t[t.WithinTag=4]="WithinTag",t[t.WithinComment=5]="WithinComment",t[t.WithinEmbeddedContent=6]="WithinEmbeddedContent",t[t.AttributeName=7]="AttributeName",t[t.AttributeValue=8]="AttributeValue"}(e.States||(e.States={}));var f=e.States,k=["script","style"],_=function(t){function e(e,n,r,o,i,a,s){t.call(this,e),this.kind=n,this.lastTagName=r,this.lastAttributeName=o,this.embeddedContentType=i,this.attributeValueQuote=a,this.attributeValue=s}return __extends(e,t),e.escapeTagName=function(t){return T.getTag(t.replace(/[:_]/g,"-"))},e.prototype.makeClone=function(){return new e(this.getMode(),this.kind,this.lastTagName,this.lastAttributeName,this.embeddedContentType,this.attributeValueQuote,this.attributeValue)},e.prototype.equals=function(n){return n instanceof e?t.prototype.equals.call(this,n)&&this.kind===n.kind&&this.lastTagName===n.lastTagName&&this.lastAttributeName===n.lastAttributeName&&this.embeddedContentType===n.embeddedContentType&&this.attributeValueQuote===n.attributeValueQuote&&this.attributeValue===n.attributeValue:!1},e.prototype.nextName=function(t){return t.advanceIfRegExp(/^[_:\w][_:\w-.\d]*/).toLowerCase()},e.prototype.tokenize=function(t){switch(this.kind){case f.WithinComment:if(t.advanceUntilString2("-->",!1))return{type:T.COMMENT};if(t.advanceIfString2("-->"))return this.kind=f.Content,{type:T.DELIM_COMMENT,bracket:c.Bracket.Close};break;case f.WithinDoctype:if(t.advanceUntilString2(">",!1))return{type:T.DOCTYPE};if(t.advanceIfString2(">"))return this.kind=f.Content,{type:T.DELIM_DOCTYPE,bracket:c.Bracket.Close};break;case f.Content:if(t.advanceIfCharCode2("<".charCodeAt(0))){if(!t.eos()&&"!"===t.peek()){if(t.advanceIfString2("!--"))return this.kind=f.WithinComment,{type:T.DELIM_COMMENT,bracket:c.Bracket.Open};if(t.advanceIfStringCaseInsensitive2("!DOCTYPE"))return this.kind=f.WithinDoctype,{type:T.DELIM_DOCTYPE,bracket:c.Bracket.Open}}return t.advanceIfCharCode2("/".charCodeAt(0))?(this.kind=f.OpeningEndTag,{type:T.DELIM_END,bracket:c.Bracket.Open}):(this.kind=f.OpeningStartTag,{type:T.DELIM_START,bracket:c.Bracket.Open})}break;case f.OpeningEndTag:var n=this.nextName(t);return n.length>0?{type:e.escapeTagName(n)}:t.advanceIfString2(">")?(this.kind=f.Content,{type:T.DELIM_END,bracket:c.Bracket.Close}):(t.advanceUntilString2(">",!1),{type:""});case f.OpeningStartTag:if(this.lastTagName=this.nextName(t),this.lastTagName.length>0)return this.lastAttributeName=null,("script"===this.lastTagName||"style"===this.lastTagName)&&(this.lastAttributeName=null,this.embeddedContentType=null),this.kind=f.WithinTag,{type:e.escapeTagName(this.lastTagName)};break;case f.WithinTag:if(t.skipWhitespace2()||t.eos())return{type:""};var r=this.nextName(t);return r.length>0?(this.lastAttributeName=r,this.kind=f.AttributeName,{type:T.ATTRIB_NAME}):t.advanceIfString2("/>")?(this.kind=f.Content,{type:T.DELIM_START,bracket:c.Bracket.Close}):t.advanceIfCharCode2(">".charCodeAt(0))?-1!==k.indexOf(this.lastTagName)?(this.kind=f.WithinEmbeddedContent,{type:T.DELIM_START,bracket:c.Bracket.Close}):(this.kind=f.Content,{type:T.DELIM_START,bracket:c.Bracket.Close}):(t.next2(),{type:""});case f.AttributeName:return t.skipWhitespace2()||t.eos()?{type:""}:t.advanceIfCharCode2("=".charCodeAt(0))?(this.kind=f.AttributeValue,{type:T.DELIM_ASSIGN}):(this.kind=f.WithinTag,this.tokenize(t));case f.AttributeValue:if(t.eos())return{type:""};if(t.skipWhitespace2())return'"'===this.attributeValueQuote||"'"===this.attributeValueQuote?{type:T.ATTRIB_VALUE}:{type:""};if('"'!==this.attributeValueQuote&&"'"!==this.attributeValueQuote){var o=t.peek();return"'"===o||'"'===o?(this.attributeValueQuote=o,this.attributeValue=o,t.next2(),{type:T.ATTRIB_VALUE}):(this.kind=f.WithinTag,this.tokenize(t))}if(this.attributeValue!==this.attributeValueQuote||"script"!==this.lastTagName&&"style"!==this.lastTagName||"type"!==this.lastAttributeName){if(t.advanceIfCharCode2(this.attributeValueQuote.charCodeAt(0)))this.kind=f.WithinTag,this.attributeValue="",this.attributeValueQuote="";else{var i=t.next();this.attributeValue+=i}return{type:T.ATTRIB_VALUE}}if(this.attributeValue=t.advanceUntilString(this.attributeValueQuote,!0),this.attributeValue.length>0)return this.embeddedContentType=this.unquote(this.attributeValue),this.kind=f.WithinTag,this.attributeValue="",this.attributeValueQuote="",{type:T.ATTRIB_VALUE}}return t.next2(),this.kind=f.Content,{type:""}},e.prototype.unquote=function(t){var e=0,n=t.length;return'"'===t[0]&&e++,'"'===t[n-1]&&n--,t.substring(e,n)},e}(p.AbstractState);e.State=_;var y=function(t){function e(e,n,o,i){var a=this;t.call(this,e,n,o),this.modeService=i,this.tokenizationSupport=new r.TokenizationSupport(this,this,!0,!0),this.electricCharacterSupport=new r.BracketElectricCharacterSupport(this,{brackets:[],regexBrackets:[{tokenType:T.getTag("$1"),open:/<(?!(?:area|base|basefont|br|col|command|embed|frame|hr|img|input|link|meta|param|source|track|wbr))(\w[\w\d]*)([^\/>]*(?!\/)>)[^<]*$/i,closeComplete:"</$1>",close:/<\/(\w[\w\d]*)\s*>$/i}],caseInsensitive:!0,embeddedElectricCharacters:["*","}","]",")"]}),this.formattingSupport=this,this.extraInfoSupport=this,this.referenceSupport=new r.ReferenceSupport(this,{tokens:["invalid"],findReferences:function(t,e,n){return a.findReferences(t,e,n)}}),this.logicalSelectionSupport=this,this.parameterHintsSupport=new r.ParameterHintsSupport(this,{triggerCharacters:["(",","],excludeTokens:["*"],getParameterHints:function(t,e){return a.getParameterHints(t,e)}}),this.suggestSupport=new r.SuggestSupport(this,{triggerCharacters:[".",":","<",'"',"=","/"],excludeTokens:["comment"],suggest:function(t,e){return a.suggest(t,e)}}),this.onEnterSupport=new h.OnEnterSupport(this.getId(),{brackets:[{open:"<!--",close:"-->"}]})}return __extends(e,t),e.prototype.asyncCtor=function(){var t=this;return s.Promise.join([this.modeService.getOrCreateMode("text/javascript"),this.modeService.getOrCreateMode("text/css")]).then(function(e){var n=t._getAutoClosingPairs(e);t.characterPairSupport=new r.CharacterPairSupport(t,{autoClosingPairs:n.slice(0),surroundingPairs:[{open:'"',close:'"'},{open:"'",close:"'"}]})})},e.prototype._getAutoClosingPairs=function(t){var e=this,n={'"':'"',"'":"'"};t.forEach(function(t){return e._collectAutoClosingPairs(n,t)});var r,o=[];for(r in n)o.push({open:r,close:n[r]});return o},e.prototype._collectAutoClosingPairs=function(t,e){if(e&&e.characterPairSupport){var n=e.characterPairSupport.getAutoClosingPairs();if(null!==n)for(var r=0;r<n.length;r++)t[n[r].open]=n[r].close}},e.prototype.getInitialState=function(){return new _(this,f.Content,"","","","","")},e.prototype.enterNestedMode=function(t){return t instanceof _&&t.kind===f.WithinEmbeddedContent},e.prototype.getNestedMode=function(t){var e=null,n=t,r=null;if(null!==n.embeddedContentType)E.isRegisteredMode(n.embeddedContentType)&&(e=this.modeService.getMode(n.embeddedContentType),e||(r=this.modeService.getOrCreateMode(n.embeddedContentType)));else{var o=null;o="script"===n.lastTagName?"text/javascript":"style"===n.lastTagName?"text/css":"text/plain",e=this.modeService.getMode(o)}return null===e&&(e=this.modeService.getMode("text/plain")),{mode:e,missingModePromise:r}},e.prototype.getLeavingNestedModeData=function(t,e){var n=e.lastTagName,r=new RegExp("<\\/"+n+"\\s*>","i"),o=r.exec(t);return null!==o?{nestedModeBuffer:t.substring(0,o.index),bufferAfterNestedMode:t.substring(o.index),stateAfterNestedMode:new _(this,f.Content,"","","","","")}:null},e.prototype.getWordDefinition=function(){return e.WORD_DEFINITION},e.prototype.getCommentsConfiguration=function(){return{blockCommentStartToken:"<!--",blockCommentEndToken:"-->"}},e.prototype._getWorkerDescriptor=function(){return a.createAsyncDescriptor2("vs/languages/html/common/htmlWorker","HTMLWorker")},e.prototype.formatDocument=function(t,e){return this._worker(function(n){return n.format(t,null,e)})},e.prototype.formatRange=function(t,e,n){return this._worker(function(r){return r.format(t,e,n)})},e.prototype.computeInfo=function(t,e){return this._worker(function(n){return n.computeInfo(t,e)})},e.prototype.findReferences=function(t,e,n){return this._worker(function(r){return r.findReferences(t,e,n)})},e.prototype.getRangesToPosition=function(t,e){return this._worker(function(n){return n.getRangesToPosition(t,e)})},e.prototype.findDeclaration=function(t,e){return this._worker(function(n){return n.findDeclaration(t,e)})},e.prototype.findOccurrences=function(t,e,n){return void 0===n&&(n=!1),this._worker(function(r){return r.findOccurrences(t,e,n)})},e.prototype.suggest=function(t,e){return this._worker(function(n){return n.suggest(t,e)})},e.prototype.findColorDeclarations=function(t){return this._worker(function(e){return e.findColorDeclarations(t)})},e.prototype.getParameterHints=function(t,e){return this._worker(function(n){return n.getParameterHints(t,e)})},e.WORD_DEFINITION=u.createWordRegExp("#-?%"),e.$formatDocument=m.OneWorkerAttr(e,e.prototype.formatDocument),e.$formatRange=m.OneWorkerAttr(e,e.prototype.formatRange),e.$computeInfo=m.OneWorkerAttr(e,e.prototype.computeInfo),e.$findReferences=m.OneWorkerAttr(e,e.prototype.findReferences),e.$getRangesToPosition=m.OneWorkerAttr(e,e.prototype.getRangesToPosition),e.$findDeclaration=m.OneWorkerAttr(e,e.prototype.findDeclaration),e.$findOccurrences=m.OneWorkerAttr(e,e.prototype.findOccurrences),e.$suggest=m.OneWorkerAttr(e,e.prototype.suggest),e.$findColorDeclarations=m.OneWorkerAttr(e,e.prototype.findColorDeclarations),e.$getParameterHints=m.OneWorkerAttr(e,e.prototype.getParameterHints),e=__decorate([__param(1,l.IInstantiationService),__param(2,g.IThreadService),__param(3,d.IModeService)],e)}(u.AbstractMode);e.HTMLMode=y;var E=i.Registry.as(n.Extensions.EditorModes)});var __extends=this&&this.__extends||function(t,e){function n(){this.constructor=t}for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r]);t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)},__decorate=this&&this.__decorate||function(t,e,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(t,e,n,r);switch(arguments.length){case 2:return t.reduceRight(function(t,e){return e&&e(t)||t},e);case 3:return t.reduceRight(function(t,r){return void(r&&r(e,n))},void 0);case 4:return t.reduceRight(function(t,r){return r&&r(e,n,t)||t},r)}},__param=this&&this.__param||function(t,e){return function(n,r){e(n,r,t)}};define("vs/languages/markdown/common/markdown",["require","exports","vs/editor/common/modes/monarch/monarch","vs/editor/common/modes/monarch/monarchCompile","vs/platform/thread/common/threadService","vs/platform/instantiation/common/descriptors","vs/languages/html/common/html","vs/languages/markdown/common/markdownTokenTypes","vs/editor/common/services/modeService","vs/platform/instantiation/common/instantiation","vs/platform/thread/common/thread","vs/editor/common/services/modelService","vs/platform/workspace/common/workspace"],function(t,e,n,r,o,i,a,s,c,u,p,m,d){e.language={displayName:"Markdown",name:"md",defaultToken:"",suggestSupport:{disableAutoTrigger:!0},autoClosingPairs:[],control:/[\\`*_\[\]{}()#+\-\.!]/,noncontrol:/[^\\`*_\[\]{}()#+\-\.!]/,escapes:/\\(?:@control)/,jsescapes:/\\(?:[btnfr\\"']|[0-7][0-7]?|[0-3][0-7]{2})/,empty:["area","base","basefont","br","col","frame","hr","img","input","isindex","link","meta","param"],tokenizer:{root:[[/^(\s*)(#+)((?:[^\\#]|@escapes)+)((?:#+)?)/,["white",s.TOKEN_HEADER_LEAD,s.TOKEN_HEADER,s.TOKEN_HEADER]],[/^\s*(=+|\-+)\s*$/,s.TOKEN_EXT_HEADER],[/^\s*((\*[ ]?)+)\s*$/,s.TOKEN_SEPARATOR],[/^\s*>+/,s.TOKEN_QUOTE],[/^\s*([\*\-+:]|\d+\.)\s/,s.TOKEN_LIST],[/^(\t|[ ]{4})[^ ].*$/,s.TOKEN_BLOCK],[/^\s*~{3}\s*((?:\w|[\/\-])+)?\s*$/,{token:s.TOKEN_BLOCK,next:"@codeblock"}],[/^\s*```\s*((?:\w|[\/\-])+)\s*$/,{token:s.TOKEN_BLOCK,next:"@codeblockgh",nextEmbedded:"$1"}],[/^\s*`{3}\s*$/,{token:s.TOKEN_BLOCK,next:"@codeblock"}],{include:"@linecontent"}],codeblock:[[/^\s*~{3}\s*$/,{token:s.TOKEN_BLOCK,next:"@pop"}],[/^\s*`{3}\s*$/,{token:s.TOKEN_BLOCK,next:"@pop"}],[/.*$/,s.TOKEN_BLOCK_CODE]],codeblockgh:[[/```\s*$/,{token:"@rematch",switchTo:"@codeblockghend",nextEmbedded:"@pop"}],[/[^`]*$/,s.TOKEN_BLOCK_CODE]],codeblockghend:[[/\s*```/,{token:s.TOKEN_BLOCK_CODE,next:"@pop"}],[/./,"@rematch","@pop"]],linecontent:[[/&\w+;/,"string.escape"],[/@escapes/,"escape"],[/\b__([^\\_]|@escapes|_(?!_))+__\b/,"strong"],[/\*\*([^\\*]|@escapes|\*(?!\*))+\*\*/,"strong"],[/\b_[^_]+_\b/,"emphasis"],[/\*([^\\*]|@escapes)+\*/,"emphasis"],[/`([^\\`]|@escapes)+`/,"variable"],[/\{[^}]+\}/,"string.target"],[/(!?\[)((?:[^\]\\]|@escapes)+)(\]\([^\)]+\))/,["string.link","","string.link"]],[/(!?\[)((?:[^\]\\]|@escapes)+)(\])/,"string.link"],{include:"html"}],html:[[/<(\w+)\/>/,a.htmlTokenTypes.getTag("$1")],[/<(\w+)/,{cases:{"@empty":{token:a.htmlTokenTypes.getTag("$1"),next:"@tag.$1"},"@default":{token:a.htmlTokenTypes.getTag("$1"),bracket:"@open",next:"@tag.$1"}}}],[/<\/(\w+)\s*>/,{token:a.htmlTokenTypes.getTag("$1"),bracket:"@close"}],[/<!--/,"comment","@comment"]],comment:[[/[^<\-]+/,"comment.content"],[/-->/,"comment","@pop"],[/<!--/,"comment.content.invalid"],[/[<\-]/,"comment.content"]],tag:[[/[ \t\r\n]+/,"white"],[/(type)(\s*=\s*)(")([^"]+)(")/,[a.htmlTokenTypes.ATTRIB_NAME,a.htmlTokenTypes.DELIM_ASSIGN,a.htmlTokenTypes.ATTRIB_VALUE,{token:a.htmlTokenTypes.ATTRIB_VALUE,switchTo:"@tag.$S2.$4"},a.htmlTokenTypes.ATTRIB_VALUE]],[/(type)(\s*=\s*)(')([^']+)(')/,[a.htmlTokenTypes.ATTRIB_NAME,a.htmlTokenTypes.DELIM_ASSIGN,a.htmlTokenTypes.ATTRIB_VALUE,{token:a.htmlTokenTypes.ATTRIB_VALUE,switchTo:"@tag.$S2.$4"},a.htmlTokenTypes.ATTRIB_VALUE]],[/(\w+)(\s*=\s*)("[^"]*"|'[^']*')/,[a.htmlTokenTypes.ATTRIB_NAME,a.htmlTokenTypes.DELIM_ASSIGN,a.htmlTokenTypes.ATTRIB_VALUE]],[/\w+/,a.htmlTokenTypes.ATTRIB_NAME],[/\/>/,a.htmlTokenTypes.getTag("$S2"),"@pop"],[/>/,{cases:{"$S2==style":{token:a.htmlTokenTypes.getTag("$S2"),switchTo:"@embedded.$S2",nextEmbedded:"text/css"},"$S2==script":{cases:{$S3:{token:a.htmlTokenTypes.getTag("$S2"),switchTo:"@embedded.$S2",nextEmbedded:"$S3"},"@default":{token:a.htmlTokenTypes.getTag("$S2"),switchTo:"@embedded.$S2",nextEmbedded:"text/javascript"}}},"@default":{token:a.htmlTokenTypes.getTag("$S2"),next:"@pop"}}}]],embedded:[[/[^"'<]+/,""],[/<\/(\w+)\s*>/,{cases:{"$1==$S2":{token:"@rematch",next:"@pop",nextEmbedded:"@pop"},"@default":""}}],[/"([^"\\]|\\.)*$/,"string.invalid"],[/'([^'\\]|\\.)*$/,"string.invalid"],[/"/,"string",'@string."'],[/'/,"string","@string.'"],[/</,""]],string:[[/[^\\"']+/,"string"],[/@jsescapes/,"string.escape"],[/\\./,"string.escape.invalid"],[/["']/,{cases:{"$#==$S2":{token:"string",next:"@pop"},"@default":"string"}}]]}};var h=function(t){function n(n,o,i,a,s,c){t.call(this,n,r.compile(e.language),o,i,a,s),this.emitOutputSupport=this;var u=c&&c.getWorkspace();this.baseUrl=u&&u.resource.toString()}return __extends(n,t),n.prototype.getCommentsConfiguration=function(){return{blockCommentStartToken:"<!--",blockCommentEndToken:"-->"}},n.prototype.getEmitOutput=function(t,e){var n=this;return this._worker(function(r){return r.getEmitOutput(t,n.baseUrl,e)})},n.prototype._getWorkerDescriptor=function(){return i.createAsyncDescriptor2("vs/languages/markdown/common/markdownWorker","MarkdownWorker")},n.$getEmitOutput=o.OneWorkerAttr(n,n.prototype.getEmitOutput),n=__decorate([__param(1,u.IInstantiationService),__param(2,p.IThreadService),__param(3,c.IModeService),__param(4,m.IModelService),__param(5,d.IWorkspaceContextService)],n)}(n.MonarchMode);e.MarkdownMode=h});