/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/razor/common/razorTokenTypes",["require","exports"],function(t,e){e.EMBED_CS="support.function.cshtml"});var __extends=this&&this.__extends||function(t,e){function n(){this.constructor=t}for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r]);t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)};define("vs/languages/razor/common/csharpTokenization",["require","exports","vs/base/common/objects","vs/editor/common/modes","vs/languages/html/common/html","vs/languages/vsxml/common/vsxml","vs/editor/common/modes/abstractState","vs/editor/common/modes/abstractMode","vs/languages/razor/common/razorTokenTypes"],function(t,e,n,r,s,i,o,a,c){var p=s.htmlTokenTypes,h="+-*%&|^~!=<>/?;:.,",u="+-*/%&|^~!=<>(){}[]\"'\\/?;:.,",l="	 ",f=function(){for(var t=[{tokenType:"punctuation.bracket.cs",open:"{",close:"}",isElectric:!0},{tokenType:"punctuation.array.cs",open:"[",close:"]",isElectric:!0},{tokenType:"punctuation.parenthesis.cs",open:"(",close:")",isElectric:!0},{tokenType:"punctuation.angle.cs",open:"<",close:">",isElectric:!1}],e=Object.create(null),n=0;n<t.length;n++){var s=t[n];e[s.open]={tokenType:s.tokenType,bracketType:r.Bracket.Open},e[s.close]={tokenType:s.tokenType,bracketType:r.Bracket.Close}}return{stringIsBracket:function(t){return!!e[t]},tokenTypeFromString:function(t){return e[t].tokenType},bracketTypeFromString:function(t){return e[t].bracketType}}}(),d=n.createKeywordMatcher(["abstract","as","async","await","base","bool","break","by","byte","case","catch","char","checked","class","const","continue","decimal","default","delegate","do","double","descending","explicit","event","extern","else","enum","false","finally","fixed","float","for","foreach","from","goto","group","if","implicit","in","int","interface","internal","into","is","lock","long","new","null","namespace","object","operator","out","override","orderby","params","private","protected","public","readonly","ref","return","switch","struct","sbyte","sealed","short","sizeof","stackalloc","static","string","select","this","throw","true","try","typeof","uint","ulong","unchecked","unsafe","ushort","using","var","virtual","volatile","void","while","where","yield","model","inject"]),g=function(t){return h.indexOf(t)>-1},m=function(t){function e(e,n,r){t.call(this,e),this.name=n,this.parent=r}return __extends(e,t),e.prototype.equals=function(n){if(!t.prototype.equals.call(this,n))return!1;var r=n;return n instanceof e&&this.getMode()===r.getMode()&&this.name===r.name&&(null===this.parent&&null===r.parent||null!==this.parent&&this.parent.equals(r.parent))},e.prototype.tokenize=function(t){return t.setTokenRules(u,l),t.skipWhitespace().length>0?{type:""}:this.stateTokenize(t)},e.prototype.stateTokenize=function(t){throw new Error("To be implemented")},e}(o.AbstractState);e.CSState=m;var y=function(t){function e(e,n,r){t.call(this,e,"string",n),this.isAtBeginning=!0,this.punctuation=r}return __extends(e,t),e.prototype.makeClone=function(){return new e(this.getMode(),this.parent?this.parent.clone():null,this.punctuation)},e.prototype.equals=function(e){return t.prototype.equals.call(this,e)&&this.punctuation===e.punctuation},e.prototype.tokenize=function(t){var e=this.isAtBeginning?1:0;for(this.isAtBeginning=!1;!t.eos();){var n=t.next();if("\\"===n)return 0===e?t.eos()?{type:"string.escape.cs"}:(t.next(),t.eos()?{type:"string.escape.cs",nextState:this.parent}:{type:"string.escape.cs"}):(t.goBack(1),{type:"string.cs"});if(n===this.punctuation)break;e+=1}return{type:"string.cs",nextState:this.parent}},e}(m),k=function(t){function e(e,n){t.call(this,e,"verbatimstring",n)}return __extends(e,t),e.prototype.makeClone=function(){return new e(this.getMode(),this.parent?this.parent.clone():null)},e.prototype.tokenize=function(t){for(;!t.eos();){var e=t.next();if('"'===e){if(t.eos()||'"'!==t.peek())return{type:"string.cs",nextState:this.parent};t.next()}}return{type:"string.cs"}},e}(m),v=function(t){function e(e,n,r){t.call(this,e,"number",n),this.firstDigit=r}return __extends(e,t),e.prototype.makeClone=function(){return new e(this.getMode(),this.parent?this.parent.clone():null,this.firstDigit)},e.prototype.tokenize=function(t){var e=this.firstDigit,n=10,r=!1,s=!1;if("0"===e&&!t.eos()){if(e=t.peek(),"x"===e)n=16;else{if("."!==e)return{type:"number.cs",nextState:this.parent};n=10}t.next()}for(;!t.eos();)if(e=t.peek(),a.isDigit(e,n))t.next();else{if(10!==n)break;if("."!==e||s||r){if("e"!==e.toLowerCase()||s){if("f"===e.toLowerCase()||"d"===e.toLowerCase()){t.next();break}break}s=!0,t.next(),t.eos()||"-"!==t.peek()||t.next()}else r=!0,t.next()}var i="number";return 16===n&&(i+=".hex"),{type:i+".cs",nextState:this.parent}},e}(m),S=function(t){function e(e,n,r){t.call(this,e,"comment",n),this.commentChar=r}return __extends(e,t),e.prototype.makeClone=function(){return new e(this.getMode(),this.parent?this.parent.clone():null,this.commentChar)},e.prototype.tokenize=function(t){for(;!t.eos();){var e=t.next();if("*"===e&&!t.eos()&&!t.peekWhitespace()&&t.peek()===this.commentChar)return t.next(),{type:"comment.cs",nextState:this.parent}}return{type:"comment.cs"}},e}(m);e.CSComment=S;var x=function(t){function e(e,n,r,s,o,a,c,p){t.call(this,e,"expression",n),this.level=r,this.plevel=s,this.razorMode=o,this.expression=a,this.vsState=new i.VSXMLExpression(e,null),this.firstToken=c,this.firstTokenWasKeyword=p}return __extends(e,t),e.prototype.setVSXMLState=function(t){this.vsState=t},e.prototype.makeClone=function(){var t=new e(this.getMode(),this.parent?this.parent.clone():null,this.level,this.plevel,this.razorMode,this.expression,this.firstToken,this.firstTokenWasKeyword);return null!==this.vsState&&t.setVSXMLState(this.vsState.clone()),t},e.prototype.equals=function(n){return t.prototype.equals.call(this,n)&&n instanceof e&&(null===this.vsState&&null===n.vsState||null!==this.vsState&&this.vsState.equals(n.vsState))},e.prototype.stateTokenize=function(t){if(a.isDigit(t.peek(),10))return this.firstToken=!1,{nextState:new v(this.getMode(),this,t.next())};var e=t.nextToken(),n=!this.firstTokenWasKeyword,r=this.level<=0&&this.plevel<=0&&t.eos()?this.parent:void 0;if(t.eos()&&(this.firstTokenWasKeyword=!1),d(e))return this.level<=0&&(this.expression=!1),this.firstToken&&(this.firstTokenWasKeyword=!0),{type:"keyword.cs"};if(this.firstToken=!1,this.razorMode&&"<"===e&&n&&!t.eos()&&/[_:!\/\w]/.test(t.peek()))return{nextState:new b(this.getMode(),this,s.States.Content)};if(this.razorMode&&this.expression&&this.level<=0&&this.plevel<=0&&!t.eos()&&(/^(\.|\[|\(|\{\w+)$/.test(t.peekToken())||(r=this.parent)),"/"===e){if(!t.eos()&&!t.peekWhitespace())switch(t.peekToken()){case"/":if(t.nextToken(),!t.eos()&&"/"===t.peekToken()){if(t.nextToken(),t.eos())return{type:"comment.vs"};if("/"!==t.peekToken())return{type:"comment.vs",nextState:new i.VSXMLEmbeddedState(this.getMode(),this.vsState,this)}}return t.advanceToEOS(),{type:"comment.cs"};case"*":return t.nextToken(),{nextState:new S(this.getMode(),this,"/")}}return{type:"punctuation.cs",nextState:r}}if("@"===e&&!t.eos())switch(t.peekToken()){case'"':return t.nextToken(),{nextState:new k(this.getMode(),this)};case"*":return t.nextToken(),{nextState:new S(this.getMode(),this,"@")}}if(/@?\w+/.test(e))return{type:"ident.cs",nextState:r};if('"'===e||"'"===e)return{nextState:new y(this.getMode(),this,e)};if(f.stringIsBracket(e)){var o={bracket:f.bracketTypeFromString(e),type:f.tokenTypeFromString(e),nextState:r};return this.razorMode&&("{"===e&&(this.expression=!1,this.level++,1===this.level&&(o.type=c.EMBED_CS,o.nextState=void 0)),"}"===e&&(this.level--,this.level<=0&&(o.type=c.EMBED_CS,o.nextState=this.parent)),this.expression&&("("===e&&(this.plevel++,1===this.plevel&&(o.type=c.EMBED_CS,o.nextState=void 0)),")"===e&&(this.plevel--,this.expression&&this.plevel<=0&&(o.type=c.EMBED_CS,o.nextState=this.parent)),"["===e&&(this.plevel++,o.nextState=void 0),"]"===e&&this.plevel--)),o}return g(e)?{type:"punctuation.cs",nextState:r}:this.razorMode&&this.expression&&this.plevel<=0?{type:"",nextState:this.parent}:{type:"",nextState:r}},e}(m);e.CSStatement=x;var T=["area","base","basefont","br","col","frame","hr","img","input","isindex","link","meta","param"],b=function(t){function e(e,n,r){t.call(this,e,"number",n),this.state=r}return __extends(e,t),e.prototype.makeClone=function(){return new e(this.getMode(),this.parent?this.parent.clone():null,this.state)},e.prototype.nextName=function(t){return t.advanceIfRegExp(/^[_:\w][_:\w-.\d]*/)},e.prototype.nextAttrValue=function(t){return t.advanceIfRegExp(/^('|').*?\1/)},e.prototype.tokenize=function(t){switch(this.state){case s.States.WithinComment:if(t.advanceUntil("-->",!1).length>0)return{type:p.COMMENT};if(t.advanceIfString("-->").length>0)return this.state=s.States.Content,{type:p.DELIM_COMMENT,bracket:r.Bracket.Close,nextState:this.parent};break;case s.States.WithinDoctype:if(t.advanceUntil(">",!1).length>0)return{type:p.DOCTYPE};if(t.advanceIfString(">").length>0)return this.state=s.States.Content,{type:p.DELIM_DOCTYPE,bracket:r.Bracket.Close,nextState:this.parent};break;case s.States.Content:return t.advanceIfString("!--").length>0?(this.state=s.States.WithinComment,{type:p.DELIM_COMMENT,bracket:r.Bracket.Open}):t.advanceIfRegExp(/!DOCTYPE/i).length>0?(this.state=s.States.WithinDoctype,{type:p.DELIM_DOCTYPE,bracket:r.Bracket.Open}):t.advanceIfString("/").length>0?(this.state=s.States.OpeningEndTag,{type:p.DELIM_END,bracket:r.Bracket.Open}):(this.state=s.States.OpeningStartTag,{type:p.DELIM_START,bracket:r.Bracket.Open});case s.States.OpeningEndTag:var e=this.nextName(t);return e.length>0?{type:p.getTag(e),bracket:-1!==T.indexOf(e)?-1:r.Bracket.Close}:t.advanceIfString(">").length>0?(this.state=s.States.Content,{type:p.DELIM_END,bracket:r.Bracket.Close,nextState:this.parent}):(t.advanceUntil(">",!1),{type:""});case s.States.OpeningStartTag:var e=this.nextName(t);if(e.length>0)return this.state=s.States.WithinTag,{type:p.getTag(e),bracket:-1!==T.indexOf(e)?-1:r.Bracket.Open};break;case s.States.WithinTag:if(t.skipWhitespace().length>0)return{type:""};var n=this.nextName(t);return n.length>0?(this.state=s.States.AttributeName,{type:p.ATTRIB_NAME}):t.advanceIfRegExp(/^\/?>/).length>0?(this.state=s.States.Content,{type:p.DELIM_START,bracket:r.Bracket.Close,nextState:this.parent}):(t.next(),{type:""});case s.States.AttributeName:return t.skipWhitespace().length>0||t.eos()?{type:""}:"="===t.peek()?(t.next(),this.state=s.States.AttributeValue,{type:""}):(this.state=s.States.WithinTag,this.tokenize(t));case s.States.AttributeValue:if(t.skipWhitespace().length>0||t.eos())return{type:""};var i=this.nextAttrValue(t);return i.length>0?(this.state=s.States.WithinTag,{type:p.ATTRIB_VALUE}):(this.state=s.States.WithinTag,this.tokenize(t))}return t.next(),this.state=s.States.Content,{type:"",nextState:this.parent}},e}(m)});var __extends=this&&this.__extends||function(t,e){function n(){this.constructor=t}for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r]);t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)},__decorate=this&&this.__decorate||function(t,e,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(t,e,n,r);switch(arguments.length){case 2:return t.reduceRight(function(t,e){return e&&e(t)||t},e);case 3:return t.reduceRight(function(t,r){return void(r&&r(e,n))},void 0);case 4:return t.reduceRight(function(t,r){return r&&r(e,n,t)||t},r)}},__param=this&&this.__param||function(t,e){return function(n,r){e(n,r,t)}};define("vs/languages/razor/common/razor",["require","exports","vs/languages/html/common/html","vs/languages/razor/common/csharpTokenization","vs/editor/common/modes/abstractMode","vs/platform/instantiation/common/descriptors","vs/editor/common/modes/supports/onEnter","vs/languages/razor/common/razorTokenTypes","vs/platform/instantiation/common/instantiation","vs/platform/thread/common/thread","vs/editor/common/services/modeService"],function(t,e,n,r,s,i,o,a,c,p,h){var u=function(t){function e(e,n,r,s,i,o,a){t.call(this,e,n,r,s,i,o,a)}return __extends(e,t),e.prototype.makeClone=function(){return new e(this.getMode(),this.kind,this.lastTagName,this.lastAttributeName,this.embeddedContentType,this.attributeValueQuote,this.attributeValue)},e.prototype.equals=function(n){return n instanceof e?t.prototype.equals.call(this,n):!1},e.prototype.tokenize=function(e){if(!e.eos()&&"@"===e.peek()){if(e.next(),!e.eos()&&"*"===e.peek())return{nextState:new r.CSComment(this.getMode(),this,"@")};if(e.eos()||"@"!==e.peek())return{type:a.EMBED_CS,nextState:new r.CSStatement(this.getMode(),this,0,0,!0,!0,!0,!1)}}return t.prototype.tokenize.call(this,e)},e}(n.State),l=function(t){function e(e,n,r,s){t.call(this,e,n,r,s),this.formattingSupport=null,this.onEnterSupport=new o.OnEnterSupport(this.getId(),{brackets:[{open:"<!--",close:"-->"},{open:"{",close:"}"},{open:"(",close:")"}]})}return __extends(e,t),e.prototype._getWorkerDescriptor=function(){return i.createAsyncDescriptor2("vs/languages/razor/common/razorWorker","RAZORWorker")},e.prototype.getInitialState=function(){return new u(this,n.States.Content,"","","","","")},e.prototype.getWordDefinition=function(){return e.WORD_DEFINITION},e.prototype.getLeavingNestedModeData=function(e,r){var s=t.prototype.getLeavingNestedModeData.call(this,e,r);return s&&(s.stateAfterNestedMode=new u(this,n.States.Content,"","","","","")),s},e.WORD_DEFINITION=s.createWordRegExp("#?%"),e=__decorate([__param(1,c.IInstantiationService),__param(2,p.IThreadService),__param(3,h.IModeService)],e)}(n.HTMLMode);e.RAZORMode=l});