/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/typescript/common/typescript",["require","exports","vs/base/common/winjs.base","vs/platform/platform","vs/base/common/uri"],function(e,t,r,n,i){function o(e){return"string"==typeof e?0===e.indexOf("ts://defaultlib"):"ts"===e.scheme&&"defaultlib"===e.authority}!function(e){e[e.Changed=0]="Changed",e[e.Added=1]="Added",e[e.Removed=2]="Removed"}(t.ChangeKind||(t.ChangeKind={}));var s=t.ChangeKind;t.defaultLib=i["default"].create("ts","defaultlib","/vs/text!vs/languages/typescript/common/lib/lib.d.ts"),t.defaultLibES6=i["default"].create("ts","defaultlib","/vs/text!vs/languages/typescript/common/lib/lib.es6.d.ts"),t.isDefaultLib=o,t.virtualProjectResource=i["default"].create("ts","projects","/virtual/1");var c=function(){function e(){this._needsProjectUpdate=!1,this._fileChanges=[],this._projectChange={kind:s.Changed,resource:t.virtualProjectResource,files:[],options:void 0}}return e.prototype.setConsumer=function(e){this._consumer=e},e.prototype.resolveProjects=function(){var e=[];return this._fileChanges.length&&(e.push(this._consumer.acceptFileChanges(this._fileChanges.slice(0))),this._fileChanges.length=0),this._needsProjectUpdate&&(e.push(this._consumer.acceptProjectChanges([this._projectChange])),this._needsProjectUpdate=!1),r.Promise.join(e)},e.prototype.resolveFiles=function(){},e.prototype.addExtraLib=function(e,t){var r=t?i["default"].file(t):i["default"].create("extralib",void 0,Date.now().toString());this._needsProjectUpdate=!0,this._projectChange.files.push(r),this._fileChanges.push({kind:s.Added,resource:r,content:e})},e.prototype.setCompilerOptions=function(e){this._needsProjectUpdate=!0,this._projectChange.options=e},e}();t.DefaultProjectResolver=c;var a;!function(e){function t(t,r){e.ProjectResolver.addExtraLib(t,r)}function r(t){e.ProjectResolver.setCompilerOptions(t)}e.ProjectResolver=new c,e.addExtraLib=t,e.setCompilerOptions=r}(a=t.Defaults||(t.Defaults={}));var u;!function(e){function t(e){i=e}function r(){return i}e.Identifier="typescript",n.Registry.add(e.Identifier,e);var i;e.setProjectResolver=t,e.getProjectResolver=r}(u=t.Extensions||(t.Extensions={}))});var __extends=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)};define("vs/languages/typescript.workbench/common/projectResolver",["require","exports","vs/base/common/glob","vs/nls!vs/languages/typescript.workbench/common/projectResolver","vs/base/common/objects","vs/languages/typescript/common/typescript","vs/base/common/lifecycle","vs/base/common/errors","vs/base/common/collections","vs/base/common/async","vs/base/common/winjs.base","vs/base/common/severity","vs/base/common/uri","vs/base/common/paths","vs/languages/typescript/common/lib/typescriptServices","vs/platform/files/common/files","vs/platform/search/common/search"],function(e,t,r,n,i,o,s,c,a,u,l,h,d,f,p,v,g){var m,_=function(){function e(e,t,r){if(this._baseDir=e,this._baseDir=f.normalize(this._baseDir,!0),Array.isArray(t)){this._includes=[];for(var n=0;n<t.length;n++){var i=t[n];this._includes.push(f.normalize(f.join(this._baseDir,i),!0))}}if(Array.isArray(r)){this._excludes=[];for(var o=0;o<r.length;o++){var i=r[o];this._excludes.push(f.normalize(f.join(this._baseDir,i),!0))}}}return e.prototype.handleChange=function(t){for(var r=0,n=e._ignores;r<n.length;r++){var i=n[r];if(-1!==t.fsPath.indexOf(i))return!1}return this._baseDir&&0!==t.fsPath.indexOf(this._baseDir)?!1:this._includes&&this._includes.indexOf(t.fsPath)<0?!1:this._excludes&&this._excludes.some(function(e){return 0===t.fsPath.indexOf(e)})?!1:!0},e._ignores=[f.normalize("/node_modules/",!0),f.normalize("/.git/",!0),f.normalize("/bower_components/",!0),f.normalize("/tmp/",!0),f.normalize("/temp/",!0)],e}(),j=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.handleChange=function(t){return/\.d\.ts$/.test(t.fsPath)&&e.prototype.handleChange.call(this,t)},t}(_),y=function(){function e(e,t,r){this._fileChangeEvents=[],this._projectFileEventListener=Object.create(null),this._projectPromises=Object.create(null),this._pendingFiles=Object.create(null),this._fileService=e.fileService,this._searchService=e.searchService,this._eventService=e.eventService,this._markerService=e.markerService,this._messageService=e.messageService,this._modelService=e.modelService,this._telemetryService=e.telemetryService,this._workspace=e.contextService.getWorkspace()&&e.contextService.getWorkspace().resource,this._consumer=r,this._configuration=t,this._fileChangesHandler=new u.RunOnceScheduler(this._processFileChangesEvents.bind(this),1500),this._unbindListener=this._eventService.addListener(v.EventType.FILE_CHANGES,this._onFileChangesEvent.bind(this))}return e.prototype.dispose=function(){s.cAll(this._unbindListener)},e.prototype.setConsumer=function(e){this._consumer=e},e.prototype.resolveProjects=function(){var e=this;if(this._workspace){var t=this._resolve;return t||(t=this._resolve=this._doResolve(),u.always(this._resolve,function(){return e._resolve=null})),new u.ShallowCancelThenPromise(t)}},e.prototype.resolveFiles=function(e){var t=this;if(e=e.filter(function(e){return"file"===e.scheme}),e.length){var r=this._messageService.setStatusMessage(n.localize(0,null),void 0,250),i=this._fileService.resolveContents(e).then(function(e){var r=e.map(function(e){return{kind:o.ChangeKind.Added,content:e.value,resource:e.resource}});return t._consumer.acceptFileChanges(r).then(void 0,function(e){return t._messageService.show(h["default"].Warning,e)})});return u.always(i,function(){return r.dispose()})}},e.prototype._doResolve=function(){var e=this,t={start:Date.now(),d:0,projects:0,files:0},r=this.projectDiscovery().then(function(t){var r=[];for(var n in e._projectPromises)r.push(e._projectPromises[n]),delete e._projectPromises[n];return l.TPromise.join(r)}).then(function(r){return t.projects=r.length,r.length?e._consumer.acceptProjectChanges(r).then(function(t){e._projectsIndex=t[0]}):void 0}).then(function(r){var n=[],s=[],c=i.clone(e._pendingFiles);for(var a in e._pendingFiles){var u=e._pendingFiles[a].kind,l=e._pendingFiles[a].resource;e._pendingFiles[a].kind===o.ChangeKind.Removed?s.push({kind:u,resource:l,content:void 0}):(n.push(l),t.files+=1),delete e._pendingFiles[a]}return n.length?e._fileService.resolveContents(n).then(function(t){return t.forEach(function(e){s.push({resource:e.resource,content:e.value,kind:c[e.resource.toString()].kind}),delete c[e.resource.toString()]}),e._consumer.acceptFileChanges(s).then(void 0,function(t){return e._messageService.show(h["default"].Warning,t)})}):s.length?e._consumer.acceptFileChanges(s).then(void 0,function(t){return e._messageService.show(h["default"].Warning,t)}):void 0}).then(function(e){t.d=Date.now()-t.start});return r},e.prototype.projectDiscovery=function(){var e=this;return this._projectDiscovery||(this._projectDiscovery=this._searchResources(this._configuration.projects).then(function(t){e._resolveProject(o.virtualProjectResource,o.ChangeKind.Added);for(var r=0,n=t.resources;r<n.length;r++){var i=n[r];e._resolveProject(i,o.ChangeKind.Added)}}),this._projectDiscovery.done(void 0,function(t){e._projectDiscovery=null,console.error(t)})),this._projectDiscovery},e.prototype._searchResources=function(e,t,r,n){void 0===t&&(t=1500),void 0===r&&(r=this._workspace);var i={};i[e]=!0;var o=Object.create(null);if(o["{**/node_modules/**,**/.git/**,**/bower_components/**,**/tmp/**,**/temp**}"]=!0,Array.isArray(n))for(var s=0;s<n.length;s++){var c=n[s];o["/"+c+"/**"]=!0}return this._searchService.search({rootResources:[r],type:g.QueryType.File,maxResults:t,includePattern:i,excludePattern:o}).then(function(e){return{resources:e.results.map(function(e){return e.resource}),limitReached:e.limitHit}})},e.prototype._resolveProject=function(e,t){var r=f.dirname(e.fsPath),n=this._doResolveProject(e,t);this._projectPromises[r]=this._projectPromises[r]&&this._projectPromises[r].then(function(e){return n},function(e){return n})||n,n.done(void 0,function(r){c.isPromiseCanceledError(r)||console.error(e.toString(),t,r)})},e.prototype._doResolveProject=function(e,t){return e.toString()===o.virtualProjectResource.toString()?this._doResolveVirtualProject(t):this._doResolveProjectFile(e,t)},e.prototype._doResolveProjectFile=function(e,t){var r=this;if(this._markerService.remove("ts.projectResolver",[e]),t===o.ChangeKind.Removed)return delete this._projectFileEventListener[e.toString()],l.TPromise.as({kind:t,resource:e,files:void 0,options:void 0});var n={kind:t,resource:e,files:[],options:p.getDefaultCompilerOptions()},i=!1;return this._fileService.resolveContent(e).then(function(t){var o=p.parseConfigFileText(e.fsPath,t.value),s=f.dirname(e.fsPath);if(o.error)return r._markerService.changeOne("ts.projectResolver",e,[{message:o.error.messageText.toString(),code:o.error.code.toString(),severity:h["default"].Error,startLineNumber:1,startColumn:1,endLineNumber:1,endColumn:1}]),l.TPromise.wrapError(c.canceled());if(n.options=p.parseConfigFile(o.config,{readDirectory:function(){return[]}},s).options,r._projectFileEventListener[e.toString()]=new _(s,o.config.files,o.config.exclude),!Array.isArray(o.config.files))return r._searchResources(r._configuration.files,r._configuration.maxFilesPerProject,d["default"].file(s),o.config.exclude).then(function(e){i=e.limitReached,n.files=e.resources});var a=o.config.files.map(function(e){return f.join(s,e)}).map(function(e){return d["default"].file(e)});n.files=a,n.files.length>r._configuration.maxFilesPerProject&&(n.files.length=r._configuration.maxFilesPerProject,i=!0)}).then(function(e){return t===o.ChangeKind.Added&&(n.files.forEach(function(e){return r._pendingFiles[e.toString()]={resource:e,kind:t}}),r._telemetryService.publicLog("js.project",{compilerOptions:n.options,fileCount:n.files.length})),i&&r._telemetryService.publicLog("js.project.fileLimitReached",{maxFilesPerProject:r._configuration.maxFilesPerProject}),n})},e.prototype._doResolveVirtualProject=function(e){var t=this;return this._projectFileEventListener[o.virtualProjectResource.toString()]=new j(void 0,void 0,void 0),this._searchService.search({rootResources:[this._workspace],type:g.QueryType.File,maxResults:50,includePattern:{"**/*.d.ts":!0},excludePattern:{"{**/lib*.d.ts,**/node_modules/**,**/.git/**,**/bower_components/**,**/tmp/**,**/temp/**}":!0}}).then(function(r){for(var n=[],i=0,s=r.results;i<s.length;i++){var c=s[i];n.push(c.resource),t._pendingFiles[c.resource.toString()]={resource:c.resource,kind:e}}return{files:n,resource:o.virtualProjectResource,kind:o.ChangeKind.Changed,options:void 0}})},e.prototype._onFileChangesEvent=function(e){(t=this._fileChangeEvents).push.apply(t,e.changes),this._fileChangesHandler.schedule();var t},e.prototype._processFileChangesEvents=function(){var t=this,r=Object.create(null),n=this._fileChangeEvents.slice(0);this._fileChangeEvents.length=0;var i=!1;n.forEach(function(n){var s;if(m.match(t._configuration.projects,n.resource.fsPath))s=e._asChangeKind(n.type),a.lookupOrInsert(r,n.resource.toString(),[]).push(s),i=!0;else if(m.match(t._configuration.files,n.resource.fsPath)){if(s=e._asChangeKind(n.type),s===o.ChangeKind.Changed&&t._modelService.getModel(n.resource))return;a.forEach(t._projectFileEventListener,function(e){e.value.handleChange(n.resource)&&(t._pendingFiles[n.resource.toString()]={kind:s,resource:n.resource},i=!0,(s===o.ChangeKind.Added||s===o.ChangeKind.Removed)&&a.lookupOrInsert(r,e.key,[]).push(o.ChangeKind.Changed))})}});for(var s in r)for(var c=r[s],u=void 0,l=0;l<c.length;l++){var h=c[l];h!==u&&(u=h,this._resolveProject(d["default"].parse(s),h))}i&&this.resolveProjects()},e._lookUpProjects=function(e,t){for(var r,n=f.dirnames(e.fsPath),i=n.next();!i.done;){var o=t[i.value];o&&(r||(r=[]),r.push(o)),i=n.next()}return r},e._asChangeKind=function(e){switch(e){case v.FileChangeType.UPDATED:return o.ChangeKind.Changed;case v.FileChangeType.ADDED:return o.ChangeKind.Added;case v.FileChangeType.DELETED:return o.ChangeKind.Removed}throw new Error("unknown change type")},e}();return function(e){function t(e,t){if("{"===e[0]&&"}"===e[e.length-1]){var r=e.substr(1,e.length-2).split(",");return r.some(function(e){return n(e,t)})}return n(e,t)}function n(e,t){var n=-1;if(0===e.indexOf(i)?n=i.length:0===e.indexOf(o)&&(n=o.length),-1===n)return r.match(e,t);var s=e.substring(n);return-1!==s.indexOf("*")?r.match(e,t):(n=t.indexOf(s),-1===n?!1:n+s.length===t.length)}var i="**/*.",o="**/";e.match=t}(m||(m={})),y});