/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/languages/typescript/common/js/importAndExportRewriter",["require","exports","vs/base/common/strings","vs/base/common/paths","vs/languages/typescript/common/js/rewriting","vs/languages/typescript/common/lib/typescriptServices","vs/base/common/collections"],function(e,t,n,r,i,s,o){var a=function(){function e(e,t){this.offset=e,this.length=t}return e}();t.Node=a;var c=function(e){function t(){e.apply(this,arguments),this.items=[]}return __extends(t,e),t}(a);t.List=c;var l=function(e){function t(t,n,r){e.call(this,t,n),this.scope=r,this.requireStatements=[],this.exportsDotExpressions=[]}return __extends(t,e),t}(a);t.DefineNode=l;var p=function(e){function t(t,n,r){e.call(this,t,n),this.name=r}return __extends(t,e),t}(a);t.CallbackParameter=p;var h=function(e){function t(t,n,i){e.call(this,t,n),this._path=i;var s,o=/('|")(.+)\1/.exec(this._path);o&&(s=r.extname(o[2]))&&(this._path=""+o[1]+o[2].substring(0,o[2].length-s.length)+o[1])}return __extends(t,e),Object.defineProperty(t.prototype,"path",{get:function(){return this._path},enumerable:!0,configurable:!0}),t}(a);t.DependencyNode=h;var u=function(e){function t(t,n,r,i){e.call(this,t,n,i),this.name=r}return __extends(t,e),t}(h);t.RequireStatement=u;var f=function(e){function t(t,n,r,i){e.call(this,t,n),this.name=r,this.node=i}return __extends(t,e),t}(a);t.ExportsExpression=f;var d=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),t}(a);t.GlobalExportsExpression=d;var _=function(e){function t(t){e.call(this,0,0),this.name=t}return __extends(t,e),t}(a);t.NamedExportExpresson=_;var m=function(){function e(){}return Object.defineProperty(e.prototype,"name",{get:function(){return"rewriter.importsAndExports"},enumerable:!0,configurable:!0}),e.prototype.computeEdits=function(e){e.newInsert("declare var exports:any; declare var module:any; declare var require:any;\n"),this._context=e,this._currentScopeId=0,this._currentNode=null,this._bucket=[],this._variableNames=new g,this._visitNode(this._context.sourceFile);for(var t=!1,n=[],r=0,s=this._bucket.length;s>r;r++){var o=this._bucket[r];if(o instanceof l&&!t&&0===o.scope)this._translateDefineNode(o),t=!0;else if(o instanceof d)this._translateGlobalExportsExpression(o);else if(o instanceof f){var a=i.encodeVariableName(o.node);this._context.newReplace(o.node.getStart(),o.node.getWidth(),"var "+a),n.push(a+" as "+o.name)}else o instanceof _?n.push(o.name):o instanceof u&&this._translateRequireStatement(o)}n.length&&this._context.newAppend("\nexport {"+n.join(", ")+"}")},Object.defineProperty(e.prototype,"nodes",{get:function(){return this._bucket},enumerable:!0,configurable:!0}),e.prototype._untilParent=function(e,t){for(var n=e.parent;n&&n.kind!==t;)n=n.parent;return n},e.prototype._store=function(e){this._currentNode?e instanceof u?this._currentNode.requireStatements.push(e):e instanceof f&&this._currentNode.exportsDotExpressions.push(e):this._bucket.push(e)},e.prototype.visitBinaryExpression=function(e){var t;if(53===e.operatorToken.kind&&185===e.parent.kind){var n,r;if(x.isIdentifier(e.left,"exports"))n=e.left.getStart(),r=e.left.getEnd(),t=new d(n,r-n);else if(158===e.left.kind){var i=e.left,o=i.name.text;if(65===i.expression.kind){var a=s.getTextOfNode(i.expression);"exports"===a?t=new f(i.getStart(),i.getWidth(),o,e.left):"module"===a&&"exports"===o&&(t=new d(i.getStart(),i.getWidth()))}else if(158===i.expression.kind){var c=i.expression;x.isIdentifier(c.expression,"module")&&x.isIdentifier(c.name,"exports")&&(t=new f(i.getStart(),i.getWidth(),o,e.left))}}t&&s.getContainingFunction(e)&&!x.getContainingAmdDefineCall(e)&&(t instanceof f?t=new _(t.name):t instanceof d&&(t=void 0))}t?this._store(t):this._visitNode(e)},e.prototype.visitCallExpression=function(t){var n;return x.isIdentifier(t.expression,e._Define)&&(this._currentNode=new l(s.getTokenPosOfNode(t),t.getWidth(),this._currentScopeId),n=t.arguments,x.isPath(n,157)?this._currentNode.objectLiteral=new a(s.getTokenPosOfNode(n[0]),n[0].getWidth()):x.isPath(n,165)?this._fillInParametersAndBody(n[0],this._currentNode):x.isPath(n,156,165)?(this._fillInDependencies(n[0],this._currentNode),this._fillInParametersAndBody(n[1],this._currentNode)):x.isPath(n,8,156,165)?(this._currentNode.identifier=n[0].text,this._fillInDependencies(n[1],this._currentNode),this._fillInParametersAndBody(n[2],this._currentNode)):this._currentNode=null,this._currentNode)?(this._bucket.push(this._currentNode),this._visitNode(t),void(this._currentNode=null)):void this._visitNode(t)},e.prototype._fillInDependencies=function(e,t){t.dependencyArray=new c(s.getTokenPosOfNode(e),e.getWidth());for(var n=0,r=e.elements.length;r>n;n++){var i=e.elements[n];t.dependencyArray.items.push(new h(s.getTokenPosOfNode(i),i.getWidth(),s.getTextOfNode(i)))}},e.prototype._fillInParametersAndBody=function(e,t){var n,r;n=e.parameters.pos,r=e.parameters.end,t.callbackParameters=new c(n,r-n);for(var i=e.parameters,o=0,l=i.length;l>o;o++){var h=i[o];t.callbackParameters.items.push(new p(s.getTokenPosOfNode(h),h.getWidth(),s.getTextOfNode(h)))}n=e.body.getStart()+1,r=e.body.getEnd()-1,t.callbackBody=new a(n,r-n)},e.prototype._visitNode=function(e){var t=this;s.forEachChild(e,function(e){switch(e.kind){case 172:t.visitBinaryExpression(e);break;case 160:t.visitCallExpression(e);break;case 203:case 165:case 166:t._currentScopeId+=1,t._visitNode(e),t._currentScopeId-=1;break;default:t._visitNode(e)}})},e.prototype._translateRequireStatement=function(e){var t=this._variableNames.next(e.name||e.path);this._context.newInsert(n.format("import {0} = require({1});\n",t,e.path)),this._context.newReplace(e.offset,e.length,t)},e.prototype._translateGlobalExportsExpression=function(e){var t=this._variableNames.next();this._context.newReplace(e.offset,e.length,n.format("var {0}",t)),this._context.newAppend(n.format("\nexport = {0};",t))},e.prototype._translateNamedExportExpresson=function(e){this._context.newAppend("export var "+e.name+":any;\n")},e.prototype._translateDefineNode=function(t){if(t.objectLiteral)this._context.newInsert(e._DeclareWithLiteral);else{for(var r,i,s=[],r=0,i=t.requireStatements.length;i>r;r++){var o=t.requireStatements[r],a=this._variableNames.next(),c=this._variableNames.next();this._context.newInsert(n.format("import {0} = require({1});\n",a,o.path)),this._context.newReplace(o.offset,o.length,c),s.push(n.format("{0}:typeof {1}",c,a))}s.length>0&&this._context.newInsert(t.callbackParameters.offset+t.callbackParameters.length,n.format("{0}{1}",t.callbackParameters.items.length>0?",":"",s.join(",")));for(var l=[],r=0,i=t.exportsDotExpressions.length;i>r;r++){var p=t.exportsDotExpressions[r],h=this._variableNames.next();this._context.newReplace(p.offset,p.length,n.format("var {0}",h)),l.push(p.name),l.push(":"),l.push(h),l.push(",")}l.length>0&&(l.pop(),this._context.newInsert(t.callbackBody.offset+t.callbackBody.length,n.format("return {{0}};",l.join(n.empty))));var u=t.identifier?"id,":n.empty,f=t.dependencyArray?"dep,":n.empty,d=t.callbackParameters.items.map(function(e){return e.name}).concat(t.requireStatements.map(function(e,t){return n.format("_p{0}",t)})).join(",");this._context.newInsert(n.format(e._DeclareTemplate,u,f,d))}var _=this._variableNames.next();this._context.newInsert(t.offset,n.format("var {0} = ",_)),this._context.newAppend(n.format("\nexport = {0};",_))},e._SpecialCallbackParams={exports:!0,module:!0,require:!0},e._DeclareWithLiteral="declare function define<T>(literal:T):T;\n",e._DeclareTemplate="declare function define<T>({0}{1}callback:({2})=>T):T;\n",e._Define="define",e._Require="require",e}();t.ImportsAndExportsCollector=m;var x,g=function(){function e(){this._counter=0,this._proposalToName={},this._allNames={}}return e.prototype.next=function(t){if(!t)return n.format("_var_{0}",this._counter++);var i=o.lookup(this._proposalToName,t);if(i)return i;if(i=t.replace(/["']/g,n.empty),i=r.basename(i),i=i.replace(e._RegExp,n.empty),0===i.length)return this.next();i=i.split(n.empty).join(e._SpecialChar),i+=e._SpecialChar;for(var s=i,a=1;o.contains(this._allNames,i);a++)i=s+a;return this._allNames[i]=!0,this._proposalToName[t]=i,i},e.prototype.allocateIfFree=function(e){return o.contains(this._allNames,e)?!1:(this._allNames[e]=!0,!0)},e.prototype.reset=function(){this._counter=0,this._proposalToName={},this._allNames={}},e._RegExp=/[^A-Za-z_$]/g,e._SpecialChar="̲",e}();!function(e){function t(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];if(t.length!==e.length)return!1;for(var r=0,i=t.length;i>r;r++)if(e[r].kind!==t[r])return!1;return!0}function n(e,t){return 65===e.kind&&s.getTextOfNode(e)===t}function r(e){for(;;)if(e=e.parent,!e||i(e))return e}function i(t){if(160!==t.kind)return!1;var r=t;return n(r.expression,"define")?e.isPath(r.arguments,157)?!0:e.isPath(r.arguments,165)?!0:e.isPath(r.arguments,156,165)?!0:e.isPath(r.arguments,8,156,165)?!0:!1:!1}e.isPath=t,e.isIdentifier=n,e.getContainingAmdDefineCall=r,e.isAmdDefineCall=i}(x||(x={}))});